// some function in AccessRule_Add.js: check_ip_format2, check_subnet_format2, isInteger, schTransStr

function schTransGPInEdit(str){
	w = 0;
	h = 0;

	bitAray = new Array(1,2,4,8);

	for (i=0; i < str.length; i++){
		val = parseInt(str.charAt(i), 16);
		
		for(j=0; j<4; j++){
			if (val & bitAray[j]){
				scheduleArrayInEdit[w][h][j] = 1;
				document.getElementById("edit_sch_"+w+"_"+h+"_"+j).style.backgroundColor = "#FFFF00";
			}
		}
		
		h++;
		
		if (h == 24){
			h=0;
			w++;		
			if (w == 7){
				w=0;
			}
		}
	}
}

function resetScheduleArrayInEdit(){
	// disable selection 
	el = document.getElementById('edit_schTable');
	disableSelection(el);

	for (i=0; i<7; i++){
		for (j=0; j<24; j++){
			for (k=0; k<4; k++){
				if (scheduleArrayInEdit[i][j][k] == 1){
					scheduleArrayInEdit[i][j][k] = 0;
					document.getElementById("edit_sch_"+i+"_"+j+"_"+k).style.backgroundColor = "";
				}
			}
		}
	}
}

var currentIPEntryCount_edit_source= 4;
var currentIPEntryCount_edit_destination = 4;
// enableDisableByClicking
function addIPEntryInEdit(entryType, val_ip, val_mask) {
    var count = entryType == 'source' ? currentIPEntryCount_edit_source : currentIPEntryCount_edit_destination;
    entryType = entryType == 'source' ? 'edit_source_ip_direct' : 'edit_destination_ip_direct';

    var entryDiv = document.createElement('div');
    var disabled = document.getElementById(entryType + '_chkbx').checked ? '' : "disabled='disabled'";
    entryDiv.innerHTML = g_str_setcfg_arule_ip+'<input type="text" class="edit_access_rule_text" style="width: 90px;" id="'+entryType+'_'+count+'_ip" name="'+entryType+'_'+count+'_ip" value="'+val_ip+'" onchange="return check_ip_format(this.value)" '+disabled+' />&nbsp;'+g_str_setcfg_arule_mask+'<input type="text" class="edit_access_rule_text" style="width: 90px;" id="'+entryType+'_'+count+'_mask" name="'+entryType+'_'+count+'_mask" value="'+val_mask+'" onchange="return check_subnet_format(this.value)" '+disabled+' />';
    document.getElementById(entryType + '_box').appendChild(entryDiv);

    enableDisableByClicking(document.getElementById(entryType + '_chkbx').checked, entryType, ['ip','mask']);

    if (entryType == 'edit_source_ip_direct') {
        currentIPEntryCount_edit_source++;
    } else {
        currentIPEntryCount_edit_destination++;
    }
}

function resetIPEntry(entryType){
    entryType = entryType == 'source' ? 'edit_source_ip_direct' : 'edit_destination_ip_direct';
	
	document.getElementById(entryType + '_box').innerHTML = "";

    if (entryType == 'edit_source_ip_direct') {
        currentIPEntryCount_edit_source = 1;
		addIPEntryInEdit('source', '', '');
    } else {
        currentIPEntryCount_edit_destination = 1;
		addIPEntryInEdit('destination', '', '');
    }
}

var currentPortEntryCount_edit_source = 4;
var currentPortEntryCount_edit_destination = 4;
function addPortEntryInEdit(entryType, val_protoNum, val_from, val_to) {
    var count = entryType == 'source' ? currentPortEntryCount_edit_source : currentPortEntryCount_edit_destination;
	var entryType2Str = entryType == 'source' ? 'edit_source' : 'edit_destination';
	var entryTypeOrgStr = entryType == 'source' ? 'source' : 'destination';
    entryType = entryType == 'source' ? 'edit_source_port' : 'edit_destination_port';

    var entryDiv = document.createElement('div');
	
	var selectedOption1 = '';
	var selectedOption2 = '';
	var selectedOption3 = '';
	
	var displayDiv1 = 'none';
	var displayDiv2 = 'none';
	
	if (val_protoNum == '' || val_protoNum == 6){
		selectedOption1 = 'selected="selected"';
		displayDiv2 = '';
	}
	else if (val_protoNum == 17){
		selectedOption2 = 'selected="selected"';
		displayDiv2 = '';
	}
	else{
		selectedOption3 = 'selected="selected"';
		displayDiv1 = '';
	}
	
    entryDiv.innerHTML = '\
					<table>\
						<tr>\
							<td width = "70px">\
								<select id="'+entryType2Str+'_protocolNum_'+count+'" name="'+entryType2Str+'_protocolNum_'+count+'" onchange="rule_changeProtocolNumInEdit(\''+entryTypeOrgStr+'\', '+count+');">\
									<option value="Not Selected">'+g_str_setcfg_arule_remove_entry+'</option>\
									<option value="6" '+selectedOption1+'>'+g_str_setcfg_arule_proto_opt1+'</option>\
									<option value="17" '+selectedOption2+'>'+g_str_setcfg_arule_proto_opt2+'</option>\
									<option value="0" '+selectedOption3+'>'+g_str_setcfg_arule_proto_opt3+'</option>\
								</select>\
							</td>\
							<td>\
								<div id="'+entryType2Str+'_proto_row_'+count+'" style="display:'+displayDiv1+';">'+g_str_setcfg_arule_proto+'<input type="text" class="edit_access_rule_text" style="width: 40px;" id="'+entryType2Str+'_specific_protocolNum_'+count+'" name="'+entryType2Str+'_specific_protocolNum_'+count+'" value="'+val_protoNum+'" onchange="return check_protoNum(this.value)" /></div>\
								<div id="'+entryType2Str+'_port_row_'+count+'" style="display:'+displayDiv2+';">'+g_str_setcfg_arule_port+g_str_setcfg_arule_from+'&nbsp;<input type="text" class="edit_access_rule_text" style="width: 40px;" id="'+entryType+'_'+count+'_from" name="'+entryType+'_'+count+'_from" value="'+val_from+'" onchange="return check_port(this.value)" />&nbsp;'+g_str_setcfg_arule_to+'<input type="text" class="edit_access_rule_text" style="width: 40px;" id="'+entryType+'_'+count+'_to" name="'+entryType+'_'+count+'_to" value="'+val_to+'" onchange="return check_port(this.value)" />\
							</td>\
						</tr>\
					</table>\
							';
	
	document.getElementById(entryType + '_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit([entryType2Str+'_protocolNum_'+count], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    if (entryType == 'edit_source_port') {
        currentPortEntryCount_edit_source++;
    } else {
        currentPortEntryCount_edit_destination++;
    }
}

function resetPortEntryInEdit(entryType) {
    entryType = entryType == 'source' ? 'edit_source_port' : 'edit_destination_port';

    document.getElementById(entryType + '_box').innerHTML = "";

    if (entryType == 'edit_source_port') {
        currentPortEntryCount_edit_source = 1;
    } else {
        currentPortEntryCount_edit_destination = 1;
    }
}

var currentEditUserEntryCount = 4;
function addUserEntryInEdit(val_username) {
    var count = currentEditUserEntryCount;

    var entryDiv = document.createElement('div');
	
	var optStr = '';
	
	var isSetDefaultSel = false;
	for (var i in userData) {
		var selStr ='';
		if (isSetDefaultSel == false && userData[i] == val_username){
			selStr = 'selected="selected"';
			isSetDefaultSel = true;
		}
		
		optStr += '<option value="'+userData[i]+'" '+selStr+'>'+userData[i]+'</option>';
	}
	
	if (isSetDefaultSel == false){
		isSetDefaultSel = true;
		optStr = '<option value="Not Selected" selected="selected" > </option>'+optStr;
		optStr = '<option value="Not Selected" >'+g_str_setcfg_arule_remove_entry+'</option>'+optStr;
	}
	else{
		optStr = '<option value="Not Selected" >'+g_str_setcfg_arule_remove_entry+'</option>'+optStr;
	}
	
    entryDiv.innerHTML = '\
					<select id="edit_user_'+count+'" name="edit_user_'+count+'">\
						'+optStr+'\
					</select>\
							';
							
	document.getElementById('edit_user_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit(['edit_user_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    currentEditUserEntryCount++;
}

function resetUserEntryInEdit() {
    document.getElementById('edit_user_box').innerHTML = "";
	
	currentEditUserEntryCount = 1;
}

var currentEditGroupEntryCount = 4;
function addGroupEntryInEdit(val_groupname) {
    var count = currentEditGroupEntryCount;

    var entryDiv = document.createElement('div');
	
	var optStr = '';
	
	var isSetDefaultSel = false;
	for (var i in groupData) {
		var selStr ='';
		if (isSetDefaultSel == false && groupData[i] == val_groupname){
			selStr = 'selected="selected"';
			isSetDefaultSel = true;
		}
		
		optStr += '<option value="'+groupData[i]+'" '+selStr+'>'+groupData[i]+'</option>';
	}
	
	if (isSetDefaultSel == false){
		isSetDefaultSel = true;
		optStr = '<option value="Not Selected" selected="selected" > </option>'+optStr;
		optStr = '<option value="Not Selected" >'+g_str_setcfg_arule_remove_entry+'</option>'+optStr;
	}
	else{
		optStr = '<option value="Not Selected" >'+g_str_setcfg_arule_remove_entry+'</option>'+optStr;
	}
	
    entryDiv.innerHTML = '\
					<select id="edit_group_'+count+'" name="edit_group_'+count+'">\
						'+optStr+'\
					</select>\
							';
							
	document.getElementById('edit_group_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit(['edit_group_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    currentEditGroupEntryCount++;
}

function resetGroupEntryInEdit() {
    document.getElementById('edit_group_box').innerHTML = "";
	
	currentEditGroupEntryCount = 1;
}

var currentEditWebFilterEntryCount = 4;
function addWebFilterEntryInEdit(val_webfiltername) {
    var count = currentEditWebFilterEntryCount;

    var entryDiv = document.createElement('div');
	
	var optStr = '';
	
	var isSetDefaultSel = false;
	for (var i in webFilterData) {
		var selStr ='';
		if (isSetDefaultSel == false && webFilterData[i] == val_webfiltername){
			selStr = 'selected="selected"';
			isSetDefaultSel = true;
		}
		
		optStr += '<option value="'+webFilterData[i]+'" '+selStr+'>'+webFilterData[i]+'</option>';
	}
	
	if (isSetDefaultSel == false){
		isSetDefaultSel = true;
		optStr = '<option value="Not Selected" selected="selected" > </option>'+optStr;
	}
	else{
		optStr = '<option value="Not Selected" > </option>'+optStr;
	}
	
    entryDiv.innerHTML = '\
					<select id="edit_web_filter_'+count+'" name="edit_web_filter_'+count+'">\
						'+optStr+'\
					</select>\
							';
							
	document.getElementById('edit_web_filter_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit(['edit_web_filter_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    currentEditWebFilterEntryCount++;
}

function resetWebFilterEntryInEdit() {
    document.getElementById('edit_web_filter_box').innerHTML = "";
	
	currentEditWebFilterEntryCount = 1;
}

// display_type = 0: normal, 1: mark as deleted
function UpdateAccessRule(display_type) {
	var editNumber = document.getElementById('edit_rule_id').value;
	
	var chkbx_class_id = "rule_chkbx";
	var left_class_id = "rule_data_left";
	var right_class_id = "rule_data_right";
	var input_class_id = "ch";
	var input_ip_class_id = "ch_ip";
	var input_u_class_id = "ch_u";
	var title_class_id = "rule_title";
	var input_other_option_str = "";
	var checkbox_other_option_str = "";
	if (display_type == 1){
		chkbx_class_id = "rule_chkbx_no_cursor_deleted";
		left_class_id = "rule_data_left_deleted";
		right_class_id = "rule_data_right_deleted";
		input_class_id = "ch_deleted";
		input_ip_class_id = "ch_ip_deleted";
		input_u_class_id = "ch_u_deleted";
		title_class_id = "rule_title_deleted";
		checkbox_other_option_str = 'style="display:none;" disabled readonly ';
		input_other_option_str = "readonly ";
	}
	
	// workaround for sometimes cannot get object by name in chrome
	if (!document.edit_access_form){
		w = document.getElementById('edit_access_form');
	}
	else
		w = document.edit_access_form;
		
	with (w){
		var isAllow = 0;
		if (edit_action[0].checked) // allow
			isAllow = 1;
		else if (edit_action[1].checked) // deny
			isAllow = 0;
			
		var isEnable = 0;
		
		isEnable = ruleData[editNumber][0];
			
		// 0: both, 1: inbound, 2: outbound
		var trafficType = 0;
		if (edit_traffic_type[0].checked)
			trafficType = edit_traffic_type[0].value;
		else if (edit_traffic_type[1].checked)
			trafficType = edit_traffic_type[1].value;
		else if (edit_traffic_type[2].checked)
			trafficType = edit_traffic_type[2].value;
			
		var ruleName = edit_rule_name.value;
		var description = edit_description.value;
		
		var label_srcip_text_1 ="";
		var label_srcip_text_2 ="";
		var label_srcip_text_3 ="";
		// src ip
		var sourceCount = 0;
		var sourceCreateEntryCount = 0;
		if (document.getElementById('edit_source_ip_direct_chkbx').checked) {
			var sourceIP = '';
			var sourceIPMask = '';
			while (true) {
				if (document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_ip')) {
					sourceIP = document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_ip').value;
					sourceIPMask = document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_mask').value;
					
					if (!sourceIP && !sourceIPMask){
						break;
					}
					
					label_srcip_text_2 +='\
											<div style="padding-left: 10px;">\
        										<input type="text" id="hinput_'+editNumber+'_source_'+sourceCreateEntryCount+'" name="hinput_'+editNumber+'_source_'+sourceCreateEntryCount+'" value="'+sourceIP+' ('+sourceIPMask+')" class="'+input_ip_class_id+'" onchange="return check_input_ip_text(this)" '+input_other_option_str+'/>\
        									</div>\
					';
					sourceCreateEntryCount++;
				} else {
					break;
				}
				sourceCount++;
			}
		}
		
		var label_destip_text_1 ="";
		var label_destip_text_2 ="";
		var label_destip_text_3 ="";
		// dest ip
		var destinationCount = 0;
		var destinationCreateEntryCount = 0;
		if (document.getElementById('edit_destination_ip_direct_chkbx').checked) {
			var destinationIP = '';
			var destinationIPMask = '';
			while (true) {
				if (document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_ip')) {
					destinationIP = document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_ip').value;
					destinationIPMask = document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_mask').value;
					
					if (!destinationIP && !destinationIPMask){
						break;
					}
					
					label_destip_text_2 +='\
											<div style="padding-left: 10px; height: 20px;">\
        										<input type="text" id="hinput_'+editNumber+'_dest_'+destinationCreateEntryCount+'" name="hinput_'+editNumber+'_dest_'+destinationCreateEntryCount+'" value="'+destinationIP+' ('+destinationIPMask+')" class="'+input_ip_class_id+'" onchange="return check_input_ip_text(this)" '+input_other_option_str+'/>\
        									</div>\
					';
					destinationCreateEntryCount++;
					
				} else {
					break;
				}
				destinationCount++;
			}
		}
		
		var label_srcipbundle_text_2 ="";
		// src ipbundle
		var sourceIpBundleCount = 0;
		var sourceIpBundleCreateEntryCount = 0;
		if (edit_source_ip_spec[1].checked) {
			var sourcebundleName = '';
			while (true) {
				if (document.getElementById('edit_source_ip_bundle_'+(sourceIpBundleCount+1))) {
					if (document.getElementById('edit_source_ip_bundle_'+(sourceIpBundleCount+1)).checked) {
						sourcebundleName = document.getElementById('edit_source_ip_bundle_'+(sourceIpBundleCount+1)).value;
						
						if (!sourcebundleName){
							break;
						}
						
						var temp = "";
						if (ipBundleData[sourcebundleName]){
						
							for (var i in ipBundleData[sourcebundleName]) {
								var temp2 = new Array();
								temp2 = ipBundleData[sourcebundleName][i].split('-');
								temp+='<span style="padding-right: 10px;">'+temp2[0]+' to '+temp2[1];
								if (i < ipBundleData[sourcebundleName].length - 1){
									temp +=',';
								}
								temp+='</span>\n';
							}
						}
						
						label_srcipbundle_text_2 +='\
											<div style="padding-left: 10px; ">\
												<table>\
													<tr><td valign="top">['+sourcebundleName+']</td>\
													<td>\
													<input type="hidden" value="'+sourcebundleName+'" id="hinput_'+editNumber+'_source_ipbundle_'+sourceIpBundleCreateEntryCount+'" name="hinput_'+editNumber+'_source_ipbundle_'+sourceIpBundleCreateEntryCount+'" />\
													'+temp+'\
													</td></tr>\
												</table>\
											</div>\
						';
						sourceIpBundleCreateEntryCount++;
					}
				} else {
					break;
				}
				sourceIpBundleCount++;
			}
		}
		
		if (sourceIpBundleCount == 0){
			label_srcipbundle_text_2 = '<div style="padding-left: 10px; height: 20px; font-weight: normal;">'+g_str_setcfg_arule_all_ip+'</div>';
		}
		
		label_srcip_text_1 = '\
								<td class="'+left_class_id+'" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_src_ip+'</span><br/>\
		';
		label_srcip_text_3 = '		</div>\
								</td>\
		';
		
		
		var label_destipbundle_text_2 ="";
		// dest ipbundle
		var destinationIpBundleCount = 0;
		var destinationIpBundleCreateEntryCount = 0;
		if (edit_destination_ip_spec[1].checked) {
			var destinationbundleName = '';
			while (true) {
				if (document.getElementById('edit_destination_ip_bundle_'+(destinationIpBundleCount+1))) {
					if (document.getElementById('edit_destination_ip_bundle_'+(destinationIpBundleCount+1)).checked) {
						destinationbundleName = document.getElementById('edit_destination_ip_bundle_'+(destinationIpBundleCount+1)).value;
						
						if (!destinationbundleName){
							break;
						}
						
						var temp = "";
						if (ipBundleData[destinationbundleName]){
						
							for (var i in ipBundleData[destinationbundleName]) {
								var temp2 = new Array();
								temp2 = ipBundleData[destinationbundleName][i].split('-');
								temp+='<span style="padding-right: 10px;">'+temp2[0]+' to '+temp2[1];
								if (i < ipBundleData[destinationbundleName].length - 1){
									temp +=',';
								}
								temp+='</span>\n';
							}
						}
						
						label_destipbundle_text_2 +='\
											<div style="padding-left: 10px; ">\
												<table>\
													<tr><td valign="top">['+destinationbundleName+']</td>\
													<td>\
													<input type="hidden" value="'+destinationbundleName+'" id="hinput_'+editNumber+'_dest_ipbundle_'+destinationIpBundleCreateEntryCount+'" name="hinput_'+editNumber+'_dest_ipbundle_'+destinationIpBundleCreateEntryCount+'" />\
													'+temp+'\
													</td></tr>\
												</table>\
											</div>\
						';
						destinationIpBundleCreateEntryCount++;
					}
				} else {
					break;
				}
				destinationIpBundleCount++;
			}
		}
		
		if (destinationIpBundleCount == 0){
			label_destipbundle_text_2 = '<div style="padding-left: 10px; height: 20px; font-weight: normal;">'+g_str_setcfg_arule_all_ip+'</div>';
		}
		
		label_destip_text_1 = '\
								<td class="'+left_class_id+'" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_dest_ip+'</span><br/>\
		';
		label_destip_text_3 = '		</div>\
								</td>\
		';
		
		// src port
		var label_srcport_text_1 ="";
		var label_srcport_text_2 ="";
		var label_srcport_text_3 ="";
		var sourcePortCount = 0;
		var sourcePortStart = 0;
		var sourcePortEnd = 0;
		var sourcePortCreateEntryCount = 0;
		var sourceProtocolName = "";
		var sourceProtocolNum = 0;
		if (edit_source_protocol_type[1].checked) {
			while (true) {
			
				if (document.getElementById('edit_source_protocolNum_'+(sourcePortCount+1))){
					sourceProtocolNum = document.getElementById('edit_source_protocolNum_'+(sourcePortCount+1)).value;
					
					if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
					
						if (sourceProtocolNum == 6){
							sourceProtocolName = g_str_setcfg_arule_proto_opt1;
						}
						else{
							sourceProtocolName = g_str_setcfg_arule_proto_opt2;
						}
					
						if (document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_from')) {
							sourcePortStart = parseInt(document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_from').value);
							sourcePortEnd = parseInt(document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_to').value);
							if (!sourcePortStart && !sourcePortEnd){
								sourcePortCount++;
								continue;
							}
							
							label_srcport_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+editNumber+'_sourcep_'+sourcePortCreateEntryCount+'" name="hinput_'+editNumber+'_sourcep_'+sourcePortCreateEntryCount+'" value="'+sourceProtocolName+' ('+sourcePortStart+'-'+sourcePortEnd+')" class="'+input_class_id+'" onchange="return check_input_protocol_text(this, '+editNumber+')" />\
													</span>\
							';
							sourcePortCreateEntryCount++;
						}
					}
					else{
						if (sourceProtocolNum == 0){
							if (document.getElementById('edit_source_specific_protocolNum_'+(sourcePortCount+1))) {
								sourceProtocolNum = parseInt(document.getElementById('edit_source_specific_protocolNum_'+(sourcePortCount+1)).value);
								
								if (!sourceProtocolNum){
									sourcePortCount++;
									continue;
								}
								
								sourceProtocolName = g_str_setcfg_arule_proto_opt3;
								
								label_srcport_text_2 +='\
														<span style="padding-right: 10px;">\
															<input type="text" id="hinput_'+editNumber+'_sourcep_'+sourcePortCreateEntryCount+'" name="hinput_'+editNumber+'_sourcep_'+sourcePortCreateEntryCount+'" value="'+sourceProtocolName+' ('+sourceProtocolNum+')" class="'+input_class_id+'" onchange="return check_input_protocol_text(this, '+editNumber+')" />\
														</span>\
								';
								sourcePortCreateEntryCount++;
							}
						}
					}
					
				}
				else{
					break;
				}
				
				sourcePortCount++;
			}
		}
		
		if (sourcePortCreateEntryCount == 0){
			label_srcport_text_2 = '<div style="padding-left: 10px; font-weight: normal;">'+g_str_setcfg_arule_all_protocol+'</div>';
		}
		else{
			label_srcport_text_2 = '<div style="padding-left: 10px;">'+label_srcport_text_2+'</div>'
		}
		
		
		label_srcport_text_1 = '\
							<td class="'+left_class_id+'" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_src_proto+'</span><br/>\
		';
		label_srcport_text_3 = '\
									</div>\
							</td>\
		';
		
		// dest port
		var label_destport_text_1 ="";
		var label_destport_text_2 ="";
		var label_destport_text_3 ="";
		var destinationPortCount = 0;
		var destinationPortStart = 0;
		var destinationPortEnd = 0;
		var destinationPortCreateEntryCount = 0;
		var destinationProtocolName = "";
		var destinationProtocolNum = 0;
		if (edit_destination_protocol_type[1].checked) {
			while (true) {
			
				if (document.getElementById('edit_destination_protocolNum_'+(destinationPortCount+1))){
					destinationProtocolNum = document.getElementById('edit_destination_protocolNum_'+(destinationPortCount+1)).value;
					
					if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
					
						if (destinationProtocolNum == 6){
							destinationProtocolName = g_str_setcfg_arule_proto_opt1;
						}
						else{
							destinationProtocolName = g_str_setcfg_arule_proto_opt2;
						}
					
						if (document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_from')) {
							destinationPortStart = parseInt(document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_from').value);
							destinationPortEnd = parseInt(document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_to').value);
							if (!destinationPortStart && !destinationPortEnd){
								destinationPortCount++;
								continue;
							}
							
							label_destport_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+editNumber+'_destp_'+destinationPortCreateEntryCount+'" name="hinput_'+editNumber+'_destp_'+destinationPortCreateEntryCount+'" value="'+destinationProtocolName+' ('+destinationPortStart+'-'+destinationPortEnd+')" class="'+input_class_id+'" onchange="return check_input_protocol_text(this, '+editNumber+')" />\
													</span>\
							';
							destinationPortCreateEntryCount++;
						}
					}
					else{
						if (destinationProtocolNum == 0){
							if (document.getElementById('edit_destination_specific_protocolNum_'+(destinationPortCount+1))) {
								destinationProtocolNum = parseInt(document.getElementById('edit_destination_specific_protocolNum_'+(destinationPortCount+1)).value);
								
								if (!destinationProtocolNum){
									destinationPortCount++;
									continue;
								}
								
								destinationProtocolName = g_str_setcfg_arule_proto_opt3;
								
								label_destport_text_2 +='\
														<span style="padding-right: 10px;">\
															<input type="text" id="hinput_'+editNumber+'_destp_'+destinationPortCreateEntryCount+'" name="hinput_'+editNumber+'_destp_'+destinationPortCreateEntryCount+'" value="'+destinationProtocolName+' ('+destinationProtocolNum+')" class="'+input_class_id+'" onchange="return check_input_protocol_text(this, '+editNumber+')" />\
														</span>\
								';
								destinationPortCreateEntryCount++;
							}
						}
					}
					
				}
				else{
					break;
				}
				
				destinationPortCount++;
			}
		}
		
		if (destinationPortCreateEntryCount == 0){
			label_destport_text_2 = '<div style="padding-left: 10px; font-weight: normal;">'+g_str_setcfg_arule_all_protocol+'</div>';
		}
		else{
			label_destport_text_2 = '<div style="padding-left: 10px;">'+label_destport_text_2+'</div>'
		}
		
		label_destport_text_1 = '\
							<td class="'+left_class_id+'" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_dest_proto+'</span><br/>\
		';
		label_destport_text_3 = '\
									</div>\
							</td>\
		';
		
		// user and group
		var label_user_and_group_text_1 ="";
		var label_user_and_group_text_2 ="";
		var label_user_and_group_text_3 ="";
		var userCount = 0;
		var userName = "";
		
		var userAndGroupCreateEntryCount = 0;
		var userCreateEntryCount = 0;
		if (edit_user_spec[1].checked) {
			while (true) {
			
				if (document.getElementById('edit_user_'+(userCount+1))){
					userName = document.getElementById('edit_user_'+(userCount+1)).value;
					
					if (userName != "Not Selected"){
						label_user_and_group_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+editNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" name="hinput_'+editNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" value="'+userName+' (user)" title="'+userName+' (user)" class="'+input_u_class_id+'" />\
													</span>\
							';
						userAndGroupCreateEntryCount++;
					}
					
				}
				else{
					break;
				}
				
				userCount++;
			}
		}
		
		if (userAndGroupCreateEntryCount >0){
			label_user_and_group_text_2 = '<div style="padding-left: 10px;">'+label_user_and_group_text_2+'</div>';
		}
		
		var groupCount = 0;
		var groupName = "";
		
		userCreateEntryCount = userAndGroupCreateEntryCount;
		if (edit_group_spec[1].checked) {
			while (true) {
			
				if (document.getElementById('edit_group_'+(groupCount+1))){
					groupName = document.getElementById('edit_group_'+(groupCount+1)).value;
					
					if (groupName != "Not Selected"){
						if (userAndGroupCreateEntryCount == userCreateEntryCount){
							// first of group
							label_user_and_group_text_2 += '<div style="padding-left: 10px;">';
						}
					
						label_user_and_group_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+editNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" name="hinput_'+editNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" value="'+groupName+' (group)" title="'+groupName+' (group)" class="'+input_u_class_id+'" />\
													</span>\
							';
						userAndGroupCreateEntryCount++;
					}
					
				}
				else{
					break;
				}
				
				groupCount++;
			}
		}
		
		if (userAndGroupCreateEntryCount > userCreateEntryCount){
			// have group
			label_user_and_group_text_2 += '</div>';
		}
		
		if(userAndGroupCreateEntryCount == 0){
			label_user_and_group_text_2 = '<div style="padding-left: 10px; font-weight: normal;">'+g_str_setcfg_arule_all_user+'</div>';
		}
		
		label_user_and_group_text_1 = '\
							<td class="'+left_class_id+'" valign="top" colspan =2>\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_user_and_group+'</span><br/>\
		';
		label_user_and_group_text_3 = '\
									</div>\
							</td>\
		';
		
		// schedule
		var ruleSchedule = "";
		var scheduleMsgStr = "";		
		
		var label_schedule_text ="";
		if (edit_schedule_spec[1].checked) {
			// special value store in javascript's variable(array)
			
			// build value string
			schValStr = "";
			
			for (i=0; i<7; i++){
				for (j=0; j<24; j++){
					val = 0;
					if (scheduleArrayInEdit[i][j][0] == 1){
						val +=1;
					}
					if (scheduleArrayInEdit[i][j][1] == 1){
						val +=2;
					}
					if (scheduleArrayInEdit[i][j][2] == 1){
						val +=4;
					}
					if (scheduleArrayInEdit[i][j][3] == 1){
						val +=8;
					}
					schValStr += val.toString(16);
				}
			}
			
			ruleSchedule = schValStr.toUpperCase();
			
			if ((ruleSchedule.split("F").length - 1) == 168){
				scheduleMsgStr = g_str_setcfg_arule_all_schedule;
				ruleSchedule = "";
			}
			else{
				scheduleMsgStr = schTransStr(ruleSchedule);
			}
		}
		else{
			scheduleMsgStr = g_str_setcfg_arule_all_schedule;
			ruleSchedule = "";
		}
		
		label_schedule_text = '\
						<td class="'+left_class_id+'" valign="top" colspan =2>\
							<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_sch+'</span><br/>\
							<div style="padding-left: 10px; font-weight: normal;">'+scheduleMsgStr+'</div>\
							<input type="hidden" value="'+ruleSchedule+'" id="schedule_'+editNumber+'" name="schedule_'+editNumber+'" />\
							</div>\
						</td>\
					';
		
		// web filter
		var appliedWebFilter = '';
		
		var label_web_filter_text ="";
		if (edit_web_filter_spec[1].checked) {
			// hard code, since now only support one
			filterName = document.getElementById('edit_web_filter_1').value;					
			if (filterName != "Not Selected"){
				appliedWebFilter = filterName;
				label_web_filter_text = '\
						<td class="'+left_class_id+'" valign="top" colspan =2>\
							<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_wf+'</span><br/>\
							<div style="padding-left: 10px;">'+appliedWebFilter+'</div>\
							<input type="hidden" value="'+appliedWebFilter+'" id="applied_web_filter_'+editNumber+'" name="applied_web_filter_'+editNumber+'" />\
						</td>\
					';
			}
		}
		
		if (label_web_filter_text == ""){
			label_web_filter_text = '\
						<td class="'+left_class_id+'" valign="top" colspan =2>\
							<input type="hidden" value="'+appliedWebFilter+'" id="applied_web_filter_'+editNumber+'" name="applied_web_filter_'+editNumber+'" />\
						</td>\
					';
		}
		
		ruleData[editNumber][1] = isAllow;
	
		var label_text_1 ="";
		var label_text_2 ="";
		var label_text_3 ="";
		if (isEnable == 1){
			label_text_1 = 'disable';
			label_text_3 = g_str_setcfg_arule_en;
			if (isAllow ==1)
				label_text_2 = 'green';
			else
				label_text_2 = 'red';
		}
		else{
			label_text_1 = 'enable';
			label_text_2 = 'grey';
			label_text_3 = g_str_setcfg_arule_dis;
		}
		var opt_act_text1 ="";
		var opt_act_text2 ="";
		if (isAllow ==1){
			opt_act_text1 = 'selected="selected"';
		}
		else{
			opt_act_text2 = 'selected="selected"';
		}
		var opt_tp_text1 ="";
		var opt_tp_text2 ="";
		var opt_tp_text3 ="";
		if (trafficType ==0){
			opt_tp_text1 = 'selected="selected"';
		}
		else if (trafficType ==1){
			opt_tp_text2 = 'selected="selected"';
		}
		else if (trafficType ==2){
			opt_tp_text3 = 'selected="selected"';
		}
		
		var entryDiv = document.getElementById('rule_box_'+editNumber);
		
		var mainLabelContent = "";
		
		if (display_type == 1){ // mark as deleted
			var label_text_2b = 'grey'; // hard code
			
			var actionStr = "";	
			if (isAllow ==1){
				actionStr = g_str_setcfg_arule_act_opt1;
			}
			else{
				actionStr = g_str_setcfg_arule_act_opt2;
			}
			
			var trafficTypeStr ="";
			if (trafficType ==0){
				trafficTypeStr = g_str_setcfg_arule_traffic_opt1;
			}
			else if (trafficType ==1){
				trafficTypeStr = g_str_setcfg_arule_traffic_opt2;
			}
			else if (trafficType ==2){
				trafficTypeStr = g_str_setcfg_arule_traffic_opt3;
			}
		
			mainLabelContent = '\
					<a name="rule_box_'+editNumber+'_pos"></a>\
					<table cellpadding="4" cellspacing="0" border="0" style="width: 100%; font-weight: bold; font-size: 12px;">\
						<tr>\
							<td style="width: 7px;" id="rule_state_box_'+editNumber+'" class="rule_state_'+label_text_2+'"></td>\
							<td class="'+title_class_id+'">\
								<div style="margin-bottom: 6px; font-weight: bold; font-size: 14px;">\
									<div style="float: right; font-size: 12px;">\
										<span style="font-size: 11px;" id="rule_state_text_'+editNumber+'" class="rule_statetxt_'+label_text_2b+'">['+label_text_3+']</span>&nbsp;'+g_str_setcfg_arule_label_act+'\
											<span style="font-weight: normal;">'+actionStr+'</span>&nbsp;'+g_str_setcfg_arule_label_traffic+'<span style="font-weight: normal;">'+trafficTypeStr+'</span>\
									</div>\
									<u>'+ruleName+'</u>\
									<input type="hidden" value="'+ruleName+'" id="rule_name_'+editNumber+'" name="rule_name_'+editNumber+'" />\
								</div>\
								<div style="padding-left: 10px;">'+description+'</div>\
								<input type="hidden" value="'+description+'" id="rule_description_'+editNumber+'" name="rule_description_'+editNumber+'" />\
							</td>\
							<td class="rule_collapse_box" id="rule_collapse_box_'+editNumber+'" onselectstart="javascript: return false;" onmouseover="javascript: this.style.background=\'#ddd\'; this.style.color=\'black\';" onmouseout="javascript: this.style.background=\'#eee\'; this.style.color=\'#777\';" onclick="javascript: ruleDetailCollapse(this, '+editNumber+');" title="Collapse">\
								&uarr;\
							</td>\
						</tr>\
						<tr id="additional_row_'+editNumber+'" name="additional_row_'+editNumber+'" style=""><td align="center" colspan=2><span id="additional_msg_'+editNumber+'" name="additional_msg_'+editNumber+'" style="background: #FFF;color: #FF0000;">'+g_str_setcfg_msg_confirm_del+'</span></td><td></td></tr>\
					</table>\
				';
		}
		else{
			mainLabelContent = '\
						<a name="rule_box_'+editNumber+'_pos"></a>\
						<table cellpadding="4" cellspacing="0" border="0" style="width: 100%; font-weight: bold; font-size: 12px;">\
							<tr>\
								<td style="width: 7px; cursor: pointer; -moz-user-select: none;" onselectstart="javascript: return false;" id="rule_state_box_'+editNumber+'" title="Click to '+label_text_1+' it" onclick="javascript: rule_changeState('+editNumber+');" class="rule_state_'+label_text_2+'"></td>\
								<td class="'+title_class_id+'">\
									<div style="margin-bottom: 6px; font-weight: bold; font-size: 14px;">\
										<div style="float: right; font-size: 12px;">\
											<span style="font-size: 11px; cursor: pointer; -moz-user-select: none;" onselectstart="javascript: return false;" id="rule_state_text_'+editNumber+'" title="Click to '+label_text_1+' it" onclick="javascript: rule_changeState('+editNumber+');" class="rule_statetxt_'+label_text_2+'">['+label_text_3+']</span>&nbsp;'+g_str_setcfg_arule_label_act+'<select id="rule_action_'+editNumber+'" name="rule_action_'+editNumber+'" onchange="rule_changeAction('+editNumber+');">\
												<option value="1" '+opt_act_text1+'>'+g_str_setcfg_arule_act_opt1+'</option>\
												<option value="0" '+opt_act_text2+'>'+g_str_setcfg_arule_act_opt2+'</option>\
											</select>'+g_str_setcfg_arule_label_traffic+'<select id="rule_trafficType_'+editNumber+'" name="rule_trafficType_'+editNumber+'" onchange="showAdditional('+editNumber+');">\
												<option value="1" '+opt_tp_text2+'>'+g_str_setcfg_arule_traffic_opt2+'</option>\
												<option value="2" '+opt_tp_text3+'>'+g_str_setcfg_arule_traffic_opt3+'</option>\
												<option value="0" '+opt_tp_text1+'>'+g_str_setcfg_arule_traffic_opt1+'</option>\
											</select>\
										</div>\
										<u>'+ruleName+'</u>\
										<input type="hidden" value="'+ruleName+'" id="rule_name_'+editNumber+'" name="rule_name_'+editNumber+'" />\
									</div>\
									<div style="padding-left: 10px;">'+description+'</div>\
									<input type="hidden" value="'+description+'" id="rule_description_'+editNumber+'" name="rule_description_'+editNumber+'" />\
								</td>\
								<td class="rule_collapse_box" id="rule_collapse_box_'+editNumber+'" onselectstart="javascript: return false;" onmouseover="javascript: this.style.background=\'#ddd\'; this.style.color=\'black\';" onmouseout="javascript: this.style.background=\'#eee\'; this.style.color=\'#777\';" onclick="javascript: ruleDetailCollapse(this, '+editNumber+');" title="Collapse">\
									&uarr;\
								</td>\
							</tr>\
							<tr id="additional_row_'+editNumber+'" name="additional_row_'+editNumber+'" style=""><td align="center" colspan=2><span id="additional_msg_'+editNumber+'" name="additional_msg_'+editNumber+'" style="background: #FFF;color: #FF0000;">'+g_str_setcfg_msg_confirm_edit+'</span></td><td></td></tr>\
						</table>\
				';
		}
		
		entryDiv.innerHTML = '\
			<table cellpadding="0" cellspacing="0" border="0" style="border-bottom: 1px solid green; width: 100%; font-size: 12px;">\
				<tr>\
					<td class="'+chkbx_class_id+'" id="rule_select_box_'+editNumber+'" valign="top">\
						<b>'+ruleData[editNumber][2]+'</b><br /><input type="checkbox" id="rule_select_chkbox_'+editNumber+'" name="rule_select_chkbox[]" value="'+editNumber+'" '+checkbox_other_option_str+'/>\
					</td>\
					<td style="text-align: left;">\
						'+mainLabelContent+'\
						<div id="rule_data_'+editNumber+'" style="overflow: hidden;">\
							<table cellpadding="3" cellspacing="0" border="0" style="width: 100%; font-size: 12px;"> \
								<tr>'+label_srcip_text_1+label_srcip_text_2+label_srcipbundle_text_2+label_srcip_text_3+'</tr>\
								<tr>'+label_srcport_text_1+label_srcport_text_2+label_srcport_text_3+'</tr>\
								<tr>'+label_destip_text_1+label_destip_text_2+label_destipbundle_text_2+label_destip_text_3+'</tr>\
								<tr>'+label_destport_text_1+label_destport_text_2+label_destport_text_3+'</tr>\
								<tr>'+label_user_and_group_text_1+label_user_and_group_text_2+label_user_and_group_text_3+'</tr>\
								<tr>'+label_schedule_text+'</tr>\
								<tr>'+label_web_filter_text+'</tr>\
							</table>\
						</div>\
					</td>\
				</tr>\
			</table>\
		';
		
		// document.getElementById('rule_boxset').appendChild(entryDiv);
		
		if (display_type == 1){
		}
		else{
			// run javascript
			// src ip
			for (i =0; i<sourceCreateEntryCount; i++){
				moduleHiddenInput.init("hinput_"+editNumber+"_source_"+i, 'ch_ip', 'cs_ip', 'cs_ip');
			}
			// dest ip
			for (i =0; i<destinationCreateEntryCount; i++){
				moduleHiddenInput.init("hinput_"+editNumber+"_dest_"+i, 'ch_ip', 'cs_ip', 'cs_ip');
			}
			// src port
			for (i =0; i<sourcePortCreateEntryCount; i++){
				moduleHiddenInput.init("hinput_"+editNumber+"_sourcep_"+i, 'ch', 'cs', 'cs');
			}
			// dest port
			for (i =0; i<destinationPortCreateEntryCount; i++){
				moduleHiddenInput.init("hinput_"+editNumber+"_destp_"+i, 'ch', 'cs', 'cs');
			}
			
			 moduleFormDecoration.selectInit(['rule_action_'+editNumber+'','rule_trafficType_'+editNumber+''], {'main_normal':'main_normal','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});
			 
			 rule_selectBoxInit(editNumber);
		 
			moduleListOrder.dragInit(editNumber);
			moduleListOrder.updateDataSequence();
			collapseExpand.UpdateCollapsed('rule_data_'+editNumber);
		}
	}
	
	if (display_type == 1){
	}
	else{
		moduleFloatingDiv.close('abcdiv');
		grayOut(false);
	}
	
    // document.getElementById('new_access_form').reset();
	
	// scroll 
	location.href="#rule_box_"+editNumber+"_pos";
	// document.getElementById('rule_select_box_'+editNumber).focus();

}

function editAccessRuleReset() {
	moduleFloatingDiv.close('abcdiv');
	grayOut(false);
}

function editAccessRuleValidate(){

	// workaround for sometimes cannot get object by name in chrome
	if (!document.edit_access_form){
		w = document.getElementById('edit_access_form');
	}
	else
		w = document.edit_access_form;
		
	with (w){
	
    var ruleName = document.getElementById('edit_rule_name');
    if (ruleName.value.length < 1 || ruleName.value.length > 64) {
        alert(g_str_js_alert_arule_1);
        document.getElementById('edit_rule_name').focus();
        return false;
    }
	
	var editNumber = document.getElementById('edit_rule_id').value;
	
	var tempCount = 1;
	while (true){
		if (!document.getElementById('rule_name_'+tempCount)){
			break;
		}
		if (editNumber == tempCount){
			// SKIP
			tempCount++;
			continue;
		}
		
		var ruleName2 = "";
		ruleName2 = document.getElementById('rule_name_'+tempCount).value;
		
		if (ruleName.value == ruleName2){
			alert(g_str_js_alert_arule_2);
			document.getElementById('edit_rule_name').focus();
			return false;
		}
		tempCount++;
	}
	
    var description = document.getElementById('edit_description');
    if (description.value.length > 128) {
        alert(g_str_js_alert_arule_3);
        document.getElementById('edit_description').focus();
        return false;
    }
	
	// src ip
	var sourceCount = 0;
	var sourceValidEntryCount = 0;
	if (edit_source_ip_spec[1].checked){
		if (document.getElementById('edit_source_ip_direct_chkbx').checked) {
			var sourceIP = '';
			var sourceIPMask = '';
			while (true) {
				if (document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_ip')) {
					sourceIP = document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_ip').value;
					sourceIPMask = document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_mask').value;
					
					if (!sourceIP && !sourceIPMask){
						// SKIP
						sourceCount++;
						continue;
					}
					else if (!sourceIP || !check_ip_format2(sourceIP)){
						alert(g_str_js_alert_arule_4);
						document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_ip').focus();
						return false;
					}
					else if (!sourceIPMask || !check_subnet_format2(sourceIPMask)){
						alert(g_str_js_alert_arule_5);
						document.getElementById('edit_source_ip_direct_'+(sourceCount+1)+'_mask').focus();
						return false;
					}
					
					
				} else {
					break;
				}
				sourceCount++;
			}
		}
		
		if (sourceCount > 0){
			for (var k =1; k <= sourceCount; k++){
				var sourceIP = '';
				var sourceIPMask = '';
				
				sourceIP = document.getElementById('edit_source_ip_direct_'+k+'_ip').value;
				sourceIPMask = document.getElementById('edit_source_ip_direct_'+k+'_mask').value;
				
				if (!sourceIP && !sourceIPMask){
					// SKIP
					continue;
				}
				
				for (var m =1; m <= sourceCount; m++){
					if (k == m)
						continue;
						
					var sourceIP2 = '';
					var sourceIPMask2 = ''; 
					
					if (document.getElementById('edit_source_ip_direct_'+m+'_ip')){
						sourceIP2 = document.getElementById('edit_source_ip_direct_'+m+'_ip').value;
						sourceIPMask2 = document.getElementById('edit_source_ip_direct_'+m+'_mask').value;
						if (sourceIP == sourceIP2 && sourceIPMask == sourceIPMask2){
							alert(g_str_js_alert_arule_6);
							document.getElementById('edit_source_ip_direct_'+k+'_ip').focus();
							return false;
						}
					}
				}
			}
		}
		
		var sourceIpBundleCount = 0;
		var sourcebundleName = '';
		while (true) {
			if (document.getElementById('edit_source_ip_bundle_'+(sourceIpBundleCount+1))) {
				if (document.getElementById('edit_source_ip_bundle_'+(sourceIpBundleCount+1)).checked) {
					sourcebundleName = document.getElementById('edit_source_ip_bundle_'+(sourceIpBundleCount+1)).value;
					
					if (!sourcebundleName){
						sourceIpBundleCount++;
						continue;
					}
					
					sourceValidEntryCount++;
				}
			} else {
				break;
			}
			sourceIpBundleCount++;
		}
		
		if (sourceValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_19);
			// hard code
			document.getElementById('edit_source_ip_bundle_1').focus();
			return false;
		}
		
	}
	
	// dest ip
	var destinationCount = 0;
	var destinationValidEntryCount = 0;
	if (edit_destination_ip_spec[1].checked){
		if (document.getElementById('edit_destination_ip_direct_chkbx').checked) {
			var destinationIP = '';
			var destinationIPMask = '';
			while (true) {
				if (document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_ip')) {
					destinationIP = document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_ip').value;
					destinationIPMask = document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_mask').value;
					
					if (!destinationIP && !destinationIPMask){
						// SKIP
						destinationCount++;
						continue;
					}
					else if (!destinationIP || !check_ip_format2(destinationIP)){
						alert(g_str_js_alert_arule_4);
						document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_ip').focus();
						return false;
					}
					else if (!destinationIPMask || !check_subnet_format2(destinationIPMask)){
						alert(g_str_js_alert_arule_5);
						document.getElementById('edit_destination_ip_direct_'+(destinationCount+1)+'_mask').focus();
						return false;
					}
					
				} else {
					break;
				}
				destinationCount++;
			}
		}
		
		if (destinationCount > 0){
			for (var k =1; k <= destinationCount; k++){
				var destinationIP = '';
				var destinationIPMask = '';
				
				destinationIP = document.getElementById('edit_destination_ip_direct_'+k+'_ip').value;
				destinationIPMask = document.getElementById('edit_destination_ip_direct_'+k+'_mask').value;
				
				if (!destinationIP && !destinationIPMask){
					// SKIP
					continue;
				}
				
				for (var m =1; m <= destinationCount; m++){
					if (k == m)
						continue;
						
					var destinationIP2 = '';
					var destinationIPMask2 = ''; 
					
					if (document.getElementById('edit_destination_ip_direct_'+m+'_ip')){
						destinationIP2 = document.getElementById('edit_destination_ip_direct_'+m+'_ip').value;
						destinationIPMask2 = document.getElementById('edit_destination_ip_direct_'+m+'_mask').value;
						if (destinationIP == destinationIP2 && destinationIPMask == destinationIPMask2){
							alert(g_str_js_alert_arule_6);
							document.getElementById('edit_destination_ip_direct_'+k+'_ip').focus();
							return false;
						}
					}
				}
			}
		}
		
		var destinationIpBundleCount = 0;
		var destinationbundleName = '';
		while (true) {
			if (document.getElementById('edit_destination_ip_bundle_'+(destinationIpBundleCount+1))) {
				if (document.getElementById('edit_destination_ip_bundle_'+(destinationIpBundleCount+1)).checked) {
					destinationbundleName = document.getElementById('edit_destination_ip_bundle_'+(destinationIpBundleCount+1)).value;
					
					if (!destinationbundleName){
						destinationIpBundleCount++;
						continue;
					}
					
					destinationValidEntryCount++;
				}
			} else {
				break;
			}
			destinationIpBundleCount++;
		}
		
		if (destinationValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_20);
			// hard code
			document.getElementById('edit_destination_ip_bundle_1').focus();
			return false;
		}
		
	}
	
	// src port
	var sourcePortCount = 0;
	var sourcePortStart = 0;
	var sourcePortEnd = 0;
	var sourceProtocolNum = 0;
	var sourcePortValidEntryCount = 0;
	if (edit_source_protocol_type[1].checked){
		while (true) {
		
			if (document.getElementById('edit_source_protocolNum_'+(sourcePortCount+1))){
				sourceProtocolNum = document.getElementById('edit_source_protocolNum_'+(sourcePortCount+1)).value;
				
				if (sourceProtocolNum == "Not Selected"){
				}
				else if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
					if (document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_from')) {
						sourcePortStart = parseInt(document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_from').value);
						sourcePortEnd = parseInt(document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_to').value);
						if (!sourcePortStart && !sourcePortEnd){
							// SKIP
							sourcePortCount++;
							continue;
						}
						else if (sourcePortEnd < sourcePortStart || !sourcePortStart || !sourcePortEnd || !isInteger(sourcePortStart) || !isInteger(sourcePortEnd)){
							alert(g_str_js_alert_arule_7);
							if (!sourcePortEnd || !isInteger(sourcePortEnd))
								document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_to').focus();
							else
								document.getElementById('edit_source_port_'+(sourcePortCount+1)+'_from').focus();
							return false;
						}
					}
				}
				
			}
			else{
				break;
			}
			
			sourcePortCount++;
		}
		
		if (sourcePortCount > 0){
			for (var k =1; k <= sourcePortCount; k++){
				var sourceProtocolNum = 0;
				var sourcePortStart = 0;
				var sourcePortEnd = 0;
				var sourceSpecProtocolNum = 0;
				sourceProtocolNum = document.getElementById('edit_source_protocolNum_'+k).value;
				sourcePortStart = parseInt(document.getElementById('edit_source_port_'+k+'_from').value);
				sourcePortEnd = parseInt(document.getElementById('edit_source_port_'+k+'_to').value);
				sourceSpecProtocolNum = parseInt(document.getElementById('edit_source_specific_protocolNum_'+k).value);
				
				if (sourceProtocolNum == "Not Selected"){
					// SKIP
					continue;
				}
				else if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
					if (!sourcePortStart && !sourcePortEnd){
						// SKIP
						continue;
					}
				}
				else{
					if (!sourceSpecProtocolNum){
						// SKIP
						continue;
					}
				}
				
				sourcePortValidEntryCount++;
				
				for (var m =1; m <= sourcePortCount; m++){
					if (k == m)
						continue;
						
					var sourceProtocolNum2 = 0;
					var sourcePortStart2 = 0;
					var sourcePortEnd2 = 0;
					var sourceSpecProtocolNum2 = 0;
					sourceProtocolNum2 = document.getElementById('edit_source_protocolNum_'+m).value;
					sourcePortStart2 = parseInt(document.getElementById('edit_source_port_'+m+'_from').value);
					sourcePortEnd2 = parseInt(document.getElementById('edit_source_port_'+m+'_to').value);
					sourceSpecProtocolNum2 = parseInt(document.getElementById('edit_source_specific_protocolNum_'+m).value);
					
					if (sourceProtocolNum2 == "Not Selected"){
						// SKIP
						continue;
					}
					else if (sourceProtocolNum == sourceProtocolNum2){
						if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
							if (sourcePortStart == sourcePortStart2 && sourcePortEnd == sourcePortEnd2){
								alert(g_str_js_alert_arule_8);
								document.getElementById('edit_source_port_'+k+'_from').focus();
								return false;
							}
						}
						else {
							if (sourceSpecProtocolNum == sourceSpecProtocolNum2){
								alert(g_str_js_alert_arule_9);
								document.getElementById('edit_source_specific_protocolNum_'+k).focus();
								return false;
							}
						}
					}
				}
			}
		}
		
		if (sourcePortValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_21);
			// hard code
			document.getElementById('edit_source_protocolNum_1').focus();
			return false;
		}
		
	}
	
	// dest port
	var destinationPortCount = 0;
	var destinationPortStart = 0;
	var destinationPortEnd = 0;
	var destinationProtocolNum = 0;
	var destinationPortValidEntryCount = 0;
	if (edit_destination_protocol_type[1].checked){
		while (true) {
		
			if (document.getElementById('edit_destination_protocolNum_'+(destinationPortCount+1))){
				destinationProtocolNum = document.getElementById('edit_destination_protocolNum_'+(destinationPortCount+1)).value;
				
				if (destinationProtocolNum == "Not Selected"){
				}
				if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
				
					if (document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_from')) {
						destinationPortStart = parseInt(document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_from').value);
						destinationPortEnd = parseInt(document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_to').value);
						if (!destinationPortStart && !destinationPortEnd){
							// SKIP
							destinationPortCount++;
							continue;
						}
						else if (destinationPortEnd < destinationPortStart || !destinationPortStart || !destinationPortEnd || !isInteger(destinationPortStart) || !isInteger(destinationPortEnd) ){
							alert(g_str_js_alert_arule_7);
							if (!destinationPortEnd || !isInteger(destinationPortEnd))
								document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_to').focus();
							else
								document.getElementById('edit_destination_port_'+(destinationPortCount+1)+'_from').focus();
							return false;
						}
					}
				}
				
			}
			else{
				break;
			}
			
			destinationPortCount++;
		}
		
		if (destinationPortCount > 0){
			for (var k =1; k <= destinationPortCount; k++){
				var destinationProtocolNum = 0;
				var destinationPortStart = 0;
				var destinationPortEnd = 0;
				var destinationSpecProtocolNum = 0;
				destinationProtocolNum = document.getElementById('edit_destination_protocolNum_'+k).value;
				destinationPortStart = parseInt(document.getElementById('edit_destination_port_'+k+'_from').value);
				destinationPortEnd = parseInt(document.getElementById('edit_destination_port_'+k+'_to').value);
				destinationSpecProtocolNum = parseInt(document.getElementById('edit_destination_specific_protocolNum_'+k).value);
				
				if (destinationProtocolNum == "Not Selected"){
					// SKIP
					continue;
				}
				else if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
					if (!destinationPortStart && !destinationPortEnd){
						// SKIP
						continue;
					}
				}
				else{
					if (!destinationSpecProtocolNum){
						// SKIP
						continue;
					}
				}
				
				destinationPortValidEntryCount++;
				
				for (var m =1; m <= destinationPortCount; m++){
					if (k == m)
						continue;
						
					var destinationProtocolNum2 = 0;
					var destinationPortStart2 = 0;
					var destinationPortEnd2 = 0;
					var destinationSpecProtocolNum2 = 0;
					destinationProtocolNum2 = document.getElementById('edit_destination_protocolNum_'+m).value;
					destinationPortStart2 = parseInt(document.getElementById('edit_destination_port_'+m+'_from').value);
					destinationPortEnd2 = parseInt(document.getElementById('edit_destination_port_'+m+'_to').value);
					destinationSpecProtocolNum2 = parseInt(document.getElementById('edit_destination_specific_protocolNum_'+m).value);
					
					if (destinationProtocolNum2 == "Not Selected"){
						// SKIP
						continue;
					}
					else if (destinationProtocolNum == destinationProtocolNum2){
						if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
							if (destinationPortStart == destinationPortStart2 && destinationPortEnd == destinationPortEnd2){
								alert(g_str_js_alert_arule_8);
								document.getElementById('edit_destination_port_'+k+'_from').focus();
								return false;
							}
						}
						else {
							if (destinationSpecProtocolNum == destinationSpecProtocolNum2){
								alert(g_str_js_alert_arule_9);
								document.getElementById('edit_destination_specific_protocolNum_'+k).focus();
								return false;
							}
						}
					}
				}
			}
		}
		
		if (destinationPortValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_22);
			// hard code
			document.getElementById('edit_destination_protocolNum_1').focus();
			return false;
		}
		
	}
	
	// user
	var userCount = 0;
	var userValidEntryCount = 0;
	if (edit_user_spec[1].checked){
		while (true) {
			var userName = "";
			if (document.getElementById('edit_user_'+(userCount+1))){
				userName = document.getElementById('edit_user_'+(userCount+1)).value;
				
				if (userName != "Not Selected"){
					var tempCount = 0;
					
					userValidEntryCount++;
					
					while (true){
						if (userCount == tempCount){
							// SKIP
							tempCount++;
							continue;
						}
						if (!document.getElementById('edit_user_'+(tempCount+1))){
							break;
						}
						var userName2 = "";
						userName2 = document.getElementById('edit_user_'+(tempCount+1)).value;
						
						if (userName == userName2){
							alert(g_str_js_alert_arule_10);
							document.getElementById('edit_user_'+(userCount+1)).focus();
							return false;
						}
						tempCount++;
					}
				}
				
			}
			else{
				break;
			}
			
			userCount++;
		}
		
		if (userValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_23);
			// hard code
			document.getElementById('edit_user_1').focus();
			return false;
		}
	}
	
	// group
	var groupCount = 0;
	var groupValidEntryCount = 0;
	if (edit_group_spec[1].checked){
		while (true) {
			var groupName = "";
			if (document.getElementById('edit_group_'+(groupCount+1))){
				groupName = document.getElementById('edit_group_'+(groupCount+1)).value;
				
				if (groupName != "Not Selected"){
					var tempCount = 0;
					
					groupValidEntryCount++;
					
					while (true){
						if (groupCount == tempCount){
							// SKIP
							tempCount++;
							continue;
						}
						if (!document.getElementById('edit_group_'+(tempCount+1))){
							break;
						}
						var groupName2 = "";
						groupName2 = document.getElementById('edit_group_'+(tempCount+1)).value;
						
						if (groupName == groupName2){
							alert(g_str_js_alert_arule_11);
							document.getElementById('edit_group_'+(groupCount+1)).focus();
							return false;
						}
						tempCount++;
					}
				}
				
			}
			else{
				break;
			}
			
			groupCount++;
		}
		
		if (groupValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_24);
			// hard code
			document.getElementById('edit_group_1').focus();
			return false;
		}
		
	}
	
	// schedule
	if (edit_schedule_spec[1].checked){
		// special value store in javascript's variable(array)
		
		isNotEmpty = false;
		
		for (i=0; i<7; i++){
			for (j=0; j<24; j++){
				for (k=0; k<4; k++){
					if (scheduleArrayInEdit[i][j][k] == 1){
						isNotEmpty = true;
						break;
					}
				}
				if (isNotEmpty)
					break;
			}
			if (isNotEmpty)
				break;
		}
		
		if (!isNotEmpty){
			// none of valid entry
			alert(g_str_js_alert_arule_26);
			// hard code
			document.getElementById('edit_schedule_spec_1').focus();
			return false
		}
	}
	
	// web filter
	if (edit_web_filter_spec[1].checked){
		filterName = document.getElementById('edit_web_filter_1').value;
				
		if (filterName == "Not Selected" || filterName == ''){
			// none of valid entry
			alert(g_str_js_alert_arule_25);
			// hard code
			document.getElementById('edit_web_filter_1').focus();
			return false
		}
	}
	
	} // end with
		
    return true;
}

function grayOut(vis, options) {
  // Pass true to gray out screen, false to ungray
  // options are optional.  This is a JSON object with the following (optional) properties
  // opacity:0-100         // Lower number = less grayout higher = more of a blackout 
  // zindex: #             // HTML elements with a higher zindex appear on top of the gray out
  // bgcolor: (#xxxxxx)    // Standard RGB Hex color code
  // grayOut(true, {'zindex':'50', 'bgcolor':'#0000FF', 'opacity':'70'});
  // Because options is JSON opacity/zindex/bgcolor are all optional and can appear
  // in any order.  Pass only the properties you need to set.
  var options = options || {}; 
  var zindex = options.zindex || 50;
  var opacity = options.opacity || 70;
  var opaque = (opacity / 100);
  var bgcolor = options.bgcolor || '#000000';
  var dark=document.getElementById('darkenScreenObject');
  if (!dark) {
    // The dark layer doesn't exist, it's never been created.  So we'll
    // create it here and apply some basic styles.
    // If you are getting errors in IE see: http://support.microsoft.com/default.aspx/kb/927917
    var tbody = document.getElementsByTagName("body")[0];
    var tnode = document.createElement('div');           // Create the layer.
        tnode.style.position='absolute';                 // Position absolutely
        tnode.style.top='0px';                           // In the top
        tnode.style.left='0px';                          // Left corner of the page
        tnode.style.overflow='hidden';                   // Try to avoid making scroll bars            
        tnode.style.display='none';                      // Start out Hidden
        tnode.id='darkenScreenObject';                   // Name it so we can find it later
    tbody.appendChild(tnode);                            // Add it to the web page
    dark=document.getElementById('darkenScreenObject');  // Get the object.
  }
  if (vis) {
    // Calculate the page width and height 
    if( document.body && ( document.body.scrollWidth || document.body.scrollHeight ) ) {
        var pageWidth = document.body.scrollWidth+'px';
        var pageHeight = document.body.scrollHeight+'px';
    } else if( document.body.offsetWidth ) {
      var pageWidth = document.body.offsetWidth+'px';
      var pageHeight = document.body.offsetHeight+'px';
    } else {
       var pageWidth='100%';
       var pageHeight='100%';
    }   
    //set the shader to cover the entire page and make it visible.
    dark.style.opacity=opaque;                      
    dark.style.MozOpacity=opaque;                   
    dark.style.filter='alpha(opacity='+opacity+')'; 
    dark.style.zIndex=zindex;        
    dark.style.backgroundColor=bgcolor;  
    dark.style.width= pageWidth;
    dark.style.height= pageHeight;
    dark.style.display='block';                          
  } else {
     dark.style.display='none';
  }
}

function rule_changeProtocolNumInEdit(entryType, id) {
	var entryTypeStr = entryType == 'source' ? 'edit_source' : 'edit_destination';
	var protoNum= document.getElementById(entryTypeStr+'_protocolNum_'+id).value;
	
	document.getElementById(entryTypeStr+'_specific_protocolNum_'+id).disabled = false;
	document.getElementById(entryTypeStr+'_specific_protocolNum_'+id).style.background = '#FFFFFF';
	document.getElementById(entryTypeStr+'_port_'+id+'_from').disabled = false;
	document.getElementById(entryTypeStr+'_port_'+id+'_from').style.background = '#FFFFFF';
	document.getElementById(entryTypeStr+'_port_'+id+'_to').disabled = false;
	document.getElementById(entryTypeStr+'_port_'+id+'_to').style.background = '#FFFFFF';
	
	if (protoNum == "Not Selected"){
		document.getElementById(entryTypeStr+'_specific_protocolNum_'+id).disabled = true;
		document.getElementById(entryTypeStr+'_specific_protocolNum_'+id).style.background = '#DDDDDD';
		document.getElementById(entryTypeStr+'_port_'+id+'_from').disabled = true;
		document.getElementById(entryTypeStr+'_port_'+id+'_from').style.background = '#DDDDDD';
		document.getElementById(entryTypeStr+'_port_'+id+'_to').disabled = true;
		document.getElementById(entryTypeStr+'_port_'+id+'_to').style.background = '#DDDDDD';
	}
	else if (protoNum == 6 || protoNum == 17){ // TCP or UDP
		document.getElementById(entryTypeStr+'_proto_row_'+id).style.display = 'none';
		document.getElementById(entryTypeStr+'_port_row_'+id).style.display = '';
	}
	else{
		document.getElementById(entryTypeStr+'_proto_row_'+id).style.display = '';
		document.getElementById(entryTypeStr+'_port_row_'+id).style.display = 'none';
	}
}

function resetIPBundle(entryType) {
	entryType = entryType == 'source' ? 'edit_source' : 'edit_destination';
	
	var ipBundleOptCount = 1;
	while (true) {
		if (document.getElementById(entryType+'_ip_bundle_'+ipBundleOptCount)) {
			var optionValue = document.getElementById(entryType+'_ip_bundle_'+ipBundleOptCount).value;
			
			if (!optionValue){
				break;
			}
			
			document.getElementById(entryType+'_ip_bundle_'+ipBundleOptCount).checked = false;
		} else {
			break;
		}
		ipBundleOptCount++;
	}
	
	enableDisableByClicking(false, entryType+'_ip_bundle');
}
