// NAT Script
function showNAT(showTxt, hideTxt)
{
    if(document.getElementById("ipPoolButton").value == showTxt)
    	document.getElementById("ipPoolButton").value = hideTxt;
    else
    	document.getElementById("ipPoolButton").value = showTxt;
    
    // if(document.getElementById("NatAddrRange").style.display == "none")
    	// document.getElementById("NatAddrRange").style.display = "";
    // else
    	// document.getElementById("NatAddrRange").style.display = "none";
}

function SwitchNAT(instance)
{
	if(instance.value == 1) {
		// document.all.proxyARP_enabled[0].checked = false;
        // document.all.proxyARP_enabled[1].checked = true;
        // document.all.proxyARP_enabled[0].disabled = true;
        // document.all.proxyARP_enabled[1].disabled = true;
		document.getElementById("NatModuleRowSep").style.display = "";
		document.getElementById("NatModuleRow").style.display = "";
		document.getElementById("NatRadioButtonsSep").style.display = "";
        document.getElementById("NatRadioButtons").style.display = "";
        
        if(document.all.nat_option[1].checked)
        	NatOption(document.all.nat_option[1]);
        // else if(document.all.nat_option[2].checked)
        	// NatOption(document.all.nat_option[2]);
    }
	else {
        // document.all.proxyARP_enabled[0].disabled = false;
        // document.all.proxyARP_enabled[1].disabled = false;
		document.getElementById("NatModuleRowSep").style.display = "none";
		document.getElementById("NatModuleRow").style.display = "none";
		document.getElementById("NatRadioButtonsSep").style.display = "none";
        document.getElementById("NatRadioButtons").style.display = "none";
        NatOption(0);
    }
		
}

function NatOption(instance)
{
	if(instance.value == 1) {
		// document.getElementById('NatAddrRange').style.display = '';
		document.getElementById('NatPortMapping').style.display = 'none';
	}
	else if(instance.value == 2) {
		// document.getElementById('NatAddrRange').style.display = 'none';
		document.getElementById('NatPortMapping').style.display = '';
	}
	else {
		document.getElementById('NatPortMapping').style.display = 'none';
		// document.getElementById('NatAddrRange').style.display = 'none';
	}
}

//NAT Port Forwarding
function addPortMap()
{
    oForm = document.c_Nat;
    
    if(!checkIP(oForm.NAT_port_ip1.value,oForm.NAT_port_ip2.value,oForm.NAT_port_ip3.value,oForm.NAT_port_ip4.value)) {
    	alert('Invalid IP address!');
    	return false;
	}
	
	if (oForm.NAT_external_port.value >65535 || 0> oForm.NAT_external_port.value || oForm.NAT_internal_port.value >65535 || 0> oForm.NAT_internal_port.value){
		alert('Invalid port number');
    	return false;
	}

    // 20080320 - External port checking
    oTagTable = window.frames.framePortMap.document.getElementsByTagName("table");
    for (i = 0; i < oTagTable.length; i++) {
	if (oTagTable[i].getAttribute("id") == "tablePortMap") {
	    errPubPort = oTagTable[i].getAttribute("errPubPort");
	}
    }
    oTagTr = window.frames.framePortMap.document.getElementsByTagName("tr");
    for (i = 0; i < oTagTr.length; i++) {
	if (oTagTr[i].getAttribute("id") == "portId" && oTagTr[i].getAttribute("value") == oForm.NAT_external_port.value) {
	    alert(errPubPort);
	    return false;
	}
    }
    
    var formValue = new Array(8);
    formValue[0] = "NAT_port_ip1="+oForm.NAT_port_ip1.value;
    formValue[1] = "NAT_port_ip2="+oForm.NAT_port_ip2.value;
    formValue[2] = "NAT_port_ip3="+oForm.NAT_port_ip3.value;
    formValue[3] = "NAT_port_ip4="+oForm.NAT_port_ip4.value;
    
    formValue[4] = "NAT_internal_port="+oForm.NAT_internal_port.value;
    formValue[5] = "NAT_external_port="+oForm.NAT_external_port.value;
    
    if(oForm.NAT_proto_tcp.checked)
    	formValue[6] = "NAT_proto_tcp="+oForm.NAT_proto_tcp.value;
    	
   	if(oForm.NAT_proto_udp.checked)
    	formValue[7] = "NAT_proto_udp="+oForm.NAT_proto_udp.value;
    
    urlenStr = formValue.join("&");
   	
    window.frames.framePortMap.location = "framePortMap.php?"+urlenStr;
    
    return false;
}

function deletePortMap()
{
    objEntry = window.frames.framePortMap.document.getElementsByName("entry");
    
    var j=0;
    var entry = new Array();
    var deleteStr = null;
    
    for (i=0; i<objEntry.length; i++) {
        if (objEntry[i].checked==true){
            entry[j]=i;
            j++;
        }
    }
        
   	deleteStr = entry.join(",");
    
    if(deleteStr == null || deleteStr == '' )
        return;
    
    document.getElementById("NAT_portmap_deleteTxt").style.display = "";
    window.frames.framePortMap.location = "framePortMap.php?delete="+deleteStr;
}

// NAT Script End

// Common script for NAT & Proxy ARP
function selectAll(obj)
{
    for (i=0; i<obj.length; i++)
        obj[i].checked = (obj[i].disabled)?false:true;
            
    return false;
}

function selectClear(obj)
{   
    for (i=0; i<obj.length; i++)
        obj[i].checked = false;
        
    return false;
}

function ip2long(ip1, ip2, ip3, ip4)
{
	iplong1 = ip1 * 0x1000000;
	iplong2 = ip2 * 0x10000;
	iplong3 = ip3 * 0x100;
    // 20080206 - Bug fix (0x1)
    iplong4 = ip4 * 0x1;
	
	return iplong1+iplong2+iplong3+iplong4;
}

// 20100622 - UI changes from the choice of NAT module
function NATModuleOpt(instance)
{
	// if (instance.value == 1) {
		// if (document.c_Nat.nat_option[1].checked) {
			// document.c_Nat.nat_option[1].checked = false;
			// document.c_Nat.nat_option[0].checked = true;
			// NatOption(document.c_Nat.nat_option);
		// }
		// document.c_Nat.nat_option[1].disabled = true;
	// } else if (document.c_Nat.nat_option[0].disabled == false && document.c_Nat.nat_option[2].disabled == false) {
		// document.c_Nat.nat_option[1].disabled = false;
	// }
}
