<?php

require_once "eg_lang.php";
require_once "common_functions.php";
require_once 'generate_common.php';

$settingobj = new COM('EGCONFIG.Cfgmgr') or die('blocked_notice.php EGCONFIG.Cfgmgr Object cannot be created!');
$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
// for testing hard code
$blocked_port="5803";
$blocked_port2="5805";
$settingobj = null;

$BLOCKED_MSG = "";

// 20081219 - Determine using message from Client Blacklist or IP Block List
if (isset($wfCase) && $wfCase > 0){
	$sub_b_msg = "";
	if (isset($bweb) && $bweb != ""){
		// $sub_b_msg = "<br/>".$bweb;
		$sub_b_msg = "<a href='http://$bweb'>$bweb</a><br/>";
	}
	$BLOCKED_MSG = $sub_b_msg.get_var('block_client_blacklist')." (Web Filter)";
}
else if (isset($bClient) && $bClient == 1) {
	$sub_b_msg = "";
	if (isset($bweb) && $bweb != ""){
		// $sub_b_msg = "<br/>".$bweb;
		$sub_b_msg = "<a href='http://$bweb'>$bweb</a><br/>";
	}
    $BLOCKED_MSG = $sub_b_msg.get_var('block_client_blacklist');
} 
else if (isset($bClient) && $bClient == 3) {
	$sub_b_msg = "";
	if (isset($bweb) && $bweb != ""){
		// $sub_b_msg = "<br/>".$bweb;
		$sub_b_msg = "<a href='http://$bweb'>$bweb</a><br/>";
	}
    $BLOCKED_MSG = $sub_b_msg.get_var('block_ip_block_list');
}
else if (isset($bClient) && $bClient == 4) {
	$sub_b_msg = "";
	if (isset($bweb) && $bweb != ""){
		// $sub_b_msg = "<br/>".$bweb;
		$sub_b_msg = "<a href='http://$bweb'>$bweb</a><br/>";
	}
	$BLOCKED_MSG = $sub_b_msg.get_var('block_client_blacklist')." (Hit max concurrent user limit)";
} 
else {
	$sub_b_msg = "";
	// print_r($_SERVER);exit();
	
	if (!isset($bweb) && !(isset($_SERVER['HTTP_HOST']) && ($_SERVER['HTTP_HOST'] == $ip_address.":".$blocked_port || $_SERVER['HTTP_HOST'] == $ip_address.":".$blocked_port2))){
		// $sub_b_msg = "<br/>".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_URL'];
		if (isset($_SERVER['SCRIPT_URL']))
			$sub_b_msg = "<a href='http://".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_URL']."'>".$_SERVER['HTTP_HOST'].$_SERVER['SCRIPT_URL']."</a><br/>";
		else
			$sub_b_msg = "<a href='http://".$_SERVER['HTTP_HOST']."'>".$_SERVER['HTTP_HOST']."</a><br/>";
	}
    $BLOCKED_MSG = $sub_b_msg.get_var('block_ip_block_list');
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <?=metaCharset()?>
    <title><?=get_var('blocked_title')?></title>
    <?=$j_common?>
</head>

<body>
    <div class="header">
	<?php include "header.htm"?>
    </div>
    <div class="contents">
	<span class="failloginspan"><?=$BLOCKED_MSG?></span>
    </div>
    <div class="footer">
	<?php include "footer.htm"?>
    </div>
</body>
</html>