<?php
    /*
     *  To add a field for a user
     *  A. Update user tab
     *    1. Add HTML element in 'userinfoform' and 'addform'
     *    2. Update javascript:
     *      -changeUser() //add displayArray[]
     *      -displayInfo() //add argument, set value according to argument 
     *      -clearAddformData() //set default value
     *      -validate_ue() // in validate.php if field validation needed
     *      -validate_ua() // in validate.php if field validation needed
     *    3. Update makeUserDetailFromODBCResult() in common_functions.php
     *    4. Update editUser.php to save user data in both add and edit mode
     *
     *  B. Update plan tab
     *    1. Add HTML element in plan
     *    2. Update settingok.php
     *    3. Update loadPlans.php
     *    4. Update javascript
     *      -clearPlan() in plan.js
     *
     *  C. Update bulk account
     *    1. settingok.php
     *
     *  D. Update advanced search user form if needed
     *    1. Steps can be found in searchUser.js
     */
?>
    <script type="text/javascript" src="./javascript/loadingBox.js"></script>
    <script type="text/javascript">
	var ns=(document.layers);
	var ie=(document.all);
	var w3=(document.getElementById && !ie);
	
	function initSavebtn(){
		if(!ns && !ie && !w3) return;
		if(ie) addSaveDiv=eval('document.all.AddSavebtn.style');
		else if(ns) addSaveDiv=eval('document.layers["AddSavebtn"]');
		else if(w3) addSaveDiv=eval('document.getElementById("AddSavebtn").style');
		
		if(ie) editSaveDiv=eval('document.all.saveBtn.style');
		else if(ns) editSaveDiv=eval('document.layers["saveBtn"]');
		else if(w3) editSaveDiv=eval('document.getElementById("saveBtn").style');
		
	    // 20071112 - Must init position of loading box here as only allow 1 init function
	    if (ie) {
		loadingBoxDiv = eval('document.all.loadingBox.style');
	    } else if (ns) {
		loadingBoxDiv = eval('document.layers["loadingBox"]');
	    } else if (w3) {
		loadingBoxDiv = eval('document.getElementById("loadingBox").style');
	    }

		showAddSavebtn();
		showEditSavebtn();

	    // 20071112 - Must set position of loading box here as only allow 1 init function
	    ShowLoadingBox();
	}

	function showAddSavebtn(){
		//var addFormHeight_ie = 1480
		//var addFormHeight_mozilla = 1420
		var addFormHeight = document.exportUsageform.exportLog.offsetParent.offsetTop - 10;
		
		// 20071109 - Adjust vertical position
		if (ie){
			documentWidth =document.body.offsetWidth - 220;
			documentHeight =document.body.offsetHeight+document.body.scrollTop-50;
		}
		else if (ns){
			documentWidth=window.innerWidth - 230;
			documentHeight=window.innerHeight+window.pageYOffset-50;
		}
		else if (w3){
			documentWidth=self.innerWidth - 230;
			documentHeight=self.innerHeight+window.pageYOffset-50;
		}
		
		addSaveDiv.left=600;
		addSaveDiv.left=documentWidth;
		
		if (documentHeight>addFormHeight)
			addSaveDiv.top = addFormHeight;
		else
			addSaveDiv.top =documentHeight;
		
		setTimeout("showAddSavebtn()",100);
	}
	
	function showEditSavebtn(){
		//var editFormHeight_ie = 1720;
		//var editFormHeight_mozilla = 1690;
		var editFormHeight = document.exportUsageform.exportLog.offsetParent.offsetTop - 10;
		
		// 20071109 - Adjust vertical position
		if (ie){
			documentWidth =document.body.offsetWidth - 220;
			documentHeight =document.body.offsetHeight+document.body.scrollTop-50;
		}
		else if (ns){
			documentWidth=window.innerWidth - 230;
			documentHeight=window.innerHeight+window.pageYOffset-50;
		}
		else if (w3){
			documentWidth=self.innerWidth - 230;
			documentHeight=self.innerHeight+window.pageYOffset-50;
		}
		
		editSaveDiv.left=600;
		editSaveDiv.left=documentWidth;
		if (documentHeight>editFormHeight)
			editSaveDiv.top = editFormHeight;
		else
			editSaveDiv.top =documentHeight;
		
		setTimeout("showEditSavebtn()",100);
	}

	// 20080318 - Fix position shown in Firefox
	// 20071112 - Control the position of loading box
	function ShowLoadingBox() {
	    if (ie) {
		documentHeight = document.body.scrollTop;
	    } else if (ns) {
		documentHeight = window.innerHeight + window.pageYOffset - 50;
	    } else if (w3) {
		documentHeight = self.pageYOffset;
	    }
	    loadingBoxDiv.right = 0;
	    loadingBoxDiv.top = documentHeight;
	    setTimeout("ShowLoadingBox()", 100);
	}
	</script>
<?php
    if (isset($searchUser)) { //Search user mode
        $allUserTabClass = "allUserTabInactive";
        if ($searchUser == "frmSimple") {
            //Simple search mode
            $simpleSearchTabClass = "simpleSearchTabActive";
            $simpleSearchTabHref = "#";
            $simpleSearchTabOnclick = "showSearch('frmSimple')";
            $advancedSearchTabClass = "advancedSearchTabInactive";
            $advancedSearchTabHref = "setcfg.php?category=u&searchUser=frmAdvanced";
            $advancedSearchTabOnclick = "";
            $stopOnclick = "stopSearch('frmSimple')";
        } else if ($searchUser=="frmAdvanced") {
            //Advaned search mode
            $simpleSearchTabClass = "simpleSearchTabInactive";
            $simpleSearchTabHref = "setcfg.php?category=u&searchUser=frmSimple";
            $simpleSearchTabOnclick = "";
            $advancedSearchTabClass = "advancedSearchTabActive";
            $advancedSearchTabHref = "#";
            $advancedSearchTabOnclick = "showSearch('frmAdvanced')";
            $stopOnclick = "stopSearch('frmAdvanced')";
        }
    } else {
        //All users mode
        $allUserTabClass = "allUserTabActive";
        $simpleSearchTabClass = "simpleSearchTabInactive";
        $simpleSearchTabHref = "setcfg.php?category=u&searchUser=frmSimple";
        $simpleSearchTabOnclick = "";
        $advancedSearchTabClass = "advancedSearchTabInactive";
        $advancedSearchTabHref = "setcfg.php?category=u&searchUser=frmAdvanced";
        $advancedSearchTabOnclick = "";
        $stopOnclick = "stopSearch()";
        echo "<script type='text/javascript'>onload=initSavebtn;</script>";
    }//end if isset($searchUser)
?>
    <!-- loading box -->
    <div id="loadingBox" class="loadingBoxBright" style="position:absolute; z-index:100;"> 
        <div id="loadingBoxText"></div>
        <a id="btn_Stop" class="stop" onclick="<?=$stopOnclick?>">
            <?=get_cm_var('setcfg_users_stop')?>
        </a>
    </div>
    <script type="text/javascript">
		var userText = "<?=get_cm_var('setcfg_users_user_name')?>";
		var macText = "<?=get_cm_var('setcfg_users_user_mac')?>";
		var ipText = "<?=get_cm_var('setcfg_users_user_ip')?>";
		var cnText = "<?=get_cm_var('setcfg_users_user_cn')?>";
	
        //Purpose of glo_Message is to allow javascript function to get data from php
        //to prevent too many javascript function being embeded inside php file.
        var glo_Message = new Object();
        glo_Message.setcfg_users_loading = "<?=get_cm_var('setcfg_users_loading')?>"; //string for loading box
        glo_Message.setcfg_users_deleting = "<?=get_cm_var('setcfg_users_deleting')?>"; //string for loading box
        callLoadingBox(true,true); //show loading box with stop button
    </script>
    <!-- Need to split javascript here to make loading box and the three tabs below to show up immediately -->

    <div class="userHeader">
        <a id="allUserTab" class="<?=$allUserTabClass?>" href="setcfg.php?category=u">
            <?=get_cm_var('setcfg_users_search_alluser')?></a>
        <a id="simpleSearchTab" class="<?=$simpleSearchTabClass?>" href="<?=$simpleSearchTabHref?>" onclick="<?=$simpleSearchTabOnclick?>">
            <?=get_cm_var('setcfg_users_search_simplesearch')?></a>
        <a id="advancedSearchTab" class="<?=$advancedSearchTabClass?>" href="<?=$advancedSearchTabHref?>" onclick="<?=$advancedSearchTabOnclick?>">
            <?=get_cm_var('setcfg_users_search_advancedsearch')?></a>

    <script type="text/javascript">
        glo_Message.js_alert_users_20 = "<?=get_cm_var('js_alert_users_20')?>"; //string for calladdform()
        glo_Message.js_alert_users_18 = "<?=get_cm_var('js_alert_users_18')?>"; //string for warnEditTimeLeft()
        glo_Message.js_alert_users_19 = "<?=get_cm_var('js_alert_users_19')?>"; //string for warnEditQuota()
        glo_Message.js_users_search_form_validation_error = "<?=get_cm_var('js_users_search_form_validation_error')?>"; //string for form validateion warnning
        glo_Message.setcfg_date_format = "<?=get_cm_var('setcfg_date_format')?>"; //string for date format
        glo_Message.setcfg_time_format = "<?=get_cm_var('setcfg_time_format')?>"; //string for time format
        glo_Message.js_users_search_form_validation_integer = "<?=get_cm_var('js_users_search_form_validation_integer')?>";
        glo_Message.js_users_search_form_validation_integer = "<?=get_cm_var('js_users_search_form_validation_integer')?>";
        glo_Message.js_users_search_form_validation_date = "<?=get_cm_var('js_users_search_form_validation_date')?>";
        glo_Message.js_users_search_form_validation_time = "<?=get_cm_var('js_users_search_form_validation_time')?>";
		glo_Message.setcfg_data_transfer_remind = "<?=get_cm_var('setcfg_data_transfer_remind')?>";
		glo_Message.setcfg_users_export_and_clear_userlog_confirm = "<?=get_cm_var('setcfg_users_export_and_clear_userlog_confirm')?>";
		glo_Message.setcfg_users_exportuserlog_confirm = "<?=get_cm_var('setcfg_users_exportuserlog_confirm')?>";
	</script>

<?php
    if (isset($searchUser)) { //only have 'show search' button in search user mode
?>
        <input type="button" id="btn_showSearch" value="<?=get_cm_var('setcfg_users_search_showsearch')?>" class="btn_showSearch" onclick="showSearch('<?=$searchUser?>')"/>
        
<?php
    } //end 'show search' button
?>
    </div> <!-- end userHeader -->
<?php
    if (isset($searchUser)) { //include search form in search user mode
        include("searchForm.php");
    } //end include search form in search user mode

    if (!isset($searchUser) || isset($searchFormData)) {
        /* Only show user detail during all user mode or a search is submitted */
		
		// treat as trial
		$arrJavascriptVariable['glo_version'] = "'trial'";

        //output version as global javascript variable
        echo "<script type=\"text/javascript\">\n";
        echo "//version of EaseGate\n";
        foreach ($arrJavascriptVariable as $key=>$value) {
            echo "$key = $value;\n";
        }
        echo "</script>\n";

        gen_head();  
?>

  <tr>
    <td width="100%" colspan="5" valign="top" height="5"><img src="./images/blank.gif" border="0" width="3" height="5"></td>
  </tr>  

  <tr valign="top">

    <td width="40%">&nbsp;</td>
    <td width="220">
        <p class="captionbig">
<?php
    //Show different word above the selection box
    if (isset($searchFormData)) {
        echo "<br>".get_cm_var('setcfg_users_search_result');
    } else {
        echo "<br>".get_cm_var('setcfg_users_existing_users');
    }
?>

        </p>
    <span style="font-family:Tahoma;">
    <font size="2"><?=get_cm_var('setcfg_users_select')?>&nbsp;</font> 
    <a href="#" onclick="selectAllUser();"><font size="2" color="blue"><?=get_cm_var('setcfg_users_select_all')?></font></a>&nbsp;
    <a href="#" onclick="selectNoneUser();"><font size="2" color="blue"><?=get_cm_var('setcfg_users_select_none')?></font></a><br><br>
    </span>

<?php
    if(!session_id())
        session_start();

    include('users.php');
?>
    <form name="userControlForm" action="setcfg.php?category=u" method="post">
        <img src="./images/double_left.gif" vspace="10" width="14" height="8" border="0" align="left" style="cursor:pointer;cursor:hand;" onclick="changePage('first')" title="First page">
        <img src="./images/left.gif" vspace="10" width="8" height="8" border="0" align="left" style="cursor:pointer;cursor:hand;" onclick="changePage('previous')" title="Previous 1000">
        <img src="./images/double_right.gif" vspace="10" width="14" height="8" border="0" align="right" style="cursor:pointer;cursor:hand;" onclick="changePage('last')" title="Last page">
        <img src="./images/right.gif" vspace="10" width="8" height="8" border="0" align="right" style="cursor:pointer;cursor:hand;" onclick="changePage('next')" title="Next 1000">&nbsp;
        <select id="curr" name="currentPage"  style="text-align:top; border:0px solid #99D1A2;font-size:0.7em; color:#003300;" onChange="changePage(this.selectedIndex)">
            <option value="">
        </select><EM>of</EM>&nbsp;
        <input type="text" name="sumofpage" value="" disabled style="width: 3em;text-align:top; border:0px;font-size:0.7em; color:#003300;">
        <input type="hidden" name="page" value="">
    </form> <!-- userControlForm -->
    </td>
    
    <td width="10">&nbsp;</td>
   
    <td width="500" rowspan="3" valign="top">

<?php
        if (!isset($searchUser) || $searchUser=="") { //only show add button in all user mode
?>
        <input type="button" id="addUserBtn" name="addUserBtn" title="<?=get_cm_var('setcfg_users_btn_add_title')?>" value="<?=get_cm_var('setcfg_users_btn_add')?>" class="graphicBtn" onClick="callAddform('normal')" />
<?php
        }
?>
        <input type='button' id='editUserBtn' value='<?=get_cm_var('setcfg_users_btn_edit')?>' title='<?=get_cm_var('setcfg_users_btn_edit_title')?>' class='graphicBtn' onClick='switchToEditMode();' />
        <input type="button" id="deleteUserBtn" value="<?=get_cm_var('setcfg_users_btn_delete')?>" title="<?=get_cm_var('setcfg_users_btn_delete_title');?>" class="graphicBtn" onClick="deleteUser()" />
        <input type="button" id="resetquotaBtn" class="graphicBtn" value="<?=get_cm_var('setcfg_users_btn_reset_quota')?>" title="<?=get_cm_var('setcfg_users_btn_reset_quota')?>" onmouseenter="initDropinQuota()" onmouseover="initDropinQuota()" onmouseout="hideDropinQuota()" onmouseleave="hideDropinQuota()" onclick="resetQuota()" />
        <input type="button" id="refresh_btn" name="refresh_btn" value="<?=get_cm_var('setcfg_users_btn_label_refresh')?>" title="<?=get_cm_var('setcfg_users_btn_label_refresh_title')?>" class="graphicBtn" onClick="window.location='setcfg.php?category=u'" />

    <!-- Add user layer -->
    <div id="adduser" style="display:none;">
    <form name="addform"> <!-- add new user form, for both prepaid and normal user -->
    <fieldset id="testing" style="border: 1px solid #99D1A2; padding: 5px;">
      <legend class="captionbig" style="color: green; padding: 0px 10px;"><?=get_cm_var('setcfg_users_add_new_user')?></legend>
      
      <input type="hidden" name="copy_addname" value="">
      <input type="hidden" name="copy_password" value="">
      <input type="hidden" name="copy_confirmpass" value="">
      
      <input type="hidden" name="copy_add_acc_enable" value="">
      <input type="hidden" name="copy_add_acc_disable" value="">
      
      <input type="hidden" name="addMode" value=""> 
      <input type="hidden" name="save_u" value="true"> 
      <input type="hidden" name="add" value=""> 
      <input type="hidden" name="page" value="1">    
      <input type="hidden" name="noOfPage" value="1">
      
    <script type="text/javascript" src="./javascript/ua.js"></script>

      <table width="500" border="0" cellspacing="0" cellpadding="0">

        <tr><td colspan="2">&nbsp;</td></tr>

    <!-- Rand User -->
    <?php
    //Marco
        $settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');  
    ?>
        <tr id="row_usrname">
          <td class="captionbig" valign="top"><div id="userTitleText"><?=get_cm_var('setcfg_users_user_name')?></div></td>
  
          <td class="captionbig">
          		<!--Normal username-->
              <div id="usr_name"><input type="text" name="addname" value="" onKeyPress="return noSpecialCharacters(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;"></div>
              <!--Mac as username-->
              <div id="usr_mac" style="display: none;">
                <input class="IPtextbox" type="text" name="userMACaddr1" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr2')" onChange="this.value=this.value.toUpperCase()" style="width:25px" >-
                <input class="IPtextbox" type="text" name="userMACaddr2" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr3')" onChange="this.value=this.value.toUpperCase()" style="width:25px" >-
                <input class="IPtextbox" type="text" name="userMACaddr3" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr4')" onChange="this.value=this.value.toUpperCase()" style="width:25px" >-
                <input class="IPtextbox" type="text" name="userMACaddr4" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr5')" onChange="this.value=this.value.toUpperCase()" style="width:25px" >-
                <input class="IPtextbox" type="text" name="userMACaddr5" maxlength="2" onKeyPress="return hexnumbersonly(this,event,'userMACaddr6')" onChange="this.value=this.value.toUpperCase()" style="width:25px" >-
                <input class="IPtextbox" type="text" name="userMACaddr6" maxlength="2" onKeyPress="return hexnumbersonly(this,event)" onChange="this.value=this.value.toUpperCase()" style="width:25px" >
              </div>
              <!--IP as username-->
              <div id="usr_ip" style="display: none;">
                <input class="IPtextbox" type="text" name="userIPaddr1" maxlength="3" onKeyPress="return numbersonly(this,event,'userIPaddr2')" onChange="this.value=this.value.toUpperCase()" style="width:30px" >.
                <input class="IPtextbox" type="text" name="userIPaddr2" maxlength="3" onKeyPress="return numbersonly(this,event,'userIPaddr3')" onChange="this.value=this.value.toUpperCase()" style="width:30px" >.
                <input class="IPtextbox" type="text" name="userIPaddr3" maxlength="3" onKeyPress="return numbersonly(this,event,'userIPaddr4')" onChange="this.value=this.value.toUpperCase()" style="width:30px" >.
                <input class="IPtextbox" type="text" name="userIPaddr4" maxlength="3" onKeyPress="return numbersonly(this,event)" onChange="this.value=this.value.toUpperCase()" style="width:30px" ><br>
              </div>
			  <div id="macipWarnText"><span style="font-weight:normal;"><?=get_cm_var('setcfg_users_use_macip_warn1')?></span></div>
			  <br/>
          </td>
          
        <!--username Type-->
        <tr valign="top" id="row_usermac">
	        <td class="captionbig"><?=get_cm_var('setcfg_users_user_name_type')?></td>
	        <td class="captionbig">
	        &nbsp;<input type="radio" name="add_name_mode" value="0" onClick="addNameMode('0');" ><?=get_cm_var('setcfg_users_use_normal')?><br>
      		&nbsp;<input type="radio" name="add_name_mode" value="4" onClick="addNameMode('4');" ><span class = "captionbig"><?=get_cm_var('setcfg_users_passive_login')?></span><br/>
		    <br/>
	        </td>
        </tr>
        
        <tr valign="top" id="row_usrpwd">
			<input type="hidden" name="scratch_mode" value="0">
          <td class="captionbig"><?=get_cm_var('setcfg_users_password')?></td>
          <td class="captionbig"><input type="password" name="password" value="" class="passwordbox" style="width:150px; font-weight:bold; color:#003300;"></td>       
        </tr>
        <tr valign="top" id="row_confirmpass">
          <td class="captionbig"><?=get_cm_var('setcfg_users_confirm_pwd')?></td>
          <td class="captionbig"><input type="password" name="confirmpass" value="" class="passwordbox" style="width:150px; font-weight:bold; color:#003300;"></td>   
        </tr>

        <tr><td colspan="2">&nbsp;</td></tr>

        <tr valign="top">
          <td class="captionbig"><?=get_cm_var('setcfg_users_account_status')?></td>
          <td class="captionbig">
            <input type="radio" name="add_acc_enable" value="0" onClick="addaccparam('0')" checked><?=get_cm_var('setcfg_users_account_status_enabled')?><br>
            <input type="radio" name="add_acc_disable" value="1" onClick="addaccparam('1')"><?=get_cm_var('setcfg_users_account_status_disabled')?>
          </td>
        </tr>

        <tr><td colspan="2">&nbsp;</td></tr>

        <tr valign="top">
            <td width="35%" valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bt')?></td>
            <td width="65%" class="captionbig">
            <input type="radio" name="add_bt_mode" value="0" onClick="addrbtn('0');" ><?=get_cm_var('setcfg_users_no_throttling')?><br>
            <input type="radio" name="add_bt_mode" value="1" onClick="addrbtn('1');" ><?=get_cm_var('setcfg_users_low')?> (~<?=$bt_num_low?> KBytes/s)<br>
            <input type="radio" name="add_bt_mode" value="2" onClick="addrbtn('2');" ><?=get_cm_var('setcfg_users_medium')?> (~<?=$bt_num_medium?> KBytes/s)<br>
            <input type="radio" name="add_bt_mode" value="3" onClick="addrbtn('3');" ><?=get_cm_var('setcfg_users_high')?> (~<?=$bt_num_high?> KBytes/s)<br>
            <input type="radio" name="add_bt_mode" value="4" onClick="addrbtn('4');" checked ><?=get_cm_var('setcfg_users_use_global_setting')?><br>
            <input class="textbox" type="radio" name="add_bt_mode" value="5" onClick="addrbtn('5');" ><?=get_cm_var('setcfg_users_upload')?> <br>
            <input type="text" name="user_bt_num_add" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" ><br>&nbsp;<?=get_cm_var('setcfg_users_download')?> <br>
            <input type="text" name="user_bt_num_add_dl" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" ><br></td>
        </tr>

        <tr><td colspan="2">&nbsp;</td></tr>

        <?php /***************************************** UPLOAD REPORT(ADD) ***********************************/ ?>
        <tr><td colspan="2" class="captionbig">UPLOAD</td></tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
            <td valign="top" class="captionbig">
            <input type="radio" name="bwcountUL" value="-1" onClick="addBwparamUL('-1')"><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="bwcountUL" value="0" onClick="addBwparamUL('0')" checked><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="bwcountUL" value="1" onClick="addBwparamUL('1')" ><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="bwcountUL" value="2" onClick="addBwparamUL('2')" ><font id="ua_bwcountUL_color"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></font><br></td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <input type="text" name="bwquotaUL" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" disabled></td>
        </tr>
        <tr><td colspan="2">&nbsp;</td></tr>

        <?php /***************************************** DOWNLOAD REPORT(ADD) ***********************************/ ?>
        <tr><td colspan="2" class="captionbig">DOWNLOAD</td></tr>
        <tr valign="top">
        <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
        <td valign="top" class="captionbig">
            <input type="radio" name="bwcount" value="-1" onClick="addBwparam('-1')"><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="bwcount" value="0" onClick="addBwparam('0')" checked><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="bwcount" value="1" onClick="addBwparam('1')" ><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="bwcount" value="2" onClick="addBwparam('2')" ><font id="ua_bwcount_color"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></font><br></td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
                <input type="text" name="bwquota" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" disabled></td>
        </tr>
        <tr><td colspan="2">&nbsp;</td></tr>
		
		
        <?php /***************************************** TOTAL REPORT(ADD) ***********************************/ ?>
        <tr><td colspan="2" class="captionbig">TOTAL</td></tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
            <td valign="top" class="captionbig">
            <input type="radio" name="bwcountSHA" value="0" onClick="addBwparamSHA('0')" checked><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="bwcountSHA" value="1" onClick="addBwparamSHA('1')" ><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="bwcountSHA" value="2" onClick="addBwparamSHA('2')" ><font id="ua_bwcountSHA_color"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></font><br></td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <input type="text" name="bwquotaSHA" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" disabled></td>
        </tr>
        <tr><td colspan="2">&nbsp;</td></tr>		

	<!-- login segment-->
<?php
			$add_usr_login_segment_default = '';
			
			$local_ip = $settingobj->getKey('gateway_IP', 'gateway');
			$local_mask = $settingobj->getKey('subnet_mask', 'gateway');
			$num_return_path = $settingobj->getKey('num_return_path', 'MNS');

			$tmp_num = '0'.trim($num_return_path);
			$num = (int)$tmp_num;

			$arr_opt = array();
			$return_path = array();
			$i = 0;
			while ($i < $num) {
				$return_path[$i] = $settingobj->getKey("return_path$i", 'MNS');
				$strarray = split(' ', trim($return_path[$i]));
				$arr_opt[$i] = ($i+1).': '.$lang['setcfg_multi_net_seg_router_IP'].'='.$strarray[0].', '.$lang['setcfg_multi_net_seg_subnet_mask'].'='.$strarray[1];
				$i++;
			}
			
			$subInput = '';
			$subInput  .= '<option VALUE="-1">'.$lang['setcfg_segment_map_login_segment_opt'];
			$subInput  .= '<option VALUE="0">'.$lang['setcfg_segment_map_login_segment_opt0']." (".$lang['setcfg_segment_map_login_segment_opt0_text1'].'='.$local_ip.', '.$lang['setcfg_segment_map_login_segment_opt0_text2'].'='.$local_mask.")";;
			$j = 0;
			
			while ($j < 20) { // hard code limit 
				if  ($j < $num)
					$subInput  .= "<option VALUE=\"".($j+1)."\">$arr_opt[$j]";
				else
					$subInput  .= "<option VALUE=\"".($j+1)."\">".($j+1).": ";
				$j++;
			}
			
		    $input = '<select NAME="select_add_login_segment" disabled>'.$subInput.'</select>';
		    gen_invisible_line3(get_cm_var('setcfg_segment_map_login_segment_title'),$input,'add_usr_login_segment',$add_usr_login_segment_default);
        
?>    
        <tr>
            <td height="4" colspan="2"><img border="0" src="./images/blank.gif" width="4" height="4"></td>
        </tr>
        
        <div id="AddSavebtn" style="position:absolute; z-index: 100;">
        <!--
        <tr>
          <td colspan="2" align="center">
        -->
              <input type="button" name="save" class="graphicBtn" alt="Save" title="Save" value="Save" onclick="addUser()" />
              <input type="button" name="cancel" class="graphicBtn" alt="Cancel" title="Cancel" value="Cancel" onClick="cancelAdd()" />
        <!--
          </td>
        </tr>
        -->
        </div>
        <?php
        	$session_handling = $settingobj->getKey('session_handling', 'gateway');
        	$passive_login_mode = $settingobj->getKey('passive_login_mode', 'gateway');
        	//$settingobj->Release();
            $settingobj=null;
        ?>
     			<input type="hidden" name="add_session_handling" value="<?=$session_handling?>"> 
     			<input type="hidden" name="add_passive_login_mode" value="<?=$passive_login_mode?>"> 
      </table>
      </fieldset>
    </form> <!-- end of addform -->
    </div>
    <!-- End add user layer -->

    <!-- Edit user layer -->
    <div id="userinfo" style="display:">
	<form name="userinfoform"> <!-- User information form for both display and editing -->
    <fieldset style="border: 1px solid #99D1A2; padding: 5px;">
        <legend class="captionbig" style="color: green; padding: 0px 10px;"><?=get_cm_var('setcfg_users_user_info')?></legend>
        <input type="hidden" name="save_u" value="true"> 
        <input type="hidden" name="name0" id="name0" value="">
		
		<input type="button" id="appliedRuleBtn" title="Show Applied Rule(s)" value="Show Applied Rule(s)" class="graphicBtn" onClick="popup=window.open('','win2','width=780,height=600,scrollbars ,resizable'); popup.location='userQueryAppliedRule.php?selectedName='+document.userinfoform.selectedName.value;" />
		<script type="text/javascript">         
            document.getElementById('appliedRuleBtn').disabled = true; 
		</script>
		
		<input type="hidden" name="selectedName" id="selectedName">
    <!-- javascript for edit user UI control -->
    <script type="text/javascript" src="./javascript/ue.js"></script>

        <input type="text" name="acc_warning" id="acc_warning" value="" style="width:450px; border:0px; font-family:Tahoma; font-size:9pt; font-weight:bold; color:red;" readonly>

        <table width="500" border="0" cellspacing="0" cellpadding="0">

        <tr><td colspan="2"><br></td></tr>
        <tr>
		
         <td width="35%" class="captionbig"><?=get_cm_var('setcfg_users_user_name')?></td>
		
          <td width="65%"><input type="text" name="name1" value="" readonly style="width:150px; border:1px solid #99D1A2; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;"></td>
        </tr>
        <tr id="passive" style="display:none;">
          <td width="35%">&nbsp;</td>
          <td width="65%" class="captionbig">
            <input type="checkbox" name="chg_passive_login" value="on" onClick="edit_passive()" disabled><?=get_cm_var('setcfg_users_passive_login')?>
            <input type="hidden" name="orignal_mode" value="">
          </td>
        </tr>
		
		<tr id="chpwRow" valign="top" style="display:none;">
			<input type="hidden" name="scratch_mode" value="0">
          <td class="captionbig"><?=get_cm_var('setcfg_users_password')?></td>
          <td><input type="password" name="chgpassword" id="chgpassword" value="     " class="passwordbox" style="width:150px; font-weight:bold; color:#003300;" onfocus="this.select()"></td>
        </tr>
        <tr id="cfpwRow" valign="top" style="display:none;">
          <td class="captionbig"><?=get_cm_var('setcfg_users_confirm_pwd')?></td>
          <td><input type="password" name="chgconfirmpass" id="chgconfirmpass" value="     " class="passwordbox" style="width:150px; font-weight: bold; color:#003300;" onfocus="this.select()"></td>
        </tr>

        <tr><td colspan="2"><br></td></tr>
        <tr valign="top"><td class="captionbig"><?=get_cm_var('setcfg_users_account_status')?></td>
          <td class="captionbig">
            <input type="radio" name="acc_enable" value="0" onClick="accparam('0')" disabled><?=get_cm_var('setcfg_users_account_status_enabled')?><br>
            <input type="radio" name="acc_disable" value="1" onClick="accparam('1')" disabled><?=get_cm_var('setcfg_users_account_status_disabled')?><br>
          </td>
        </tr>

        <tr valign="top">
            <td class="captionbig"><?=get_cm_var('setcfg_users_status')?></td>
            <td><input type="text" id="status" name="status" value="" style="width:100px; border:0px; font-family:Tahoma; font-size:9pt; font-weight:bold; color:#003300;" readonly></td>
        </tr>

        <tr><td colspan="2"><br></td></tr>
		
        <tr valign="top">
            <td width="35%" valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bt')?>
            </td>
            <td width="65%" class="captionbig">
            <input type="radio" name="usr_bt_mode" value="0" onClick="rbtn('0')" disabled><?=get_cm_var('setcfg_users_no_throttling')?><br>
            <input type="radio" name="usr_bt_mode" value="1" onClick="rbtn('1')" disabled><?=get_cm_var('setcfg_users_low')?> (~<?=$bt_num_low?> KBytes/s)<br>
            <input type="radio" name="usr_bt_mode" value="2" onClick="rbtn('2')" disabled><?=get_cm_var('setcfg_users_medium')?> (~<?=$bt_num_medium?> KBytes/s)<br>
            <input type="radio" name="usr_bt_mode" value="3" onClick="rbtn('3')" disabled><?=get_cm_var('setcfg_users_high')?> (~<?=$bt_num_high?> KBytes/s)<br>
            <input type="radio" name="usr_bt_mode" value="4" onClick="rbtn('4')" disabled><?=get_cm_var('setcfg_users_use_global_setting')?><br>
            <input type="radio" name="usr_bt_mode" value="5" onClick="rbtn('5')" disabled>
                <?=get_cm_var('setcfg_users_upload')?><br>
            <input type="text" class="shorttextbox" name="user_bt_num" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled><br>&nbsp;<?=get_cm_var('setcfg_users_download')?> <br>
            <input type="text" class="shorttextbox" name="user_bt_num_dl" maxlength="10" value="" onKeyPress="return numbersonly(this,event)" disabled>
            </td>
        </tr>

        <tr><td colspan="2"><br></td></tr>

        <?php /***************************************** UPLOAD REPORT(EDIT) ***********************************/ ?>
        <tr><td colspan="3" class="captionbig">UPLOAD</td></tr>
        <tr valign="top">
        <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
        <td valign="top" class="captionbig">

            <input type="radio" name="Bn_bwcountUL" value="-1" onClick="bwparamUL('-1')" disabled><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="Bn_bwcountUL" value="0" onClick="bwparamUL('0')" disabled><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="Bn_bwcountUL" value="1" onClick="bwparamUL('1')" disabled><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="Bn_bwcountUL" value="2" onClick="bwparamUL('2')" disabled><font id="ue_bwcountUL_color"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></font>
        </td></tr>

        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <!-- following textbox use onmouseup instead of onclick because onmouseup still work even if textbox is disabled -->
            <input class="shorttextbox" type="text" name="bwquota1UL" maxlength="15" value="" onmouseup="warnEditQuota()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr id="addQuotaULRow" style="display:none;">
            <td width="35%"><br/></td>
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_add_quota')?>&nbsp;&nbsp;&nbsp;
            <input class="shorttextbox" type="text" id="edit_addquotaUL" name="edit_addquotaUL" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr valign="top">
            <td valign="top" class="captionbig">
            <?=get_cm_var('setcfg_users_field_acc_bandwidth')?><br/><br/><br/>
            </td>
            <td valign="top" class="captionbig">
            <input class="shorttextbox" type="text" name="acc_bandwidthUL" value="" disabled><br/><br/><br/>
            </td>
        </tr>

        <tr><td colspan="2"><br></td></tr>

        <?php /***************************************** DOWNLOAD REPORT(EDIT) ***********************************/ ?>
        <tr><td colspan="3" class="captionbig">DOWNLOAD</td></tr>
        <tr valign="top">
          <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
          <td valign="top" class="captionbig">
            <input type="radio" name="Bn_bwcount" value="-1" onClick="bwparam('-1')" disabled><?=get_cm_var('setcfg_users_global_counting')?><br>
            <input type="radio" name="Bn_bwcount" value="0" onClick="bwparam('0')" disabled><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="Bn_bwcount" value="1" onClick="bwparam('1')" disabled><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="Bn_bwcount" value="2" onClick="bwparam('2')" disabled><font id="ue_bwcount_color"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></font>
          </td>
        </tr>
        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <input class="shorttextbox" type="text" name="bwquota1" maxlength="10" value="" onClick="warnEditQuota()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>
        <tr id="addQuotaRow" valign="top" style="display: none;">
            <td width="35%"><br/></td>
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_add_quota')?>&nbsp;&nbsp;&nbsp;
            <input class="shorttextbox" type="text" name="edit_addquota" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr valign="top">
            <td valign="top" class="captionbig">
          <?=get_cm_var('setcfg_users_field_acc_bandwidth')?><br/><br/><br/>
            </td>
            <td valign="top" class="captionbig">
              <input class="shorttextbox" type="text" name="acc_bandwidth" value="" disabled><br/><br/><br/>
            </td>
        </tr>

		<tr><td colspan="2"><br></td></tr>
		
        <?php /***************************************** TOTAL REPORT(EDIT) ***********************************/ ?>
        <tr><td colspan="3" class="captionbig">TOTAL</td></tr>
        <tr valign="top">
        <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_bandwidth_counting_param')?></td>
        <td valign="top" class="captionbig">

            <!--<input type="radio" name="Bn_bwcountSHA" value="-1" onClick="bwparamSHA('-1')" disabled></*=get_cm_var('setcfg_users_global_counting'*/)?><br> -->
            <input type="radio" name="Bn_bwcountSHA" value="0" onClick="bwparamSHA('0')" disabled><?=get_cm_var('setcfg_users_disable_counting')?><br>
            <input type="radio" name="Bn_bwcountSHA" value="1" onClick="bwparamSHA('1')" disabled><?=get_cm_var('setcfg_users_enable_counting')?><br>
            <input type="radio" name="Bn_bwcountSHA" value="2" onClick="bwparamSHA('2')" disabled><font id="ue_bwcountSHA_color"><?=get_cm_var('setcfg_users_enable_counting_and_quota')?></font>
        </td></tr>

        <tr valign="top">
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_quota')?></td>
            <td valign="top">
            <!-- following textbox use onmouseup instead of onclick because onmouseup still work even if textbox is disabled -->
            <input class="shorttextbox" type="text" name="bwquota1SHA" maxlength="15" value="" onmouseup="warnEditQuota()" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr id="addQuotaSHARow" style="display:none;">
            <td width="35%"><br/></td>
            <td valign="top" class="captionbig"><?=get_cm_var('setcfg_users_add_quota')?>&nbsp;&nbsp;&nbsp;
            <input class="shorttextbox" type="text" id="edit_addquotaSHA" name="edit_addquotaSHA" value="" onKeyPress="return numbersonly(this,event)" onfocus="this.select()" disabled>
            </td>
        </tr>

        <tr valign="top">
            <td valign="top" class="captionbig">
            <?=get_cm_var('setcfg_users_field_acc_bandwidth')?><br/><br/><br/>
            </td>
            <td valign="top" class="captionbig">
            <input class="shorttextbox" type="text" name="acc_bandwidthSHA" value="" disabled><br/><br/><br/>
            </td>
        </tr>
		
	<!--login segment-->
<?php
        $usr_login_segment_default = '';
			
			$settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');
			$local_ip = $settingobj->getKey('gateway_IP', 'gateway');
			$local_mask = $settingobj->getKey('subnet_mask', 'gateway');
			$num_return_path = $settingobj->getKey('num_return_path', 'MNS');

			$tmp_num = '0'.trim($num_return_path);
			$num = (int)$tmp_num;

			$arr_opt = array();
			$return_path = array();
			$i = 0;
			while ($i < $num) {
				$return_path[$i] = $settingobj->getKey("return_path$i", 'MNS');
				$strarray = split(' ', trim($return_path[$i]));
				$arr_opt[$i] = ($i+1).': '.$lang['setcfg_multi_net_seg_router_IP'].'='.$strarray[0].', '.$lang['setcfg_multi_net_seg_subnet_mask'].'='.$strarray[1];
				$i++;
			}
			$settingobj = null;
			
			$subInput = '';
			$subInput  .= '<option VALUE="-1">'.$lang['setcfg_segment_map_login_segment_opt'];
			$subInput  .= '<option VALUE="0">'.$lang['setcfg_segment_map_login_segment_opt0']." (".$lang['setcfg_segment_map_login_segment_opt0_text1'].'='.$local_ip.', '.$lang['setcfg_segment_map_login_segment_opt0_text2'].'='.$local_mask.")";;
			$j = 0;
			
			while ($j < 20) { // hard code limit 
				if  ($j < $num)
					$subInput  .= "<option VALUE=\"".($j+1)."\">$arr_opt[$j]";
				else
					$subInput  .= "<option VALUE=\"".($j+1)."\">".($j+1).": ";
				$j++;
			}
			
		    $input = '<select NAME="select_edit_login_segment" disabled>'.$subInput.'</select>';
		    gen_invisible_line3(get_cm_var('setcfg_segment_map_login_segment_title'),$input,'usr_login_segment',$usr_login_segment_default);
        
?>
    
    <tr><td height="4" colspan="2"><img border="0" src="./images/blank.gif" width="4" height="4"></td></tr>
    <!--
    <tr id="saveBtn" style="display:none;">
      <td colspan="2" align="center">
    -->
    	<div id="saveBtn" style="position:absolute; z-index: 100; display:none;">
          <input type="button" name="save" value="Save" class="graphicBtn" alt="Save" title="Save" onClick="editUser();return false">
          <input type="button" id="cancelBtn" name="cancel" class="graphicBtn" value="Cancel" alt="Cancel" title="Cancel" onClick="cancelEdit()">
    	</div>
    <!--
      </td>
    </tr>
    -->
    <?php
    	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');
    	$session_handling = $settingobj->getKey('session_handling', 'gateway');
    	$settingobj = null;
    ?>
     		<input type="hidden" name="session_handling" value="<?=$session_handling?>"> 
    </table>
      </fieldset>
      </form> <!-- end of userinfoform -->
      </div>
      <!-- End edit user layer -->
    </td>

  </tr>    

  <tr>
    <td width="40%" colspan="2" valign="top" height="3"><img src="./images/blank.gif" border="0" width="3" height="3"></td>
    <td width="20" valign="top" height="3"><img src="./images/blank.gif" border="0" width="20" height="3"></td>    
    <td width="40%" valign="top" height="5"><img src="./images/blank.gif" border="0" width="3" height="5"></td>
  </tr>  

<tr>
    <td width="40%" valign="top">&nbsp;</td>
    <td width="170" valign="top"> 

    <!-- 'Move to Existing user' to fix the mislocation problem-->
   
    <!-- Fix mislocation problem -->
    
    </td>
    <td width="20">&nbsp;</td>
    <td width="40%">&nbsp;</td>
  </tr>
  <tr>
    <td width="100%" colspan="5" valign="top" height="12"><img src="./images/blank.gif" border="0" width="3" height="12"></td>
  </tr>  

  <tr>

    <td width="40%">&nbsp;</td>
  </tr>    
  <tr>
	<?/*    
	<td width="100%" colspan="5" valign="top" height="12"><img src="./images/blank.gif" border="0" width="3" height="12"></td>
	*/?>
	<!-- Dummy form for cal form height-->
	<form name="exportUsageform" method="post">
		<td width="100%" colspan="5" valign="top" height="12" ><img src="./images/blank.gif" border="0" width="3" height="12" name="exportLog"></td>
	</form>
	<!-- this iframe is for remote scripting -->
	<iframe id="serverFrame" name="serverFrame" src="about:blank" style="width:0px; height:0px; border:0px"></iframe>
  </tr>
  
  <?
  /*
  <tr>
    <td width="40%">&nbsp;</td>
    <td width="60%" colspan="2" valign="top" height="12">
        <input id="log_button" type="button" value="<?=get_cm_var('setcfg_users_btn_show_user_log')?>" title="<?=get_cm_var('setcfg_users_btn_show_user_log_title')?>" class="graphicBtn" onClick="show_userlog()" altValue="<?=get_cm_var('setcfg_users_btn_hide_user_log')?>" altTitle="<?=get_cm_var('setcfg_users_btn_hide_user_log_title')?>" />
    </td>
    <!-- Export User Log -->
    <td width="100%" colspan="2" valign="top" align="center" height="12">
        <form action="settingok.php" name="exportUsageform" method="post">
            <input type="hidden" id="exportUsageLog" name="exportUsageLog"  value="true"/>
			<input type="hidden" id="ClearLog" name="ClearLog"  value=""/>
            <input type="button" name="exportLog" title="<?=get_cm_var('setcfg_users_btn_export_user_log_title')?>" value="<?=get_cm_var('setcfg_users_btn_export_user_log')?>" class="graphicBtn" onclick = "DoTheCheck()" />&nbsp;&nbsp;&nbsp;
			<input type = "checkbox" name ="box1"> <font size = "2"><b><?=get_cm_var('setcfg_users_userlog_clearbox')?></b></font>
		</form>
    </td>
  </tr>
  <tr>
      <td colspan="5" width="100%">
            <!-- user log -->
            <div id="userlog" style="display:none">
		<!-- 20071109 - Set src not to load anything by default -->
                <iframe id="logFrame" class="bordered_frame" frameborder="0" width="100%" height="200" marginwidth="2" marginheight="0"></iframe>
            </div>
            <!-- this iframe is for remote scripting -->
            <iframe id="serverFrame" name="serverFrame" src="about:blank" style="width:0px; height:0px; border:0px"></iframe>
      </td>
  </tr>
  */
  ?>
<?php
      gen_foot(); //close table and div

        if (isset($searchuser) && $searchuser!='') { //restore search form field only in search user mode
            echo "<script type=\"text/javascript\">\nrestoresearchformdata('$searchuser');\n//searchuser.js\n</script>";
        }
    } // all user mode or $searchformdata is set

    if (!isset($searchUser) || $searchUser=='') { //show export form only in all user mode

	// later to add inport and export table
?>

<?php
        } //all user mode
?>

<!-- end -->
<?php
    if (!isset($searchUser) || isset($searchFormData)) {
        //only do in all user mode or after search
        echo("<script type=\"text/javascript\"><!--\n");
        echo("totalPage($pages, $pageno);\n"); //users.js

        echo("initcombobox();\n"); //users.js
        echo("// -->\n</script>");  
     } //only do in all user mode or after search
?>

<? require_once "dropinQuota.php"; ?>

<script type="text/javascript">
callLoadingBox(false,false); //loadingBox.js hide loading box and stop button
</script>
