/**
 *  setcfg.php needs the following functions
 */
//20080827	fixed some display problems in Scenario2
//20080814	fixed the refresh function and some display problems on IE 5
//20080805	1. enable sorting for both ascending and desending order
//			2. changed all compare function to accending order, deleted "sortBy..." functions
//			3. added several lines and functions to support the enhancement on interface(Status)
//called by c_Sstatus.php
function refreshStatus(){
	//fix the display problems on IE version<5.5 for regonizing DOM contentWindow 
	var regx=/MSIE (\d+\.\d+);/;
	if (regx.test(navigator.userAgent) && Number(RegExp.$1) < 5.5){//check for ie ver<5.5
		var conn_frame=document.connFrame;
		conn_frame.window.location.reload(true);
	}
	else{
		var conn_frame=document.getElementById('conn_frame');
		conn_frame.contentWindow.location.reload(true);
		
	}
}
function selectAllUser()
{
    var arrCheckbox = frames['connFrame'].document.getElementsByName('OnlineUser'); 
    for (var i=0; i<arrCheckbox.length; i++) {
        if (arrCheckbox[i].checked == false) {
            arrCheckbox[i].checked = true;
            frames['connFrame'].selectToggle(arrCheckbox[i]);
        }
    }
}

function selectNoneUser()
{
    var arrCheckbox;
	
	arrCheckbox = frames['connFrame'].document.getElementsByName('OnlineUser'); 
    
	for (var i=0; i<arrCheckbox.length; i++) {
        if (arrCheckbox[i].checked == true) {
            arrCheckbox[i].checked = false;
            frames['connFrame'].selectToggle(arrCheckbox[i]);
        }
    }
}

/**
 *  user_status.php needs the following functions
 */

function selectToggle(cb)
{

    var name = cb.value;
    
    if( cb.checked == true ) {
        document.getElementById(name).className='checked';
        AddTerminateConn(name);
    }
    else {
        document.getElementById(name).className='normal';
        RemoveTerminateConn(name);
    }
    
    var count =0;
	var arrCheckbox = parent.frames['connFrame'].document.getElementsByName('OnlineUser');
	
	for (var i=0; i<arrCheckbox.length; i++) {
		if (arrCheckbox[i].checked == true)
			count++;
	}
}

function AddTerminateConn(name)
{
    if(parent.document.StatusControlForm.TerminateConnString.value == '' )
        parent.document.StatusControlForm.TerminateConnString.value = name; 
    else                    
        parent.document.StatusControlForm.TerminateConnString.value = parent.document.StatusControlForm.TerminateConnString.value + ',' + name;  
}
function RemoveTerminateConn(name)
{
    var tmpStr = parent.document.StatusControlForm.TerminateConnString.value;
    var head = tmpStr.substring(0, (tmpStr).indexOf(name)-1);
    var tail = tmpStr.substring(tmpStr.indexOf(name)+name.length, tmpStr.length);
    tmpStr = head + tail;
    if( tmpStr.indexOf(',')==0 )
        tmpStr = tmpStr.substring(1, tmpStr.length);
    parent.document.StatusControlForm.TerminateConnString.value = tmpStr;
}
/*
function buildGroupList(listOfGroup) {
	var arrGroup = listOfGroup.split(',');
	var obj = document.getElementById('groupList');
	with (obj) {
		if (listOfGroup!='') {
			length = arrGroup.length + 1;
			for (var i=0; i<arrGroup.length; i++) {
				options[i+1].text = arrGroup[i];
				options[i+1].value = arrGroup[i];
			}
		}
	}
}
*/
/*
//called by c_Sstatus.php
function filterOnlineUserByGroup() {
	var groupSelectionBox = document.getElementById('groupList');
	var groupName = groupSelectionBox.options[groupSelectionBox.selectedIndex].value;
	var tableObj = frames[2].document.getElementById('onlineUserList');
	filterOnlineUserTableByGroup(tableObj,groupName);
	
}
function filterOnlineUserTableByGroup(tableObj,groupName){
	if (tableObj.rows.length>0) {
		with (tableObj) {
			if (groupName=="all") {
				for (var i=0; i<rows.length; i++) {
					rows[i].style.display = '';
				}	
			} else {
				for (var i=0; i<rows.length; i++) {
					if (rows[i].getAttribute('id')!='struct_row' && rows[i].getAttribute('group')!=groupName) {
						rows[i].style.display = 'none';
					} else {
						rows[i].style.display = '';
					}
				} //end for each rows	
			}
		} //end with table object
	} //end if table is not empty
}
//called by c_Sstatus.php
function filterOnlineUserBySite() {
	var siteSelectionBox = document.getElementById('siteList');
	var siteID = siteSelectionBox.options[siteSelectionBox.selectedIndex].value;
	var selectValue = siteSelectionBox.selectedIndex; // 0 = all, 1 = self, 2 = others
	var tableObj = frames['connFrame'].document.getElementById('onlineUserList');
	filterOnlineUserTableBySite(tableObj,siteID,selectValue);
}
function filterOnlineUserTableBySite(tableObj,siteID,selectValue) {
	if (tableObj.rows.length>0) {
		with (tableObj) {
			if (siteID=="all") {
				for (var i=0; i<rows.length; i++) {
					rows[i].style.display = '';
				}	
			} else {
				for (var i=0; i<rows.length; i++) {
					
					if (rows[i].getAttribute('id')!='struct_row' && ( (selectValue == 2 && rows[i].getAttribute('siteID')==siteID) || (selectValue != 2 && rows[i].getAttribute('siteID')!=siteID)) ){
						rows[i].style.display = 'none';
					} else {
						rows[i].style.display = '';
					}
				} //end for each rows	
			}
		} //end with table object
	} //end if table is not empty
}
//called by c_Sstatus.php
function filterOnlineUserBySiteAndGroup(){
	// site selection box
	var siteSelectionBox = document.getElementById('siteList');
	var siteID = siteSelectionBox.options[siteSelectionBox.selectedIndex].value;
	var selectValue = siteSelectionBox.selectedIndex; // 0 = all, 1 = self, 2 = others
	// // group name selection box
	var groupSelectionBox = document.getElementById('groupList');
	var groupName = groupSelectionBox.options[groupSelectionBox.selectedIndex].value;

	var tableObj = frames['connFrame'].document.getElementById('onlineUserList');
	//end if table is not empty
	filterOnlineUserTableBySiteAndGroup(tableObj,groupName,siteID,selectValue);
}

function filterOnlineUserTableBySiteAndGroup(tableObj,groupName,siteID,selectValue){
	if (tableObj.rows.length>0) {
		with (tableObj) {
			if (siteID=="all" && groupName=="all") { // Show All Group and Site
				for (var i=0; i<rows.length; i++) {
					rows[i].style.display = '';
				}	
			} else if (siteID!="all" && groupName=="all") { // Show specify Site in all group
				for (var i=0; i<rows.length; i++) {
					
					if (rows[i].getAttribute('id')!='struct_row' && ((selectValue == 2 && rows[i].getAttribute('siteID')==siteID) || (selectValue != 2 && rows[i].getAttribute('siteID')!=siteID) )) {
						rows[i].style.display = 'none';
					} else {
						rows[i].style.display = '';
					}
				} //end for each rows	
			} else if (siteID=="all" && groupName!="all") { // Show All Site in specify group
				for (var i=0; i<rows.length; i++) {
					if (rows[i].getAttribute('id')!='struct_row' && rows[i].getAttribute('group')!=groupName) {
						rows[i].style.display = 'none';
					} else {
						rows[i].style.display = '';
					}
				} //end for each rows	
			} else { // Show specify Site in specify group
				for (var i=0; i<rows.length; i++) {					
					if (rows[i].getAttribute('id')!='struct_row' && ( (selectValue == 2 && rows[i].getAttribute('siteID')==siteID) || (selectValue != 2 && rows[i].getAttribute('siteID')!=siteID) || rows[i].getAttribute('group')!=groupName )) {
						rows[i].style.display = 'none';
					} else {
							rows[i].style.display = '';
					}
				} //end for each rows	
			}
		} //end with table object
	}
}

*/
//20080805	enable sorting of both ascending and desending order
//			colStatus--ascending order: 1, decending order: 2
//			sort the user status table according to the current sorting status
//called by user_status.php
function sortStatusTable(){
	// //start applying filters to the user table
	// //site selection box
	// var siteSelectionBox = parent.document.getElementById('siteList');
	// //group name selection box
	// var groupSelectionBox = parent.document.getElementById('groupList');
	// //online user table
	// var tableObj = document.getElementById('onlineUserList');
	// if (siteSelectionBox != null){
		// var siteID = siteSelectionBox.options[siteSelectionBox.selectedIndex].value;
		// var selectValue = siteSelectionBox.selectedIndex; // 0 = all, 1 = self, 2 = others
		// if (groupSelectionBox == null){//seenario2: enable, shared secret mode:disable
			// filterOnlineUserTableBySite(tableObj,siteID,selectValue);
		// }
	// }
	// if (groupSelectionBox!=null){
		// var groupName = groupSelectionBox.options[groupSelectionBox.selectedIndex].value;
		// if (siteSelectionBox == null){//seenario2: disable, shared secret mode:enable
			// filterOnlineUserTableByGroup(tableObj,groupName);
		// }
		// if (siteSelectionBox != null){//seenario2: enable, shared secret mode:enable
			// filterOnlineUserTableBySiteAndGroup(tableObj,groupName,siteID,selectValue);
		// }
	// }
	// //end of applying filters to the user table
	
	// var labelTables = parent.frames[1].document.getElementsByTagName('TABLE');
	// var labelTable = labelTables[0];
	// //find the sorted column and sort it according to its current sorting satus
	// if (labelTable){
		// with (labelTable.rows[0]) {
			// for (var col=1; col< cells.length; col++){//skip the first column as it contains the checkbox only
				// var colStatus=cells[col].getAttribute("sortstatus");
				// if(colStatus == "1"){
					// sortTableCol(col, "1");
					// break;
				// }else if (colStatus == "2"){
					// sortTableCol(col, "2");
					// break;
				// }
			// }
		// }
	// }
	
}
//20080805	enable sorting of both ascending and desending order
//colStatus--ascending order: 1, desending order: 2
//sort the table to the order(colStatus) of the column(whichColumn) 
function sortTableCol(whichColumn, colStatus) {
	
	var oTables = parent.frames[2].document.getElementsByTagName('TABLE');
	var oTable = oTables[0];
	if (oTable) { //check if the table in iframe is ready
		var arrRow = new Array();
		//must to put all rows into an array because the sort() function only apply to array object
		with (oTable) {
			for (var i=0; i<rows.length-1; i++) {//skip the last row which is for maintaining the structure
				arrRow[i] = rows[i];
			}
			var lastrow=rows[rows.length-1];//store the lastrow
		}
		//sort the columns with different function
		
		switch (whichColumn) {
			case 1:
				arrRow.sort(compareName);
				break;
			case 2:
				arrRow.sort(compareMAC);
				break;
			case 3:
				arrRow.sort(compareIP);
				break;
			case 4:
				arrRow.sort(compareLoginTimeAsc);
				break;
			case 5:
				arrRow.sort(compareLoginTimeDsc);
				break;
			case 6:
				arrRow.sort(compareDownload);
				break;
			case 7:
				arrRow.sort(compareUpload);
				break;
			case 8:
				arrRow.sort(compareSite);
				break;
		}
		//put back row to DOM in order, it auto delete the old linkage
		if (oTable.tBodies[0]) {
			with (oTable.tBodies[0]) {				
				if (colStatus== "1" ){
					for (var i=0; i<arrRow.length; i++) {
						appendChild(arrRow[i]);
					}
					appendChild(lastrow);
				}else if (colStatus== "2" ){
					for (var i=arrRow.length-1; i>=0; i--) {
						appendChild(arrRow[i]);
					}
					appendChild(lastrow);
				}
			
				
				
			}
		}

		// 20090612 - Add ticks in checkboxes for those selected rows (problem of IE)
		var arrCheckbox = parent.frames['connFrame'].document.getElementsByName('OnlineUser');
		for (var i = 0; i < arrCheckbox.length; i++) {
			if (parent.frames['connFrame'].document.getElementById(arrCheckbox[i].value).className == 'checked') {
				arrCheckbox[i].checked = true;
			}
		}
	} //end if table is ready
}
//reverse the status table row
function reverseTableRow() {
	
	var oTables = parent.frames[2].document.getElementsByTagName('TABLE');
	var oTable = oTables[0];
	if (oTable) { //check if the table in iframe is ready
		var arrRow = new Array();
		//must to put all rows into an array because the sort() function only apply to array object
		with (oTable) {
			for (var i=0; i<rows.length-1; i++) {
				arrRow[i] = rows[i];
			}
			var lastrow=rows[rows.length-1];
		}
		//reverse the rows
		if (oTable.tBodies[0]) {
			with (oTable.tBodies[0]) {
				for (var i=arrRow.length-1; i>=0; i--) {
					appendChild(arrRow[i]);
				}
				appendChild(lastrow);
			}
		}

		// 20090612 - Add ticks in checkboxes for those selected rows (problem of IE)
		var arrCheckbox = parent.frames['connFrame'].document.getElementsByName('OnlineUser');
		for (var i = 0; i < arrCheckbox.length; i++) {
			if (parent.frames['connFrame'].document.getElementById(arrCheckbox[i].value).className == 'checked') {
				arrCheckbox[i].checked = true;
			}
		}
	}
}

//20080805 changed all compare function to accending order, deleted "sortBy..." functions
function compareName(a,b) {
	var aValue= a.cells[1].innerHTML.toLowerCase();
	var bValue= b.cells[1].innerHTML.toLowerCase();
	//var aValue = a.getAttribute('username').toLowerCase();
	//var bValue = b.getAttribute('username').toLowerCase();
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
function compareMAC(a,b) {
	var aValue= a.cells[2].innerHTML;
	var bValue= b.cells[2].innerHTML;
	//var aValue = a.getAttribute('mac');
	//var bValue = b.getAttribute('mac');
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
function compareIP(a,b) {
	var arrAValue = a.cells[3].innerHTML.split('.');
	var arrBValue = b.cells[3].innerHTML.split('.');
	//var arrAValue = a.getAttribute('ip').split('.');
	//var arrBValue = b.getAttribute('ip').split('.');
	var aValue, bValue;
	for (var i=0; i<arrAValue.length; i++) {
		aValue = parseInt(arrAValue[i]);
		bValue = parseInt(arrBValue[i]);
		if ( aValue > bValue) {
			return 1;
		} else if (aValue < bValue) {
			return -1;
		}
	}
	return 0;
}
function compareLoginTimeAsc(a,b) {
	var aValue = parseInt(a.getAttribute('loginTime'));
	var bValue = parseInt(b.getAttribute('loginTime'));
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
function compareLoginTimeDsc(a,b) {
	var aValue = parseInt(a.getAttribute('timeDiff'));
	var bValue = parseInt(b.getAttribute('timeDiff'));

	// 20090611 - Fix return value
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
function compareDownload(a,b) {
	var aValue = parseInt(a.getAttribute('bwUse'));
	var bValue = parseInt(b.getAttribute('bwUse'));
	
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
function compareUpload(a,b) {
	var aValue = parseInt(a.getAttribute('bwUseUL'));
	var bValue = parseInt(b.getAttribute('bwUseUL'));
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
function compareSite(a,b) {
	var aValue = a.getAttribute('siteID');
	var bValue = b.getAttribute('siteID');
	
	if (aValue > bValue) {
		return 1;
	} else if (aValue < bValue) {
		return -1;
	} else {
		return 0;
	}
}
//20080805	enable sorting of both scending and desending order
//			colStatus--ascending order: 1, desending order: 2
//			sort the user status table accroding to the current sorting status
function tableHeadOnclick(whichColumn) {
	
	var labelTables = document.getElementsByTagName('TABLE');
	var labelTable = labelTables[0];
	with (labelTable.rows[0]) {
		//1. clear all unselected header color and up/down icon first
		//2. store the sort status for refresh use
		for (var col=1; col<cells.length; col++) {
			var colStatus = cells[col].getAttribute("sortstatus");
			var imgs = cells[col].getElementsByTagName('img');
			var img = imgs[0];
			if (col!=whichColumn){
				cells[col].className = "unselected";
				cells[col].setAttribute("sortstatus","0");
				img.style.display="none";
			}
		}
		var imgs = cells[whichColumn].getElementsByTagName('img');
		var img = imgs[0];
		var colStatus=cells[whichColumn].getAttribute("sortstatus");
		//change the up/down icon and sort status according to the current sort status
		if (colStatus == "0" || colStatus == "2") {
			
			img.style.display="";
			img.src="images/up_tri.png";
			
			if (colStatus == "0"){
				sortTableCol(whichColumn, "1");
			}else if (colStatus == "2"){
				reverseTableRow();
			}
			cells[whichColumn].setAttribute("sortstatus", "1");
		}else if (colStatus == "1"){
			img.style.display="";
			img.src="images/down_tri.png";
			reverseTableRow();
			cells[whichColumn].setAttribute("sortstatus", "2");
		}
		cells[whichColumn].className = "selected";
	}
}

// 20090611 - Restore rows with selected effect after list refresh
function RestoreSelect()
{
	var	arrCheckbox = parent.frames['connFrame'].document.getElementsByName('OnlineUser');
	var nameStr = '';
	var selConnCnt = 0;
	var tmpStr = parent.document.StatusControlForm.TerminateConnString.value;
	var updateStr = '';

	// Search through the string of selected users
	while (tmpStr.length > 0) {
		var commaPos = tmpStr.indexOf(',');

		// Extract a username
		if (commaPos >= 0) {
			nameStr = tmpStr.substring(0, commaPos);
			tmpStr = tmpStr.substring(commaPos+1);
		} else {
			nameStr = tmpStr;
			tmpStr = '';
		}
		
		// Set the row checked if this username is still in the online user list
		for (var i = 0; i < arrCheckbox.length; i++) {
			if (nameStr == arrCheckbox[i].value) {
				if (arrCheckbox[i].checked == false) {
					arrCheckbox[i].checked = true;
					document.getElementById(nameStr).className = 'checked';

					// Add the username into the updated string of selected users
					selConnCnt++;
					if (updateStr.length > 0) {
						updateStr = updateStr + ',' + nameStr;
					} else {
						updateStr = nameStr;
					}
				}
				break;
			}
		}
	}

	// Update information about selected users
	parent.document.StatusControlForm.TerminateConnString.value = updateStr;
}

