<?php
echo "<!-- Debug \n";

// change directory to prevent that file call in different directory level
$settingobj = new COM("EGCONFIG.Cfgmgr") or die("addGroup.php EGCONFIG.Cfgmgr Object cannot be created!");
$dsnFile = $settingobj->getKey( 'Datasource', 'gateway');
$group_tablename = $settingobj->getKey('Datasource_group_Tablename', 'gateway');
$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
$path = $settingobj->getFsPath();
chdir($path."cfgmgr"); 
$settingobj = null;

/**
 * Database connection
 */ 
$dsn="";
if ($dsnSource = fopen($dsnFile, 'r')) { 
  if (!feof($dsnSource)) {
    $dbType = fgets($dsnSource, 512);
  }
  while (!feof($dsnSource)) {
    $readLine = trim(fgets($dsnSource, 512));
    if (!empty($readLine)) {
      $dsn .= ($dsn ? ';' : '') . $readLine;
    }
  }
  fclose($dsnSource);
} else {
  exit('Cannot open DSN source file');
}

// get all group's member from db
$member_list = array();

$userDB=odbc_connect($dsn,'','');

$result = odbc_exec($userDB, "SELECT * FROM `".$member_tablename."` ORDER BY `userName` ASC ");
while(odbc_fetch_row($result)) {
	$data = array();
	$data['groupName'] =odbc_result($result,'groupName');
	$data['userName'] =odbc_result($result,'userName');
	
	$member_list[$data['groupName']][] = $data;
}	
// close the odbc connection
odbc_close($userDB);

// print_r($member_list);exit();

// convert script argv to _GET
if (isset($argv)){
	foreach($argv as $k => $v){

		// echo $k."=".$v."\n";
		
		if ($k == 0){
			// ignore first argument (path+filename)
			continue;
		}
		
		$tmpkey="";
		$tmpVal="";
		
		// checking format: key=val
		if (stristr($v,"=") == NULL){
			echo "ERROR: Input incorrect paramter format ($v)\\n";
			exit();
		}
		
		list($tmpkey, $tmpVal) = split('=', $v);
		
		$_GET[$tmpkey] = $tmpVal;
		
	}
}

include_once ("..\\authserv\\common_functions.php");
require_once 'cmvar.php';

// default
$logType = "httpdata"; // logType: using which log information
$MaxTopEntry = 20; 

$timerange_start = 0;
$timerange_end = time();
$reprot_type=1; // 1: most visited sites, 2: most bandwidth used by
$group_by = "";
$file_name = "test.html";
$image_name = "test.jpg";

$for_sp="all";
$chosen_user_list_data="";
$chosen_ip_list_data="";
$chosen_group_list_data="";

if (isset($_GET['reprot_type'])) {
	$reprot_type =$_GET['reprot_type'];
}
else{
	$debugLocal = true;
}

if (isset($_GET['file_name'])) {
	$file_name =$_GET['file_name'];
}

if (isset($_GET['timerange_start'])) {
	$timerange_start =$_GET['timerange_start'];
}

if (isset($_GET['timerange_end'])) {
	$timerange_end =$_GET['timerange_end'];
}

if (isset($_GET['group_by'])) {
	$group_by =$_GET['group_by'];
}

if (isset($_GET['for_sp'])) {
	$for_sp =$_GET['for_sp'];
}

if (isset($_GET['chosen_user_list_data'])) {
	$chosen_user_list_data =$_GET['chosen_user_list_data'];
}

if (isset($_GET['chosen_ip_list_data'])) {
	$chosen_ip_list_data =$_GET['chosen_ip_list_data'];
}
if (isset($_GET['chosen_group_list_data'])) {
	$chosen_group_list_data =$_GET['chosen_group_list_data'];
}

// print_r($_GET);exit();

$other_bar_label="Others";
$other_bar_label_no_user="Others (Not assign user)";
$other_bar_label_no_group="Others (Not assign group)";

$glo_desc= "";
$glo_content = "";
$glo_chartDataArray = array();
$glo_tableContentArray = array();

// chart information 
$titleStr="";
$xColStr="";
$yColStr="";

$keyTitle="";
$valueTitle="";

// overwride by specific report setting
if ($reprot_type == 1){ // visited site
	if (!isset($_GET['group_by'])) // default
		$group_by = "domain";
	$logType = "httpdata"; // logType: using which log information
	$titleStr="Most Visited Sites";
	$xColStr="Requests";
	$yColStr="Most Visited Sites";
	$valueTitle="Requests";
}
else if ($reprot_type == 2){ // bandwidth used by
	if (!isset($_GET['group_by'])) // default
		$group_by = "user";
	$logType = "fwdata"; // logType: using which log information
	$titleStr="Most Bandwidth Used By";
	$xColStr="Traffic";
	$yColStr="";
	$valueTitle="Traffic";
}

if ($group_by == "domain"){
	$yColStr.=" (Domain)";
	$keyTitle.="Domain";
}
else if ($group_by == "ip"){
	$yColStr.=" (IP)";
	$keyTitle.="IP";
}
else if ($group_by == "user"){
	$yColStr.=" (User)";
	$keyTitle.="User";
}
else if ($group_by == "group"){
	$yColStr.=" (Group)";
	$keyTitle.= "Group";
}

$appliedArray = array();
$glo_desc = "For";

if ($for_sp == "all"){
	$glo_desc .= " all";
}
else if ($for_sp == "user"){
	// echo $chosen_user_list_data;
	
	$appliedArray = json_decode(stripslashes($chosen_user_list_data), true); // true: assoc array, not stdClass
	
	$glo_desc .= " user (".join(",", $appliedArray).")";
	
	// becareful some of field will need wrap by double quote "";
	foreach ($appliedArray as $key => $value) {
		$appliedArray[$key] = "\"".$value."\"";
	}
}
else if ($for_sp == "ip"){
	$appliedArray = json_decode(stripslashes($chosen_ip_list_data), true); // true: assoc array, not stdClass
			
	// echo $chosen_ip_list_data;
	// print_r($appliedArray);exit();
	$glo_desc .= " IP (".join(",", $appliedArray).")";
	
	// becareful some of field will need wrap by double quote "";
	foreach ($appliedArray as $key => $value) {
		$appliedArray[$key] = "\"".$value."\"";
	}	
}
else if ($for_sp == "group"){
	$tmp_desc = "";
	$appliedGroup = array();

	$appliedGroup = json_decode(stripslashes($chosen_group_list_data), true); // true: assoc array, not stdClass
	
	// echo $chosen_group_list_data;
	// print_r($appliedGroup);exit();
	
	$groupNum=0;
	foreach ($appliedGroup as $k => $v) {
		$tmpCount = 0;
		$tmpArray = array();
		if (isset($member_list[$v])){
			foreach ($member_list[$v] as $arr2){
				$tmpArray[$tmpCount] = $arr2['userName'];
				$tmpCount++;
			}
		}
		
		if ($groupNum > 0){
			$tmp_desc .= ",";
		}
		
		$groupNum++;
		$tmp_desc .= " ".$v." [".join(",", $tmpArray)."]";
		
		// becareful some of field will need wrap by double quote "";
		foreach ($tmpArray as $key => $value) {
			$tmpArray[$key] = "\"".$value."\"";
		}
		
		$appliedArray = array_merge($appliedArray, $tmpArray);
	}
	
	// print_r($appliedArray);
	
	$appliedArray = array_unique($appliedArray);
	
	// print_r($appliedArray);exit();
	
	$glo_desc .= " Group (".$tmp_desc.")";
}

if (isset($_GET['timerange_start']) && $_GET['timerange_start'] >0 && isset($_GET['timerange_end'])) {
	$glo_desc .= " from (".date("M j, Y", $_GET['timerange_start']).") to (".date("M j, Y", ($_GET['timerange_end'])- 36000).")";
}

// get data from
$logDirArr = array("..\\log\\archive", "..\\log");
// $logDirArr = array("..\\log");
$csvPrfx = '';
$csvSufx = '.csv';
$csvArr = array();

$imageSufx = '.jpg';

$tmpReport = "_tmp_report";
$tmpEmptyReport = "_tmp_empty_report";

// In this stage have 4 different log tempdata, fwdata, rawdata, httpdata
// [0]:State, [1]:Created by, [2]:Source IP, [3]:Destination IP, [4]:Source Port, [5]:Destination Port, [6]:Redirect Type, [7]:Redirect IP, [8]:Redirect Port, [9]:Source Mac, 
// [10]:Destination Mac, [11]:Byte To Send, [12]:Byte TO Receive, [13]:Total Byte to Send, [14]:Total Byte to Receive, [15]:Protocol, [16]:Username, [17]:Applied Rule, [18]:Start Time, [19]:Sub Start Time, 
// [20]:Finish Time, [21]:Domain, [22]:URL, [23]:Others

$tempValPos = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23');
$fwValPos = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23');
// * rawdata have 23 :"HTTP Header"
$rawValPos = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '24');
$httpValPos = array('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23');

$valPos = array();
if(strtolower("tempdata") == strtolower($logType)){
	$csvPrfx = 'tempdata_';
	$valPos = $tempValPos;
}
else if(strtolower("fwdata") == strtolower($logType)){
	$csvPrfx = 'fwdata_';
	$valPos = $fwValPos;
}
else if(strtolower("rawdata") == strtolower($logType)){
	$csvPrfx = 'rawdata_';
	$valPos = $rawValPos;
}
else if(strtolower("httpdata") == strtolower($logType)){
	$csvPrfx = 'httpdata_';
	$valPos = $httpValPos;
}

// Extract full path of the CSV files
foreach ($logDirArr as $l) {
	$fileArr = scandir($l);
	foreach ($fileArr as $f) {
		$filePath = "$l\\$f";
		if (is_file($filePath) && ereg('^'.$csvPrfx.'[0-9]{4}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}[_]{1}[0-9]{2}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}'.$csvSufx.'$', $f)) {
			$treatFilePath = str_replace($csvSufx, '', $filePath);
			$getPos = strpos($treatFilePath, $csvPrfx, 1) + strlen($csvPrfx);
			$fileDate = explode('_', substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos));
			$dateArray = explode('.', $fileDate[0]);
			$timeArray = explode('.', $fileDate[1]);
			$dateTimeStamp = mktime($timeArray[0], $timeArray[1], $timeArray[2], $dateArray[1], $dateArray[2], $dateArray[0]);
			$csvArr[$dateTimeStamp] = $filePath;
		}
	}
}
ksort($csvArr);

// Read CSV files one by one
$dataArray = array();
$count = 0;
$shown = 0;
$previous_timestamp = 9999999999;

foreach ($csvArr as $timestamp => $c) {
	if ($timestamp >= $timerange_end || $timestamp <= $timerange_start) {
		continue;
	}
	
	if ($for_sp == "all"){
		// all
		$dataArray = read_csv($c, ",", true);
	}
	else if ($for_sp == "user"){
		// filter or select specific		
		$dataArray = select_csv($c, ",", $valPos[16], $appliedArray, true); // [16]:Username
	}
	else if ($for_sp == "ip"){
		// filter or select specific		
		// more difficult select_csv
		
		$data_array = file($c);
		$result_array = array();
		
		for ( $i = 0; $i < count($data_array); $i++ ) 
		{ 
			if ($i == 0) // ignore first line
				continue;
				
			$parts_array[$i] = explode(",",$data_array[$i]);
			
			foreach ($appliedArray as $key => $value) {
				if(trim(strtolower($parts_array[$i][$valPos[2]])) == trim(strtolower($value)) && trim(strtolower($parts_array[$i][$valPos[1]])) == trim(strtolower("IN"))) // [2]:Source IP, [1]:Created by
				{ 
					$result_array[] = $parts_array[$i]; 
					break;
				}
				else if(trim(strtolower($parts_array[$i][$valPos[3]])) == trim(strtolower($value)) && trim(strtolower($parts_array[$i][$valPos[1]])) == trim(strtolower("OUT"))) // [3]:Destination IP, [1]:Created by
				{ 
					$result_array[] = $parts_array[$i]; 
					break;
				}
			}
		}
		
		$dataArray = $result_array;
		
	}
	else if ($for_sp == "group"){
		// filter or select specific		
		$dataArray = select_csv($c, ",", $valPos[16], $appliedArray, true); // [16]:Username
	}
	
	// ==========Start Interpret=========//
	{
		$count=0;
		
		foreach ($dataArray as $dataArr) {
			$state = $dataArr[$valPos[0]];
			$src_port = $dataArr[$valPos[4]];
			$dest_port = $dataArr[$valPos[5]];
			$protocol = $dataArr[$valPos[15]];
			
			$byteToSend = $dataArr[$valPos[11]];
			$byteToReceive = $dataArr[$valPos[12]];
			$totalByteToSend = $dataArr[$valPos[13]];
			$totalbyteToReceive = $dataArr[$valPos[14]];
			
			// remove double quote
			$src_ip = substr($dataArr[$valPos[2]], 1, (strlen($dataArr[$valPos[2]]) -2));
			$dest_ip = substr($dataArr[$valPos[3]], 1, (strlen($dataArr[$valPos[3]]) -2));
			$username = substr($dataArr[$valPos[16]], 1, (strlen($dataArr[$valPos[16]]) -2));
			$applied_rule = substr($dataArr[$valPos[17]], 1, (strlen($dataArr[$valPos[17]]) -2));
			$domain = substr($dataArr[$valPos[21]], 1, (strlen($dataArr[$valPos[21]]) -2));
			$url = substr($dataArr[$valPos[22]], 1, (strlen($dataArr[$valPos[22]]) -2));
			
			if (strcasecmp($dataArr[1], "OUT") == 0){
				// flip src to dest, dest to src
				$ent_src_ip = $dest_ip;
				$ent_dest_ip = $src_ip;
				$ent_src_port = $dest_port;
				$ent_dest_port = $src_port;
			}
			else{
				$ent_src_ip = $src_ip;
				$ent_dest_ip = $dest_ip;
				$ent_src_port = $src_port;
				$ent_dest_port = $dest_port;
			}
			
			$dataInformation = array();
			
			$labelKey="";
			$mult_labelKey = array();
			$addValue=0;
			
			$isSpecialType = false;
			$isUpdateMultiple = false;
			
			if ($group_by == "ip"){
				$labelKey= $ent_src_ip;
			}
			else if ($group_by == "domain"){
				$labelKey= $domain;
			}
			else if ($group_by == "user"){ // empty username
				if (strlen($username) <=0){
					$username = $other_bar_label_no_user;
					$isSpecialType = true;
				}
				$labelKey= $username;
			}
			else if ($group_by == "group"){
				$groupname = "";
				if (strlen($username) <=0){ // empty username
					$groupname = $other_bar_label_no_group;
					$isSpecialType = true;
				}
				else{
					// search group
					foreach ($member_list as $g => $arr) {
					
						foreach ($arr as $arr2) {
							if ($username == $arr2['userName']){
								// is member of that group
								$mult_labelKey[] = $g;
								break;
							}
						}
					}
					
					if (count($mult_labelKey) > 0){
						$isUpdateMultiple = true;
					}
					else
					{
						$groupname = $other_bar_label_no_group;
						$isSpecialType = true;
					}
				}
				$labelKey= $groupname;
			}
			
			// print_r($mult_labelKey);
			
			if ($reprot_type == 1){
				$dataInformation["Bytes to Send"] = $byteToSend;				
				$dataInformation["% of Bytes to Send"] = $byteToSend;
				$dataInformation["Bytes to Receive"] = $byteToReceive;
				$dataInformation["% of Bytes to Receive"] = $byteToReceive;
				
				$addValue=1;
				
				// overwrite
				if ($group_by == "ip")
					$labelKey= $ent_dest_ip;
				
			}
			else if ($reprot_type == 2){
				$dataInformation["Total Bytes to Send"] = $totalByteToSend;
				$dataInformation["% of Total Bytes to Send"] = $totalByteToSend;
				$dataInformation["Total Bytes to Receive"] = $totalbyteToReceive;
				$dataInformation["% of Total Bytes to Receive"] = $totalbyteToReceive;
				
				$addValue=($totalByteToSend+$totalbyteToReceive);
			}
			
			if ($isUpdateMultiple == false){
				if (!array_key_exists($labelKey, $glo_chartDataArray) && $isSpecialType == false){ // not exist
					$exceptCountVal = 0;
					if (array_key_exists($other_bar_label, $glo_chartDataArray))
						$exceptCountVal++;
					if (array_key_exists($other_bar_label_no_user, $glo_chartDataArray))
						$exceptCountVal++;
					if (array_key_exists($other_bar_label_no_group, $glo_chartDataArray))
						$exceptCountVal++;
					if ((count($glo_chartDataArray) - $exceptCountVal) >= $MaxTopEntry){
						$labelKey = $other_bar_label;
					}
				}
				if (isset($glo_chartDataArray[$labelKey])){
					$glo_chartDataArray[$labelKey] += $addValue;
					
					foreach ($dataInformation as $k => $v) {
						$glo_tableContentArray[$labelKey][$k] += $v;
					}
				}
				else{
					$glo_chartDataArray[$labelKey] = $addValue;
					$glo_tableContentArray[$labelKey] = $dataInformation;
				}
			}
			else{
				foreach ($mult_labelKey as $key => $val) {
					if (!array_key_exists($val, $glo_chartDataArray)){ // not exist
						$exceptCountVal = 0;
						if (array_key_exists($other_bar_label, $glo_chartDataArray))
							$exceptCountVal++;
						if (array_key_exists($other_bar_label_no_user, $glo_chartDataArray))
							$exceptCountVal++;
						if (array_key_exists($other_bar_label_no_group, $glo_chartDataArray))
							$exceptCountVal++;
						if ((count($glo_chartDataArray) - $exceptCountVal) >= $MaxTopEntry){
							$mult_labelKey[$key] = $other_bar_label;
						}
					}
					if (isset($glo_chartDataArray[$mult_labelKey[$key]])){
						$glo_chartDataArray[$mult_labelKey[$key]] += $addValue;
						foreach ($dataInformation as $k => $v) {
							$glo_tableContentArray[$mult_labelKey[$key]][$k] += $v;
						}
					}
					else{
						$glo_chartDataArray[$mult_labelKey[$key]] = $addValue;
						$glo_tableContentArray[$mult_labelKey[$key]] = $dataInformation;
					}
				}
			}
			
			$count++;
		}
	}
	// ==========End of Interpret========//
	
	$previous_timestamp = $timestamp;
}

// print_r($glo_chartDataArray);exit();

if (!isset($debugLocal) || !$debugLocal){
	$image_folder_path	= substr($file_name, 0, strlen($file_name) - strlen(strrchr($file_name, "/")) +1);
	$image_name = substr($file_name, (strlen($file_name) - strlen(strrchr($file_name, "/")) +1), strlen($file_name) - ((strlen($file_name) - strlen(strrchr($file_name, "/"))) + strlen(strrchr($file_name, ".")) +1)).$imageSufx;
}

if (count($glo_chartDataArray) >0){
	
	arsort($glo_chartDataArray);
	
	// modify some array field position	
	$tempArray = array();
	
	foreach($glo_chartDataArray as $key => $value){
		if ($key == $other_bar_label){}
		else if ($key == $other_bar_label_no_user){}
		else if ($key == $other_bar_label_no_group){}
		else{
			$tempArray[$key] = $glo_chartDataArray[$key];
		}
	}
	
	// add back
	if (array_key_exists($other_bar_label_no_user, $glo_chartDataArray)){
		$tempArray[$other_bar_label_no_user] = $glo_chartDataArray[$other_bar_label_no_user];
	}
	if (array_key_exists($other_bar_label_no_group, $glo_chartDataArray)){
		$tempArray[$other_bar_label_no_group] = $glo_chartDataArray[$other_bar_label_no_group];
	}
	if (array_key_exists($other_bar_label, $glo_chartDataArray)){
		$tempArray[$other_bar_label] = $glo_chartDataArray[$other_bar_label];
	}
	
	$glo_chartDataArray = $tempArray;
	
	// final adjust value 
	if ($reprot_type == 1){
	}
	else if ($reprot_type == 2){
		$maxVal = max($glo_chartDataArray);
		
		$divUnit = 1;
		
		if ($maxVal<1024){
			$divUnit = 1;
			$unit="Byte";
		}
		else if ($maxVal<1024*1024){
			$divUnit = 1024;
			$unit="KB";
		}
		else if ($maxVal<1048576*1024){
			$divUnit = 1024*1024;
			$unit="MB";
		}
		else{
			$divUnit = 1048576*1024;
			$unit="GB";
		}
			
		$xColStr.=" (".$unit.")";
		$valueTitle.=" (".$unit.")";
	
	
		foreach ($glo_chartDataArray as $key => $value){
			$glo_chartDataArray[$key] = round($value/$divUnit,2);
		}
	}
	
	// calculate total
	$total = array();
	$totalKeyValue=0;
	foreach ($glo_chartDataArray as $key => $value){
		foreach ($glo_tableContentArray[$key] as $c_key => $c_val){
			if (!array_key_exists($c_key, $total))
			{
				$total[$c_key] = $c_val;
			}
			else{
				$total[$c_key] += $c_val;
			}
		}
		$totalKeyValue+=$value;
	}

	// createBarChartImage($image_folder_path.$image_name, $glo_chartDataArray);
	
	
	// create bar chart image
	if (1)
	{
		$chartDataArray = $glo_chartDataArray;
		$filename = $image_folder_path.$image_name;
		
		// Init
		$bar_width=20;
		$numOfGrid=20;

		$org_margin_left=40;
		$margin_left=$org_margin_left;
		$margin_right=40;
		$margin_top=30;
		$margin_bottom=40;
		
		$margin_side=4;

		$title_font_size=4;
		$xColTitle_font_size=2;
		$yColTitle_font_size=2;
		$xCol_font_size=1;
		$yCol_font_size=2;

		$numOfChar = 0;
			
		foreach ($chartDataArray as $key => $value){
			if ($numOfChar < strlen($key)){
				$numOfChar = strlen($key);
			}
		}

		// adjust
		$margin_left= $margin_left + ceil($numOfChar*imagefontwidth($yCol_font_size));

		$totalBar=count($chartDataArray)+2;
		print("totalBar + 2 =".$totalBar."\n");

		// adjust the scale 
		$max_value=max($chartDataArray);
		
		print("max_value=".$max_value."\n");
		
		$isInt = true;
		foreach ($chartDataArray as $val){
			if (!is_int($val)){
				$isInt = false;
				break;
			}
		}
		
		$perGrid = round($max_value/($numOfGrid-1), 2);
		
		print("perGrid=".$perGrid."\n");
		
		if ($perGrid <= 0)
			$perGrid = 1;
			
		print("isInt=".$isInt."\n");
		
		if ($isInt == true){
			$perGrid = ceil($perGrid);
			print("New perGrid=".$perGrid."\n");
		}
		
		$numOfMarkChar = 0;
		for ($i=1; $i<$numOfGrid+1; $i++){
			if (strlen($i* $perGrid) > $numOfMarkChar)
				$numOfMarkChar = strlen($i* $perGrid);
		}
		
		print("numOfMarkChar=".$numOfMarkChar."\n");
		
		if ($bar_width <= $numOfMarkChar*imagefontwidth($xCol_font_size)){
			$bar_width = ceil($numOfMarkChar*imagefontwidth($xCol_font_size)) + 5;
		}
		
		$imgWidth=$bar_width * $numOfGrid;
		$imgHeight=$bar_width * $totalBar;

		$screenW = $margin_left+$imgWidth+$margin_right;
		$screenH = $margin_top+$imgHeight+$margin_bottom;
		
		// check screen height 
		if ($screenH <= strlen($yColStr)*imagefontwidth($yColTitle_font_size)){
			$screenH = strlen($yColStr)*imagefontwidth($yColTitle_font_size) + 10;
		}

		// Create image and define colors
		$image=imagecreate($screenW, $screenH);
		$colorWhite=imagecolorallocate($image, 255, 255, 255);
		$colorGrey=imagecolorallocate($image, 192, 192, 192);
		$colorDarkBlue=imagecolorallocate($image, 104, 157, 228);
		$colorLightBlue=imagecolorallocate($image, 184, 212, 250);
		$colorDark=imagecolorallocate($image, 0, 0, 0);
		$xColTextColor=imagecolorallocate($image, 120, 120, 120);
		$yColTextColor=imagecolorallocate($image, 100, 100, 100);

		$x1= ceil($screenW/2) - ceil(strlen($titleStr)*imagefontwidth($title_font_size)/2);
		$y1= 0+$margin_side;
		// title
		imagestring($image, $title_font_size, $x1, $y1, $titleStr, $colorDark);
		// line
		imageline($image, $x1, imagefontheight($title_font_size)+$margin_side+1, $x1+(strlen($titleStr)*imagefontwidth($title_font_size))+1, imagefontheight($title_font_size)+$margin_side+1, $colorDark);

		$x1= ceil($screenW/2) - ceil(strlen($xColStr)*imagefontwidth($xColTitle_font_size)/2);
		$y1= $screenH - imagefontheight($xColTitle_font_size) -$margin_side;
		// xCol string 
		imagestring($image, $xColTitle_font_size, $x1, $y1, $xColStr, $colorDark);

		// create new image to use for output. fill with transparency. ALPHA BLENDING MUST BE FALSE
		$image2 = imagecreatetruecolor($screenH, $screenW);
		imagealphablending($image2, false);
		$transBg = imagecolortransparent($image2, imagecolorallocatealpha($image2, 255, 255, 255, 127));
		imagefill($image2, 0, 0, $transBg);

		$x1= ceil($screenH/2) - ceil(strlen($yColStr)*imagefontwidth($yColTitle_font_size)/2);
		$y1=0+$margin_side;
		// yCol string 
		imagestring($image2, $yColTitle_font_size, $x1, $y1, $yColStr, $colorDark);
		// Rotate
		$image2 = imagerotate($image2, 90, 0);
		imagecopymerge($image, $image2, 0, 0, 0, 0, $screenW, $screenH, 100);

		// Create border around image
		$x1=$margin_left;
		$x2=$imgWidth+ $margin_left -1;
		$y1=$margin_top;
		$y2=$imgHeight+ $margin_top -1;

		imageline($image, $x1, $y1, $x1, $y2, $colorGrey);
		imageline($image, $x1, $y1, $x2, $y1, $colorGrey);
		// imageline($image, $x2, $y1, $x2, $y2, $colorGrey);
		imageline($image, $x1, $y2, $x2, $y2, $colorGrey);


		// Create grid
		for ($i=1; $i<$totalBar; $i++){
			// horizontal(x)
			imageline($image, $margin_left, $margin_top+($i*$bar_width), $margin_left+$imgWidth, $margin_top+($i*$bar_width), $colorGrey);
		}
			
		for ($i=1; $i<$numOfGrid+1; $i++){
			// vertical(y)
			imageline($image, $margin_left+($i*$bar_width), $margin_top, $margin_left+($i*$bar_width), $margin_top+$imgHeight, $colorGrey);

			$x1=$margin_left+($i*$bar_width);
			$y1=$margin_top+$imgHeight;
			$mark= ($i*$perGrid);
			$space= ceil(strlen($mark)*imagefontwidth($xCol_font_size)/2);
			
			imagestring($image, $xCol_font_size, $x1-$space, $y1+2, $mark, $xColTextColor);
		}

		// // Add some shadow to the text
		// imagettftext($im, 20, 0, 11, 21, $grey, $font, $text);

		// // Add the text
		// imagettftext($im, 20, 0, 10, 20, $black, $font, $text);


		// Create bar charts
		$countBar=1;
		foreach ($chartDataArray as $key => $value){
			
			$x1=$margin_left;
			$x2=$margin_left+($chartDataArray[$key]/($perGrid/$bar_width));
			
			$y1=$margin_top+($countBar*$bar_width);
			$y2=$margin_top+(($countBar+1)*$bar_width);
			
			if ($x1 != $x2)
			{
				// orginal bar
				imagefilledrectangle($image, $x1, $y1, $x2, $y2, $colorDarkBlue);
				// hight light
				imagefilledrectangle($image, $x1+1, $y1+1, $x2-2, $y2-5, $colorLightBlue);
			}
			
			$space_w = ceil(strlen($key)*imagefontwidth($yCol_font_size));
			$space_h = ceil(imagefontheight($yCol_font_size)/2);
			
			// texts
			imagestring($image, $yCol_font_size, $x1-$space_w-2, $y1+($bar_width/2)-$space_h, $key, $yColTextColor);
			// value
			imagestring($image, $yCol_font_size, $x2+2, $y1+($bar_width/2)-$space_h, $value, $colorDark);
			
			$countBar++;
		}

		// Output graph and clear image from memory
		imagejpeg($image, $filename);
		imagedestroy($image);
		
	}
	
	
	// create pipe chart image
	if (0)
	{
		$chartDataArray = $glo_chartDataArray;
		$filename = $image_folder_path.$image_name;
		
		// convert value into percentage
		foreach ($chartDataArray as $key => $val){
			$chartDataArray[$key] = round(round(($val*100)/($totalKeyValue),2)*360/100,0);
		}
		
		print_r($chartDataArray);
		
		// label
		
		$title_font_size=4;
		$pLabel_font_size=2;
		$numOfChar = 0;
			
		foreach ($chartDataArray as $key => $value){
			if ($numOfChar < strlen($key)){
				$numOfChar = strlen($key);
			}
		}
		
		$labelSquare=20;
		$label_margin_left=20;
		$label_margin_right=20;
		$label_margin_top=20;
		$label_margin_bottom=20;
		$label_space_x=10;
		$label_space_y=10;
		
		if($labelSquare <= imagefontheight($pLabel_font_size)){
			$labelSquare = imagefontheight($pLabel_font_size);
		}
		
		$totalBar=count($chartDataArray);
		
		$labelImage_w= $label_margin_left + $labelSquare + $label_space_x + ceil($numOfChar*imagefontwidth($pLabel_font_size)) + $label_margin_right;
		$labelImage_h= $label_margin_top + (($labelSquare + $label_space_y) * $totalBar) + $label_margin_bottom;
		
		$labelImage = imageCreateTrueColor($labelImage_w,$labelImage_h);
		$white=imagecolorallocate($labelImage, 255, 255, 255);
		$black=imagecolorallocate($labelImage, 0, 0, 0);
		imagefill($labelImage,0,0,$white);
		imagerectangle($labelImage, 0, 0, $labelImage_w-1, $labelImage_h-1, $black);
		
		// chart
		
		$chartRadius=200;
		$border_w=1;
		$margin=2;
		
		$chartImage_w=$chartRadius*8;
		$chartImage_h=$chartRadius*8;
		$antiChartImage_w=$chartRadius*2;
		$antiChartImage_h=$chartRadius*2;
		
		$chartImage = imageCreateTrueColor($chartImage_w,$chartImage_h);
		$anti_chartImage = imageCreateTrueColor($antiChartImage_w,$antiChartImage_h);		
		
		$white=imagecolorallocate($chartImage, 255, 255, 255);
		$gray=imagecolorallocate($chartImage, 200, 200, 200);
		$black=imagecolorallocate($chartImage, 0, 0, 0);
		
		imagefill($chartImage,0,0,$white);
		
		$chart_w=($chartImage_w -($border_w*8))-$margin;
		$chart_h=($chartImage_h -($border_w*8))-$margin;

		// draw the border of the pie
		imagearc($chartImage,round($chartImage_w/2),round($chartImage_h/2),$chartImage_w-$margin,$chartImage_h-$margin,0,360,$black);
		
		// init position (in degrees) where to place the next piece
		$position=270;
		
		// we will use calculated colors for simple example
		$colorRValue=255;
		$colorGValue=255;
		$colorBValue=255;
		
		$countBar =0;
		foreach($chartDataArray as $k => $deg)
		{
			// calculate color
			// if($colorGValue==255){
				// $colorRValue+=50;
				// $colorBValue+=50;
				// if($colorRValue>255){
					// $colorRValue=255;
				// }
				// if($colorBValue>255){
					// $colorBValue=255;
				// }
			// }
			// else if($colorGValue>255){
				// $colorGValue=255;
			// }
			// else{
				// $colorGValue+=30;
			// }
			if($countBar%3==0){
				$colorRValue-=40;
				if($colorRValue < 0)
					$colorRValue = 255;
				
			}
			else if($countBar%2==0){
				$colorGValue-=50;
				if($colorGValue < 0)
					$colorGValue = 255;
			}
			else{
				$colorBValue-=60;
				if($colorBValue < 0)
					$colorBValue = 255;
			}
			
			$color=imagecolorallocate($chartImage,$colorRValue,$colorGValue,$colorBValue);

			// position must be kept < 360
			if($position>360) $position-=360;

			// imagefilledarc($chartImage, round($chartImage_w/2), round($chartImage_h/2), $chart_w, $chart_h, $position, $position+$deg, $color, IMG_ARC_EDGED);
			
			// we use some maths to calculate the pixel on the circle
			$pix_x=round(floor(($chartImage_w-$margin)/2)*cos($position/180*M_PI) +round($chartImage_w/2));
			$pix_y=round(floor(($chartImage_h-$margin)/2)*sin($position/180*M_PI) +round($chartImage_h/2));
			// now we  draw a line from the mid of the circle to the
			// calculated pixel on the circle
			imageline($chartImage, round($chartImage_w/2), round($chartImage_h/2), $pix_x, $pix_y, $black);
			
			$fill_x=floor($chartImage_w/2)-2;
			$fill_y=3;
			
			// now we flood fill the circle
			@imagefilltoborder ($chartImage,$fill_x,$fill_y,$black,$color);
			
			$x1 = $label_margin_left;
			$x2 = $x1 + $labelSquare;
			$y1 = $label_margin_top + ($countBar*$labelSquare) + ($countBar*$label_space_y);
			$y2 = $y1 + $labelSquare;
			
			$cur_label_color=imagecolorallocate($labelImage,$colorRValue,$colorGValue,$colorBValue);
			imagefilledrectangle($labelImage, $x1, $y1, $x2, $y2, $cur_label_color);
			
			$x3 = $x2+$label_space_x;
			$y3 = (($y1+$y2)/2) - (imagefontheight($pLabel_font_size)/2);
			
			imagestring($labelImage, $pLabel_font_size, $x3, $y3, $k, $black);
			
			// the position of the next piece is $deg degrees further
			$position+=$deg;
			
			$countBar++;
		}		
		
		imagecopyresampled($anti_chartImage,$chartImage,0,0,0,0,$antiChartImage_w,$antiChartImage_h,$chartImage_w,$chartImage_h);
		
		$screen_margin_left=20;
		$screen_margin_right=20;
		$screen_margin_top=20;
		$screen_margin_bottom=20;
		$screen_space_x=20;
		$screen_space_y=20;
		
		$screen_w=$screen_margin_left + imagesx($anti_chartImage) + $screen_space_x + imagesx($labelImage) + $screen_margin_right;
		
		$lHeight = imagesy($anti_chartImage) + imagefontheight($title_font_size) + $screen_space_y;
		if (imagesy($labelImage) > $lHeight)
			$lHeight = imagesy($labelImage);
		
		$screen_h=$screen_margin_top + $lHeight + $screen_margin_bottom;
		
		$screenImage = imageCreateTrueColor($screen_w,$screen_h);
		$white=imagecolorallocate($screenImage, 255, 255, 255);
		$black=imagecolorallocate($screenImage, 0, 0, 0);
		imagefill($screenImage,0,0,$white);
		
		imagecopyresampled($screenImage,$anti_chartImage,$screen_margin_left,$screen_margin_top,0,0,imagesx($anti_chartImage),imagesy($anti_chartImage),imagesx($anti_chartImage),imagesy($anti_chartImage));
		imagecopyresampled($screenImage,$labelImage,$screen_margin_left+imagesx($anti_chartImage)+$screen_space_x,$screen_margin_top,0,0,imagesx($labelImage),imagesy($labelImage),imagesx($labelImage),imagesy($labelImage));
		
		$x1= ceil(($screen_margin_left + imagesx($anti_chartImage) + $screen_space_x)/2) - ceil(strlen($titleStr)*imagefontwidth($title_font_size)/2);
		$y1= $screen_margin_top + imagesy($anti_chartImage) + $screen_space_y;
		
		// title
		imagestring($screenImage, $title_font_size, $x1, $y1, $titleStr, $black);
		// line
		imageline($screenImage, $x1, imagefontheight($title_font_size)+$y1+1, $x1+(strlen($titleStr)*imagefontwidth($title_font_size))+1, imagefontheight($title_font_size)+$y1+1, $black);

		
		// imagejpeg($chartImage, $filename);
		// imagejpeg($anti_chartImage, $filename);
		// imagejpeg($labelImage, $filename);
		imagejpeg($screenImage, $filename);
		
		// Output graph and clear image from memory
		imagedestroy($screenImage);
	}
		
	// create table content
	{
		$glo_content.='<table id="ta" width="100%" border="1" cellspacing="2" cellpadding="2">';
		
		$isFirstRow=false;
		$rowCount=1;
		
		// checking
		$checkSumPercentage = array();
		
		$isRoundModify = true;
		foreach ($glo_chartDataArray as $key => $value){
			$tmpStr = "";
			$tmpStr2 = "";
			foreach ($glo_tableContentArray[$key] as $c_key => $c_val){
				$tmp_val = $c_val;
				
				if ($c_key == "Bytes to Send" || $c_key == "Bytes to Receive" || $c_key == "Total Bytes to Send" || $c_key == "Total Bytes to Receive")
				{
					if ($tmp_val<1024)
						$tmp_val = $tmp_val." Byte";
					else if ($tmp_val<1024*1024)
						$tmp_val = round($tmp_val/1024, 2)." KB";
					else if ($tmp_val<1048576*1024)
						$tmp_val = round($tmp_val/(1024*1024),2)." MB";
					else 
						$tmp_val = round($tmp_val/(1048576*1024),2)." GB";
				}
				else if ($c_key == "% of Bytes to Send" || $c_key == "% of Bytes to Receive" || $c_key == "% of Total Bytes to Send" || $c_key == "% of Total Bytes to Receive")
				{
					$val = ($tmp_val*100)/($total[$c_key]);
					$tmp_val = round($val,2);
					
					// if ($tmp_val > $val){
						// // round up
						// if ($isRoundModify == true){
							// $tmp_val -= 0.01;
							// $isRoundModify = false;
						// }
						// else{
							// $isRoundModify = true;
						// }
					// }
					// else if ($tmp_val < $val){
						// // round down
						// if ($isRoundModify == true){
							// $tmp_val += 0.01;
							// $isRoundModify = false;
						// }
						// else{
							// $isRoundModify = true;
						// }
					// }
					
					if (!array_key_exists($c_key, $checkSumPercentage)){
						$checkSumPercentage[$c_key] = $tmp_val;
					}
					else
						$checkSumPercentage[$c_key] += $tmp_val;
					
					$tmp_val .= " %";
				}
			
				$tmpStr .= '<td width="" NOWRAP>'.$tmp_val.'</td>';
				$tmpStr2 .= '<td width="" NOWRAP>'.$c_key.'</td>';
			}
			
			if ($isFirstRow == false){
				$glo_content .= '
					<tr style="font-weight:bold;">
						<td width="" NOWRAP>No</td>
						<td width="" NOWRAP>'.$keyTitle.'</td>
						<td width="" NOWRAP>'.$valueTitle.'</td>
						'.$tmpStr2.'
					</tr>
				';
				$isFirstRow=true;
			}
			
			$glo_content .= '
				<tr style="">
					<td width="" NOWRAP>'.$rowCount.'</td>
					<td width="" NOWRAP>'.$key.'</td>
					<td width="" NOWRAP>'.$value.'</td>
					'.$tmpStr.'
				</tr>
			';
			
			$rowCount++;
			
		}
		
		print_r($checkSumPercentage);
		
		// Total 
		$tmpTotalStr="";
		foreach ($total as $c_key => $c_val){
			$tmp_val = $c_val;
				
			if ($c_key == "Bytes to Send" || $c_key == "Bytes to Receive" || $c_key == "Total Bytes to Send" || $c_key == "Total Bytes to Receive")
			{
				if ($tmp_val<1024)
					$tmp_val = $tmp_val." Byte";
				else if ($tmp_val<1024*1024)
					$tmp_val = round($tmp_val/1024, 2)." KB";
				else if ($tmp_val<1048576*1024)
					$tmp_val = round($tmp_val/(1024*1024),2)." MB";
				else 
					$tmp_val = round($tmp_val/(1048576*1024),2)." GB";
			}
			else if ($c_key == "% of Bytes to Send" || $c_key == "% of Bytes to Receive" || $c_key == "% of Total Bytes to Send" || $c_key == "% of Total Bytes to Receive")
			{
				$tmp_val = round(($tmp_val*100)/($total[$c_key]),2)." %";
			}
		
			$tmpTotalStr .= '<td width="" NOWRAP>'.$tmp_val.'</td>';
		}
		
		$glo_content .= '
					<tr style="font-weight:bold;">
						<td width="" NOWRAP></td>
						<td width="" NOWRAP>Total</td>
						<td width="" NOWRAP>'.$totalKeyValue.'</td>
						'.$tmpTotalStr.'
					</tr>
				';
		
		$glo_content.='</table>';
	}
}
else{
	// update tmp empty control report file
	$fp = fopen($tmpEmptyReport, 'w');
	fwrite($fp, $file_name);
	fclose($fp);
	exit();
}

// reads a csv file and returns a two-dimensional array of lines/fields 
function read_csv($file,$delimiter, $ignoreFirstLine) 
{
	$data_array = file($file);	
	$parts_array = array();
	
	for ( $i = 0; $i < count($data_array); $i++ ) 
	{ 
		if ($ignoreFirstLine == true && $i == 0)
			continue;
			
		$parts_array[$i] = explode($delimiter,$data_array[$i]); 
	} 
	return $parts_array; 
}

// reads a csv file and returns an two-dimensional array of lines/fields 
function select_csv($file,$delimiter,$field,$appliedArray, $ignoreFirstLine) 
{
	$data_array = file($file);
	$result_array = array();
	
	for ( $i = 0; $i < count($data_array); $i++ ) 
	{ 
		if ($ignoreFirstLine == true && $i == 0)
			continue;
			
		$parts_array[$i] = explode($delimiter,$data_array[$i]);
		
		foreach ($appliedArray as $key => $value) {
			if(trim(strtolower($parts_array[$i][$field])) == trim(strtolower($value))) 
			{ 
				$result_array[] = $parts_array[$i]; 
				break;
			} 
		}
	} 
	return $result_array; 
}
?>

<?php

$content='
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Report</title>
<style type="text/css">
	table {
		font-family: Arial, sans-serif;
		font-size: 8pt;
	}
</style>
</head>
<body>
<table border="0">
<tr><td style="font-weight: bold; font-size: 14px; padding-top: 7px; padding-bottom: 7px; color: green;">'.$glo_desc.'</td></tr>
<tr><td>
<img src="'.$image_name.'" />
</td></tr>
<tr><td>
'.$glo_content.'
</td></tr>
</table>
<div id="di">
</div>
</body>
</html>
';

$fp = fopen($file_name, 'w');
fwrite($fp, $content);
fclose($fp);

echo "OK the end.\n";
echo "-->";

echo $content;

?>
