<?php
	require_once "cmvar.php";
	
	$ret = 0;
	$report_file="";
	$alertMsg="";
	$divMsg="";
	$query="";
	$gen_file="";
	
	$currentTime = time();	
	$reportDir = 'report/';
	$reportSufx = '.html';
	$resultArray = array();
	$tmpReport = "_tmp_report";
	$tmpEmptyReport = "_tmp_empty_report";
	
	$myobj = new COM("EGCONFIG.Cfgmgr") or die("reportResult.php EGCONFIG.Cfgmgr Object cannot be created!");
	
	if (isset($_GET['cancelGenerateReport']) && ($_GET['cancelGenerateReport'] == 1 )){
		if (isset($_SESSION['wait_report']) && ($_SESSION['wait_report'] != "" || strlen($_SESSION['wait_report']) > 0)){
			// terminate process
			$result = $myobj->terminateProcessByIdName($_SESSION['wait_report']);
			
			$_SESSION['cancelGenerateReport'] = 1;
		}
		else{
			// something wrong missing wait_report
		}
		
		$myobj=null;
		exit();
	}
	
	if (isset($_SESSION['cancelGenerateReport']) && ($_SESSION['cancelGenerateReport'] == 1 )){
		// check process is it exist			
		$result = $myobj->checkProcessByIdName($_SESSION['wait_report']);
		
		$_SESSION['cancelGenerateReport'] = 0;
		
		if ($result == 'exist'){
			// process still exist
			$ret = -1;
			$divMsg .= get_cm_var('report_cancel_generate_report_Fail');
		}
		else{
			// process not exist
			$ret = 3;
			$divMsg .= get_cm_var('report_cancel_generate_report_success');
			
			// reset
			$_SESSION['wait_report'] = "";
			
			// remvoe tmp control report file
			if (is_file($tmpReport)){
				unlink($tmpReport);
			}
		}
	}	
	else if(isset($_SESSION['wait_report']) && ($_SESSION['wait_report'] != "" || strlen($_SESSION['wait_report']) > 0)){
		// check file is it exist
		if (is_file($_SESSION['wait_report'])){
			// exist
			$ret = 1;
			
			$report_file=$_SESSION['wait_report'];
			
			// reset
			$_SESSION['wait_report'] = "";
			
			// remvoe tmp control report file
			if (is_file($tmpReport)){
				unlink($tmpReport);
			}
			
		}
		else{
			// check process is it exist			
			$result = $myobj->checkProcessByIdName($_SESSION['wait_report']);
			
			if ($result == 'exist'){
				// process exist, remain wait state
				$report_file=$_SESSION['wait_report'];
			}
			else{
				// process not exist
				$ret = -1;
				
				// check tmp empty control report file
				if (is_file($tmpEmptyReport)){
					$divMsg .= get_cm_var('report_generation_failure_by_empty');
				}
				else
					$divMsg .= get_cm_var('report_generation_failure');
				
				// reset
				$_SESSION['wait_report'] = "";
				
				// remvoe tmp control report file
				if (is_file($tmpReport)){
					unlink($tmpReport);
				}
			}
		}
	}
	else{
		// create report
		
		// common report attribute
		$timerange_start = 0;
		$timerange_end = $currentTime;
		if ($_GET['time_range'] == 'date_range') {
			$treatStartDate = explode('-', $_GET['time_range_start']);
			if (!checkdate($treatStartDate[1], $treatStartDate[2], $treatStartDate[0])) {
				$ret = -1;
				$alertMsg .= get_cm_var('js_alert_report_8');
			}
			$timerange_start = mktime(0, 0, 0, $treatStartDate[1], $treatStartDate[2], $treatStartDate[0]);

			$treatEndDate = explode('-', $_GET['time_range_end']);
			if (!checkdate($treatEndDate[1], $treatEndDate[2], $treatEndDate[0])) {
				$ret = -1;
				$alertMsg .= get_cm_var('js_alert_report_9');
			}
			$timerange_end = mktime(0, 0, 0, $treatEndDate[1], $treatEndDate[2], $treatEndDate[0]) + 86400;
		}
		
		$group_by="";
		$for_sp="";
		
		if (isset($_GET['stat_about'])){
			switch ($_GET['stat_about']){
				case 1: // most visited site
				{
					if (isset($_GET['group_by']) && ($_GET['group_by'] == "ip" || $_GET['group_by'] == "domain")){
						$group_by=$_GET['group_by'];
						
						$report_file = $reportDir."report_visited_site_".date('Y.m.d_H.i.s', $currentTime).$reportSufx;
						$gen_file = "gen_report.php";
						$query = "reprot_type=1 file_name=$report_file timerange_start=$timerange_start timerange_end=$timerange_end group_by=$group_by";
						
					}
					else{
						$ret = -1;
						$alertMsg .= get_cm_var('js_alert_report_10');
					}
					
					if ($ret != -1){
						$for_sp=$_GET['for_sp'];
						
						$query .= " for_sp=$for_sp";
						
						if($for_sp == "user"){
							if (isset($_GET['chosen_user_list_data']))
								$query .= " chosen_user_list_data=".addslashes($_GET['chosen_user_list_data']);
							else{
								$ret = -1;
								$alertMsg .= get_cm_var('js_alert_report_2');
							}
						}
						else if($for_sp == "ip"){
						
							// if (isset($ser_sp_ip)){
								// $sp_ip = unserialize($ser_sp_ip);
								// $query .= " chosen_ip_list_data=".addslashes(json_encode($sp_ip));
							// }
							
							if (isset($_GET['chosen_ip_list_data']))
								$query .= " chosen_ip_list_data=".addslashes($_GET['chosen_ip_list_data']);
							else{
								$ret = -1;
								$alertMsg .= get_cm_var('js_alert_report_3');
							}
						}
						else if($for_sp == "group"){
							
							if (isset($_GET['chosen_group_list_data']))
								$query .= " chosen_group_list_data=".addslashes($_GET['chosen_group_list_data']);
							else{
								$ret = -1;
								$alertMsg .= get_cm_var('js_alert_report_12');
							}
						}
					}
				}
				break;
				case 2: // most bandwidth used 
				{
					if (isset($_GET['group_by']) && ($_GET['group_by'] == "ip" || $_GET['group_by'] == "user" || $_GET['group_by'] == "group")){
						$group_by=$_GET['group_by'];
						
						$report_file = $reportDir."report_visited_site_".date('Y.m.d_H.i.s', $currentTime).$reportSufx;
						$gen_file = "gen_report.php";
						$query = " reprot_type=2 file_name=$report_file timerange_start=$timerange_start timerange_end=$timerange_end group_by=$group_by";
						
					}
					else{
						$ret = -1;
						$alertMsg .= get_cm_var('js_alert_report_10');
					}
					
					if ($ret != -1){
						$for_sp=$_GET['for_sp'];
						
						$query .= " for_sp=$for_sp";
						
						if($for_sp == "user"){
							if (isset($_GET['chosen_user_list_data']))
								$query .= " chosen_user_list_data=".addslashes($_GET['chosen_user_list_data']);
							else{
								$ret = -1;
								$alertMsg .= get_cm_var('js_alert_report_2');
							}
						}
						else if($for_sp == "ip"){							
							if (isset($_GET['chosen_ip_list_data']))
								$query .= " chosen_ip_list_data=".addslashes($_GET['chosen_ip_list_data']);
							else{
								$ret = -1;
								$alertMsg .= get_cm_var('js_alert_report_3');
							}
						}
						else if($for_sp == "group"){							
							if (isset($_GET['chosen_group_list_data']))
								$query .= " chosen_group_list_data=".addslashes($_GET['chosen_group_list_data']);
							else{
								$ret = -1;
								$alertMsg .= get_cm_var('js_alert_report_12');
							}
						}
					}
				}
				break;
				default :{
					$ret = -1;
					$alertMsg .= get_cm_var('js_alert_report_11');
					break;
				}
			}
			
			
		}
		else{
			$ret = -1;
			$alertMsg .= get_cm_var('js_alert_report_11');
		}
		
		// run command
		if ($ret != -1){
			$fs_path = $myobj->getFsPath();
			
			$cmd = "\"" . $fs_path . "dispatcher\\create_process.exe\" \"".$report_file."\" "."\"\\\"" . $fs_path . "www\\PHP\\php.exe\\\" "."\\\"" . $fs_path . "cfgmgr\\".$gen_file."\\\" ".$query."\"";

			// echo $cmd;exit();
			
			$myobj->runCommandNoWait($cmd);
			
			$ret = 2;
			$_SESSION['wait_report'] = $report_file;
			
			// remvoe tmp empty control report file
			if (is_file($tmpEmptyReport)){
				unlink($tmpEmptyReport);
			}
			
			// update tmp control report file
			$fp = fopen($tmpReport, 'w');
			fwrite($fp, $report_file);
			fclose($fp);
		}
		
	}
	
	$myobj = null;
	
	$resultArray["return"] = $ret;
	$resultArray["report_file"] = $report_file;
	$resultArray["alertMsg"] = $alertMsg;
	$resultArray["divMsg"] = $divMsg;
	echo json_encode($resultArray);
?>
