<?php

header('Cache-Control: no-cache, must-revalidate');
require_once "cmvar.php";

$rfmResult = array();
if (isset($_SESSION['fs_reduce'])) {
	$rfmResult = explode("|", $_SESSION['fs_reduce']);
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>What is Reduced Functionality Mode?</title>
<style type="text/css">
<!--
body { font-family: sans-serif; font-size:0.9em; }
-->
</style>
</head>
<body>
EaseGate&trade; will validate your license key online during startup phase. If there is a problem with the validation
(e.g. External connection problem, MAC address does not match our record,), EaseGate&trade; will enter into <i>Reduced Functionality Mode</i> 
(limited to 15 minutes per login session, 5 concurrent users).<br><br>
Please make sure during EaseGate startup:<br>
1) Your EaseGate machine has a valid External connection (check DNS too. You can use command line tool nslookup to double-check). Note that EaseGate will query patronsoft.com and www.EaseGate.info at port 443 (i.e. https) during startup. Make sure your firewall does not block this.<br>
2) Your time in your EaseGate machine is correct.<br>
<br>
Please fix your External connection, and then restart EaseGate.<br>
<br>

<p style="color:#063">
<?php

if (isset($rfmResult[1]) && $rfmResult[1] != 0) {
	$rfmReason = '';
	switch ($rfmResult[1]) {
	case 12002:
		$rfmReason = get_cm_var('setrf_reason_12002');
		break;
	case 12007:
		$rfmReason = get_cm_var('setrf_reason_12007');
		break;
	case 12031:
		$rfmReason = get_cm_var('setrf_reason_12031');
		break;
	case 12037:
		$rfmReason = get_cm_var('setrf_reason_12037');
		break;
	case 20000:
		$rfmReason = get_cm_var('setrf_reason_20000');
		break;
	default:
	}

	if ($rfmResult[1] < 20000) {
?>
	<?=get_cm_var('setrf_label_HTTP_err_code')?> <?=$rfmResult[1]?><br>
<?php

	}
	if ($rfmReason != '') {
?>
	<?=get_cm_var('setrf_label_reason')?> <?=$rfmReason?><br>
<?php

	}
}

?>
</p>
</body>
</html>
