<?php

// security check
require_once 'secureLogin.php';

$category = 'r';
require_once 'validate.php';
require_once 'display_list.php';

// 20090518 - Remove Start, add Premium
if (substr_count(strtolower($version), 'standard') > 0 || substr_count(strtolower($version), 'premium') > 0) {
    if (substr_count(strtolower($version),'donation')>0)
        $version = substr($version,0,strlen($version)-9);
    $disabled = ' disabled';
    $version_msg = '*This feature is not available in '.ucwords($version).' Edition.';
    $version_star = '<span class="star">*</span>';
} else {
    $disabled = '';
    $version_msg = '';
    $version_star = '';
}

// purge if cancel
if (isset($purge)&&($purge=='true')) {
    $ser_display_route=NULL;
    $ser_add_route=NULL;
}

// register sessions, if needed
if(!isset($num_return_path)) {
    $num_return_path = '';
    session_register('num_return_path');
}
if(!isset($return_path)) {
    $return_path = '';
    session_register('return_path');
}


if (!isset($ser_display_route)||($ser_display_route == '')) {
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('setroute.php EGCONFIG.Cfgmgr Object cannot be created!');
    $num_return_path = $settingobj->getKey('num_return_path', 'MNS');

    $tmp_num = '0'.trim($num_return_path);
    $num = (int)$tmp_num;

    $display_route = new Site_Array;
	$return_path = array();
    $i = 0;
    while ($i < $num) {
        $Login_php_Num = $settingobj->getKey("Login_php_Num$i", 'loginPhp');
        $Login_php_Num = trim($Login_php_Num);
        $enable_php = $settingobj->getKey("Login_enable$i", 'loginPhp');
        $enable_php = trim($enable_php);
        $enable_php = (int)$enable_php;
        $return_path[$i] = $settingobj->getKey("return_path$i", 'MNS');
        $strarray = split(' ', trim($return_path[$i]));
        $display_route->add_site($strarray[0],$strarray[1],'false',$enable_php,$Login_php_Num);
        $display_route->site_list[$i]->span = $strarray[2];
        $i++;
    }
    //$settingobj->Release();
    $settingobj=null;

    $ser_display_route = serialize($display_route);
    session_register('ser_display_route');
}

if (!isset($ser_add_route)||($ser_add_route == '')) {
    $add_route = new Site_Array;
    $ser_add_route = serialize($add_route);
    session_register('ser_add_route');
}

// unserialize data
if (isset($ser_display_route)&&($ser_display_route !== '')) {
    $display_route = unserialize($ser_display_route);
}
if (isset($ser_add_route)&&($ser_add_route !== '')) {
    $add_route = unserialize($ser_add_route);
}

echo '<link rel="stylesheet" href="setcfg.css" type="text/css" />';

// include menu
require_once 'menu.php';

gen_head();

gen_license_warning($version_msg);

if (isset($saving_msg_route)&&$saving_msg_route==1) {
    echo '    <tr><td><span class="captionbig" style="color: #FF0000;">'.get_cm_var('setcfg_multi_net_seg_confirm_del_by_saving').'</span></td></tr>';
    $saving_msg_route=0;
}

?>

        </div></table>

<script type="text/javascript">
<!--
function combo_submit(element)
{
    document.combo.item_no_route.value = element;
    document.combo.submit();
}
// -->
</script>


<style type="text/css">
    input.noborder { border: 0; }
    form { margin: 0; padding: 0; }
    fieldset { padding: 10px; width: 80%; border: 1px solid green; display: block; }
    fieldset p { margin: 3px 0px; }
    legend { color: green; padding: 0px 8px; }
    label { width: 150px; float: left; }
    .odd { background: #FFF; }
    .even { background: #F0F0F0; }
    .checked { background: #BAEAD6; }
    #route_table { border:1px solid #99D1A2; border-bottom: 0; }
    #route_table td { border-bottom:1px solid #99D1A2; }
</style>

<table id="route_table" cellpadding="3" cellspacing="0" border="0">
<colgroup span="4">
<col width="120" />
<col width="120" />
<col width="120" />
<col width="70" />
</colgroup>
<thead>
<tr class="captionbig" align="center" bgcolor="#D0D0D0">
    <td><?=$version_star.' '.get_cm_var('setcfg_multi_net_seg_router_IP')?></td>
    <td><?=get_cm_var('setcfg_multi_net_seg_subnet_mask')?></td>
    <td><?=get_cm_var('setcfg_multi_net_seg_gateway').get_cm_var('setcfg_multi_net_seg_return_path')?></td>
    <td>
        <form action="intermediate.php" method="post">
            <input type="hidden" name="delete_flag_route" value="true">
            <input type="submit" class="graphicBtn" value="Delete">
        </form>
    </td>
</tr>
</thead>
<tbody class="normal">
<?php

if (($display_route->num_sites + $add_route->num_sites) < 1) {
    echo'
<tr>
    <td colspan="6" align="center"><br>'.get_cm_var('setcfg_multi_net_seg_no').'<br><br></td>
</tr>';
} else {
    if ($display_route->num_sites > 0) {
        $i = 0;
        $class = '';

        while ($i < $display_route->num_sites) {
            if ($display_route->site_list[$i]->name != ';') {
                $class = ($class == 'odd')? 'even': 'odd';
                if ($display_route->site_list[$i]->checked == 'true') {
                    $checked = 'checked';
                    $class = 'checked';
                } else {
                    $checked = '';
                }

                $enable_text = ($display_route->site_list[$i]->enable_redirect==TRUE)? 'YES': 'NO';

                echo "\n<tr class=\"$class\">\n";

                echo '    <td>'.$display_route->site_list[$i]->name."</td>\n";
                echo '    <td>'.$display_route->site_list[$i]->line_no."</td>\n";
                echo '    <td>'.$display_route->site_list[$i]->span."</td>\n";
                echo '    <td align="center"><input type="checkbox" onclick="combo_submit(\'dis'.$i.'\');" '.$checked.'></td>';
                echo "\n</tr>\n";
            }
            $i++;
        }
    }

    if ($add_route->num_sites > 0) {
        $i = 0;
        $class = '';

        while ($i < $add_route->num_sites) {
            if ($add_route->site_list[$i]->name != ';') {
                $class = ($class == 'odd')? 'even': 'odd';
                if ($add_route->site_list[$i]->checked == 'true') {
                    $checked = 'checked';
                    $class = 'checked';
                } else {
                    $checked = '';
                }

                $enable_text = ($add_route->site_list[$i]->enable_redirect==TRUE)? 'YES': 'NO';

                echo "\n<tr class=\"$class\" style=\"color: #096;\">\n";

                echo '    <td>'.$add_route->site_list[$i]->name."</td>\n";
                echo '    <td>'.$add_route->site_list[$i]->line_no."</td>\n";
                echo '    <td>'.$add_route->site_list[$i]->span."</td>\n";
                echo '    <td align="center"><input type="checkbox" onclick="combo_submit(\'add'.$i.'\');" '.$checked.'></td>';
                echo "\n</tr>\n";
            }
            $i++;
        }
    }
}

?>

</tbody>
</table>

<form name="combo" action="intermediate.php" method="post">
    <input type="hidden" name="item_no_route" value="">
</form>

<br>
<!-- 20071017 - Add onReset -->
<form action="intermediate.php" name="form_r" method="post" onSubmit="return validate_r()">
<fieldset class="captionbig">
    <legend><?=$version_star.' '.get_cm_var('setcfg_multi_net_seg_new')?></legend>
<p>
    <label><?=get_cm_var('setcfg_multi_net_seg_router_IP')?></label>
    <input class="IPtextbox" <?=$disabled?> type="text" name="router_to_add1" maxlength="3" onKeyPress="return numbersonly(this,event,'router_to_add2')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="router_to_add2" maxlength="3" onKeyPress="return numbersonly(this,event,'router_to_add3')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="router_to_add3" maxlength="3" onKeyPress="return numbersonly(this,event,'router_to_add4')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="router_to_add4" maxlength="3" onKeyPress="return numbersonly(this,event)">
</p>
<p>
    <label><?=get_cm_var('setcfg_multi_net_seg_subnet_mask')?></label>
    <input class="IPtextbox" <?=$disabled?> type="text" name="subnet_to_add1" maxlength="3" onKeyPress="return numbersonly(this,event,'subnet_to_add2')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="subnet_to_add2" maxlength="3" onKeyPress="return numbersonly(this,event,'subnet_to_add3')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="subnet_to_add3" maxlength="3" onKeyPress="return numbersonly(this,event,'subnet_to_add4')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="subnet_to_add4" maxlength="3" onKeyPress="return numbersonly(this,event)">
</p>
<p>
    <label><?=get_cm_var('setcfg_multi_net_seg_gateway')?></label>
    <input class="IPtextbox" <?=$disabled?> type="text" name="gateway_to_add1" maxlength="3" onKeyPress="return numbersonly(this,event,'gateway_to_add2')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="gateway_to_add2" maxlength="3" onKeyPress="return numbersonly(this,event,'gateway_to_add3')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="gateway_to_add3" maxlength="3" onKeyPress="return numbersonly(this,event,'gateway_to_add4')">.
    <input class="IPtextbox" <?=$disabled?> type="text" name="gateway_to_add4" maxlength="3" onKeyPress="return numbersonly(this,event)">
</p>
<br>
<input type="hidden" name="add_flag_route" value="true">
<input type="submit" value="Add" class="graphicBtn" <?=$disabled?>>
<input type="reset" value="Reset form" class="graphicBtn" <?=$disabled?>>
</fieldset>
</form>

<br>
<table width="94%" border="0" cellspacing="0" cellpadding="0">
<div>
<form action="settingok.php" method="post">
<?php

    gen_sep();
    gen_save('save_r',$fs_status);
    gen_foot();

?>
