<?php
require_once 'secureLogin.php'; //prevent hacker run this script by setting GET variables
?>
<html>
<head>
<title>NAT table</title>
<style type="text/css">
<!--
    ul { font-family: Tahoma, sans-serif; font-size: 10pt; }
    .odd { background: #F0F0F0; }
    .even { background: #FFF; }
    .checked { background: #BAEAD6; }
    #display { color: #000; list-style: none; margin: 0px; padding: 0;}
    #add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    #display li, #add li { padding-left: 10px; }
    #display span, #add span { width: 350px; float:left; }
    form { margin: 0;}
-->
</style>
</head>
<body>

<?php

require_once 'display_list.php';

// should be added in dispatcher setting ok - cancel
// purge if cancel
if (isset($purge)&&($purge=='true')) {
    $ser_display_nat_P=NULL;
    $ser_display_nat_R=NULL;
    $ser_add_nat_P=NULL;
    $ser_add_nat_R=NULL;
}

// register sessions, if needed
if (!isset($ser_display_nat_P)||($ser_display_nat_P=='')) {
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('table_NAT.php EGCONFIG.Cfgmgr Object cannot be created!');

    $num_nat = $settingobj->getKey( 'NAT_AddrM_Count', 'NAT');

    $tmp_num='0'.trim($num_nat);
    $num = (int)$tmp_num;

    $display_nat_P= new Site_Array;
    $display_nat_R= new Site_Array;

    $i=0;
    while ($i<$num) {
        $NAT_P[$i] = $settingobj->getKey( 'Mapping_Internal_IP_'.$i, 'NAT');
        $NAT_R[$i] = $settingobj->getKey( 'Mapping_Real_IP_'.$i, 'NAT');
        $strarray_P = trim($NAT_P[$i]);
        $strarray_R = trim($NAT_R[$i]);

        $display_nat_P->add_site('','','false',FALSE,'');
        $display_nat_R->add_site('','','false',FALSE,'');
        $display_nat_P->site_list[$i]->span = $strarray_P;
        $display_nat_R->site_list[$i]->span = $strarray_R;
        $i++;
    }

    //free COM object
    //$settingobj->Release();
    $settingobj=null;

    $ser_display_nat_P=serialize($display_nat_P);
	$ser_display_nat_R=serialize($display_nat_R);
    session_register('ser_display_nat_P');  
	session_register('ser_display_nat_R');  
}

if (!isset($ser_add_nat_P)) {
    $add_nat_P = new Site_Array;
    $ser_add_nat_P = serialize($add_nat_P);
    session_register('ser_add_nat_P');
}
if (!isset($ser_add_nat_R)) {
    $add_nat_R = new Site_Array;
    $ser_add_nat_R = serialize($add_nat_R);
    session_register('ser_add_nat_R');
}
// unserialize data
if (isset($ser_display_nat_P)) {
    $display_nat_P = unserialize($ser_display_nat_P);
}
if (isset($ser_display_nat_R)) {
    $display_nat_R = unserialize($ser_display_nat_R);
}
if (isset($ser_add_nat_P)) {
    $add_nat_P = unserialize($ser_add_nat_P);
}
if (isset($ser_add_nat_R)) {
    $add_nat_R = unserialize($ser_add_nat_R);
}

if ($display_nat_P->num_sites > 0) {
    echo '<ul id="display">';

    $i=0;
    $class='';

    while ($i < $display_nat_P->num_sites) {
        if ($display_nat_P->site_list[$i]->name!=";") {
            $class = ($class == 'odd')? 'even': 'odd';
            if ($display_nat_P->site_list[$i]->checked == 'true') {
                $checked = 'checked';
                $class = 'checked';
            } else {
                $checked = '';
            }
            echo '
    <li class="'.$class.'">
        <span>'.$display_nat_P->site_list[$i]->name.$display_nat_P->site_list[$i]->span.' - '.$display_nat_R->site_list[$i]->name.$display_nat_R->site_list[$i]->span.'</span>
        <input type="checkbox" onclick="document.combo.item_no_nat.value=\'dis'.$i.'\'; document.combo.submit();"'.$checked.'>
    </li>';
        }
        $i++;
    }

    echo "\n</ul>\n";
}

if ($add_nat_P->num_sites>0) {
    echo '<ul id="add">';

    $i=0;
    $class='';

    while ($i < $add_nat_P->num_sites) {
        if ($add_nat_P->site_list[$i]->name!=";") {
            $class = ($class == 'odd')? 'even': 'odd';
            if ($add_nat_P->site_list[$i]->checked == 'true') {
                $checked = 'checked';
                $class = 'checked';
            } else {
                $checked = '';
            }
            echo '
    <li class="'.$class.'">
        <span>'.$add_nat_P->site_list[$i]->name.$add_nat_P->site_list[$i]->span.' - '.$add_nat_R->site_list[$i]->name.$add_nat_R->site_list[$i]->span.'</span>
        <input type="checkbox" onclick="document.combo.item_no_nat.value=\'add'.$i.'\'; document.combo.submit();"'.$checked.'>
    </li>';
        }
        $i++;
    }

    echo "\n</ul>\n";
}

?>

<form name="combo" action="intermediate.php" method="post">
    <input type="hidden" name="item_no_nat" value="">
</form>

</body>
</html>
