<?
require_once "cmvar.php";

$reportDir = 'report//';
$reportPrfx = 'report_';
$reprotSufx = '.html';
$imageSufx = '.jpg';

if(isset($report_del_Status)) // delete report
{
	$errOccur= false;

	$del_Record = explode(',', $report_del_str);
	
	foreach($del_Record as $val){
		$file = $reportDir.$val;
		if (file_exists($file)) {
			unlink($file);
		}
		
		$image_name = substr($val, 0, strlen($val) - strlen(strrchr($val, "."))).$imageSufx;
		$imgFile = $reportDir.$image_name;
		
		if (file_exists($imgFile)) {
			unlink($imgFile);
		}
		
	}
}

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Report Record</title>
<link rel="stylesheet" href="setcfg.css" type="text/css">
<style type="text/css">
tr.normal { background-color: #FFFFFF; }
tr.checked { background-color: #BAEAD6; }
tr.odd { background: #FFF; }
tr.even { background: #F0F0F0; }

table.status_table {
	border-width: 0px;
	border-style: solid;
	border-color: #99D1A2;
	border-collapse: collapse;
	width:750px;
}
table.status_table td{
	border-width: 0px 0px 0px 0px;
	border-style:solid;
	border-color: #99D1A2;
	padding-left:3px;
	padding-right:3px;
	
}
table.status_table th{
	border-width: 0px 0px 0px 0px;
	border-style:solid;
	border-color: #99D1A2;
	padding-left:3px;
	padding-right:3px;
	text-align: center;
}
table.status_table div{
	overflow:hidden;
	/*white-space:nowrap;*/
}
#struct_row td{
	border-width:0px;
}

td{
	overflow: hidden;
}

</style>
</head>

<script>

function AddDeleteReport(val)
{
    if(document.form_report_record.report_del_str.value == '' )
        document.form_report_record.report_del_str.value = val; 
    else                    
        document.form_report_record.report_del_str.value = document.form_report_record.report_del_str.value + ',' + val;
}
function RemoveDeleteReport(val)
{
    var tmpStr = document.form_report_record.report_del_str.value;
    var head = tmpStr.substring(0, (tmpStr).indexOf(val)-1);
    var tail = tmpStr.substring(tmpStr.indexOf(val)+val.length, tmpStr.length);
    tmpStr = head + tail;
    if( tmpStr.indexOf(',')==0 )
        tmpStr = tmpStr.substring(1, tmpStr.length);
    document.form_report_record.report_del_str.value = tmpStr;
}

function selectToggle(cb, id, orgClass)
{    

    if( cb.checked == true ) {
        document.getElementById(id).className='checked';
		AddDeleteReport(cb.value);
    }
    else {
        document.getElementById(id).className=orgClass;
		RemoveDeleteReport(cb.value);
    }
}

function confirmDeleteMessage(str)
{
    var pos=0, message=0;
    var len=str.length;

    while((pos = str.search(","))!=-1) {
        str = str.substring(pos+1, str.length );
        message++;
    }
	
    message++;

    if(document.form_report_record.report_del_str.value == "") {
        alert( "Please select report to delete" );
        return false;
    } else {
        var answer=confirm(message + " report will be deleted, confirm?" );
        if(answer)
            return true;
        else
            return false;
    }
	
	alert("end");
}

</script>

<?

// init width of each cell
$CellWidth_1="40";
$CellWidth_2="15";
$CellWidth_3="15";
$CellWidth_4="20";

$checkboxCellWidth="10";

// Header label
?>
<form action="" name="form_report_record" method="post">
<input type="hidden" name="report_del_str">
<input type="hidden" name="report_del_Status">
<table class="status_table" border="0" cellspacing="0" cellpadding="0" style="table-layout:fixed">
<col width=<?=$CellWidth_1?>>
<col width=<?=$CellWidth_2?>>
<col width=<?=$CellWidth_3?>>
<col width=<?=$CellWidth_4?>>
<col width=<?=$checkboxCellWidth?>>
<thead>
<tr bgcolor="#D0D0D0" >
	<th>
		<label class='captionbig'>File Name</label>
	</th>
	<th>
		<label class='captionbig'>Type</label>
	</th>
	<th >
		<label class='captionbig'>Size</label>
	</th>
	<th >
		<label class='captionbig'>Time</label>
	</th>
	<th >
		<input type="submit" class="graphicBtn" value="Delete" onClick="if (confirmDeleteMessage(document.form_report_record.report_del_str.value) == true){document.form_report_record.report_del_Status.value=''; document.form_report_record.submit();}else return false;">
	</th>
</tr>
</table>
<div STYLE="height:200px; overflow:scroll;overflow-x:hidden;width:100%;">
<table class="status_table" id="reportList" border="0" cellspacing="0" cellpadding="0" style="table-layout:fixed">
<col width=<?=$CellWidth_1?>>
<col width=<?=$CellWidth_2?>>
<col width=<?=$CellWidth_3?>>
<col width=<?=$CellWidth_4?>>
<col width=<?=$checkboxCellWidth?>>
<tbody class="normal" id="tb">
<?php

function scandir_by_mtime($folder) {
  
  $arr = array();
  
  if (is_dir($folder) == false)
	return $arr;
	
  $dircontent = scandir($folder);
  
  foreach($dircontent as $filename) {
   if ($filename != '.' && $filename != '..') {
     if (filemtime($folder.$filename) === false) return false;
     $dat = date("YmdHis", filemtime($folder.$filename));
	 
	 $tmpAddChar = "";
	 
	 while (isset($arr[$dat.$tmpAddChar])){
		$tmpAddChar .="a";
	}
	
	$arr[$dat.$tmpAddChar] = $filename;
	
   }
  }
  if (!krsort($arr)) return false;
  return $arr;
}

$fileArr = scandir_by_mtime($reportDir);

$class = '';
$no_report = 1;
foreach ($fileArr as $k => $f) {
	$filePath = $reportDir.$f;
	
	if (is_file($filePath) && ereg('^'.$reportPrfx.'(.*)[0-9]{4}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}[_]{1}[0-9]{2}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}'.$reprotSufx.'$', $f)) {

		/* Get file stat */
		$stat = stat($filePath);
		// print_r($stat);
		$file_size = $stat['size'];
		$file_modify_time = $stat['mtime'];
		
		$class = ($class == 'odd')? 'even': 'odd';
		
		$type = "Unknow";
		if (!strstr($f, "report_visited_site_") === FALSE){
			$type = "Most visited site";
		}
		
		?>
		<tr class="<?=$class?>" id="report_row_<?=$no_report?>" >
			<td title="<?=$f?>" ><a href='<?=$filePath?>' target='_blank'><?=$f?></a></td>
			<td align="center" title="<?=$type?>" ><?=$type?></td>
			<td align="center" title="<?=$file_size?>kb" ><?=$file_size?>kb</td>
			<td align="center" title="<?=date("M j, Y g:i a", $file_modify_time)?>" ><?=date("M j, Y g:i a", $file_modify_time)?></td>
			<td align="center" ><input type="checkbox" onclick="selectToggle(this, 'report_row_<?=$no_report?>', '<?=$class?>');" value="<?=$f?>"></td>
		</tr>
		<?		
		$no_report++;
	}
}
?>
</tbody>
</table>
</div>
</form>
</body>
</html>

