<?php

// 20090430 - Handle URL log retrieving

set_time_limit(0);

if(!session_id()) {
    session_start();
}

// include ("secureLogin.php");
include_once ("..\\authserv\\common_functions.php");
require_once 'cmvar.php';

// create COM object
$settingObj = new COM('EGCONFIG.Cfgmgr') or die ('urllog_entry.php EGCONFIG.Cfgmgr Object cannot be created!');
$isAnony = $settingObj->getKey('anonymous_login', 'gateway');
$settingObj = null;

// $type = 'date_range';
$type = 'most_recent';
$num = 500;
$start_date = mktime(0, 0, 0, date('n'), date('j'), date('Y'));
$start_date = '0';
$end_date = mktime(0, 0, 0, date('n'), date('j'), date('Y')) + 86400;

if (isset($_GET['type'])) {
	$type = $_GET['type'];
	if ($type == 'most_recent') {
		$num = $_GET['num'];
	} else {
		$treatStartDate = explode('-', $_GET['start']);
		if (!checkdate($treatStartDate[1], $treatStartDate[2], $treatStartDate[0])) {
			exit('start date not exist');
		}
		$start_date = mktime(0, 0, 0, $treatStartDate[1], $treatStartDate[2], $treatStartDate[0]);

		$treatEndDate = explode('-', $_GET['end']);
		if (!checkdate($treatEndDate[1], $treatEndDate[2], $treatEndDate[0])) {
			exit('end date not exist');
		}
		$end_date = mktime(0, 0, 0, $treatEndDate[1], $treatEndDate[2], $treatEndDate[0]) + 86400;
	}
}

$logDirArr = array("..\\log");
$csvPrfx = 'tempdata_';
$csvSufx = '.csv';
$csvArr = array();
$cnt = 0;

// Extract full path of the CSV files
foreach ($logDirArr as $l) {
	$fileArr = scandir($l);
	foreach ($fileArr as $f) {
		$filePath = "$l\\$f";
		if (is_file($filePath) && ereg('^'.$csvPrfx.'[0-9]{4}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}[_]{1}[0-9]{2}[\.]{1}[0-9]{2}[\.]{1}[0-9]{2}'.$csvSufx.'$', $f)) {
			$treatFilePath = str_replace($csvSufx, '', $filePath);
			$getPos = strpos($treatFilePath, $csvPrfx, 1) + strlen($csvPrfx);
			$fileDate = explode('_', substr($treatFilePath, $getPos, strlen($treatFilePath) - $getPos));
			$dateArray = explode('.', $fileDate[0]);
			$timeArray = explode('.', $fileDate[1]);
			$dateTimeStamp = mktime($timeArray[0], $timeArray[1], $timeArray[2], $dateArray[1], $dateArray[2], $dateArray[0]);
			$csvArr[$dateTimeStamp] = $filePath;
		}
	}
}
ksort($csvArr);

// Read CSV files one by one
$dataArray = array();
$count = 0;
$shown = 0;
$previous_timestamp = 9999999999;

// NEW==== 
$glo_content = "";

foreach ($csvArr as $timestamp => $c) {
	/*
	if ($type == 'date_range' && ($timestamp >= $end_date || $previous_timestamp <= $start_date)) {
		continue;
	}
	if ($num == 0) break;
	$fp = fopen($c, 'rt');
	if ($type == 'most_recent') {
		$seekStartFrom = filesize($c) - (150 * ($num - $count));
		
		if ($seekStartFrom >= 0) {
			fseek($fp, $seekStartFrom);
		}
		
		
	}
	if ($fp != FALSE) {
		$meetTitle = 0;

		// 20090302 - Show port numbers for non-well-known protocols
		// 20090106 - Retrieve destination port and convert to protocol if possible
		while (($dataArr = fgetcsv($fp, 512, ',', "'")) !== FALSE) {
			// Skip the title line
			if ($meetTitle == 0) {
				$meetTitle = 1;
				continue;
			}
			
			if ($num == 0) break;

			// if ($type == 'date_range' && $dataArr[5] >= $start_date && $dataArr[5] <= $end_date) {
				// logShowData($dataArr);
			// } else if ($type == 'most_recent') {
				// $dataArray[] = $dataArr;
				// $count++;
			// }
			
			if ($type == 'most_recent') {
				$dataArray[] = $dataArr;
				$count++;
			}
		}

		fclose($fp);
	}
	if ($type == 'most_recent' && $count > $num) {
		krsort($dataArray);
		foreach ($dataArray as $dataArr) {
			if ($shown >= $num) break;
			$shown++;
			$glo_content.= logShowData($dataArr, $shown);
		}
		break;
	} else {
		krsort($dataArray);
		foreach ($dataArray as $dataArr) {
			$shown++;
			$glo_content.= logShowData($dataArr, $shown);
		}
	}
	*/
	$previous_timestamp = $timestamp;
}

if (count($csvArr) >0){
	$_SESSION['last_seek'] = filesize($csvArr[$previous_timestamp]);
	$_SESSION['last_timestamp'] = $previous_timestamp;
}

function logShowData($dataArr, $lineNumbers) {
	$outStr = "";
	
	$state = $dataArr[0];
	// $src_ip = $dataArr[2];
	// $dest_ip = $dataArr[3];
	$src_port = $dataArr[4];
	$dest_port = $dataArr[5];
	$protocol = $dataArr[15];
	// $username = $dataArr[16];
	// $applied_rule = $dataArr[17];
	// $domain = $dataArr[21];
	// $url = $dataArr[22];
	
	// remove double quote
	$src_ip = substr($dataArr[2], 1, (strlen($dataArr[2]) -2));
	$dest_ip = substr($dataArr[3], 1, (strlen($dataArr[3]) -2));
	$username = substr($dataArr[16], 1, (strlen($dataArr[16]) -2));
	$applied_rule = substr($dataArr[17], 1, (strlen($dataArr[17]) -2));
	$domain = substr($dataArr[21], 1, (strlen($dataArr[21]) -2));
	$url = substr($dataArr[22], 1, (strlen($dataArr[22]) -2));
	
	if (strcasecmp($dataArr[1], "OUT") == 0){
		// flip src to dest, dest to src
		$ent_src_ip = $dest_ip;
		$ent_dest_ip = $src_ip;
		$ent_src_port = $dest_port;
		$ent_dest_port = $src_port;
	}
	else{
		$ent_src_ip = $src_ip;
		$ent_dest_ip = $dest_ip;
		$ent_src_port = $src_port;
		$ent_dest_port = $dest_port;
	}
	
	$trStyle = "";
	if(stristr($state, "deny") === FALSE){
	}
	else{
		$trStyle = "color: red;";
	}
	
	$outStr = '
		<tr style="'.$trStyle.'" onMouseOut="HighlightRow(this, 0)" onMouseOver="HighlightRow(this, 1)">
			<td width="" NOWRAP>'.$state.'</td>
			<td width="" NOWRAP>'.$ent_src_ip.'</td>
			<td width="" NOWRAP>'.$ent_dest_ip.'</td>
			<td width="" NOWRAP>'.$ent_src_port.'</td>
			<td width="" NOWRAP>'.$ent_dest_port.'</td>
			<td width="" NOWRAP>'.$protocol.'</td>
			<td width="" NOWRAP>'.$username.'</td>
			<td width="" NOWRAP>'.$applied_rule.'</td>
			<td width="" NOWRAP>'.$domain.'</td>
			<td width="" NOWRAP>'.$url.'</td>
		</tr>
	';
	
	return $outStr;
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>URL Log Entry</title>
<style type="text/css">
	table {
		font-family: Arial, sans-serif;
		font-size: 8pt;
	}
</style>
<script type="text/javascript" src="./javascript/loadingBox.js"></script>
<script type="text/javascript" src="./javascript/url_log.js"></script>
<script type="text/javascript" src="./responsexml.js"></script>
<script type="text/javascript">setTimeout("queryTempLog()", 500);</script>
</head>
<body>
<table id="ta" width="100%" border="1" cellspacing="2" cellpadding="2">
<tr style="font-weight:bold;">
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_state')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_src_ip')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_dest_ip')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_src_port')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_dest_port')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_protocol')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_username')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_applied_rule')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_domain')?></td>
	<td width="" NOWRAP><?=get_cm_var('setcfg_tmp_label_url')?></td>
</tr>
<tbody id="tb">
<?=$glo_content?>
</table>
</tbody>
<div id="di">
</div>
<script type="text/javascript">
	CallParentLoadingBox(false, false);
</script>
</body>
</html>
