<?php

error_reporting(E_ALL | E_STRICT);
$settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');

$dsnFile = $settingobj->getKey( 'Datasource', 'gateway');

$group_tablename = $settingobj->getKey('Datasource_group_Tablename', 'gateway');
$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
$ipbundle_tablename = $settingobj->getKey('Datasource_ipbundle_Tablename', 'gateway');
$rule_ip_tablename = $settingobj->getKey('Datasource_rule_ip_Tablename', 'gateway');
$rule_ipbundle_tablename = $settingobj->getKey('Datasource_rule_ipbundle_Tablename', 'gateway');
$rule_user_tablename = $settingobj->getKey('Datasource_rule_user_Tablename', 'gateway');
$rule_group_tablename = $settingobj->getKey('Datasource_rule_group_Tablename', 'gateway');
$rule_port_tablename = $settingobj->getKey('Datasource_rule_port_Tablename', 'gateway');
$access_rule_tablename = $settingobj->getKey('Datasource_access_rule_Tablename', 'gateway');
$bw_rule_tablename = $settingobj->getKey('Datasource_bw_rule_Tablename', 'gateway');
$user_tablename = $settingobj->getKey('Datasource_Tablename', 'gateway');

/**
 * Database connection
 */ 
if ($dsnSource = fopen($dsnFile, 'r')) { 
  $dsn = '';
  if (!feof($dsnSource)) {
    $dbType = fgets($dsnSource, 512);
  }
  while (!feof($dsnSource)) {
    $readLine = trim(fgets($dsnSource, 512));
    if (!empty($readLine)) {
      $dsn .= ($dsn ? ';' : '') . $readLine;
    }
  }
  fclose($dsnSource);
  $db = odbc_connect($dsn, '', '');
} else {
  exit('Cannot open DSN source file');
}



/**
 * Script start
 */
$fsBandwidthRule_list = array(); 
$result = odbc_exec($db, "SELECT * FROM `$bw_rule_tablename` ORDER BY `seqOrder` ASC");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['bw_ruleName'] =odbc_result($result,'bwRuleName');
	$data['description'] =odbc_result($result,'descript');
	$data['seqOrder'] =round(odbc_result($result,'seqOrder'));
	$data['ipBundleName'] =odbc_result($result,'bundleName');
	$data['bwul'] =round(odbc_result($result,'bwul'));
	$data['bwdl'] =round(odbc_result($result,'bwdl'));
	
	$fsBandwidthRule_list[$data['bw_ruleName']] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $fsBandwidthRule_list[$data['bw_ruleName']] = $data;
// }
 
$ipbundle_list = array();
$result = odbc_exec($db, "SELECT * FROM `$ipbundle_tablename`");

// most for dbf, since all of key will become captial letter
while(odbc_fetch_row($result)) {
	$data = array();
	$data['ipBundleName'] =odbc_result($result,'bundleName');
	$data['start_ip'] =odbc_result($result,'start_ip');
	$data['end_ip'] =odbc_result($result,'end_ip');
	
	$ipbundle_list[$data['ipBundleName']][] = $data;
}

// while ($data = odbc_fetch_array($query)) {
  // $ipbundle_list[$data['ipipBundleName']][] = $data;
// }

include 'ui_bw.temp.php';

?>