<?php
require_once 'secureLogin.php';
require_once "..\\authserv\\common_functions.php";
require_once 'cmvar.php';
//20080814	fixed some display problems on IE version 5 and version 5.5
//			fixed the display problem of vertical scroll bar 
//20080805	1.enhanced interface(added new effects and new icons for sorting)
// create COM object
$settingobj = new COM("EGCONFIG.Cfgmgr") or die("user_status.php EGCONFIG.Cfgmgr Object cannot be created!");

//* scenario2 and load balancing: same layout, different text 
$isScenario2 = $settingobj->getKey('scenario2', 'gateway');
$FOMode=$settingobj->getKey('mode', 'FSFO');
$isShareSecret = fs_is_shared_secret_in_anonymous_mode();
$scratchLogin = $settingobj->getKey('scratch_login', 'gateway');

if($FOMode == 3)
	$enableLoadBalancing=1;
else
	$enableLoadBalancing=0;
// init width of each cell

$checkboxCellWidth="3%";
$nameCellWidth="13%";
$mac_strCellWidth="16%";
$IP_strCellWidth="12%";
$login_TimeCellWidth="19%";
$durationCellWidth="15%";
$bw_UseCellWidth="11%";
$bw_UseULCellWidth="11%";

//use for scenario2
$siteIDCellWidth="";
	
if ($isScenario2 || $enableLoadBalancing){
	
	// width of each cell in scenario2
	$checkboxCellWidth="3%";
	$nameCellWidth="12%";
	$mac_strCellWidth="13%";
	$IP_strCellWidth="12%";
	$login_TimeCellWidth="18%";
	$durationCellWidth="14%";
	$bw_UseCellWidth="10%";
	$bw_UseULCellWidth="10%";
	$bw_UseSHACellWidth="10%";
	$siteIDCellWidth="8%";
}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>User status label</title>
<style type="text/css">
  table { font-family: Arial, sans-serif; font-size:8pt; font-weight:bold; color:#000000; }
	.selected {
		color: green;
		}
	.unselected {
		color: black;
	}
	table.status_label {
		font-family: Arial, sans-serif; 
		font-size:8pt; 
		font-weight:bold; 
		color:#000000;
		border-width: 0px;
		/*
		border-style: solid;
		border-color: #99D1A2;*/
		border-collapse: collapse;
		background-color: rgb(221, 221, 221);
		width: 100%;
	}
	table.status_label td {
		background-image: url(images/tblhd_light.png); 
		border-width: 0px 1px 0px 0px;
		border-style:solid;
		border-color: #99D1A2;
		padding-left:6px;
		cursor: pointer;
		cursor: hand;
		height: 40px;
	}
	table.status_label div {
		overflow:hidden;
		/*white-space:nowrap;*/
	}
</style>
<script type="text/javascript" src="./javascript/sstatus.js"></script>
<script type="text/javascript">
function useLightBg(tdElement){
	tdElement.style.background="url(images/tblhd_light.png)";
}
function useDarkBg(tdElement){
	tdElement.style.background="url(images/tblhd_dark.png)";
}
function useDarkCBg(tdElement){
	tdElement.style.background="url(images/tblhd_dark_c.png)";
}
</script>

</head>

<body>
<table id="status_header" class="status_label" cellspacing="0" cellpadding="0">
	<tr>
		<td width="<?=$checkboxCellWidth?>" style="border-left:0px; cursor:default"><div><input type="checkbox"  style="visibility:hidden" /></div></td>

		<td width="<?=$nameCellWidth?>" class="unselected" title="Sort" onclick="tableHeadOnclick(1)" onmouseover="useDarkBg(this)" onmouseout="useLightBg(this)" onmousedown="useDarkCBg(this)" onmouseup="useDarkBg(this)" sortstatus="1"><div><?=get_cm_var('setcfg_sstatus_online_user')?>&nbsp;<img src="images/up_tri.png" /></div></td>

		<td width="<?=$mac_strCellWidth?>" class="unselected" title="Sort" onclick="tableHeadOnclick(2)" onmouseover="useDarkBg(this)" onmouseout="useLightBg(this)" onmousedown="useDarkCBg(this)" onmouseup="useDarkBg(this)" sortstatus="0"><div><?=get_cm_var('setcfg_sstatus_mac')?>&nbsp;<img style="display:none" src="images/down_tri.png" /></div></td>
		<td width="<?=$IP_strCellWidth?>" class="unselected" title="Sort" onclick="tableHeadOnclick(3)" onmouseover="useDarkBg(this)" onmouseout="useLightBg(this)" onmousedown="useDarkCBg(this)" onmouseup="useDarkBg(this)" sortstatus="0"><div><?=get_cm_var('setcfg_sstatus_ip')?><font id="externalIPtitle" color="blue" style="display: none"><?=get_cm_var('setcfg_sstatus_ipExternal')?></font>&nbsp;<img style="display:none" src="images/down_tri.png" /></div></td>
		<td width="<?=$bw_UseCellWidth?>" class="unselected" title="Sort" onclick="tableHeadOnclick(4)"onmouseover="useDarkBg(this)" onmouseout="useLightBg(this)" onmousedown="useDarkCBg(this)" onmouseup="useDarkBg(this)" sortstatus="0"><div><?=get_cm_var('setcfg_sstatus_data_download')?>&nbsp;<img style="display:none" src="images/down_tri.png" /></div></td>
		<td width="<?=$bw_UseULCellWidth?>" class="unselected" title="Sort" onclick="tableHeadOnclick(5)"onmouseover="useDarkBg(this)" onmouseout="useLightBg(this)" onmousedown="useDarkCBg(this)" onmouseup="useDarkBg(this)" sortstatus="0"><div><?=get_cm_var('setcfg_sstatus_data_upload')?>&nbsp;<img style="display:none" src="images/down_tri.png" /></div></td>
	</tr>
</table>
<script type="text/javascript">
	body_element=document.body;
	if (typeof body_element.onselectstart!="undefined"){
		document.body.onselectstart=function(){return false};
	}else{
		document.getElementById("status_header").onmousedown=function(){return false};
	}	
</script>
<!-- preload the images for faster reponds on the click action-->
<img style="display:none" src="images/tblhd_dark.png" />
<img style="display:none" src="images/tblhd_dark_c.png" />
</body>
</html>