<?php
    require_once "secureLogin.php";
    define("USER_PER_PAGE", 1000);
    require_once "cmvar.php";

  // create COM object
  if (!isset($settingobj)) {
      $settingobj = new COM("EGCONFIG.Cfgmgr") or die("users.php EGCONFIG.Cfgmgr Object cannot be created!");
  }
  $dsn_file = $settingobj->getKey( "Datasource", "gateway");
  $dsn_source=fopen($dsn_file, "r") or die("Cannot open DSN source file!");
  
  $dsn="";

  if (!feof($dsn_source)) { $line=fgets($dsn_source,512); }
  while (!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!="") $dsn=$dsn.$line;
  }
  $dsn=str_replace("\r\n",";",$dsn);
  fclose($dsn_source);

  $userDB=odbc_connect($dsn,"","");
?>

<script type="text/javascript" src="./javascript/users.js"></script>

<?php
// user info

if ($userDB) {
    // obtain low, medium or high BT value from config.ini

    $outval = $settingobj->getKey( "bt_low", "bw_throttle");
        
    if($outval!="")       
      $low=$outval;

    $outval = $settingobj->getKey( "bt_medium", "bw_throttle");
        
    if($outval!="")       
      $medium=$outval;
 
    $outval = $settingobj->getKey( "bt_high", "bw_throttle");
        
    if($outval!="")       
      $high=$outval;

    $EaseGateusertable=$settingobj->getKey( "Datasource_Tablename", "gateway"); 

    //Check if need to search users
    if (!isset($searchUser)) { 
        //only need to count(*) in all user mode
        $query="SELECT count(*) FROM ".$EaseGateusertable.";";
        $result=odbc_exec($userDB,$query);
        $num=odbc_result($result, 1);
    }
	
    //make result here
    if (isset($sqlWhereStatement)) {
        $query="SELECT name,macasusr FROM $EaseGateusertable WHERE $sqlWhereStatement ORDER BY NAME;";
    } else {
        $query="SELECT name,macasusr FROM $EaseGateusertable ORDER BY NAME;";
    }
    $result=odbc_exec($userDB,$query);

?>
<script type="text/javascript">
//It come from users.php
<?php
    if (isset($page)) {
        $pageno = $page;
    } else {
        $pageno = 1;
    }

    if (isset($searchUser)) { //search user mode
        $i=1;
        while (odbc_fetch_row($result,$i)) {
            $name=odbc_result($result,"name");
            $macuser=odbc_result($result,"MACasUsr");
           // highlight the account which use MAC address as username
            $arrayOfUsers[] = "['$name','$macuser','']";
            $i++;
        } //end of looping through all query result
        $num = $i-1;
        $pages = ceil($num/USER_PER_PAGE);
        if ($pages==0) { //when number of users is zero
            $pages = 1;
        }
        $numOfRecordToShow = $i-1;
        if ($numOfRecordToShow > USER_PER_PAGE) {
            $numOfRecordToShow = USER_PER_PAGE;
        }
    } else { //all user mode
        $pages = ceil($num/USER_PER_PAGE);
        if ($pages==0) { //when number of users is zero
            $pages = 1;
        }

        if($pageno > $pages) { //page number overflow
            $pageno = $pages;
        } else if($pageno<1) { //page number underflow
            $pageno = $pages;
        }
        
        $start = ($pageno - 1) * USER_PER_PAGE + 1;
        $end = $start + USER_PER_PAGE - 1;
        $i=0;
        while (odbc_fetch_row($result,$start) && $start<=$end) {
            $name=odbc_result($result,"name");
            $macuser=odbc_result($result,"MACasUsr");
           // highlight the account which use MAC address as username
            $arrayOfUsers[] = "['$name','$macuser','']";
            $i++;
            $start++;
        } //end of looping through 1000 query result

        $numOfRecordToShow = $i;
    } //end all user mode

    if (isset($arrayOfUsers)) { // > 0 users found
        echo "var glo_arrUser = [".implode(",",$arrayOfUsers)."];\n";
    } else { //no user is found
        echo "var glo_arrUser = [];\n";
    }
    odbc_close($userDB); //close odbc
?>
var glo_page = <?=$pageno?>; //current page
var glo_userPerPage = <?=USER_PER_PAGE?>; //number of user showing per page
var glo_totalNumOfUser = <?=$num?>; //total number of user found
</script>

<span class="normalUser">
    <span id="totalNumOfUser" class="userNumber"><?=$num?></span>
    <?=get_cm_var('setcfg_users_search_result_message_found')?>
    <br />
    <?=get_cm_var('setcfg_users_search_result_message_show')?>
    <span id="showNumOfUser" class="userNumber"><?=$numOfRecordToShow?></span>
    <?=get_cm_var('setcfg_users_search_result_message_users')?>
</span>

<script type="text/javaScript" src="./javascript/users.js"></script>
<form name="userForm">
    <select name="userList" size="20" style="width:170px" onChange="changeUser();" multiple>
    </select>
</form> <!-- end of userForm -->
<script lang="javascript">
refreshUserList(); //make all options in userList
</script>
<?php
} else {
    echo "connection failed!";
}
//release COM object
//$settingobj->Release();
$settingobj=null;
?>
<head>
<script type="text/javascript">
glo_jsMessage = new Object();
glo_jsMessage.js_alert37 = '<?=get_cm_var('js_alert37')?>';
</script>
</head>