function check_ip_format2(ip_addr) {
var valid=true;

if (ip_addr == ""){
	return true;
}

var ip = ip_addr.split("."); 
if(ip.length!= 4) {
	valid = false;
}
else {
	for (i=0; i<ip.length; i++) {
		if (i == 0 || i == 3){
			if (isNaN(ip[i])==true || parseInt(ip[i]) > 255 || parseInt(ip[i]) < 1) {
				valid = false; 
			}
		}
		else{
			if (isNaN(ip[i])==true || parseInt(ip[i]) > 255 || parseInt(ip[i]) < 0) {
				valid = false; 
			}
		}
	}
}

return valid;
}
function check_subnet_format2(subnet_addr) {
var valid=true;

if (subnet_addr == ""){
	return true;
}

var ip = subnet_addr.split("."); 
if(ip.length!= 4) {
	valid = false;
}
else {
	for (i=0; i<ip.length; i++) {
		if (i == 0){
			if (isNaN(ip[i])==true || !isInteger(ip[i]) || ip[i] != 255) {
				valid = false; 
			}
		}
		else{
			if (isNaN(ip[i])==true || !isInteger(ip[i]) || (ip[i] != 255 && ip[i] != 0)) {
				valid = false; 
			}
		}
	}
}

return valid;
}
function isInteger(s){
    var i;
    for (i = 0; i < s.length; i++){   
        // Check that current character is number.
        var c = s.charAt(i);
        if (((c < "0") || (c > "9")))
        return false;
    }
    // All characters are numbers.
    return true;
}

// javascript version of schTransStr()
function schTransStr(str){
	w = 0;
	h = 0;

	message="";

	weekArr = new Array('Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat');	
	hourArr = new Array('00', '01', '02', '03', '04', '05', '06', '07', '08', '09', '10', '11', '12', '13', '14', '15', '16', '17', '18', '19', '20', '21', '22', '23');
	fromMinuteArr = new Array(':00', ':15', ':30', ':45');
	toMinuteArr = new Array(':00', ':15', ':30', ':45');

	bitAray = new Array(1,2,4,8);
	isContinue = false;
	isFirst = true;

	for (i=0; i < str.length; i++){
		val = parseInt(str.charAt(i), 16);
		
		for(j=0; j<4; j++){
			if (val & bitAray[j]){
				if (isContinue == false){
					isContinue = true;
					
					if (isFirst == true){
						isFirst = false;
					}
					else{						
						message+= ", </span>";
					}
					
					message+= "<span style='white-space: nowrap;'>"+weekArr[w]+" "+hourArr[h]+fromMinuteArr[j]+"~";
				}
			}
			else{
				if (isContinue == true){
					isContinue = false;
					message+= ""+weekArr[w]+" "+hourArr[h]+toMinuteArr[j];
				}
			}
		}
		
		h++;
		
		if (h == 24){
			h=0;
			w++;		
			if (w == 7){
				// w=6;
				// h=23;
				w=0;
				h=0;
			}
		}		
		
		// special for last
		if (i == (str.length -1)){
			if (val & bitAray[3]){
				if (isContinue == true){
					isContinue = false;
					message+= ""+weekArr[w]+" "+hourArr[h]+toMinuteArr[0]+"</span>";
				}
			}
		}
	}
	return message;
}

function resetScheduleArray(){
	for (i=0; i<7; i++){
		for (j=0; j<24; j++){
			for (k=0; k<4; k++){
				if (scheduleArray[i][j][k] == 1){
					scheduleArray[i][j][k] = 0;
					document.getElementById("sch_"+i+"_"+j+"_"+k).style.backgroundColor = "";
				}
			}
		}
	}
}

var currentIPEntryCount_source = 4;
var currentIPEntryCount_destination = 4;
// enableDisableByClicking
function addIPEntry(entryType) {
    var count = entryType == 'source' ? currentIPEntryCount_source : currentIPEntryCount_destination;
    entryType = entryType == 'source' ? 'source_ip_direct' : 'destination_ip_direct';

    var entryDiv = document.createElement('div');
    var disabled = document.getElementById(entryType + '_chkbx').checked ? '' : "disabled='disabled'";
    entryDiv.innerHTML = g_str_setcfg_arule_ip+'<input type="text" class="new_access_rule_text" style="width: 90px;" id="'+entryType+'_'+count+'_ip" name="'+entryType+'_'+count+'_ip" value="" onchange="return check_ip_format(this.value)" '+disabled+' />&nbsp;'+g_str_setcfg_arule_mask+'<input type="text" class="new_access_rule_text" style="width: 90px;" id="'+entryType+'_'+count+'_mask" name="'+entryType+'_'+count+'_mask" value="" onchange="return check_subnet_format(this.value)" '+disabled+' />';
    document.getElementById(entryType + '_box').appendChild(entryDiv);

    enableDisableByClicking(document.getElementById(entryType + '_chkbx').checked, entryType, ['ip','mask']);

    if (entryType == 'source_ip_direct') {
        currentIPEntryCount_source++;
    } else {
        currentIPEntryCount_destination++;
    }
}

var currentPortEntryCount_source = 4;
var currentPortEntryCount_destination = 4;
function addPortEntry(entryType) {
    var count = entryType == 'source' ? currentPortEntryCount_source : currentPortEntryCount_destination;
	var entryType2Str = entryType == 'source' ? 'source' : 'destination';
    entryType = entryType == 'source' ? 'source_port' : 'destination_port';

    var entryDiv = document.createElement('div');
    entryDiv.innerHTML = '\
					<table>\
						<tr>\
							<td width = "70px">\
								<select id="'+entryType2Str+'_protocolNum_'+count+'" name="'+entryType2Str+'_protocolNum_'+count+'" onchange="new_rule_changeProtocolNum(\''+entryType2Str+'\', '+count+');">\
									<option value="6" selected="selected">'+g_str_setcfg_arule_proto_opt1+'</option>\
									<option value="17" >'+g_str_setcfg_arule_proto_opt2+'</option>\
									<option value="0">'+g_str_setcfg_arule_proto_opt3+'</option>\
								</select>\
							</td>\
							<td>\
								<div id="'+entryType2Str+'_proto_row_'+count+'" style="display:none;">'+g_str_setcfg_arule_proto+'<input type="text" class="new_access_rule_text" style="width: 40px;" id="'+entryType2Str+'_specific_protocolNum_'+count+'" name="'+entryType2Str+'_specific_protocolNum_'+count+'" value="" onchange="return check_protoNum(this.value)" /></div>\
								<div id="'+entryType2Str+'_port_row_'+count+'">'+g_str_setcfg_arule_port+g_str_setcfg_arule_from+'&nbsp;<input type="text" class="new_access_rule_text" style="width: 40px;" id="'+entryType+'_'+count+'_from" name="'+entryType+'_'+count+'_from" value="" onchange="return check_port(this.value)" />&nbsp;'+g_str_setcfg_arule_to+'<input type="text" class="new_access_rule_text" style="width: 40px;" id="'+entryType+'_'+count+'_to" name="'+entryType+'_'+count+'_to" value="" onchange="return check_port(this.value)" />\
							</td>\
						</tr>\
					</table>\
							';
	
	document.getElementById(entryType + '_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit([''+entryType2Str+'_protocolNum_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});


    if (entryType == 'source_port') {
        currentPortEntryCount_source++;
    } else {
        currentPortEntryCount_destination++;
    }
}

var currentUserEntryCount = 4;
function addUserEntry() {
    var count = currentUserEntryCount;

    var entryDiv = document.createElement('div');
	
	var optStr = '<option value="Not Selected" selected="selected" > </option>';
	
	for (var i in userData) {
		optStr += '<option value="'+userData[i]+'">'+userData[i]+'</option>';
	}
	
    entryDiv.innerHTML = '\
					<select id="new_user_'+count+'" name="new_user_'+count+'">\
						'+optStr+'\
					</select>\
							';
							
	document.getElementById('user_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit(['user_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    currentUserEntryCount++;
}

var currentGroupEntryCount = 4;
function addGroupEntry() {
    var count = currentGroupEntryCount;

    var entryDiv = document.createElement('div');
	
	var optStr = '<option value="Not Selected" selected="selected" > </option>';
	
	for (var i in groupData) {
		optStr += '<option value="'+groupData[i]+'">'+groupData[i]+'</option>';
	}
	
    entryDiv.innerHTML = '\
					<select id="new_group_'+count+'" name="new_group_'+count+'">\
						'+optStr+'\
					</select>\
							';
							
	document.getElementById('group_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit(['group_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    currentGroupEntryCount++;
}

var currentWebFilterEntryCount = 4;
function addWebFilterEntry() {
    var count = currentWebFilterEntryCount;

    var entryDiv = document.createElement('div');
	
	var optStr = '<option value="Not Selected" selected="selected" > </option>';
	
	for (var i in webFilterData) {
		optStr += '<option value="'+webFilterData[i]+'">'+webFilterData[i]+'</option>';
	}
	
    entryDiv.innerHTML = '\
					<select id="new_web_filter_'+count+'" name="new_web_filter_'+count+'">\
						'+optStr+'\
					</select>\
							';
							
	document.getElementById('web_filter_box').appendChild(entryDiv);
	// assign css in select
	// moduleFormDecoration.selectInit(['web_filter_'+count+''], {'main_normal':'main_mouseover','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});

    currentWebFilterEntryCount++;
}

// enableDisableByClicking
function newAccessRuleReset() {
    enableDisableByClicking(true, 'source_ip_direct', ['ip','mask']);
    enableDisableByClicking(true, 'destination_ip_direct', ['ip','mask']);
    enableDisableByClicking(false, 'source_ip_bundle');
    enableDisableByClicking(false, 'destination_ip_bundle');
	
	swithSpecIP('source', 0);
	switchSpecProto('source', 0);
	swithSpecIP('destination', 0);
	switchSpecProto('destination', 0);
	swithSpecUser('new', 0);
	swithSpecGroup('new', 0);
	swithSpecSchedule('new', 0);
	swithSpecWebFilter('new', 0);
	
	// special for port
	// src port
	var sourcePortCount = 0;
	while (true) {
	
		if (document.getElementById('source_protocolNum_'+(sourcePortCount+1))){
			document.getElementById('source_proto_row_'+(sourcePortCount+1)).style.display = 'none';
			document.getElementById('source_port_row_'+(sourcePortCount+1)).style.display = '';
			sourcePortCount++;
		}
		else{
			break;
		}
	}
	// dest port
	var destinationPortCount = 0;
	while (true) {
	
		if (document.getElementById('destination_protocolNum_'+(destinationPortCount+1))){
			document.getElementById('destination_proto_row_'+(destinationPortCount+1)).style.display = 'none';
			document.getElementById('destination_port_row_'+(destinationPortCount+1)).style.display = '';
			destinationPortCount++;
		}
		else{
			break;
		}
	}
	
	// specail for schedule panel
	resetScheduleArray();
	
}

function newAccessRuleValidate() {

	// workaround for sometimes cannot get object by name in chrome
	if (!document.new_access_form){
		w = document.getElementById('new_access_form');
	}
	else
		w = document.new_access_form;
		
	with (w){

    var ruleName = document.getElementById('new_rule_name');
    if (ruleName.value.length < 1 || ruleName.value.length > 64) {
        alert(g_str_js_alert_arule_1);
        document.getElementById('new_rule_name').focus();
        return false;
    }
	
	var tempCount = 1;
	while (true){
		if (!document.getElementById('rule_name_'+tempCount)){
			break;
		}
		var ruleName2 = "";
		ruleName2 = document.getElementById('rule_name_'+tempCount).value;
		
		if (ruleName.value == ruleName2){
			alert(g_str_js_alert_arule_2);
			document.getElementById('new_rule_name').focus();
			return false;
		}
		tempCount++;
	}
	
	
    var description = document.getElementById('new_description');
    if (description.value.length > 128) {
        alert(g_str_js_alert_arule_3);
        document.getElementById('new_description').focus();
        return false;
    }
	
	// src ip
	var sourceCount = 0;
	var sourceValidEntryCount = 0;
	if (source_ip_spec[1].checked){
		if (document.getElementById('source_ip_direct_chkbx').checked) {
			var sourceIP = '';
			var sourceIPMask = '';
			while (true) {
				if (document.getElementById('source_ip_direct_'+(sourceCount+1)+'_ip')) {
					sourceIP = document.getElementById('source_ip_direct_'+(sourceCount+1)+'_ip').value;
					sourceIPMask = document.getElementById('source_ip_direct_'+(sourceCount+1)+'_mask').value;
					
					if (!sourceIP && !sourceIPMask){
						// SKIP
						sourceCount++;
						continue;
					}
					else if (!sourceIP || !check_ip_format2(sourceIP)){
						alert(g_str_js_alert_arule_4);
						document.getElementById('source_ip_direct_'+(sourceCount+1)+'_ip').focus();
						return false;
					}
					else if (!sourceIPMask || !check_subnet_format2(sourceIPMask)){
						alert(g_str_js_alert_arule_5);
						document.getElementById('source_ip_direct_'+(sourceCount+1)+'_mask').focus();
						return false;
					}
					
					
				} else {
					break;
				}
				sourceCount++;
			}
		}
		
		if (sourceCount > 0){
			for (var k =1; k <= sourceCount; k++){
				var sourceIP = '';
				var sourceIPMask = '';
				
				sourceIP = document.getElementById('source_ip_direct_'+k+'_ip').value;
				sourceIPMask = document.getElementById('source_ip_direct_'+k+'_mask').value;
				
				if (!sourceIP && !sourceIPMask){
					// SKIP
					continue;
				}
				
				for (var m =1; m <= sourceCount; m++){
					if (k == m)
						continue;
						
					var sourceIP2 = '';
					var sourceIPMask2 = ''; 
					
					if (document.getElementById('source_ip_direct_'+m+'_ip')){
						sourceIP2 = document.getElementById('source_ip_direct_'+m+'_ip').value;
						sourceIPMask2 = document.getElementById('source_ip_direct_'+m+'_mask').value;
						if (sourceIP == sourceIP2 && sourceIPMask == sourceIPMask2){
							alert(g_str_js_alert_arule_6);
							document.getElementById('source_ip_direct_'+k+'_ip').focus();
							return false;
						}
					}
				}
			}
		}
		
		var sourceIpBundleCount = 0;
		var sourcebundleName = '';
		while (true) {
			if (document.getElementById('source_ip_bundle_'+(sourceIpBundleCount+1))) {
				if (document.getElementById('source_ip_bundle_'+(sourceIpBundleCount+1)).checked) {
					sourcebundleName = document.getElementById('source_ip_bundle_'+(sourceIpBundleCount+1)).value;
					
					if (!sourcebundleName){
						sourceIpBundleCount++;
						continue;
					}
					
					sourceValidEntryCount++;
				}
			} else {
				break;
			}
			sourceIpBundleCount++;
		}
		
		if (sourceValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_19);
			// hard code
			document.getElementById('source_ip_bundle_1').focus();
			return false;
		}
		
	}
	
	// dest ip
	var destinationCount = 0;
	var destinationValidEntryCount = 0;
	if (destination_ip_spec[1].checked){
		if (document.getElementById('destination_ip_direct_chkbx').checked) {
			var destinationIP = '';
			var destinationIPMask = '';
			while (true) {
				if (document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_ip')) {
					destinationIP = document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_ip').value;
					destinationIPMask = document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_mask').value;
					
					if (!destinationIP && !destinationIPMask){
						// SKIP
						destinationCount++;
						continue;
					}
					else if (!destinationIP || !check_ip_format2(destinationIP)){
						alert(g_str_js_alert_arule_4);
						document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_ip').focus();
						return false;
					}
					else if (!destinationIPMask || !check_subnet_format2(destinationIPMask)){
						alert(g_str_js_alert_arule_5);
						document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_mask').focus();
						return false;
					}
					
				} else {
					break;
				}
				destinationCount++;
			}
		}
		
		if (destinationCount > 0){
			for (var k =1; k <= destinationCount; k++){
				var destinationIP = '';
				var destinationIPMask = '';
				
				destinationIP = document.getElementById('destination_ip_direct_'+k+'_ip').value;
				destinationIPMask = document.getElementById('destination_ip_direct_'+k+'_mask').value;
				
				if (!destinationIP && !destinationIPMask){
					// SKIP
					continue;
				}
				
				for (var m =1; m <= destinationCount; m++){
					if (k == m)
						continue;
						
					var destinationIP2 = '';
					var destinationIPMask2 = ''; 
					
					if (document.getElementById('destination_ip_direct_'+m+'_ip')){
						destinationIP2 = document.getElementById('destination_ip_direct_'+m+'_ip').value;
						destinationIPMask2 = document.getElementById('destination_ip_direct_'+m+'_mask').value;
						if (destinationIP == destinationIP2 && destinationIPMask == destinationIPMask2){
							alert(g_str_js_alert_arule_6);
							document.getElementById('destination_ip_direct_'+k+'_ip').focus();
							return false;
						}
					}
				}
			}
		}
		
		var destinationIpBundleCount = 0;
		var destinationbundleName = '';
		while (true) {
			if (document.getElementById('destination_ip_bundle_'+(destinationIpBundleCount+1))) {
				if (document.getElementById('destination_ip_bundle_'+(destinationIpBundleCount+1)).checked) {
					destinationbundleName = document.getElementById('destination_ip_bundle_'+(destinationIpBundleCount+1)).value;
					
					if (!destinationbundleName){
						destinationIpBundleCount++;
						continue;
					}
					
					destinationValidEntryCount++;
				}
			} else {
				break;
			}
			destinationIpBundleCount++;
		}
		
		if (destinationValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_20);
			// hard code
			document.getElementById('destination_ip_bundle_1').focus();
			return false;
		}
	
	}
	
	// src port
	var sourcePortCount = 0;
	var sourcePortStart = 0;
	var sourcePortEnd = 0;
	var sourceProtocolNum = 0;
	var sourcePortValidEntryCount = 0;
	if (source_protocol_type[1].checked){
		while (true) {
		
			if (document.getElementById('source_protocolNum_'+(sourcePortCount+1))){
				sourceProtocolNum = document.getElementById('source_protocolNum_'+(sourcePortCount+1)).value;
				
				if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
					if (document.getElementById('source_port_'+(sourcePortCount+1)+'_from')) {
						sourcePortStart = parseInt(document.getElementById('source_port_'+(sourcePortCount+1)+'_from').value);
						sourcePortEnd = parseInt(document.getElementById('source_port_'+(sourcePortCount+1)+'_to').value);
						if (!sourcePortStart && !sourcePortEnd){
							// SKIP
							sourcePortCount++;
							continue;
						}
						else if (sourcePortEnd < sourcePortStart || !sourcePortStart || !sourcePortEnd || !isInteger(sourcePortStart) || !isInteger(sourcePortEnd)){
							alert(g_str_js_alert_arule_7);
							if (!sourcePortEnd || !isInteger(sourcePortEnd))
								document.getElementById('source_port_'+(sourcePortCount+1)+'_to').focus();
							else
								document.getElementById('source_port_'+(sourcePortCount+1)+'_from').focus();
							return false;
						}
					}
				}
				
			}
			else{
				break;
			}
			
			sourcePortCount++;
		}
		
		if (sourcePortCount > 0){
			for (var k =1; k <= sourcePortCount; k++){
				var sourceProtocolNum = 0;
				var sourcePortStart = 0;
				var sourcePortEnd = 0;
				var sourceSpecProtocolNum = 0;
				sourceProtocolNum = document.getElementById('source_protocolNum_'+k).value;
				sourcePortStart = parseInt(document.getElementById('source_port_'+k+'_from').value);
				sourcePortEnd = parseInt(document.getElementById('source_port_'+k+'_to').value);
				sourceSpecProtocolNum = parseInt(document.getElementById('source_specific_protocolNum_'+k).value);
				
				if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
					if (!sourcePortStart && !sourcePortEnd){
						// SKIP
						continue;
					}
				}
				else{
					if (!sourceSpecProtocolNum){
						// SKIP
						continue;
					}
				}
				
				sourcePortValidEntryCount++;
				
				for (var m =1; m <= sourcePortCount; m++){
					if (k == m)
						continue;
						
					var sourceProtocolNum2 = 0;
					var sourcePortStart2 = 0;
					var sourcePortEnd2 = 0;
					var sourceSpecProtocolNum2 = 0;
					sourceProtocolNum2 = document.getElementById('source_protocolNum_'+m).value;
					sourcePortStart2 = parseInt(document.getElementById('source_port_'+m+'_from').value);
					sourcePortEnd2 = parseInt(document.getElementById('source_port_'+m+'_to').value);
					sourceSpecProtocolNum2 = parseInt(document.getElementById('source_specific_protocolNum_'+m).value);
					
					if (sourceProtocolNum == sourceProtocolNum2){
						if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
							if (sourcePortStart == sourcePortStart2 && sourcePortEnd == sourcePortEnd2){
								alert(g_str_js_alert_arule_8);
								document.getElementById('source_port_'+k+'_from').focus();
								return false;
							}
						}
						else {
							if (sourceSpecProtocolNum == sourceSpecProtocolNum2){
								alert(g_str_js_alert_arule_9);
								document.getElementById('source_specific_protocolNum_'+k).focus();
								return false;
							}
						}
					}
				}
			}
		}
		
		if (sourcePortValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_21);
			// hard code
			document.getElementById('source_protocolNum_1').focus();
			return false;
		}
	}
	
	// dest port
	var destinationPortCount = 0;
	var destinationPortStart = 0;
	var destinationPortEnd = 0;
	var destinationProtocolNum = 0;
	var destinationPortValidEntryCount = 0;
	if (destination_protocol_type[1].checked){
		while (true) {
		
			if (document.getElementById('destination_protocolNum_'+(destinationPortCount+1))){
				destinationProtocolNum = document.getElementById('destination_protocolNum_'+(destinationPortCount+1)).value;
				
				if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
				
					if (document.getElementById('destination_port_'+(destinationPortCount+1)+'_from')) {
						destinationPortStart = parseInt(document.getElementById('destination_port_'+(destinationPortCount+1)+'_from').value);
						destinationPortEnd = parseInt(document.getElementById('destination_port_'+(destinationPortCount+1)+'_to').value);
						if (!destinationPortStart && !destinationPortEnd){
							// SKIP
							destinationPortCount++;
							continue;
						}
						else if (destinationPortEnd < destinationPortStart || !destinationPortStart || !destinationPortEnd || !isInteger(destinationPortStart) || !isInteger(destinationPortEnd) ){
							alert(g_str_js_alert_arule_7);
							if (!destinationPortEnd || !isInteger(destinationPortEnd))
								document.getElementById('destination_port_'+(destinationPortCount+1)+'_to').focus();
							else
								document.getElementById('destination_port_'+(destinationPortCount+1)+'_from').focus();
							return false;
						}
					}
				}
				
			}
			else{
				break;
			}
			
			destinationPortCount++;
		}
	
		if (destinationPortCount > 0){
			for (var k =1; k <= destinationPortCount; k++){
				var destinationProtocolNum = 0;
				var destinationPortStart = 0;
				var destinationPortEnd = 0;
				var destinationSpecProtocolNum = 0;
				destinationProtocolNum = document.getElementById('destination_protocolNum_'+k).value;
				destinationPortStart = parseInt(document.getElementById('destination_port_'+k+'_from').value);
				destinationPortEnd = parseInt(document.getElementById('destination_port_'+k+'_to').value);
				destinationSpecProtocolNum = parseInt(document.getElementById('destination_specific_protocolNum_'+k).value);
				
				if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
					if (!destinationPortStart && !destinationPortEnd){
						// SKIP
						continue;
					}
				}
				else{
					if (!destinationSpecProtocolNum){
						// SKIP
						continue;
					}
				}
				
				destinationPortValidEntryCount++;
				
				for (var m =1; m <= destinationPortCount; m++){
					if (k == m)
						continue;
						
					var destinationProtocolNum2 = 0;
					var destinationPortStart2 = 0;
					var destinationPortEnd2 = 0;
					var destinationSpecProtocolNum2 = 0;
					destinationProtocolNum2 = document.getElementById('destination_protocolNum_'+m).value;
					destinationPortStart2 = parseInt(document.getElementById('destination_port_'+m+'_from').value);
					destinationPortEnd2 = parseInt(document.getElementById('destination_port_'+m+'_to').value);
					destinationSpecProtocolNum2 = parseInt(document.getElementById('destination_specific_protocolNum_'+m).value);
					
					if (destinationProtocolNum == destinationProtocolNum2){
						if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
							if (destinationPortStart == destinationPortStart2 && destinationPortEnd == destinationPortEnd2){
								alert(g_str_js_alert_arule_8);
								document.getElementById('destination_port_'+k+'_from').focus();
								return false;
							}
						}
						else {
							if (destinationSpecProtocolNum == destinationSpecProtocolNum2){
								alert(g_str_js_alert_arule_9);
								document.getElementById('destination_specific_protocolNum_'+k).focus();
								return false;
							}
						}
					}
				}
			}
		}
		
		if (destinationPortValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_22);
			// hard code
			document.getElementById('destination_protocolNum_1').focus();
			return false;
		}
	}
	
	// user
	var userCount = 0;
	var userValidEntryCount = 0;
	if (user_spec[1].checked){
		while (true) {
			var userName = "";
			if (document.getElementById('new_user_'+(userCount+1))){
				userName = document.getElementById('new_user_'+(userCount+1)).value;
				
				if (userName != "Not Selected"){
					var tempCount = 0;
					
					userValidEntryCount++;
					
					while (true){
						if (userCount == tempCount){
							// SKIP
							tempCount++;
							continue;
						}
						if (!document.getElementById('new_user_'+(tempCount+1))){
							break;
						}
						var userName2 = "";
						userName2 = document.getElementById('new_user_'+(tempCount+1)).value;
						
						if (userName == userName2){
							alert(g_str_js_alert_arule_10);
							document.getElementById('new_user_'+(userCount+1)).focus();
							return false;
						}
						tempCount++;
					}
				}
				
			}
			else{
				break;
			}
			
			userCount++;
		}
		
		if (userValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_23);
			// hard code
			document.getElementById('new_user_1').focus();
			return false;
		}
	}
	
	// group
	var groupCount = 0;
	var groupValidEntryCount = 0;
	if (group_spec[1].checked){
		while (true) {
			var groupName = "";
			if (document.getElementById('new_group_'+(groupCount+1))){
				groupName = document.getElementById('new_group_'+(groupCount+1)).value;
				
				if (groupName != "Not Selected"){
					var tempCount = 0;
					
					groupValidEntryCount++;
					
					while (true){
						if (groupCount == tempCount){
							// SKIP
							tempCount++;
							continue;
						}
						if (!document.getElementById('new_group_'+(tempCount+1))){
							break;
						}
						var groupName2 = "";
						groupName2 = document.getElementById('new_group_'+(tempCount+1)).value;
						
						if (groupName == groupName2){
							alert(g_str_js_alert_arule_11);
							document.getElementById('new_group_'+(groupCount+1)).focus();
							return false;
						}
						tempCount++;
					}
				}
				
			}
			else{
				break;
			}
			
			groupCount++;
		}
		
		if (groupValidEntryCount == 0){
			// none of valid entry
			alert(g_str_js_alert_arule_24);
			// hard code
			document.getElementById('new_group_1').focus();
			return false;
		}
	}
	
	// schedule
	if (schedule_spec[1].checked){
		// special value store in javascript's variable(array)
		
		isNotEmpty = false;
		
		for (i=0; i<7; i++){
			for (j=0; j<24; j++){
				for (k=0; k<4; k++){
					if (scheduleArray[i][j][k] == 1){
						isNotEmpty = true;
						break;
					}
				}
				if (isNotEmpty)
					break;
			}
			if (isNotEmpty)
				break;
		}
		
		if (!isNotEmpty){
			// none of valid entry
			alert(g_str_js_alert_arule_26);
			// hard code
			document.getElementById('schedule_spec_1').focus();
			return false
		}
	}
	
	// web filter
	if (web_filter_spec[1].checked){
		filterName = document.getElementById('new_web_filter_1').value;
				
		if (filterName == "Not Selected" || filterName == ''){
			// none of valid entry
			alert(g_str_js_alert_arule_25);
			// hard code
			document.getElementById('new_web_filter_1').focus();
			return false
		}
	}
	
	} // end with
		
    return true;
}

function addAccessRule() {
	// add into temp array
	var newNumber = num_ruleData +1;
	var newOrder = 1;
	if (num_ruleData >1)
		newOrder = ruleData[num_ruleData][2] +1;
		
	// workaround for sometimes cannot get object by name in chrome
	if (!document.new_access_form){
		w = document.getElementById('new_access_form');
	}
	else
		w = document.new_access_form;
		
	with (w){
		var isAllow = 0;
		if (new_action[0].checked) // allow
			isAllow = 1;
		else if (new_action[1].checked) // deny
			isAllow = 0;
			
		var isEnable = 1;
		var trafficType = 0;
		
		// 0: both, 1: inbound, 2: outbound
		if (new_traffic_type[0].checked)
			trafficType = new_traffic_type[0].value;
		else if (new_traffic_type[1].checked)
			trafficType = new_traffic_type[1].value;
		else if (new_traffic_type[2].checked)
			trafficType = new_traffic_type[2].value;
			
		var ruleName = new_rule_name.value;
		var description = new_description.value;		
		
		var label_srcip_text_1 ="";
		var label_srcip_text_2 ="";
		var label_srcip_text_3 ="";
		// src ip
		var sourceCount = 0;
		var sourceCreateEntryCount = 0;
		if (document.getElementById('source_ip_direct_chkbx').checked) {
			var sourceIP = '';
			var sourceIPMask = '';
			while (true) {
				if (document.getElementById('source_ip_direct_'+(sourceCount+1)+'_ip')) {
					sourceIP = document.getElementById('source_ip_direct_'+(sourceCount+1)+'_ip').value;
					sourceIPMask = document.getElementById('source_ip_direct_'+(sourceCount+1)+'_mask').value;
					
					if (!sourceIP && !sourceIPMask){
						sourceCount++;
						continue;
					}
					
					label_srcip_text_2 +='\
											<div style="padding-left: 10px;">\
        										<input type="text" id="hinput_'+newNumber+'_source_'+sourceCreateEntryCount+'" name="hinput_'+newNumber+'_source_'+sourceCreateEntryCount+'" value="'+sourceIP+' ('+sourceIPMask+')" class="ch" onchange="return check_input_ip_text(this)" />\
        									</div>\
					';
					sourceCreateEntryCount++;
				} else {
					break;
				}
				sourceCount++;
			}
		}
		var label_destip_text_1 ="";
		var label_destip_text_2 ="";
		var label_destip_text_3 ="";
		// dest ip
		var destinationCount = 0;
		var destinationCreateEntryCount = 0;
		if (document.getElementById('destination_ip_direct_chkbx').checked) {
			var destinationIP = '';
			var destinationIPMask = '';
			while (true) {
				if (document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_ip')) {
					destinationIP = document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_ip').value;
					destinationIPMask = document.getElementById('destination_ip_direct_'+(destinationCount+1)+'_mask').value;
					
					if (!destinationIP && !destinationIPMask){
						destinationCount++;
						continue;
					}
					
					label_destip_text_2 +='\
											<div style="padding-left: 10px; height: 20px;">\
        										<input type="text" id="hinput_'+newNumber+'_dest_'+destinationCreateEntryCount+'" name="hinput_'+newNumber+'_dest_'+destinationCreateEntryCount+'" value="'+destinationIP+' ('+destinationIPMask+')" class="ch" onchange="return check_input_ip_text(this)" />\
        									</div>\
					';
					destinationCreateEntryCount++;
					
				} else {
					break;
				}
				destinationCount++;
			}
		}
		
		var label_srcipbundle_text_2 ="";
		// src ipbundle
		var sourceIpBundleCount = 0;
		var sourceIpBundleCreateEntryCount = 0;
		if (source_ip_spec[1].checked) {
			var sourcebundleName = '';
			while (true) {
				if (document.getElementById('source_ip_bundle_'+(sourceIpBundleCount+1))) {
					if (document.getElementById('source_ip_bundle_'+(sourceIpBundleCount+1)).checked) {
						sourcebundleName = document.getElementById('source_ip_bundle_'+(sourceIpBundleCount+1)).value;
						
						if (!sourcebundleName){
							sourceIpBundleCount++;
							continue;
						}
						
						var temp = "";
						if (ipBundleData[sourcebundleName]){
						
							for (var i in ipBundleData[sourcebundleName]) {
								var temp2 = new Array();
								temp2 = ipBundleData[sourcebundleName][i].split('-');
								temp+='<span style="padding-right: 10px;">'+temp2[0]+' to '+temp2[1];
								if (i < ipBundleData[sourcebundleName].length - 1){
									temp +=',';
								}
								temp+='</span>\n';
							}
						}
						
						label_srcipbundle_text_2 +='\
											<div style="padding-left: 10px; ">\
												<table>\
													<tr><td valign="top">['+sourcebundleName+']</td>\
													<td>\
													<input type="hidden" value="'+sourcebundleName+'" id="hinput_'+newNumber+'_source_ipbundle_'+sourceIpBundleCreateEntryCount+'" name="hinput_'+newNumber+'_source_ipbundle_'+sourceIpBundleCreateEntryCount+'" />\
													'+temp+'\
													</td></tr>\
												</table>\
											</div>\
						';
						sourceIpBundleCreateEntryCount++;
					}
				} else {
					break;
				}
				sourceIpBundleCount++;
			}
		}
		
		if (sourceIpBundleCount == 0){
			label_srcipbundle_text_2 = '<div style="padding-left: 10px; height: 20px; font-weight: normal;">'+g_str_setcfg_arule_all_ip+'</div>';
		}
		
		label_srcip_text_1 = '\
								<td class="rule_data_left" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_src_ip+'</span><br/>\
		';
		label_srcip_text_3 = '		</div>\
								</td>\
		';
		
		
		var label_destipbundle_text_2 ="";
		// dest ipbundle
		var destinationIpBundleCount = 0;
		var destinationIpBundleCreateEntryCount = 0;
		if (destination_ip_spec[1].checked) {
			var destinationbundleName = '';
			while (true) {
				if (document.getElementById('destination_ip_bundle_'+(destinationIpBundleCount+1))) {
					if (document.getElementById('destination_ip_bundle_'+(destinationIpBundleCount+1)).checked) {
						destinationbundleName = document.getElementById('destination_ip_bundle_'+(destinationIpBundleCount+1)).value;
						
						if (!destinationbundleName){
							destinationIpBundleCount++;
							continue;
						}
						
						var temp = "";
						if (ipBundleData[destinationbundleName]){
						
							for (var i in ipBundleData[destinationbundleName]) {
								var temp2 = new Array();
								temp2 = ipBundleData[destinationbundleName][i].split('-');
								temp+='<span style="padding-right: 10px;">'+temp2[0]+' to '+temp2[1];
								if (i < ipBundleData[destinationbundleName].length - 1){
									temp +=',';
								}
								temp+='</span>\n';
							}
						}
						
						label_destipbundle_text_2 +='\
											<div style="padding-left: 10px; ">\
												<table>\
													<tr><td valign="top">['+destinationbundleName+']</td>\
													<td>\
													<input type="hidden" value="'+destinationbundleName+'" id="hinput_'+newNumber+'_dest_ipbundle_'+destinationIpBundleCreateEntryCount+'" name="hinput_'+newNumber+'_dest_ipbundle_'+destinationIpBundleCreateEntryCount+'" />\
													'+temp+'\
													</td></tr>\
												</table>\
											</div>\
						';
						destinationIpBundleCreateEntryCount++;
					}
				} else {
					break;
				}
				destinationIpBundleCount++;
			}
		}
		
		if (destinationIpBundleCount == 0){
			label_destipbundle_text_2 = '<div style="padding-left: 10px; height: 20px; font-weight: normal;">'+g_str_setcfg_arule_all_ip+'</div>';
		}
		
		label_destip_text_1 = '\
								<td class="rule_data_left" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_dest_ip+'</span><br/>\
		';
		label_destip_text_3 = '		</div>\
								</td>\
		';
		
		// src port
		var label_srcport_text_1 ="";
		var label_srcport_text_2 ="";
		var label_srcport_text_3 ="";
		var sourcePortCount = 0;
		var sourcePortStart = 0;
		var sourcePortEnd = 0;
		var sourcePortCreateEntryCount = 0;
		var sourceProtocolName = "";
		var sourceProtocolNum = 0;
		if (source_protocol_type[1].checked) {
			while (true) {
			
				if (document.getElementById('source_protocolNum_'+(sourcePortCount+1))){
					sourceProtocolNum = document.getElementById('source_protocolNum_'+(sourcePortCount+1)).value;
					
					if (sourceProtocolNum == 6 || sourceProtocolNum == 17){
					
						if (sourceProtocolNum == 6){
							sourceProtocolName = g_str_setcfg_arule_proto_opt1;
						}
						else{
							sourceProtocolName = g_str_setcfg_arule_proto_opt2;
						}
					
						if (document.getElementById('source_port_'+(sourcePortCount+1)+'_from')) {
							sourcePortStart = parseInt(document.getElementById('source_port_'+(sourcePortCount+1)+'_from').value);
							sourcePortEnd = parseInt(document.getElementById('source_port_'+(sourcePortCount+1)+'_to').value);
							if (!sourcePortStart && !sourcePortEnd){
								sourcePortCount++;
								continue;
							}
							
							label_srcport_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+newNumber+'_sourcep_'+sourcePortCreateEntryCount+'" name="hinput_'+newNumber+'_sourcep_'+sourcePortCreateEntryCount+'" value="'+sourceProtocolName+' ('+sourcePortStart+'-'+sourcePortEnd+')" class="ch" onchange="return check_input_protocol_text(this, '+newNumber+')" />\
													</span>\
							';
							sourcePortCreateEntryCount++;
						}
					}
					else{
						if (sourceProtocolNum == 0){
							if (document.getElementById('source_specific_protocolNum_'+(sourcePortCount+1))) {
								sourceProtocolNum = parseInt(document.getElementById('source_specific_protocolNum_'+(sourcePortCount+1)).value);
								
								if (!sourceProtocolNum){
									sourcePortCount++;
									continue;
								}
								
								sourceProtocolName = g_str_setcfg_arule_proto_opt3;
								
								label_srcport_text_2 +='\
														<span style="padding-right: 10px;">\
															<input type="text" id="hinput_'+newNumber+'_sourcep_'+sourcePortCreateEntryCount+'" name="hinput_'+newNumber+'_sourcep_'+sourcePortCreateEntryCount+'" value="'+sourceProtocolName+' ('+sourceProtocolNum+')" class="ch" onchange="return check_input_protocol_text(this, '+newNumber+')" />\
														</span>\
								';
								sourcePortCreateEntryCount++;
							}
						}
					}
					
				}
				else{
					break;
				}
				
				sourcePortCount++;
			}
		}
		
		if (sourcePortCreateEntryCount == 0){
			label_srcport_text_2 = '<div style="padding-left: 10px; font-weight: normal;">'+g_str_setcfg_arule_all_protocol+'</div>';
		}
		else{
			label_srcport_text_2 = '<div style="padding-left: 10px;">'+label_srcport_text_2+'</div>'
		}
		
		
		label_srcport_text_1 = '\
							<td class="rule_data_left" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_src_proto+'</span><br/>\
		';
		label_srcport_text_3 = '\
									</div>\
							</td>\
		';
		
		// dest port
		var label_destport_text_1 ="";
		var label_destport_text_2 ="";
		var label_destport_text_3 ="";
		var destinationPortCount = 0;
		var destinationPortStart = 0;
		var destinationPortEnd = 0;
		var destinationPortCreateEntryCount = 0;
		var destinationProtocolName = "";
		var destinationProtocolNum = 0;
		if (destination_protocol_type[1].checked) {
			while (true) {
			
				if (document.getElementById('destination_protocolNum_'+(destinationPortCount+1))){
					destinationProtocolNum = document.getElementById('destination_protocolNum_'+(destinationPortCount+1)).value;
					
					if (destinationProtocolNum == 6 || destinationProtocolNum == 17){
					
						if (destinationProtocolNum == 6){
							destinationProtocolName = g_str_setcfg_arule_proto_opt1;
						}
						else{
							destinationProtocolName = g_str_setcfg_arule_proto_opt2;
						}
					
						if (document.getElementById('destination_port_'+(destinationPortCount+1)+'_from')) {
							destinationPortStart = parseInt(document.getElementById('destination_port_'+(destinationPortCount+1)+'_from').value);
							destinationPortEnd = parseInt(document.getElementById('destination_port_'+(destinationPortCount+1)+'_to').value);
							if (!destinationPortStart && !destinationPortEnd){
								destinationPortCount++;
								continue;
							}
							
							label_destport_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+newNumber+'_destp_'+destinationPortCreateEntryCount+'" name="hinput_'+newNumber+'_destp_'+destinationPortCreateEntryCount+'" value="'+destinationProtocolName+' ('+destinationPortStart+'-'+destinationPortEnd+')" class="ch" onchange="return check_input_protocol_text(this, '+newNumber+')" />\
													</span>\
							';
							destinationPortCreateEntryCount++;
						}
					}
					else{
						if (destinationProtocolNum == 0){
							if (document.getElementById('destination_specific_protocolNum_'+(destinationPortCount+1))) {
								destinationProtocolNum = parseInt(document.getElementById('destination_specific_protocolNum_'+(destinationPortCount+1)).value);
								
								if (!destinationProtocolNum){
									destinationPortCount++;
									continue;
								}
								
								destinationProtocolName = g_str_setcfg_arule_proto_opt3;
								
								label_destport_text_2 +='\
														<span style="padding-right: 10px;">\
															<input type="text" id="hinput_'+newNumber+'_destp_'+destinationPortCreateEntryCount+'" name="hinput_'+newNumber+'_destp_'+destinationPortCreateEntryCount+'" value="'+destinationProtocolName+' ('+destinationProtocolNum+')" class="ch" onchange="return check_input_protocol_text(this, '+newNumber+')" />\
														</span>\
								';
								destinationPortCreateEntryCount++;
							}
						}
					}
					
				}
				else{
					break;
				}
				
				destinationPortCount++;
			}
		}
		
		if (destinationPortCreateEntryCount == 0){
			label_destport_text_2 = '<div style="padding-left: 10px; font-weight: normal;">'+g_str_setcfg_arule_all_protocol+'</div>';
		}
		else{
			label_destport_text_2 = '<div style="padding-left: 10px;">'+label_destport_text_2+'</div>'
		}
		
		label_destport_text_1 = '\
							<td class="rule_data_left" valign="top">\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_dest_proto+'</span><br/>\
		';
		label_destport_text_3 = '\
									</div>\
							</td>\
		';
		
		// user and group
		var label_user_and_group_text_1 ="";
		var label_user_and_group_text_2 ="";
		var label_user_and_group_text_3 ="";
		var userCount = 0;
		var userName = "";
		
		var userAndGroupCreateEntryCount = 0;
		var userCreateEntryCount = 0;
		if (user_spec[1].checked) {
			while (true) {
			
				if (document.getElementById('new_user_'+(userCount+1))){
					userName = document.getElementById('new_user_'+(userCount+1)).value;
					
					if (userName != "Not Selected"){
						label_user_and_group_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+newNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" name="hinput_'+newNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" value="'+userName+' (user)" title="'+userName+' (user)" class="ch" />\
													</span>\
							';
						userAndGroupCreateEntryCount++;
					}
					
				}
				else{
					break;
				}
				
				userCount++;
			}
		}
		
		if (userAndGroupCreateEntryCount >0){
			label_user_and_group_text_2 = '<div style="padding-left: 10px;">'+label_user_and_group_text_2+'</div>';
		}
		
		var groupCount = 0;
		var groupName = "";
		
		userCreateEntryCount = userAndGroupCreateEntryCount;
		if (group_spec[1].checked) {
			while (true) {
			
				if (document.getElementById('new_group_'+(groupCount+1))){
					groupName = document.getElementById('new_group_'+(groupCount+1)).value;
					
					if (groupName != "Not Selected"){
					
						if (userAndGroupCreateEntryCount == userCreateEntryCount){
							// first of group
							label_user_and_group_text_2 += '<div style="padding-left: 10px;">';
						}
					
						label_user_and_group_text_2 +='\
													<span style="padding-right: 10px;">\
														<input type="text" id="hinput_'+newNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" name="hinput_'+newNumber+'_user_and_group_'+userAndGroupCreateEntryCount+'" value="'+groupName+' (group)" title="'+groupName+' (group)" class="ch" />\
													</span>\
							';
						userAndGroupCreateEntryCount++;
					}
					
				}
				else{
					break;
				}
				
				groupCount++;
			}
		}
		
		if (userAndGroupCreateEntryCount > userCreateEntryCount){
			// have group
			label_user_and_group_text_2 += '</div>';
		}
		
		if(userAndGroupCreateEntryCount == 0){
			label_user_and_group_text_2 = '<div style="padding-left: 10px; font-weight: normal;">'+g_str_setcfg_arule_all_user+'</div>';
		}
		
		label_user_and_group_text_1 = '\
							<td class="rule_data_left" valign="top" colspan =2>\
									<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_user_and_group+'</span><br/>\
		';
		label_user_and_group_text_3 = '\
									</div>\
							</td>\
		';
		
		// schedule
		var ruleSchedule = "";
		var scheduleMsgStr = "";		
		
		var label_schedule_text ="";
		if (schedule_spec[1].checked) {
			// special value store in javascript's variable(array)
			
			// build value string
			schValStr = "";
			
			for (i=0; i<7; i++){
				for (j=0; j<24; j++){
					val = 0;
					if (scheduleArray[i][j][0] == 1){
						val +=1;
					}
					if (scheduleArray[i][j][1] == 1){
						val +=2;
					}
					if (scheduleArray[i][j][2] == 1){
						val +=4;
					}
					if (scheduleArray[i][j][3] == 1){
						val +=8;
					}
					schValStr += val.toString(16);
				}
			}
			
			ruleSchedule = schValStr.toUpperCase();
			
			if ((ruleSchedule.split("F").length - 1) == 168){
				scheduleMsgStr = g_str_setcfg_arule_all_schedule;
				ruleSchedule = "";
			}
			else{
				scheduleMsgStr = schTransStr(ruleSchedule);
			}
		}
		else{
			scheduleMsgStr = g_str_setcfg_arule_all_schedule;
			ruleSchedule = "";
		}
		
		label_schedule_text = '\
						<td class="rule_data_left" valign="top" colspan =2>\
							<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_sch+'</span><br/>\
							<div style="padding-left: 10px; font-weight: normal;">'+scheduleMsgStr+'</div>\
							<input type="hidden" value="'+ruleSchedule+'" id="schedule_'+newNumber+'" name="schedule_'+newNumber+'" />\
							</div>\
						</td>\
					';
		
		// web filter
		var appliedWebFilter = '';
		
		var label_web_filter_text ="";
		if (web_filter_spec[1].checked) {
			// hard code, since now only support one
			filterName = document.getElementById('new_web_filter_1').value;					
			if (filterName != "Not Selected"){
				appliedWebFilter = filterName;
				label_web_filter_text = '\
						<td class="rule_data_left" valign="top" colspan =2>\
							<div><span style="font-weight: bold;">'+g_str_setcfg_arule_label_wf+'</span><br/>\
							<div style="padding-left: 10px;">'+appliedWebFilter+'</div>\
							<input type="hidden" value="'+appliedWebFilter+'" id="applied_web_filter_'+newNumber+'" name="applied_web_filter_'+newNumber+'" />\
						</td>\
					';
			}
		}
		
		if (label_web_filter_text == ""){
			label_web_filter_text = '\
						<td class="rule_data_left" valign="top" colspan =2>\
							<input type="hidden" value="'+appliedWebFilter+'" id="applied_web_filter_'+newNumber+'" name="applied_web_filter_'+newNumber+'" />\
						</td>\
					';
		}
		
		ruleData[newNumber] = [isEnable, isAllow, newOrder];
		num_ruleData ++;
	
		var label_text_1 ="";
		var label_text_2 ="";
		var label_text_3 ="";
		if (isEnable == 1){
			label_text_1 = 'disable';
			label_text_3 = g_str_setcfg_arule_en;
			if (isAllow ==1)
				label_text_2 = 'green';
			else
				label_text_2 = 'red';
		}
		else{
			label_text_1 = 'enable';
			label_text_2 = 'grey';
			label_text_3 = g_str_setcfg_arule_dis;
		}
		var opt_act_text1 ="";
		var opt_act_text2 ="";
		if (isAllow ==1){
			opt_act_text1 = 'selected="selected"';
		}
		else{
			opt_act_text2 = 'selected="selected"';
		}
		var opt_tp_text1 ="";
		var opt_tp_text2 ="";
		var opt_tp_text3 ="";
		if (trafficType ==0){
			opt_tp_text1 = 'selected="selected"';
		}
		else if (trafficType ==1){
			opt_tp_text2 = 'selected="selected"';
		}
		else if (trafficType ==2){
			opt_tp_text3 = 'selected="selected"';
		}
		
		var entryDiv = document.createElement('div');
		
		entryDiv.className = 'rule';
		entryDiv.id= 'rule_box_'+newNumber;
		
		entryDiv.innerHTML = '\
			<a name="rule_box_'+newNumber+'_pos"></a>\
			<table cellpadding="0" cellspacing="0" border="0" style="border-bottom: 1px solid green; width: 100%; font-size: 12px;">\
				<tr>\
					<td class="rule_chkbx" id="rule_select_box_'+newNumber+'" valign="top">\
						<b>'+newOrder+'</b><br /><input type="checkbox" id="rule_select_chkbox_'+newNumber+'" name="rule_select_chkbox[]" value="'+newNumber+'" />\
					</td>\
					<td style="text-align: left;">\
						<table cellpadding="4" cellspacing="0" border="0" style="width: 100%; font-weight: bold; font-size: 12px;">\
							<tr>\
								<td style="width: 7px; cursor: pointer; -moz-user-select: none;" onselectstart="javascript: return false;" id="rule_state_box_'+newNumber+'" title="Click to '+label_text_1+' it" onclick="javascript: rule_changeState('+newNumber+');" class="rule_state_'+label_text_2+'"></td>\
								<td style="background: #fff;">\
									<div style="margin-bottom: 6px; font-weight: bold; font-size: 14px;">\
										<div style="float: right; font-size: 12px;">\
											<span style="font-size: 11px; cursor: pointer; -moz-user-select: none;" onselectstart="javascript: return false;" id="rule_state_text_'+newNumber+'" title="Click to '+label_text_1+' it" onclick="javascript: rule_changeState('+newNumber+');" class="rule_statetxt_'+label_text_2+'">['+label_text_3+']</span>&nbsp;'+g_str_setcfg_arule_label_act+'<select id="rule_action_'+newNumber+'" name="rule_action_'+newNumber+'" onchange="rule_changeAction('+newNumber+');">\
												<option value="1" '+opt_act_text1+'>'+g_str_setcfg_arule_act_opt1+'</option>\
												<option value="0" '+opt_act_text2+'>'+g_str_setcfg_arule_act_opt2+'</option>\
											</select>'+g_str_setcfg_arule_label_traffic+'<select id="rule_trafficType_'+newNumber+'" name="rule_trafficType_'+newNumber+'" onchange="showAdditional('+newNumber+');">\
												<option value="1" '+opt_tp_text2+'>'+g_str_setcfg_arule_traffic_opt2+'</option>\
												<option value="2" '+opt_tp_text3+'>'+g_str_setcfg_arule_traffic_opt3+'</option>\
												<option value="0" '+opt_tp_text1+'>'+g_str_setcfg_arule_traffic_opt1+'</option>\
											</select>\
										</div>\
										<u>'+ruleName+'</u>\
										<input type="hidden" value="'+ruleName+'" id="rule_name_'+newNumber+'" name="rule_name_'+newNumber+'" />\
									</div>\
									<div style="padding-left: 10px;">'+description+'</div>\
									<input type="hidden" value="'+description+'" id="rule_description_'+newNumber+'" name="rule_description_'+newNumber+'" />\
								</td>\
								<td class="rule_collapse_box" id="rule_collapse_box_'+newNumber+'" onselectstart="javascript: return false;" onmouseover="javascript: this.style.background=\'#ddd\'; this.style.color=\'black\';" onmouseout="javascript: this.style.background=\'#eee\'; this.style.color=\'#777\';" onclick="javascript: ruleDetailCollapse(this, '+newNumber+');" title="Collapse">\
									&uarr;\
								</td>\
							</tr>\
							<tr id="additional_row_'+newNumber+'" name="additional_row_'+newNumber+'" style=""><td align="center" colspan=2><span id="additional_msg_'+newNumber+'" name="additional_msg_'+newNumber+'" style="background: #FFF;color: #FF0000;">'+g_str_setcfg_msg_confirm_add+'</span></td><td></td></tr>\
						</table>\
						<div id="rule_data_'+newNumber+'" style="overflow: hidden;">\
							<table cellpadding="3" cellspacing="0" border="0" style="width: 100%; font-size: 12px;"> \
								<tr>'+label_srcip_text_1+label_srcip_text_2+label_srcipbundle_text_2+label_srcip_text_3+'</tr>\
								<tr>'+label_srcport_text_1+label_srcport_text_2+label_srcport_text_3+'</tr>\
								<tr>'+label_destip_text_1+label_destip_text_2+label_destipbundle_text_2+label_destip_text_3+'</tr>\
								<tr>'+label_destport_text_1+label_destport_text_2+label_destport_text_3+'</tr>\
								<tr>'+label_user_and_group_text_1+label_user_and_group_text_2+label_user_and_group_text_3+'</tr>\
								<tr>'+label_schedule_text+'</tr>\
								<tr>'+label_web_filter_text+'</tr>\
							</table>\
						</div>\
					</td>\
				</tr>\
			</table>\
		';
		
		document.getElementById('rule_boxset').appendChild(entryDiv);	
		
		// run javascript
		// src ip
		for (i =0; i<sourceCreateEntryCount; i++){
			moduleHiddenInput.init("hinput_"+newNumber+"_source_"+i, 'ch', 'cs', 'cs');
		}
		// dest ip
		for (i =0; i<destinationCreateEntryCount; i++){
			moduleHiddenInput.init("hinput_"+newNumber+"_dest_"+i, 'ch', 'cs', 'cs');
		}
		// src port
		for (i =0; i<sourcePortCreateEntryCount; i++){
			moduleHiddenInput.init("hinput_"+newNumber+"_sourcep_"+i, 'ch', 'cs', 'cs');
		}
		// dest port
		for (i =0; i<destinationPortCreateEntryCount; i++){
			moduleHiddenInput.init("hinput_"+newNumber+"_destp_"+i, 'ch', 'cs', 'cs');
		}
		
		 rule_selectBoxInit(newNumber);
		 moduleFormDecoration.selectInit(['rule_action_'+newNumber+'','rule_trafficType_'+newNumber+''], {'main_normal':'main_normal','main_click':'main_click','main_mouseover':'main_mouseover','icon_normal':['icon_normal','ui/module/ModuleFormDecoration_normal.gif',11],'icon_active':['icon_active','ui/module/ModuleFormDecoration_over.gif',11],'list_box':'list_box','list_item_normal':'list_item_normal','list_item_mouseover':'list_item_mouseover','fit':true});
		 
		 moduleListOrder.orderData[newNumber] = ruleData[newNumber][2];
		  moduleListOrder.initialPossibleValue.push(ruleData[newNumber][2]);
		  moduleListOrder.dragInit(newNumber);
		  moduleListOrder.updateDataSequence();
		  
		  collapseExpand.initCollapsed('rule_data_' + newNumber);
		  collapseExpand.perform('expand', 'rule_data_' + newNumber, function() {});  
		 
		 // result = {};
		  // for (var i in ruleData) {
			// result[i] = ruleData[i][2];
		  // }
		  
		// moduleListOrder = new ModuleAddLastListOrder(moduleListOrder, 'rule_boxset', 'rule_box_', 'rule_select_box_', result, newNumber, ruleData[newNumber][2]);
		// moduleListOrder.changeStatusByDrag = function(id){showAdditional(id);}
  
	}
	
	// reset
    document.getElementById('new_access_form').reset();
	// scroll 
	location.href="#rule_box_"+newNumber+"_pos";
	// document.getElementById('rule_select_box_'+newNumber).focus();

}

function new_rule_changeProtocolNum(entryType, id) {
	var entryTypeStr = entryType == 'source' ? 'source' : 'destination';
	var protoNum= document.getElementById(entryTypeStr+'_protocolNum_'+id).value;
	
	if (protoNum == 6 || protoNum == 17){ // TCP or UDP
		document.getElementById(entryTypeStr+'_proto_row_'+id).style.display = 'none';
		document.getElementById(entryTypeStr+'_port_row_'+id).style.display = '';
	}
	else if (protoNum == 0){ // OTHER
		document.getElementById(entryTypeStr+'_proto_row_'+id).style.display = '';
		document.getElementById(entryTypeStr+'_port_row_'+id).style.display = 'none';
	}
}


