// display_type = 0: normal, 1: mark as deleted
function UpdateBandwidthRule(display_type) {
	var editNumber = document.getElementById('edit_rule_id').value;
	
	var chkbx_class_id = "rule_chkbx";
	var left_class_id = "rule_data_left";
	var right_class_id = "rule_data_right";
	var input_class_id = "ch";
	var title_class_id = "rule_title";
	var input_other_option_str = "";
	var checkbox_other_option_str = "";
	
	var aditionalMsg = g_str_setcfg_msg_confirm_edit;
	
	if (display_type == 1){
		chkbx_class_id = "rule_chkbx_no_cursor_deleted";
		left_class_id = "rule_data_left_deleted";
		right_class_id = "rule_data_right_deleted";
		input_class_id = "ch_deleted";
		title_class_id = "rule_title_deleted";
		checkbox_other_option_str = 'style="display:none;" disabled readonly ';
		input_other_option_str = "readonly ";
		
		aditionalMsg = g_str_setcfg_msg_confirm_del;
	}
	
		
	with (document.edit_bandwidth_form){
		var ruleName = edit_rule_name.value;
		var description = edit_description.value;
		var bwul = edit_throttle_ul.value;
		var bwdl = edit_throttle_dl.value;
		var bundleName = edit_bundle_1.value;
		
		var entryDiv = document.getElementById('rule_box_'+editNumber);
		
		var mainLabelContent = "";
		
		var temp = "";
		
		for (var i in ipBundleData[bundleName]) {
			var temp2 = new Array();
			temp2 = ipBundleData[bundleName][i].split('-');
			  temp+="<br/>&nbsp;&nbsp;+"+temp2[0]+" to "+temp2[1]+"";
		}
		
		entryDiv.innerHTML = '\
			<a name="rule_box_'+editNumber+'_pos"></a>\
			<table cellpadding="0" cellspacing="0" border="0" style="border-bottom: 1px solid green; width: 100%; font-size: 12px;">\
				<tr>\
					<td class="'+chkbx_class_id+'" id="rule_select_box_'+editNumber+'" valign="top">\
						<b>'+ruleData[editNumber]+'</b><br /><input type="checkbox" id="rule_select_chkbox_'+editNumber+'" name="rule_select_chkbox[]" value="'+editNumber+'" '+checkbox_other_option_str+'/>\
					</td>\
					<td style="text-align: left;">\
						<table cellpadding="4" cellspacing="0" border="0" style="width: 100%; font-weight: bold; font-size: 12px;">\
							<tr>\
								<td style="width: 7px;" id="rule_state_box_'+editNumber+'" class="rule_state_brown"></td>\
								<td class="'+title_class_id+'">\
									<div style="margin-bottom: 6px; font-weight: bold; font-size: 14px;">\
										<div style="float: right; font-size: 12px;">\
										</div>\
										<u>'+ruleName+'</u>\
										<input type="hidden" value="'+ruleName+'" id="rule_name_'+editNumber+'" name="rule_name_'+editNumber+'" />\
									</div>\
									<div style="padding-left: 10px;">'+description+'</div>\
									<input type="hidden" value="'+description+'" id="rule_description_'+editNumber+'" name="rule_description_'+editNumber+'" />\
								</td>\
								<td class="rule_collapse_box" id="rule_collapse_box_'+editNumber+'" onselectstart="javascript: return false;" onmouseover="javascript: this.style.background=\'#ddd\'; this.style.color=\'black\';" onmouseout="javascript: this.style.background=\'#eee\'; this.style.color=\'#777\';" onclick="javascript: ruleDetailCollapse(this, '+editNumber+');" title="Collapse">\
									&uarr;\
								</td>\
							</tr>\
							<tr id="additional_row_'+editNumber+'" name="additional_row_'+editNumber+'" style=""><td></td><td align="center" ><span id="additional_msg_'+editNumber+'" name="additional_msg_'+editNumber+'" style="background: #FFF;color: #FF0000;">'+aditionalMsg+'</span></td><td></td></tr>\
						</table>\
						<div id="rule_data_'+editNumber+'" style="overflow: hidden;">\
							<table cellpadding="3" cellspacing="0" border="0" style="width: 100%; font-size: 12px;"> \
							<!--throttling-->\
								<tr>\
									<td class="'+left_class_id+'" valign="top" colspan =2>\
										<div style="font-weight: bold;">'+g_str_setcfg_bwrule_label_bwt+'</div>\
											<div style="padding-left: 10px; ">\
												<b>'+g_str_setcfg_bwrule_label_bwt_ul+'</b>'+bwul+'<input type="hidden" value="'+bwul+'" id="hinput_'+editNumber+'_bwul" name="hinput_'+editNumber+'_bwul" />\
											</div>\
											<div style="padding-left: 10px; ">\
												<b>'+g_str_setcfg_bwrule_label_bwt_dl+'</b>'+bwdl+'<input type="hidden" value="'+bwdl+'" id="hinput_'+editNumber+'_bwdl" name="hinput_'+editNumber+'_bwdl" />\
											</div>\
										</div>\
									</td>\
								</tr>\
								<!--ipbundle-->\
								<tr>\
									<td class="'+left_class_id+'" valign="top" colspan =2>\
										<div style="font-weight: bold;">'+g_str_setcfg_bwrule_label_ipbundle+'</div>\
										<div style="padding-left: 10px; ">\
											['+bundleName+']\
											<input type="hidden" value="'+bundleName+'" id="hinput_'+editNumber+'_ipbundle" name="hinput_'+editNumber+'_ipbundle" />\
											'+temp+'\
										</div>\
									</td>\
								</tr>\
							</table>\
						</div>\
					</td>\
				</tr>\
			</table>\
		';
		
		// document.getElementById('rule_boxset').appendChild(entryDiv);
		
		if (display_type == 1){
		}
		else{
			// run javascript
			rule_selectBoxInit(editNumber);
		 
			moduleListOrder.dragInit(editNumber);
			moduleListOrder.updateDataSequence();
			collapseExpand.UpdateCollapsed('rule_data_'+editNumber);
		}
	}
	
	if (display_type == 1){
	}
	else{
		moduleFloatingDiv.close('abcdiv');
		grayOut(false);
	}
	
    // document.getElementById('new_bandwidth_form').reset();
	
	// scroll 
	location.href="#rule_box_"+editNumber+"_pos";
	// document.getElementById('rule_data_'+editNumber).focus();

}

function editBandwidthRuleReset() {
	moduleFloatingDiv.close('abcdiv');
	grayOut(false);
}

function editBandwidthRuleValidate(){
	var ruleName = document.getElementById('edit_rule_name');
    if (ruleName.value.length < 1 || ruleName.value.length > 64) {
        alert(g_str_js_alert_bwrule_1);
        document.getElementById('edit_rule_name').focus();
        return false;
    }
	
	var editNumber = document.getElementById('edit_rule_id').value;
	
	var tempCount = 1;
	while (true){
		if (!document.getElementById('rule_name_'+tempCount)){
			break;
		}
		if (editNumber == tempCount){
			// SKIP
			tempCount++;
			continue;
		}
		
		var ruleName2 = "";
		ruleName2 = document.getElementById('rule_name_'+tempCount).value;
		
		if (ruleName.value == ruleName2){
			alert(g_str_js_alert_bwrule_2);
			document.getElementById('edit_rule_name').focus();
			return false;
		}
		tempCount++;
	}
	
	
    var description = document.getElementById('edit_description');
    if (description.value.length > 128) {
        alert(g_str_js_alert_bwrule_3);
        document.getElementById('edit_description').focus();
        return false;
    }
	
	var throttle_ul = document.getElementById('edit_throttle_ul');
    if (throttle_ul.value == "" || parseInt(throttle_ul.value) <= 0) {
        alert(g_str_js_alert_bwrule_4);
        document.getElementById('edit_throttle_ul').focus();
        return false;
    }
	
	var throttle_dl = document.getElementById('edit_throttle_dl');
    if (throttle_dl.value == "" || parseInt(throttle_dl.value) <= 0) {
        alert(g_str_js_alert_bwrule_5);
        document.getElementById('edit_throttle_dl').focus();
        return false;
    }
	
	var bundleName = document.getElementById('edit_bundle_1').value;
	if (bundleName == "Not Selected"){
		alert(g_str_js_alert_bwrule_6);
        document.getElementById('edit_bundle_1').focus();
        return false;
	}
    return true;
}

function grayOut(vis, options) {
  // Pass true to gray out screen, false to ungray
  // options are optional.  This is a JSON object with the following (optional) properties
  // opacity:0-100         // Lower number = less grayout higher = more of a blackout 
  // zindex: #             // HTML elements with a higher zindex appear on top of the gray out
  // bgcolor: (#xxxxxx)    // Standard RGB Hex color code
  // grayOut(true, {'zindex':'50', 'bgcolor':'#0000FF', 'opacity':'70'});
  // Because options is JSON opacity/zindex/bgcolor are all optional and can appear
  // in any order.  Pass only the properties you need to set.
  var options = options || {}; 
  var zindex = options.zindex || 50;
  var opacity = options.opacity || 70;
  var opaque = (opacity / 100);
  var bgcolor = options.bgcolor || '#000000';
  var dark=document.getElementById('darkenScreenObject');
  if (!dark) {
    // The dark layer doesn't exist, it's never been created.  So we'll
    // create it here and apply some basic styles.
    // If you are getting errors in IE see: http://support.microsoft.com/default.aspx/kb/927917
    var tbody = document.getElementsByTagName("body")[0];
    var tnode = document.createElement('div');           // Create the layer.
        tnode.style.position='absolute';                 // Position absolutely
        tnode.style.top='0px';                           // In the top
        tnode.style.left='0px';                          // Left corner of the page
        tnode.style.overflow='hidden';                   // Try to avoid making scroll bars            
        tnode.style.display='none';                      // Start out Hidden
        tnode.id='darkenScreenObject';                   // Name it so we can find it later
    tbody.appendChild(tnode);                            // Add it to the web page
    dark=document.getElementById('darkenScreenObject');  // Get the object.
  }
  if (vis) {
    // Calculate the page width and height 
    if( document.body && ( document.body.scrollWidth || document.body.scrollHeight ) ) {
        var pageWidth = document.body.scrollWidth+'px';
        var pageHeight = document.body.scrollHeight+'px';
    } else if( document.body.offsetWidth ) {
      var pageWidth = document.body.offsetWidth+'px';
      var pageHeight = document.body.offsetHeight+'px';
    } else {
       var pageWidth='100%';
       var pageHeight='100%';
    }   
    //set the shader to cover the entire page and make it visible.
    dark.style.opacity=opaque;                      
    dark.style.MozOpacity=opaque;                   
    dark.style.filter='alpha(opacity='+opacity+')'; 
    dark.style.zIndex=zindex;        
    dark.style.backgroundColor=bgcolor;  
    dark.style.width= pageWidth;
    dark.style.height= pageHeight;
    dark.style.display='block';                          
  } else {
     dark.style.display='none';
  }
}
