<?php
// security check
require_once "secureLogin.php";
include_once "egAPI.php";

if(isset($logincorrect) && $logincorrect=="true") { //previous login sucessfully
	$subMsg = '';
	$addSubMsg = false;
	
	$settingobj = new COM('EGCONFIG.Cfgmgr') or die('settingok.php EGCONFIG.Cfgmgr Object cannot be created!');
	$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
	$rule_user_tablename = $settingobj->getKey('Datasource_rule_user_Tablename', 'gateway');
	$settingobj=null;
	
	$new_del_string="";
	$numOfUser = 0;
	
	// checking
	$tok = strtok($deleteString, ',');

	while ($tok != '') {
		$q = "SELECT count(*) as no FROM ".$rule_user_tablename." WHERE userName = '".$tok."' ;";
		$result= db_query($q);
		$no = odbc_result($result, 'no');
		$inAccessRule = false;
		if ($no >0){
			$inAccessRule = true;
		}
		
		$q = "SELECT count(*) as no FROM ".$member_tablename." WHERE userName = '".$tok."' ;";
		$result= db_query($q);
		$no = odbc_result($result, 'no');
		$inGroup = false;
		if ($no >0){
			$inGroup = true;
		}
		
		if ($inAccessRule && $inGroup){
			$subMsg .= "User (".$tok.") - is used by Access Rules and Groups<br/>";
			$addSubMsg = true;
		}
		else if ($inAccessRule){
			$subMsg .= "User (".$tok.") - is used by Access Rules<br/>";
			$addSubMsg = true;
		}
		else if ($inGroup){
			$subMsg .= "User (".$tok.") - is used by Groups<br/>";
			$addSubMsg = true;
		}
		else{
			// OK
			if ($new_del_string != "")
				$new_del_string .= ",";
			
			$new_del_string .= $tok;
			$numOfUser++;
		}
		
		$tok = strtok(',');
	}

	$myfsapi = new fsAPI();
	$result_fields = array();
	if ($numOfUser >0)
		$result_fields = $myfsapi->deleteUser($new_del_string);
	
	 // inform user
	if (count($result_fields) >0 || $numOfUser == 0){
		$message = "";
		if ($addSubMsg){
			$subMsg = "Below Users are not deleted. Please remove the corresponding user from Access Rules and Groups first.<br/>".$subMsg;
		}
		if ($numOfUser > 0){
			if ($result_fields['usr_forced_logout_count'] > 0){
				$msg=$result_fields['usr_forced_logout_count'] ." user(s) are forced to logout before account deletion. ";
			}
			
			$message .= $msg.$result_fields['usr_deleted_count']." user record(s) are deleted.<br/>";
		}
		
		$message .= $subMsg;
		$rpcMessage = "deleteUser.php|$new_del_string|ok";
        $saved="true";
        $errorlog="";

	}
} else { //login failed
    $rpcMessage = "deleteUser.php|$new_del_string|failed";
    $message="Login failed or session timeout, please login to config manager again.";
    $errorlog="Login failed or sesssion timeout";
    $saved="true";
}
?>
<html>
<body>
<script lang="javascript">
parent.rpcReply('<?=$rpcMessage?>'); //send reply to caller
parent.location='setcfg.php?category=u';//refresh the User page
parent.parent.mid_right_bottom.location.reload(); //display message
</script>
</body>
</html>
