<?php

if (isset($_GET['clear']) && $_GET['clear'] == 1){
	$_SESSION['skip_http_auth']=1;
	print_r($_SESSION);
	exit();
}

// no cache for browser
header('Cache-Control: no-cache, must-revalidate');
// include functions
require_once 'common_functions.php';
require_once 'eg_lang.php';

// print_r($_SERVER);exit();

// $wait_b4_to_ok_page='0';
$wait_b4_to_fail_page='3';
$wait_b4_to_zero_page='5';

// 20080502 - Add retrieving Self Sign-up display flag
// 20080417 - Add retrieving scratch mode
$settingobj = new COM('EGCONFIG.Cfgmgr') or die('eg_login.php EGCONFIG.Cfgmgr Object cannot be created!');
$redirect_address = $settingobj->getKey( 'redirect_address', 'gateway');
$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');
$dsn = '';

if (!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
}
while (!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!='') $dsn=$dsn.$line;
}
$dsn=str_replace("\r\n",';',$dsn);

// client pass-through  by 0 = MAC-based 1 = IP-based
$session_handling = $settingobj->getKey( 'session_handling', 'gateway');
// 0: using (base on session handling) passive login mode, 1: using (computer name) passive login mode
$passive_login_mode = $settingobj->getKey( 'passive_login_mode', 'gateway');

// get verion
$version = $settingobj->getKey('version', 'version');

// get the absolute path and infobox port
$urlhead=fs_urlhead("infobox");

// 20090918 - Add retrieving login page content display control
$disable_show_reminder = $settingobj->getKey('disable_show_reminder', 'lang');
$disable_show_example = $settingobj->getKey('disable_show_example', 'lang');
$disable_show_link = $settingobj->getKey('disable_show_link', 'lang');
$disable_show_tc = $settingobj->getKey('disable_show_tc', 'lang');

//$settingobj->Release();
$settingobj=null;

// assume it is valid
$valid=true;

// workaround for clear http auth (using dummy username and password)
$userTag="Guest";
$pwdTag="Password";

$scriptInputFunc = '
function wClearHttpAuth(redirectLink){
	try{
		// create an xmlhttp object
		var xmlhttp = GetXmlHttpObject();
		// get the force page to logout for mozilla
	   
		xmlhttp.open("GET","eg_login.php?clear=1",true,"'.$userTag.'","'.$pwdTag.'");
		// send the request to the server
		xmlhttp.send("");
		// // abort the request
		// xmlhttp.abort();
		
	  // redirect
	  if (redirectLink.length > 0)
		window.location = redirectLink;
	} catch(e) {
		// There was an error
		alert("It was not possible to clear your credentials from browser cache.Please, close your browser window to ensure that you are completely clear cache.");
	}
}

function GetXmlHttpObject()
{ 
	var objXMLHttp=null
	if (window.XMLHttpRequest)
	{
		objXMLHttp=new XMLHttpRequest()
	}
	else if (window.ActiveXObject)
	{
		objXMLHttp=new ActiveXObject("Microsoft.XMLHTTP")
	}
	return objXMLHttp
}

	';
	
// default
$scriptInput = $scriptInputFunc.'wClearHttpAuth("")';

// checking special
$skipUsingAuth=false; // true: skip using http auth as username and password
if (isset($_SERVER['PHP_AUTH_USER']) && isset($_SERVER['PHP_AUTH_PW'])){
	if ($_SERVER['PHP_AUTH_USER'] == $userTag && $_SERVER['PHP_AUTH_PW'] == $pwdTag ){
		$skipUsingAuth = true;
	}
}

if (isset($_SESSION['skip_http_auth']) && $_SESSION['skip_http_auth'] == 1){
	$_SESSION['skip_http_auth'] = 0;
	$skipUsingAuth = true;
}

// assume it is first time
if (!isset($_SESSION['sess_desturl']) && !isset($_SESSION['sess_patronsoft1']) && !isset($_SESSION['sess_patronsoft2'])){
	$_SESSION['skip_http_auth'] = 0;
	$skipUsingAuth = true;
}

if (!$skipUsingAuth){
	if (isset($_SERVER['PHP_AUTH_USER']) && strlen($_SERVER['PHP_AUTH_USER']) > 0){
		if ($_SERVER['PHP_AUTH_USER'] != ' ')
			$username = $_SERVER['PHP_AUTH_USER'];
	}

	if (isset($_SERVER['PHP_AUTH_PW']) && strlen($_SERVER['PHP_AUTH_PW']) > 0){
		if ($_SERVER['PHP_AUTH_PW'] != ' ')
			$password = $_SERVER['PHP_AUTH_PW'];
	}
}

$ok_url='';
if (isset($_SESSION['sess_ok_url']) && strlen($_SESSION['sess_ok_url']) > 0){
	$ok_url = $_SESSION['sess_ok_url'];
}

$fail_url='';
if (isset($_SESSION['sess_fail_url']) && strlen($_SESSION['sess_fail_url']) > 0){
	$fail_url = $_SESSION['sess_fail_url'];
}

// 20080714 - Retrieve destination string after auto refresh
if (!isset($desturl) && isset($_SESSION['sess_desturl'])) {
    $desturl = 'desturl='.$_SESSION['sess_desturl'];
}

// now, form is submitted and desturl is not posted
if(isset($desturl)) {
    // COM object provides desturl when user login

    // 'desturl' is empty
    if($desturl=='') {
        // invalid case
        $valid = false;
    } else {    // continue processing..
	// 20090129 - Apply URL-encoded format according to RFC 1738 to the redirect links
	// 20080714 - Add else branch to get back information after auto refresh
	if (count($_GET) > 0) {
	    // in case there are others non-firstspot specific querystring, concat them..
	    // for security reason, POST data will not concat
	    foreach($_GET as $item=>$value) {
		//echo "$item: $value<br/>";
		// 20080707 - Prepare extra redirect information at the 2nd round fs_login
		if ($item == 'desturl') {
		    if (strpos($value, '&sslredir=') != FALSE) {
			$sslRedir = rawurlencode(substr($value, strpos($value, '&sslredir=')+10));
		    } elseif (strpos($value, '&loginPage=') != FALSE) {
			$loginPage = substr($value, strpos($value, '&loginPage=')+11);
		    }
		}
		// concat if value posted is neither 'desturl' nor 'patronsoft1' nor 'patronsoft2' nor 'firstspotL'
		if($item!='desturl' && $item!='patronsoft1' && $item!='patronsoft2' && $item!='firstspotL')
		    $desturl = $desturl.'&'.$item.'='.$value;
	    }
	} else {
	    if (strpos($desturl, '&sslredir=') != FALSE) {
		$sslRedir = rawurlencode(substr($desturl, strpos($desturl, '&sslredir=')+10));
	    } elseif (strpos($desturl, '&loginPage=') != FALSE) {
		$loginPage = substr($desturl, strpos($desturl, '&loginPage=')+11);
	    }
	}
    }
    // reigster desturl session, if needed
    if(!isset($_SESSION['sess_desturl']))
        $_SESSION['sess_desturl']=$desturl;

    $sess_desturl=$_SESSION['sess_desturl'];
}

if(isset($sslpage)) {
        foreach($_GET as $item=>$value) {
            if($item!='sslpage' && $item!='loginPage' && $item!='desturl' && $item!='patronsoft1' && $item!='patronsoft2' && $item!='firstspotL')
                $sslpage .= '&'.$item.'='.$value;
        }
    // 20080707
    unset($loginPage);
}

if(isset($patronsoft1)) {
    // empty ip
    if($patronsoft1=='')
        $valid=false;

    // assign session value
    if(!isset($_SESSION['sess_patronsoft1']))
        $_SESSION['sess_patronsoft1']=$patronsoft1;

    $sess_patronsoft1=$_SESSION['sess_patronsoft1'];
}

if(isset($patronsoft2)) {
    // empty ip
    if($patronsoft2=='')
        $valid=false;

    // assign session value
    if(!isset($_SESSION['sess_patronsoft2']))
        $_SESSION['sess_patronsoft2']=$patronsoft2;

    $sess_patronsoft2=$_SESSION['sess_patronsoft2'];
}

if(!isset($_SESSION['sess_desturl']) && !isset($sess_patronsoft1) && !isset($sess_patronsoft2)) {
    //echo "<script type=\"text/javascript\">location.href='".$redirect_address."';</script>";
    // 20080703 - Add extra information in redirect link at the 1st round entering fs_login
    if (isset($sslpage)) {
	$redirect_suffix = "?&sslredir=$sslpage";
    } else {
	$redirect_suffix = "?&loginPage=1";
    }
	
    // header("Location: $redirect_address$redirect_suffix");
	$scriptInput = $scriptInputFunc."wClearHttpAuth(\"$redirect_address$redirect_suffix\")";
	print("<script>".$scriptInput."</script>");	
    exit;
} elseif (isset($sslpage)) {
    // 20080707 - New case for HTTPS request at the 1st round entering fs_login and already have session values
    // header("Location: $redirect_address?&sslredir=$sslpage");
	$scriptInput = $scriptInputFunc."wClearHttpAuth(\"$redirect_address?&sslredir=$sslpage\")";
	print("<script>".$scriptInput."</script>");	
    exit;
} elseif ((!isset($ok_url) && !isset($desturl)) || !isset($_SESSION['sess_desturl']) || !isset($sess_patronsoft1) || !isset($sess_patronsoft2)) {
    // 20080707 - New case for direct accessing 5788 at the 1st round entering fs_login and already have several session values
    // header("Location: $redirect_address?&loginPage=1");
	$scriptInput = $scriptInputFunc."wClearHttpAuth(\"$redirect_address?&loginPage=1\")";
	print("<script>".$scriptInput."</script>");	
    exit;
} else {
    // no cache for browser
    header('Cache-Control: no-cache, must-revalidate');
}

// check if valid
if($valid) {
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('eg_login.php EGCONFIG.Cfgmgr Object cannot be created!');

    if(isset($sess_patronsoft2)) {
        $IP_str=long2ip($sess_patronsoft2);  
        $tok = explode('.', $IP_str);
        $IP=$tok[3].'.'.$tok[2].'.'.$tok[1].'.'.$tok[0];

        $num=$settingobj->getKey( 'num_return_path', 'MNS');

	// 20080416 - Bug fix for getKey, store redirect template file to new variable for login_form use
	for ($x = 0; $x < $num; $x++) {
	    $path = $settingobj->getKey('return_path'.$x, 'MNS');
	    $net = explode(' ', $path);
	    if (isInSubnet($net[0], $net[1], $IP)) {
		$enableRedir = $settingobj->getKey('Login_enable'.$x, 'loginPhp');
		if ($enableRedir == 1) {
		    $fail_url = fs_form_to_load();
		    $redirTpl = $settingobj->getKey('Login_php_Num'.$x, "loginPhp");
		}
	    }
	}
    }

    // release the COM object
    //$settingobj->Release();

    if( !(isset($fieldEmpty)&&($fieldEmpty==true))) {
        // create COM Object
		$settingobj = new COM('EGCONFIG.Cfgmgr') or die('eg_login.php EGCONFIG.Cfgmgr Object cannot be created!');
		$IsRandom=$settingobj->getKey( 'random', 'gateway');
        if ($IsRandom) {
			$count=$settingobj->getKey( 'loginpage_pic_count', 'gateway');
			$r_no=gen_random_no($count);
		}
		else
			$r_no=0;
		$fname_loginpage_pic="loginpage_pic";
		$fname_loginpage_pic.=$r_no;
		$fname_loginpage_pic_html="loginpage_pic_html";
		$fname_loginpage_pic_html.=$r_no;
		$pic=get_pic($fname_loginpage_pic);
		$html=get_html($fname_loginpage_pic_html);
		$pic='./loginpage_pic/'.$pic;
        $login_msg = '';

        // check username
        if((isset($username) && $username!='')) {
            // create COM Object
            $myobj = new COM('EGAUTH.Authserv') or die('eg_login.php EGAUTH.Authserv Object cannot be created!');

            $firstspotusertable=$settingobj->getKey( 'Datasource_Tablename', 'gateway'); 

			// 20100621 - Handle escape chars
			if (get_magic_quotes_gpc()) {
				if (isset($password)) {
					$password = stripslashes($password);
				}
				if (isset($username)) {
					$username = stripslashes($username);
				}
			}

            // get clinet browser information
            $useragent = $_SERVER['HTTP_USER_AGENT'];
            
            if(isset($logout))
				$objrsult = $myobj->ForceLogout($username);
				
            $objrsult = $myobj->Authenticate($username, $password, $sess_patronsoft1, $sess_patronsoft2, $useragent);
			
			// workaround to notify not using http auth as username and passord after refresh
			$_SESSION['skip_http_auth']=1;
			
			// free the COM object
            //$myObj->Release();
            $myobj=null;  			
           	
           	//authentication mode
            if($objrsult=='TR_MODE') {
		// 20080709 - Add okurl
                // In firstspot trial version, users will be automatically redirected to the page "Redirect.php" 
                // during the following object call, while no redirection will happen for release version.
                // header("Location: trialmode.dll?login=$username&patronsoft1=$sess_patronsoft1&patronsoft2=$sess_patronsoft2&browserInfo=$useragent&okurl=$ok_url");
                $scriptInput = $scriptInputFunc."wClearHttpAuth(\"trialmode.dll?login=$username&patronsoft1=$sess_patronsoft1&patronsoft2=$sess_patronsoft2&browserInfo=$useragent&okurl=$ok_url\")";
				print("<script>".$scriptInput."</script>");
				exit;
            } else if($objrsult=='SUCCESS' || $objrsult=='INSERT_TABLE') {
                if(!session_id())
                    session_start();

                if (isset($_SESSION['session_username']))
                    $_SESSION['session_username']='';

                // The following code has no effect in trial version, but will cause a redirection to the 
                // page 'Redirect.php' in release version.
                // header("Location: $ok_url");
				
				$scriptInput = $scriptInputFunc."wClearHttpAuth(\"$ok_url\")";
				print("<script>".$scriptInput."</script>");
                exit;
            } else if($objrsult=='ALREADY_SERVING') {
                // current user and machine has already logged in and external connection has been made ready, 
                // no need to submit login information again
                // header("Location: $ok_url");
				$scriptInput = $scriptInputFunc."wClearHttpAuth(\"$ok_url\")";
				print("<script>".$scriptInput."</script>");
            } else if($objrsult=='ALREADY_LOGGED') {
                $input = '
		    <br><span class="failloginspan">'.get_var('logged').'</span><br><br>
		    <form class="failloginspan" name="forcelogout" action="eg_login.php" method="post">
			<input type="hidden" name="username" value="'.$username.'">
			<input type="hidden" name="password" value="'.$password.'">
			<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
			<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
			<input type="hidden" name="ok_url" value="redirect.php">
			<input type="hidden" name="fail_url" value="login_form.php">
			<input type="hidden" name="logout" value="true">
			<input type="submit" class="normalbtn" name="btn_relogin" value="Click here to re-login">
		    </form>';
                GenTable('', $input, $scriptInput);
            } else if($objrsult=='BWFAIL') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'.get_var('data_transfer_0').'</span><br>';
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='BWFAILUL') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'.get_var('data_transfer_1').'</span><br>';
                GenTable($meta, $input, $scriptInput);
	    // 20071126 - Add case for bandwidth quota sharing
	    } else if ($objrsult == 'BWFAILSHARE') {
                if (!session_id()) {
		    session_start();
		}
                $_SESSION['session_username'] = $username;
                $meta = '';
                $input = '<span class="failloginspan">'.get_var('data_transfer_2').'</span><br>';
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='ACC_DISABLED') {
                if(!session_id())
                    session_start();
                $_SESSION['session_username']=$username;
				$meta='';
                $input = '<span class="failloginspan">'.get_var('acc_disabled').'</span><br>';
                GenTable($meta, $input, $scriptInput);
		// 20100707 - IP is being used by another user
		} else if ($objrsult == 'IP_IS_LOGGED_IN') {
			$input = '<span class="failloginspan">'.get_var('login_ip_occupied').'</span><br>';
			GenTable('', $input, $scriptInput);

		// 20100707 - MAC is being used by another user
		} else if ($objrsult == 'MAC_IS_LOGGED_IN') {
			$input = '<span class="failloginspan">'.get_var('login_mac_occupied').'</span><br>';
			GenTable('', $input, $scriptInput);

            } else {
                $input='<span class="failloginspan">'.get_var('invalid').'</span><br>';
		// 20080714 - Save destination string
                $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
                GenTable($meta, $input, $scriptInput);
            }
        } elseif (isset($username) && $username=='') {
            $input= '<span class="failloginspan">'.get_var('invalid').'</span><br>';
	    // 20080714 - Save destination string
            $meta= "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>"; 
            GenTable($meta, $input, $scriptInput);         
        }

        //release COM object
        //$settingobj->Release();
        $settingobj=null;
    } // end fieldEmpty
} else {  // login invalid
    if (!isset($fail_url)) $fail_url='login_select.php';
    $input= '<span class="failloginspan">'.get_var('invalid_access').'</span><br>';
    // 20080714 - Save destination string
    $meta= '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_b4_to_fail_page.';URL='.$fail_url.'?desturl='.urlencode($_SESSION['sess_desturl']).'">';
    GenTable($meta, $input, $scriptInput);
}

// check RADIUS mode
$obj = new COM("EGCONFIG.Cfgmgr") or die("eg_login.php EGCONFIG.Cfgmgr Object cannot be created!");
$global_bwcount_dl = $obj->getKey("bwcount_dl", "DataTransfer");
$global_bwquota_dl = $obj->getKey("bwquota_dl", "DataTransfer");
$global_bwcount_ul = $obj->getKey("bwcount_ul", "DataTransfer");
$global_bwquota_ul = $obj->getKey("bwquota_ul", "DataTransfer");
//$obj->Release();
$obj=null;

if ( ((isset($sess_patronsoft2) && $sess_patronsoft2!="" && $session_handling == 0) || (isset($sess_patronsoft1) && $sess_patronsoft1 !="" && $session_handling == 1))) {
		
	if ($session_handling==0){
		// Auto fill the username when the MAC address is the username
		$macname = make_mac_name($sess_patronsoft2);
		$q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$macname."'";
		$result = db_query($q);

		// 20090326 - Improve error handling
		if ($result == FALSE) {
		    $num = 0;
		} else {
		    $num = odbc_result($result, "num");
		    $s_name = $macname;
		}
	}else{
		// Auto fill the username when the IP address is the username
		$ipname = make_ip_name($sess_patronsoft1);
		$q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$ipname."' ;";
		$result = db_query($q);

		// 20090326 - Improve error handling
		if ($result == FALSE) {
		    $num = 0;
		} else {
		    $num = odbc_result($result, "num");
		    $s_name = $ipname;
		}
	}
	
    if( $num > 0 ) {
	    $q = "SELECT pwd as pw, status, bwquota, bwquotaUL, bwquotaSha, bwcount, bwcountUL, bwcountSha, accumbw, accumbwUL, accumbwSha FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$s_name."'";
	    $result = db_query($q);
	    $pw = odbc_result($result, "pw");
		$status = odbc_result($result, "status");
		$bwquota = odbc_result($result, "bwquota");
		$bwquotaUL = odbc_result($result, "bwquotaUL");
		$bwquotaSha = odbc_result($result, "bwquotaSha");
		$bwcount = odbc_result($result, "bwcount");
		$bwcountUL = odbc_result($result, "bwcountUL");
		$bwcountSha = odbc_result($result, "bwcountSha");
		$accumbw = odbc_result($result, "accumbw");
		$accumbwUL = odbc_result($result, "accumbwUL");
		$accumbwSha = odbc_result($result, "accumbwSha");
		
		$currenttime = mktime();
		
		if ($passive_login_mode == 1){
		}
		else
		{
			// Passive Login
			if ($pw == ''){
				if(!session_id())
					session_start();
					
			  $_SESSION['session_username']=$s_name;
		
			  $meta='';
			  
			  if ($status == 1){
				$input = '<span class="failloginspan">'.get_var('acc_disabled').'</span><br>';
			  }
			  else if (($bwcount == 2 && $accumbw>= $bwquota) || ($bwcount == "" && $global_bwcount_dl == 2 && $accumbw>= $global_bwquota_dl)){
				$input = '<span class="failloginspan">'.get_var('data_transfer_0').'</span><br>';
			  }
			  else if (($bwcountUL == 2 && $accumbwUL>= $bwquotaUL) || ($bwcountUL == "" && $global_bwcount_dl == 2 && $accumbwUL>= $global_bwquota_ul)){
				$input = '<span class="failloginspan">'.get_var('data_transfer_1').'</span><br>';
			  }
			  else if (($bwcountSha == 2 && $accumbwSha>= $bwquotaSha)){
				$input = '<span class="failloginspan">'.get_var('data_transfer_2').'</span><br>';
			  }
			  else{
				$input = '<span class="failloginspan">'.get_var('no_usage').'</span><br>';
			  }	        
				
				GenTable($meta, $input, $scriptInput);	
			}
		}

    // 20090326 - Handling for database failure
    } elseif ($result == FALSE) {
		$input = '<span class="failloginspan">'.get_var('login_database_unavailable').'</span><br>';
		GenTable('', $input, $scriptInput);
	}
}
?>
