<?php
function table_new($row) {
		
	$table = '<table width="100%" border="0" cellspacing="0" cellpadding="0">';
	
	//x - row, y - col
	//$row[x][0] - html style class
	//$row[x][y] - field value
	foreach($row as $field) {			
		
		$table .= "<tr class='$field[0]'>";
		for($i=1; $i<count($field); $i++) {
			$table .= "<td>";	
			$table .= "$field[$i]";
			$table .= "</td>";
		}
		$table .= "</tr>";
		
	}

	$table .= '</table>';
	
	return $table;
}

function longip($ip_long)
{
	if($ip_long <0)
		return "";
	
	//dec to hex
	$iphex = array();
	$i = 0;
	while($ip_long!=0) {
		$rslt = floor($ip_long/16); 
		$iphex[$i] = $ip_long - ($rslt*16);
		$ip_long = $rslt;
		$i++;
	}

	$ip = "";
	for($i=count($iphex)-1; $i>=0; $i--) {
		$ip .= dechex($iphex[$i]);
	}
	
	//convert hex to 12 digits
	while(strlen($ip)<8) {
		$ip = "0".$ip;
	}
	
	//convert hex to ip format
	if(strlen($ip) == 8) {
		$ip_array = array();
		
		$count = 0;
		for($i=0; $i<8; $i=$i+2) {
			$ip_array[$count] = hexdec(strtoupper(substr($ip, $i, 2)));
			$count++;
		}
			
		$ip = "$ip_array[3].$ip_array[2].$ip_array[1].$ip_array[0]";
		
		return $ip;
	}
	
	return "";
}
?>
<html>
<head>
<style type="text/css">
<!--
    table { font-family: Tahoma, sans-serif; font-size: 10pt; }
    .odd { background: #F0F0F0; }
    .even { background: #FFF; }
    .checked { background: #BAEAD6; }
    .add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    .delete { color: #FF0000; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green;
    #display { color: #000; list-style: none; margin: 0px; padding: 0;}
    #add { color: #096; list-style: none; margin: 0px; padding: 0; border-top: 1px solid green; }
    #display li, #add li { padding-left: 10px; }
    #display span, #add span { width: 350px; float:left; }
    form { margin: 0;}
-->
</style>
</head>
<body>
<?php
$row = array();
	$sp_ip = isset($ser_sp_ip)? unserialize($ser_sp_ip) : array();
	
	$isUpdated=false;
	
	//new entries
	if(isset($ip) && $ip!="") {
		$sp_ip[count($sp_ip)] = $ip;
		$isUpdated = true;
	}
	
	// ignore repeated entry
	if ($isUpdated){
		$tmpArray = array();
		$tmpCount = 0;
		for($i=0; $i<count($sp_ip); $i++){
			$isRepeated = false;
			for($j=0; $j<count($tmpArray); $j++){
				if ($sp_ip[$i] == $tmpArray[$j]){
					$isRepeated = true;
					break;
				}
			}
			
			if ($isRepeated == false){
				$tmpArray[$tmpCount] = $sp_ip[$i];
				$tmpCount++;
			}
		}
		$sp_ip = $tmpArray;
	}
	
	// new delete entries
	if(isset($delete) && $delete!="") {
		$delArray = explode(',', $delete);
		
		$tmpArray = array();
		$tmpCount = 0;		
		
		// filter mark as deleted entry
		for($i=0; $i<count($sp_ip); $i++){
			$isMarkAsDel = false;
			for($j=0; $j<count($delArray); $j++){
				if ($i == $delArray[$j]){
					$isMarkAsDel = true;
					break;
				}
			}
			
			if ($isMarkAsDel == false){
				$tmpArray[$tmpCount] = $sp_ip[$i];
				$tmpCount++;
			}
		}
		$sp_ip = $tmpArray;
		$isUpdated = true;
	}
	
	//output exist entries
	$count = count($row);
	for($i=0; $i<count($sp_ip); $i++) {
		$pos = $i + $count;
		$row[$pos][0] = "";
		$row[$pos][1] = "&nbsp;".$sp_ip[$i];
		$row[$pos][2] = "<input type='checkbox' name='entry' value='".$sp_ip[$i]."' >";
	}	
	
	if ($isUpdated){
		$ser_sp_ip = serialize($sp_ip);
		session_register('ser_sp_ip');
	}

echo table_new($row);

?>
</body>
</html>