<?php

if (isset($_SESSION['sess_sslpage']))
{
    $sslpage ="&sslpage=".$sess_sslpage;
}
else
{
    $sslpage = "";
}
if (isset($_SESSION['sess_loginPage']))
{
    $loginPage ="&loginPage=".$sess_loginPage;
}
else
{
    $loginPage = "";
}

//It is very important that to unset the session cookies here
//since the session cookies are started by auto (see php.ini)
//Unsetting it here can stop those DoS requests
session_unset(); 
session_destroy(); 

// divert to different php depending on whether it's anonymous mode

require_once "common_functions.php";
require_once "eg_lang.php";
require_once 'generate_common.php';

// extract all parameter in original URL passed from dispatcher
$req="";
foreach ($_GET as $key => $value) {
    $value = urlencode(stripslashes($value));
    $req .= "&$key=$value";
}
if ($req != "" ) $req="?".$req . $sslpage . $loginPage;

//*************************************************************************************
$settingobj = new COM("EGCONFIG.Cfgmgr") or die("login_select.php EGCONFIG.Cfgmgr Object cannot be created!");
// connect to database
$dsn_file = $settingobj->getKey( "Datasource", "gateway");
$dsn_source = fopen($dsn_file, "r") or die("Cannot open DSN source file!");  
$dsn="";
if(!feof($dsn_source)) 
    $line=fgets($dsn_source,512);
while(!feof($dsn_source)){
    $line=fgets($dsn_source,512);
    if (trim($line)!="")
        $dsn=$dsn.$line;
}
$dsn        = str_replace("\r\n",";",$dsn);

// 20090326 - Suppress SQL error
$er = error_reporting(0);
$userDB = odbc_connect($dsn, "", "");
error_reporting($er);

$vers="";
$vers=$settingobj->getKey( "version", "version");

$linkStr = '';
$resultStr = '';
if($userDB) {
        //*************************************************************************************
        // query for timeleft and login time for this client in EaseGate user table
        $EaseGateusertable=$settingobj->getKey( "Datasource_Tablename", "gateway");
        // count the concurrent user
        $query  = "SELECT reserved1 FROM ".$EaseGateusertable.";";
        $result = odbc_exec($userDB,$query);
        $i      = 0;
        while(odbc_fetch_row($result)) {
            $RESERVED1[$i] = odbc_result($result, 1);
            $i++;
        }
        //echo "result=[".$result."]<br>[".$i."]<br>";
        $loginCount = 0;
        if(isset($RESERVED1)) {
            for($j=0;$j<sizeof($RESERVED1);$j++) {
                if($RESERVED1[$j]!=null)
                    $loginCount++;
            }
        }
        
        // count the concurrent user which using passive login 
        $query  = "SELECT reserved1 FROM ".$EaseGateusertable." WHERE MACasUsr = 'Y' and pwd is null;";
        $result2 = odbc_exec($userDB,$query);
        $m      = 0;
        while(odbc_fetch_row($result2)) {
            $RESERVED2[$m] = odbc_result($result2, 1);
            $m++;
        }
        $passiveLoginCount = 0;
        if(isset($RESERVED2)) {
            for($j=0;$j<sizeof($RESERVED2);$j++) {
                if($RESERVED2[$j]!=null)
                    $passiveLoginCount++;
            }
        }
        
        //echo $loginCount." user(s) logged in (include passive: ".$passiveLoginCount.")and max concurrent user is set ".$max_user;
        
        //*************************************************************************************
		odbc_close($userDB);
	
        // go get the corresponding login form 
        header ("Location: ".fs_form_to_load().$req);
        exit;
} else {
    $resultStr = '
		<span class="welcomespan">'.get_var('login_database_unavailable').'</span>';
}

// release the COM object
//$settingobj->Release();
$settingobj=null;

?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
    <?=metaCharset()?>
    <?=$j_common?>
    <script type="text/javascript">
	<!--
	<?php include "script/login_select_body.js"?>
	-->
    </script>
    <title><?=get_var('greeting')?></title>
</head>

<body>
    <table border="0" width="100%" cellpadding="20">
	<tr>
	    <td width="100%">
		<?=$resultStr?>
	    </td>
	</tr>
    </table>

    <?=$linkStr?>
</body>
</html>

