<?php

require_once 'form_elements.php';
require_once 'category.php';

// check RADIUS, anonymous and Standby mode
$settingobj = new COM('EGCONFIG.Cfgmgr') or die('menu.php EGCONFIG.Cfgmgr Object cannot be created!');
$isRADIUS = $settingobj->getKey( 'use_radius', 'radius');
$anonymous_login_rsult = $settingobj->getKey( 'anonymous_login', 'gateway'); //check for anonymous login
$isAnonymous = $anonymous_login_rsult == 'on';

//check for Standby mode of started / stopped 
//$fs_status  = $settingobj->queryService();
//$fs_standby  = $settingobj->QueryStandby();

if (!isset($_SESSION['fs_standby'])||$_SESSION['fs_standby']=='')
    $_SESSION['fs_standby'] = 0;

$version = $settingobj->getKey('version', 'version');

	// 20090518 - Remove Start
	if (substr_count(strtolower($version), 'standard') > 0) {
        if (substr_count(strtolower($version),'donation')>0)
            $version = substr($version,0,strlen($version)-9);
        $disabled = ' disabled';
    } else {
        $disabled = '';
    }    

$FOMode = $settingobj->getKey( 'mode', 'FSFO'); 
$isStandby = $FOMode == '2';
if ($FOMode == 3)
	$isLoadBalancing=1;
else
	$isLoadBalancing=0;
	
$show_license_warning = $settingobj->getKey( 'ShowLicenseWarning', 'misc'); 

//$settingobj->Release();
$settingobj=null;

?>

<!-- menu -->
<style type="text/css">
@import url(menu.css);
</style>
<script type="text/javascript">
var countdown;
function startList()
{

    var delay=2000;
    if (document.getElementById) {
	navRoot = document.getElementById("nav");
        for (i=0; i<navRoot.childNodes.length; i++) {
            node = navRoot.childNodes[i];
            if (node.nodeName=="LI") {
		node.onmouseover =function() { clearTimeout(countdown);{showDropdownList();} }
                node.onmouseout = function() {  countdown=setTimeout("hideDropdownList()",delay); }
		
            }
        }
    }
    setTimeout("OnclickFrame()",1000);
}
function showDropdownList()
{
	navRoot = document.getElementById("nav");
        for (i=0; i<navRoot.childNodes.length; i++) {
            node = navRoot.childNodes[i];
            if (node.nodeName=="LI") {if (node.className.search("over")==-1) node.className += " over";else return;}
	}
	
}
function hideDropdownList()
{
	navRoot = document.getElementById("nav");
        for (i=0; i<navRoot.childNodes.length; i++) {
            node = navRoot.childNodes[i];
            if (node.nodeName=="LI") {if (node.className.search("over")!=-1) node.className =node.className.replace(" over",""); else return;}
	}
}
function OnclickFrame()
{
	var frms = window.parent.frames;
	var embedfrms1;
	var embedfrms2;
		
	for (i=0; i < frms.length; i++)
	{
		frms[i].document.onclick=function() {clearTimeout(countdown);hideDropdownList();}
		embedfrms1 = frms[i].frames;
		for (j=0; j < embedfrms1.length; j++)
		{
			embedfrms1[j].document.onclick=function() {clearTimeout(countdown);hideDropdownList();}
			embedfrms2 = embedfrms1[j].frames;
			for (k=0; k < embedfrms2.length; k++)
			{
				embedfrms2[k].document.onclick=function() {clearTimeout(countdown);hideDropdownList();}
			}
		}
		
		
	}
}
function popWarning()
{
	open('license_warning.php','','toolbar=0,directories=0,status=0,menubar=0,scrollbars=1,resizable=1,width=550,height=320');
}

var show = true;
function aniWarningBtn(){
	if (show == true){
		document.getElementById('warning_button').style.borderColor= "#8C0000";
		show = false;
	}
	else{
		document.getElementById('warning_button').style.borderColor= "#FFFFFF";
		show = true;
	}
	setTimeout('aniWarningBtn();', 500);
}

</script>
<div id="divnav">
    <ul id="nav">
        <li class="m"><?php echo get_cm_var('menu_menu');?>

        <ul>
		<div>
<?php

foreach ($arr_category as $i => $value) {
	// 20100519 - Hide items with no access right
    if ($_SESSION['rootlogin']!='true' && $_SESSION['access_parameter']{$i+1} == '0') {
    } else if (($isRADIUS == 'true') && in_array($value, $DRM)) {
        $title = get_cm_var('menu_DRM');
		echo "
				<div><span><a href=\"javascript:alert('$title');\" title=\"$title\">".get_cm_var("setcfg_config_mgr_access_$value")."</a></span></div>
				<div><span>|</span></div>";
    } else if (($isAnonymous) && in_array($value, $DAM)) {
        $title = get_cm_var('menu_DAM');
		echo "
				<div><span><a href=\"javascript:alert('$title');\" title=\"$title\">".get_cm_var("setcfg_config_mgr_access_$value")."</a></span></div>
				<div><span>|</span></div>";
    } else if ( $isLoadBalancing== '0' && ((($isStandby== 'true' && $_SESSION['fs_status']  != 'STARTED' ) || ( $_SESSION['fs_standby']  == '1' && $_SESSION['fs_status']  == 'STARTED')) && in_array($value, $DSM) && $disabled !=' disabled' )) {
		$title = get_cm_var('menu_DSM');
		echo "
				<div><span><a href=\"javascript:alert('$title');\" title=\"$title\">".get_cm_var("setcfg_config_mgr_access_$value")."</a></span></div>
				<div><span>|</span></div>";
    } else {
        $title = get_cm_var('menu_navigate').get_cm_var("setcfg_config_mgr_access_$value");
		echo "
				<div><span><a href=\"setcfg.php?category=$value\" title=\"$title\">".get_cm_var("setcfg_config_mgr_access_$value")."</a></span></div>
				<div><span>|</span></div>";
    }
}

?>
		</div>
        </ul>
        </li>
        <li class="current_category"><?php echo get_cm_var("setcfg_config_mgr_access_$category"); ?></li>
    </ul>
	
	<?php
	//	 license warning
	if ($show_license_warning == 1){
		?>
	<input type="button" id="warning_button" value="<?=get_cm_var("setcfg_license_warning_pop_btn")?>" style="height:25; left:0; top:0; background-color:#CC0000; border:3px solid #8C0000; font-family: Tahoma, sans-serif; font-size:10pt; font-weight:bold; color:#FFFFFF; cursor:hand" onclick="popWarning();">
		<?php
		}
	?>
</div>
<script type="text/javascript">
<!--
    startList();
	<?
		if ($show_license_warning == 1){
			echo "aniWarningBtn();";
		}
	?>
// -->
</script>
<!-- end menu -->

