<?php

require_once 'common_functions.php';
require_once "eg_lang.php";
require_once 'generate_common.php';

function GetRedirectCfg()
{
    global $start_up_redirect_option, $start_up_redirect_url, $start_up_redirect_wait, $wait_time, $value;
    
    // create COM Object
    $settingobj = new COM("EGCONFIG.Cfgmgr") or die("redirect.php EGCONFIG.Cfgmgr Object cannot be created!");
    $start_up_redirect_option = $settingobj->getKey("start_up_redirect_option", "gateway");
    $start_up_redirect_url = $settingobj->getKey('start_up_redirect_url', 'gateway');	  
    $start_up_redirect_wait = $settingobj->getKey("start_up_redirect_wait", "gateway");
    $wait_time = $start_up_redirect_wait * 1000;

	if ($start_up_redirect_option == 1) {
	// 20080708 - Save to session variable and add protocol checking
	$sess_desturl = $start_up_redirect_url;
	$_SESSION['sess_desturl'] = $start_up_redirect_url;
    }

    // release the COM object
    $settingobj = null;
}

$access_directly = 0;
$redirect_pic_fname_html = "redirectpage_pic_name_html";		
$redirect_pic_fname = "redirectpage_pic_name";		
$redirect_html = get_html($redirect_pic_fname_html);
$redirect_pic = get_pic($redirect_pic_fname);
$input_pic = '';
$input = '';
$start_up_redirect_option = 0;
$start_up_redirect_url = '';
$start_up_redirect_wait = 0;
$wait_time = 0;
$value = 0;

// 20080707 - Obtain information from redirect link
if (isset($_GET['loginPage'])) {
    $loginPage = $_GET['loginPage'];
}
if (isset($_GET['sslredir'])) {
    $sslredir = $_GET['sslredir'];
	
	// check is it end of ?
	$pos = strrpos($sslredir, "?");
	if (!$pos === false) {
		if ($pos == strlen($sslredir) -1 ){
			//remove ?
			$sslredir = substr($sslredir, 0, strlen($sslredir) -1);
		}
	}
	
    $_SESSION['sess_desturl'] = $sslredir;
    $sess_desturl = $sslredir;
}

// 20080707 - Change not to use session variables
if (isset($loginPage)) {

    // 20080707 - Change not to use session variables
    if ($loginPage == true) {
		// access http://10.20.7.1:5788 directly
		$access_directly = 1;
		GetRedirectCfg();
		
		// 20080707 - Change not to use session variables
        unset($loginPage);
        unset($sslredir);
		
		if ($start_up_redirect_option == 0) {
			// echo get_var('redirect_surf')."<br/>".get_var('redirect_addr');
			$input = "
				<span class=\"redirectaddr\">".get_var('redirect_surf')."</span><br>
				<span class=\"redirectaddr\">".get_var('redirect_addr')."</span>";
			GenTable('', $input, '');
		} else {
			header("Location: ".$_SESSION['sess_desturl']);
		}
    } else {
		GetRedirectCfg();
		header("Location: ".$_SESSION['sess_desturl']);
    }
}
else {
    GetRedirectCfg();
	header("Location: ".$_SESSION['sess_desturl']);
}

?>