<?php
// security check
require_once "secureLogin.php";
include_once "db_access.php";

    function numberOperator($operatorString) {
        /* 
         *  Purpose: It transform english description to numerical operator
         */
        switch ($operatorString) {
            case "0":
                $operator = "<";
            break;
            case "1":
                $operator = "=";
            break;
            case "2":
                $operator = ">";
            break;
            default:
                $operator = "unknown";
            break;
        }
        return $operator;
    } //numberOperator()

    function makeComplexDateSql($startOrExpire,$mode,$timeStamp) {
        /*
         *  Purpose:
         *  Make SQL statement to compare date.
         *  This function is rather complicated and is needed because of
         *  the non-standard design of date field of user table.
         */
        $dateString = explode(" ",date("Y n d H:i:s",$timeStamp));
        $monthInteger = (int)$dateString[1];
        $monthAbbre[1] = "Jan";
        $monthAbbre[2] = "Feb";
        $monthAbbre[3] = "Mar";
        $monthAbbre[4] = "Apr";
        $monthAbbre[5] = "May";
        $monthAbbre[6] = "Jun";
        $monthAbbre[7] = "Jul";
        $monthAbbre[8] = "Aug";
        $monthAbbre[9] = "Sep";
        $monthAbbre[10] = "Oct";
        $monthAbbre[11] = "Nov";
        $monthAbbre[12] = "Dec";
        if ($startOrExpire == "s") {
            $dateField = "sdate";
        } else { // "e"
            $dateField = "edate";
        }
        $yy = "right($dateField,4)";
        $mm = "right(left($dateField,7),3)";
        $dd = "right(left($dateField,10),2)";
        $timeStr = "right(left($dateField,19),8)";
        if ($mode == "before") {
            $startMonth = 1;
            $endMonth = $monthInteger - 1;
            $operator = "<";
        } else { // "after"
            $startMonth = $monthInteger + 1;
            $endMonth = 12;
            $operator = ">";
        }
        for ($i = $startMonth; $i<=$endMonth; $i++) {
            $aMonthCheck[] = "$mm = '$monthAbbre[$i]'";
        }
        if (isset($aMonthCheck)) {
            $monthCheck = join(" OR ", $aMonthCheck);
            $monthCheck = "OR $yy = '$dateString[0]' AND ($monthCheck)";
        } else {
            $monthCheck = "";
        }
        $dayCheck = "$dd $operator '$dateString[2]'";
        $timeCheck = "$timeStr $operator '$dateString[3]'";
        $suffix = "($yy $operator '$dateString[0]' $monthCheck OR $yy = '$dateString[0]' AND $mm = '$monthAbbre[$monthInteger]' AND $dayCheck OR $yy = '$dateString[0]' AND $mm = '$monthAbbre[$monthInteger]' AND $dd = '$dateString[2]' AND $timeCheck)";
        return $suffix;
    } //makeComplexDateSql()
    
    include_once("..\\authserv\\common_functions.php");
    if (!isset($settingobj)) {
        $settingobj = new COM("EGCONFIG.Cfgmgr") or die("searchForm.php EGCONFIG.Cfgmgr Object cannot be created!");
    }
    $outval = $settingobj->getKey( "bt_low", "bw_throttle");
    if($outval!="") {
        $low=$outval;
    }

    $outval = $settingobj->getKey( "bt_medium", "bw_throttle");
    if($outval!="") {
        $medium=$outval;
    }
     
    $outval = $settingobj->getKey( "bt_high", "bw_throttle");
    if($outval!="") {
        $high=$outval;
    }

    // 20081030 - Obtain login mode status
	$local_ip = $settingobj->getKey('gateway_IP', 'gateway');
	$local_mask = $settingobj->getKey('subnet_mask', 'gateway');
	$num_return_path = $settingobj->getKey('num_return_path', 'MNS');

	$tmp_num = '0'.trim($num_return_path);
	$num = (int)$tmp_num;

	$arr_opt = array();
	$return_path = array();
	$i = 0;
	while ($i < $num) {
		$return_path[$i] = $settingobj->getKey("return_path$i", 'MNS');
		$strarray = split(' ', trim($return_path[$i]));
		$arr_opt[$i] = ($i+1).': '.$lang['setcfg_multi_net_seg_router_IP'].'='.$strarray[0].', '.$lang['setcfg_multi_net_seg_subnet_mask'].'='.$strarray[1];
		$i++;
	}
	
    //$settingobj->Release();
    $settingobj=null;
?>
<script lang="javascript">
//from searchForm.php to declare useful global variables
var glo_isSearchUser = "<?=$searchUser?>";
<?php
if (isset($searchFormData)) {
    echo "var glo_oldSearchFormData = \"$searchFormData\";\n";
}
?>
</script>

<?php
    if (isset($searchFormData)) {

        //Put back the search form date to array $formElement
        //For format of $searchFormData please refer to formDataToString() in searchUser.js 
        foreach (explode("|", $searchFormData) as $value) {
            $temp = explode(",", $value);
            $formElement[$temp[0]] = array("type" =>$temp[1], "value" =>$temp[2]);
        }

        if ($searchUser=="frmAdvanced") { //Advanced search form is submitted
            /***************************************************
             * Generate SQL where statement of advanced search *
             ***************************************************/
            if ($formElement['fACUN']['value']=="t") { //Username
                $sqlSuffix[] = "name LIKE '".preg_replace("/\*+/","%",$formElement['fATUN']['value'])."'";
            }
            if ($formElement['fACMAC']['value']=="t") { //MAC user?
                if ($formElement['fASMAC']['value']=="0") { //must be MAC user
                    $sqlSuffix[] = "(macasusr IS NOT NULL AND macasusr = 'Y')";
                    if ($formElement['fACMACPL']['value']=="t") { //passive login?
                        if ($formElement['fASMACPL']['value']=="0") { //must be passive login
                            $sqlSuffix[] = "(pwd IS NULL)";
                        } else { //must not be passive login
                            $sqlSuffix[] = "(pwd IS NOT NULL)";
                        }
                    }
                } else { //must not be MAC user
                    $sqlSuffix[] = "(macasusr IS NULL)";
                }
            }
            if ($formElement['fACAD']['value']=="t") { //account disabled?
                if ($formElement['fASAD']['value']=="0") { //account enabled
                    $sqlSuffix[] = "(status IS NULL OR status = 0)";
                } else { //account disabled
                    $sqlSuffix[] = "(status = 1)";
                }
            } //end account disabled? //end account suspension
            if ($formElement['fACB']['value']=="t") { //bandwidth throttle
                switch ($formElement['fASB']['value']) {
                    case "0": //none
                        $sqlSuffix[] = "(btul = 0) AND (btdl = 0)";
                        break;
                    case "1": //low
                        $sqlSuffix[] = "(btul = $low) AND (btdl = $low)";
                        break;
                    case "2": //medium
                        $sqlSuffix[] = "(btul = $medium) AND (btdl = $medium)";
                        break;
                    case "3": //high
                        $sqlSuffix[] = "(btul = $high) AND (btdl = $high)";
                        break;
                    case "4": //global setting
                        $sqlSuffix[] = "(btul IS NULL) AND (btdl IS NULL)";
                        break;
                    case "5": //specify
                        if ($formElement['fACBSU']['value']=="t") { //upload
                            $sqlSuffix[] = "(btul ".numberOperator($formElement['fASBSU']['value']).$formElement['fATBSU']['value'].")";
                        }
                        if ($formElement['fACBSD']['value']=="t") { //download
                            $sqlSuffix[] = "(btdl ".numberOperator($formElement['fASBSD']['value']).$formElement['fATBSD']['value'].")";
                        }
                        break;
                    default:
                        break;  
                }
            } //end bandwidth throttle
            if ($formElement['fACDU']['value']=="t") { //data transfer counting UL
                switch ($formElement['fASDU']['value']) {
                    case "0": //global setting
                        $sqlSuffix[] = "(bwcountUL IS NULL)";
                        break;
                    case "1": //no
                        $sqlSuffix[] = "(bwcountUL = 0)";
                        break;
                    case "2": //yes
                        $sqlSuffix[] = "(bwcountUL = 1)";
                        break;
                    case "3": //yes and disable account
                        $sqlSuffix[] = "(bwcountUL = 2)";
                        if ($formElement['fACDUQ']['value']=="t") { //specify upload quota
                            $sqlSuffix[] = "(bwquotaUL ".numberOperator($formElement['fASDUQ']['value']).$formElement['fATDUQ']['value'].")";
                        }
                        break;
                    default:
                        break;
                }
            } //end data transfer counting UL
            if ($formElement['fACDUC']['value']=="t") { //data transfer consummed UL
                $sqlSuffix[] = "(accumbwUL ".numberOperator($formElement['fASDUC']['value']).$formElement['fATDUC']['value'].")";
            }
            if ($formElement['fACDD']['value']=="t") { //data transfer counting DL
                switch ($formElement['fASDD']['value']) {
                    case "0": //global setting
                        $sqlSuffix[] = "(bwcount IS NULL)";
                        break;
                    case "1": //no
                        $sqlSuffix[] = "(bwcount = 0)";
                        break;
                    case "2": //yes
                        $sqlSuffix[] = "(bwcount = 1)";
                        break;
                    case "3": //yes and disable account
                        $sqlSuffix[] = "(bwcount = 2)";
                        if ($formElement['fACDDQ']['value']=="t") { //specify download quota
                            $sqlSuffix[] = "(bwquota ".numberOperator($formElement['fASDDQ']['value']).$formElement['fATDDQ']['value'].")";
                        }
                        break;
                    default:
                        break;
                }
            } //end data transfer counting DL
            if ($formElement['fACDDC']['value']=="t") { //data transfer consummed DL
                $sqlSuffix[] = "(accumbw ".numberOperator($formElement['fASDDC']['value']).$formElement['fATDDC']['value'].")";
            } //end data transfer consummed DL
            // Segment mapping
			if ($formElement['fACSEGMENTMAP']['value']=='t') {
	            switch ($formElement['fASSEGMENTMAP']['value']) {
                    case '0': //yes
						{
						$sqlSuffix[] = "(loginseg IS NOT NULL)";
						if ($formElement['fACSEGMENT']['value']=='t') {
							$sqlSuffix[] = "(loginseg = ".($formElement['fASSEGMENT']['value']).")"; // since don't have option "No selected", do not need +1 of the value
						}
                        break;
						}
                    case '1': //no
                        $sqlSuffix[] = '(loginseg IS NULL)';
                        break;
                    default:
                        break;
                }
            } //end
        } else if ($searchUser=="frmSimple") { //Simple search form was submitted
            /*************************************************
             * Generate SQL where statement of simple search *
             *************************************************/
            if ($formElement["fSTUN"]["value"] != "null") { //username
                $sqlSuffix[] = "(name LIKE '%" . $formElement["fSTUN"]["value"] . "%')";
            }
            if ($formElement["fSSLl"]["value"] != "0") { //last login date
                if ($formElement["fSSLl"]["value"] == "1") {
                    $sqlSuffix[] = "(reserved2 < ". mktime_from_datetime($formElement["fSTLd"]["value"], $formElement["fSTLt"]["value"]) . ")";
                } else if ($formElement["fSSLl"]["value"] == "2") {
                    $sqlSuffix[] = "(reserved2 > ". mktime_from_datetime($formElement["fSTLd"]["value"], $formElement["fSTLt"]["value"]) . ")";
                }
            }
            if ($formElement["fSSAS"]["value"] == "1") { //account functional
                $sqlSuffix[] = "(status = 0 OR status IS NULL)"; //account enabled
                $sqlSuffix[] = "(bwcountUL IS NULL OR bwcountUL <> 2 OR accumbwUL IS NULL OR accumbwUL < bwquotaUL)"; //upload counting is not set or upload used does not exceed upload quota
                $sqlSuffix[] = "(bwcount IS NULL OR bwcount <> 2 OR accumbw IS NULL OR accumbw < bwquota)"; //downlaod counting is not set or downlaod quota used does not exceed download quota
            } else if ($formElement["fSSAS"]["value"]== "2") { //account non-functional
                $sqlSuffix[] = "((status = 1) OR (bwcountUL IS NOT NULL AND bwcountUL = 2 AND accumbwUL IS NOT NULL AND accumbwUL > bwquotaUL) OR (bwcount IS NOT NULL AND bwcount = 2 AND accumbw IS NOT NULL AND accumbw > bwquota))"; 
            }
        } //end making SQL where statement 
        if (isset($sqlSuffix)) {
            $sqlWhereStatement = join(" AND ",$sqlSuffix); //join all conditions with AND
        }
    } //end Processing search form data
?>
<script src="./javascript/searchUser.js" lang="javascript">//Perform action related to search user</script>
<?php
if ($searchUser=="frmSimple") { //output simple simple form only
?>
    <div id="simpleSearchBox">
        <ul class="simpleSearchBoxHeader">
            <li><input type="button" value="<?=get_cm_var('setcfg_users_search_simple_startsearch')?>" class="btn_startSearch" onclick="startSearchOnclick('frmSimple')"/>
                <input type="button" id="btn_hideSearch" value="<?=get_cm_var('setcfg_users_search_simple_hide')?>" class="btn_hideSearch" onclick="hideSearch('frmSimple')"/>
        </ul>
        <form id="frmSimple" action="setcfg.php?category=u" method="post">
            <ul>
			<li/><label><?=get_cm_var('setcfg_users_search_simple_username')?></label>
			
                    <input type="text" size="25" id="fSTUN" name="fSTUN">
                <li/><label><?=get_cm_var('setcfg_users_search_simple_accountstatus')?></label>
                    <select id="fSSAS" name="fSSAS">
                        <option value="dk" selected><?=get_cm_var('setcfg_users_search_simple_accountstatus_select_0')?>
                        <option value="f"><?=get_cm_var('setcfg_users_search_simple_accountstatus_select_1')?>
                        <option value="nf"><?=get_cm_var('setcfg_users_search_simple_accountstatus_select_2')?>
                    </select>
                <li/><label><?=get_cm_var('setcfg_users_search_simple_lastlogin')?></label>
                    <select  id="fSSLl" name="fSSLl" onchange="searchElementOnclick(this)">
                        <option value="dk" selected><?=get_cm_var('setcfg_users_search_simple_lastlogin_select_0')?>
                        <option value="before"><?=get_cm_var('setcfg_users_search_simple_lastlogin_select_1')?>
                        <option value="after"><?=get_cm_var('setcfg_users_search_simple_lastlogin_select_2')?>
                    </select>
                    <input id="fSTLd" name="fSTLd" type="text" size="10" disabled><?=get_cm_var('setcfg_users_search_simple_lastlogin_dmy')?>
                    <input id="fSTLt" name="fSTLt" type="text" size="5" disabled><?=get_cm_var('setcfg_users_search_simple_lastlogin_hhmm')?>
                    <input type="hidden" name="searchUser" value="frmSimple">
                    <input type="hidden" name="searchFormData" value="">
            </ul>
        </form><!-- frmSimple -->
    </div><!-- simple search box -->
<?php
} else if ($searchUser=="frmAdvanced") { //output advanced search form only
?>
    <div id="advancedSearchBox"> 
        <ul class="advancedSearchBoxHeader">
            <li><input type="button" value="<?=get_cm_var('setcfg_users_search_advanced_startsearch')?>" class="btn_startSearch" onclick="startSearchOnclick('frmAdvanced')"/>
                <input type="button" id="btn_hideSearch" value="<?=get_cm_var('setcfg_users_search_advanced_hide')?>" class="btn_hideSearch" onclick="hideSearch('frmAdvanced')"/>
        </ul>
        <form id="frmAdvanced" action="setcfg.php?category=u" method="post">
            <ul>
                <li id="us.1" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACUN" name="fACUN" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_username')?>

                    </span>
                    <input type="text" size="25" id="fATUN" name="fATUN" disabled>
                <li id="us.2" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACMAC" name="fACMAC" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_mac')?>
                    </span>
                    <select id="fASMAC" name="fASMAC" onchange="searchElementOnclick(this)" disabled>
                        <option id="fASMAC1" value="mac"><?=get_cm_var('setcfg_users_search_advanced_mac_y')?>
                        <option id="fASMAC2" value="non-mac"><?=get_cm_var('setcfg_users_search_advanced_mac_n')?>
                    </select>
                <li id="us.2.1" class="secondLevel">
                    <span class="secondLevelLeft">
                        <input type="checkbox" id="fACMACPL" name="fACMACPL" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_mac_passive')?>
                    </span>
                    <select id="fASMACPL" name="fASMACPL" onchange="searchElementOnclick(this)" disabled>
                        <option id="fASMACPL1" value="passive"><?=get_cm_var('setcfg_users_search_advanced_y')?>
                        <option id="fASMACPL2" value="non-passive"><?=get_cm_var('setcfg_users_search_advanced_n')?>
                    </select>
                <li id="as.1" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACAD" name="fACAD" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_accountdisable')?>
                    </span>
                    <select id="fASAD" name="fASAD" disabled>
                        <option value="enabled"><?=get_cm_var('setcfg_users_search_advanced_accountdisable_select_0')?>
                        <option value="disabled"><?=get_cm_var('setcfg_users_search_advanced_accountdisable_select_1')?>
                    </select>
					
                <li id="bt.1" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACB" name="fACB" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_bt')?>
                    </span>
                    <select id="fASB" name="fASB" onchange="searchElementOnclick(this)" disabled>
                        <option id="fASB1" value="none"><?=get_cm_var('setcfg_users_search_advanced_bt_select_0')?>
                    <option id="fASB2" value="low"><?=get_cm_var('setcfg_users_search_advanced_bt_select_1')?> (<?=$low?> <?=get_cm_var('setcfg_users_search_advanced_bt_upload_unit')?>)
                        <option id="fASB3" value="medium"><?=get_cm_var('setcfg_users_search_advanced_bt_select_2')?> (<?=$medium?> <?=get_cm_var('setcfg_users_search_advanced_bt_upload_unit')?>)
                        <option id="fASB4" value="high"><?=get_cm_var('setcfg_users_search_advanced_bt_select_3')?> (<?=$high?> <?=get_cm_var('setcfg_users_search_advanced_bt_upload_unit')?>)
                        <option id="fASB5" value="global"><?=get_cm_var('setcfg_users_search_advanced_bt_select_4')?>
                        <option id="fASB6" value="specify"><?=get_cm_var('setcfg_users_search_advanced_bt_select_5')?>
                    </select>
                <li id="bt.1.1"class="secondLevel">
                    <span class="secondLevelLeft">
                        <input type="checkbox" id="fACBSU" name="fACBSU" onclick="searchElementOnclick(this)" disabled><?=get_cm_var('setcfg_users_search_advanced_bt_upload')?>    
                    </span>
                    <select id="fASBSU" name="fASBSU" disabled>
                        <option value="lessthan"><?=get_cm_var('setcfg_users_search_advanced_less_than')?>
                        <option value="equal"><?=get_cm_var('setcfg_users_search_advanced_equal_to')?>
                        <option value="greaterthan"><?=get_cm_var('setcfg_users_search_advanced_greater_than')?>
                    </select>
                    <input type="text" id="fATBSU" name="fATBSU" size="7" disabled><?=get_cm_var('setcfg_users_search_advanced_bt_upload_unit')?>
                <li id="bt.1.2"class="secondLevel">
                    <span class="secondLevelLeft">
                        <input type="checkbox" id="fACBSD" name="fACBSD" onclick="searchElementOnclick(this)" disabled><?=get_cm_var('setcfg_users_search_advanced_bt_download')?>  
                    </span>
                    <select id="fASBSD" name="fASBSD" disabled>
                        <option value="lessthan"><?=get_cm_var('setcfg_users_search_advanced_less_than')?>
                        <option value="equal"><?=get_cm_var('setcfg_users_search_advanced_equal_to')?>
                        <option value="greaterthan"><?=get_cm_var('setcfg_users_search_advanced_greater_than')?>
                    </select>
                    <input type="text" id="fATBSD" name="fATBSD" size="7" disabled><?=get_cm_var('setcfg_users_search_advanced_bt_download_unit')?>
                <li id="dtc.1" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACDU" name="fACDU" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_dtc_ul')?>
                    </span>
                    <select id="fASDU" name="fASDU" onchange="searchElementOnclick(this)" disabled>
                        <option id="fASDU1" value="global"><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_select_0')?>
                        <option id="fASDU2" value="no"><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_select_1')?>
                        <option id="fASDU3" value="yes"><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_select_2')?>
                        <option id="fASDU4" value="yesdisable"><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_select_3')?>
                    </select>
                <li id="dtc.1.1" class="secondLevel">
                    <span class="secondLevelLeft">
                        <input type="checkbox" id="fACDUQ" name="fACDUQ" onclick="searchElementOnclick(this)" disabled><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_quota')?>
                    </span>
                    <select id="fASDUQ" name="fASDUQ" disabled>
                        <option value="lessthan"><?=get_cm_var('setcfg_users_search_advanced_less_than')?>
                        <option value="equal"><?=get_cm_var('setcfg_users_search_advanced_equal_to')?>
                        <option value="greaterthan"><?=get_cm_var('setcfg_users_search_advanced_greater_than')?>
                    </select>
                    <input type="text" id="fATDUQ" name="fATDUQ" size="7" disabled><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_quota_unit')?>
                <li id="dtc.2" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACDUC" name="fACDUC" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_dtc_ul_consume')?>
                    </span>
                    <select id="fASDUC" name="fASDUC" disabled>
                        <option value="lessthan" ><?=get_cm_var('setcfg_users_search_advanced_less_than')?>
                        <option value="equal"><?=get_cm_var('setcfg_users_search_advanced_equal_to')?>
                        <option value="greaterthan"><?=get_cm_var('setcfg_users_search_advanced_greater_than')?>
                    </select>
                    <input type="text" id="fATDUC" name="fATDUC" size="7" disabled>&nbsp;
                    <?=get_cm_var('setcfg_users_search_advanced_dtc_ul_consume_unit')?>
                <li id="dtc.3" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACDD" name="fACDD" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_dtc_dl')?>
                    </span>
                    <select id="fASDD" name="fASDD" onchange="searchElementOnclick(this)" disabled>
                        <option id="fASDD1" value="global"><?=get_cm_var('setcfg_users_search_advanced_dtc_dl_select_0')?>
                        <option id="fASDD2" value="no"><?=get_cm_var('setcfg_users_search_advanced_dtc_dl_select_1')?>
                        <option id="fASDD3" value="yes"><?=get_cm_var('setcfg_users_search_advanced_dtc_dl_select_2')?>
                        <option id="fASDD4" value="yesdisable"><?=get_cm_var('setcfg_users_search_advanced_dtc_dl_select_3')?>
                    </select>
                <li id="dtc.3.1" class="secondLevel">
                    <span class="secondLevelLeft">
                        <input type="checkbox" id="fACDDQ" name="fACDDQ" onclick="searchElementOnclick(this)" disabled><?=get_cm_var('setcfg_users_search_advanced_dtc_dl_quota')?>
                    </span>
                    <select id="fASDDQ" name="fASDDQ" disabled>
                        <option value="lessthan"><?=get_cm_var('setcfg_users_search_advanced_less_than')?>
                        <option value="equal"><?=get_cm_var('setcfg_users_search_advanced_equal_to')?>
                        <option value="greaterthan"><?=get_cm_var('setcfg_users_search_advanced_greater_than')?>
                    </select>
                    <input type="text" id="fATDDQ" name="fATDDQ" size="7" disabled>&nbsp;
                    <?=get_cm_var('setcfg_users_search_advanced_dtc_dl_quota_unit')?>
                <li id="dtc.4" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACDDC" name="fACDDC" onclick="searchElementOnclick(this)"><?=get_cm_var('setcfg_users_search_advanced_dtc_dl_consume')?>
                    </span>
                    <select id="fASDDC" name="fASDDC" disabled>
                        <option value="lessthan" ><?=get_cm_var('setcfg_users_search_advanced_less_than')?>
                        <option value="equal"><?=get_cm_var('setcfg_users_search_advanced_equal_to')?>
                        <option value="greaterthan"><?=get_cm_var('setcfg_users_search_advanced_greater_than')?>
                    </select>
                    <input type="text" id="fATDDC" name="fATDDC" size="7" disabled>&nbsp;
                    <?=get_cm_var('setcfg_users_search_advanced_dtc_dl_consume_unit')?>
					
				<!-- Segment mapping -->
				<li id="segmentmap_search" class="firstLevel">
                    <span class="firstLevelLeft">
                        <input type="checkbox" id="fACSEGMENTMAP" name="fACSEGMENTMAP" onclick="searchElementOnclick(this)"> <?=get_cm_var('setcfg_users_search_advanced_segmentmap')?>
                    </span>
					<!-- option id must match session id + number-->
                    <select id="fASSEGMENTMAP" name="fASSEGMENTMAP" onchange="searchElementOnclick(this)" disabled>
                        <option id="fASSEGMENTMAP1" value="yes" selected><?=get_cm_var('setcfg_users_search_advanced_y')?>
                        <option id="fASSEGMENTMAP2" value="no"><?=get_cm_var('setcfg_users_search_advanced_n')?>
                    </select>
                <li id="segment_search" class="secondLevel">
                    <span class="secondLevelLeft">
                        <input type="checkbox" id="fACSEGMENT" name="fACSEGMENT" onclick="searchElementOnclick(this)" disabled><?=get_cm_var('setcfg_users_search_advanced_segmentmap_specify')?>
                    </span>
					<select id="fASSEGMENT" name="fASSEGMENT" disabled>
					<?
					$subInput = '';
					$subInput  .= '<option VALUE="0">'.$lang['setcfg_segment_map_login_segment_opt0']." (".$lang['setcfg_segment_map_login_segment_opt0_text1'].'='.$local_ip.', '.$lang['setcfg_segment_map_login_segment_opt0_text2'].'='.$local_mask.")";
					$j = 0;
					
					while ($j < 20) { // hard code limit 
						if  ($j < $num)
							$subInput  .= "<option VALUE=\"".($j+1)."\">$arr_opt[$j]";
						else
							$subInput  .= "<option VALUE=\"".($j+1)."\">".($j+1).": ";
						$j++;
					}
					echo $subInput;
					?>
                    </select>
            </ul>
            <input type="hidden" name="searchUser" value="frmAdvanced">
            <input type="hidden" name="searchFormData" value="">
        </form><!-- formAdvanced -->
    </div> <!-- advanced search box -->
<?php
} //end output simple/advanced search form
?>
<script lang="javascript">
//This block of statement come from searchUser.php
//The aim is to hide the inactive search form
init('<?=$searchUser?>');
</script>
