<?php
include_once "..\\cfgmgr\\db_access.php";
include_once '..\\authserv\\common_functions.php';

// print_r($_POST);
// exit();

if (!isset($access_rule_order_list) && $access_rule_order_list == ""){
	// error 
	echo "error";
	exit();
}

$arr_order = array();

$arr_order_list = explode(",", $access_rule_order_list);
$arr_enable_list = explode(",", $access_rule_isEnable_list);
if (isset($deleted_access_rule_list))
	$arr_deleted_list = explode(",", $deleted_access_rule_list);
else
	$arr_deleted_list = array();

sort($arr_deleted_list);

// print_r($arr_deleted_list);exit();

$settingobj = new COM('EGCONFIG.Cfgmgr') or die('setcfg.php EGCONFIG.Cfgmgr Object cannot be created!');

$group_tablename = $settingobj->getKey('Datasource_group_Tablename', 'gateway');
$member_tablename = $settingobj->getKey('Datasource_member_Tablename', 'gateway');
$ipbundle_tablename = $settingobj->getKey('Datasource_ipbundle_Tablename', 'gateway');
$rule_ip_tablename = $settingobj->getKey('Datasource_rule_ip_Tablename', 'gateway');
$rule_ipbundle_tablename = $settingobj->getKey('Datasource_rule_ipbundle_Tablename', 'gateway');
$rule_user_tablename = $settingobj->getKey('Datasource_rule_user_Tablename', 'gateway');
$rule_group_tablename = $settingobj->getKey('Datasource_rule_group_Tablename', 'gateway');
$rule_port_tablename = $settingobj->getKey('Datasource_rule_port_Tablename', 'gateway');
$access_rule_tablename = $settingobj->getKey('Datasource_access_rule_Tablename', 'gateway');
$bw_rule_tablename = $settingobj->getKey('Datasource_bw_rule_Tablename', 'gateway');
$user_tablename = $settingobj->getKey('Datasource_Tablename', 'gateway');

$myDB = new db();

$field_name="";
$field_value="";

$del_count = 0;
foreach ($arr_order_list as $key => $val){
$markAsDelete = false;
foreach ($arr_deleted_list as $v){
	if ($v == $val){
		// which mark as deleted, skip
		$markAsDelete = true;
		break;
	}
}

if (!isset($_POST["rule_name_".$val])){
	continue;
}

// clear table
$q="DELETE from $access_rule_tablename where ruleName = '".$_POST["rule_name_".$val]."'; ";
// echo $q."<br/>";
$result=$myDB->query($q);
$q="DELETE from $rule_ip_tablename where ruleName = '".$_POST["rule_name_".$val]."'; ";
// echo $q."<br/>";
$result=$myDB->query($q);
$q="DELETE from $rule_port_tablename where ruleName = '".$_POST["rule_name_".$val]."'; ";
// echo $q."<br/>";
$result=$myDB->query($q);
$q="DELETE from $rule_ipbundle_tablename where ruleName = '".$_POST["rule_name_".$val]."'; ";
// echo $q."<br/>";
$result=$myDB->query($q);
$q="DELETE from $rule_user_tablename where ruleName = '".$_POST["rule_name_".$val]."'; ";
// echo $q."<br/>";
$result=$myDB->query($q);
$q="DELETE from $rule_group_tablename where ruleName = '".$_POST["rule_name_".$val]."'; ";
// echo $q."<br/>";
$result=$myDB->query($q);

if ($markAsDelete){
	$del_count++;
	continue;
}
	
// access rule
$schedule = "";
if (isset($_POST["schedule_".$val])){
	if (strlen($_POST["schedule_".$val]) == 0){
		$schedule = ""; // empty string (all the time)
	}
	else if (substr_count(strtoupper($_POST["schedule_".$val]),"F")==168){
		$schedule = ""; // empty string (all the time)
	}
	else if (substr_count($_POST["schedule_".$val],"0")==168){
		$schedule = "0"; // zero
	}
	else{
		$schedule = strtoupper($_POST["schedule_".$val]);
	}
}

$field_name="ruleName, descript, isAllow, traffType, isEnable, seqOrder, webFltName, schedule";
$field_value="'".$_POST["rule_name_".$val]."', '".$_POST["rule_description_".$val]."', ".$_POST["rule_action_".$val].", ".$_POST["rule_trafficType_".$val].", ".$arr_enable_list[$key].", ".($key+1-$del_count).", '".$_POST["applied_web_filter_".$val]."', '".$schedule."'";

$q="INSERT INTO $access_rule_tablename ($field_name) VALUES ($field_value); ";
// echo $q."<br/>";
$result=$myDB->query($q);

// src ip
$count = 0;
while(1){
	$src_ip_mask_name = "hinput_".$val."_source_".$count;

	if (isset($_POST[$src_ip_mask_name])){
		$arr_temp = array();
		$arr_temp = explode(" ", $_POST[$src_ip_mask_name]);
		
		$ip = $arr_temp[0];
		$mask = substr($arr_temp[1], 1, strlen($arr_temp[1]) -2);
	
		$field_name="";
		$field_value="";

		$field_name="ip, mask, type, ruleName";
		
		$field_value = "'".$ip."', '".$mask."', 1, '".$_POST["rule_name_".$val]."'";

		$q="INSERT INTO $rule_ip_tablename ($field_name) VALUES ($field_value); ";
		// echo $q."<br/>";
		$result=$myDB->query($q);
	}
	else 
		break;
		
	$count++;
}

// src ipbundle
$count = 0;
while(1){
	$src_ip_bundle_name = "hinput_".$val."_source_ipbundle_".$count;

	if (isset($_POST[$src_ip_bundle_name])){
	
		$ipBundleName = $_POST[$src_ip_bundle_name];
	
		$field_name="";
		$field_value="";

		$field_name="bundleName, type, ruleName";
		
		$field_value = "'".$ipBundleName."', 1, '".$_POST["rule_name_".$val]."'";

		$q="INSERT INTO $rule_ipbundle_tablename ($field_name) VALUES ($field_value); ";
		// echo $q."<br/>";
		$result=$myDB->query($q);
	}
	else 
		break;
		
	$count++;
}

// dest ip
$count = 0;
while(1){
	$dest_ip_mask_name = "hinput_".$val."_dest_".$count;

	if (isset($_POST[$dest_ip_mask_name])){
		$arr_temp = array();
		$arr_temp = explode(" ", $_POST[$dest_ip_mask_name]);
		
		$ip = $arr_temp[0];
		$mask = substr($arr_temp[1], 1, strlen($arr_temp[1]) -2);
	
		$field_name="";
		$field_value="";

		$field_name="ip, mask, type, ruleName";
		
		$field_value = "'".$ip."', '".$mask."', 0, '".$_POST["rule_name_".$val]."'";

		$q="INSERT INTO $rule_ip_tablename ($field_name) VALUES ($field_value); ";
		// echo $q."<br/>";
		$result=$myDB->query($q);
	}
	else 
		break;
		
	$count++;
}

// dest ipbundle
$count = 0;
while(1){
	$dest_ip_bundle_name = "hinput_".$val."_dest_ipbundle_".$count;

	if (isset($_POST[$dest_ip_bundle_name])){
	
		$ipBundleName = $_POST[$dest_ip_bundle_name];
	
		$field_name="";
		$field_value="";

		$field_name="bundleName, type, ruleName";
		
		$field_value = "'".$ipBundleName."', 0, '".$_POST["rule_name_".$val]."'";

		$q="INSERT INTO $rule_ipbundle_tablename ($field_name) VALUES ($field_value); ";
		// echo $q."<br/>";
		$result=$myDB->query($q);
	}
	else 
		break;
		
	$count++;
}

// src port
$count = 0;
while(1){
	$src_port_name = "hinput_".$val."_sourcep_".$count;

	if (isset($_POST[$src_port_name])){
		$arr_temp = array();
		$arr_temp = explode(" ", $_POST[$src_port_name]);
		
		$type = $arr_temp[0];
		
		$protoNum = 0;
		
		$field_name="";
		$field_value="";
		
		if (strcasecmp($type, "tcp")==0 || strcasecmp($type, "udp")==0){
			if (strcasecmp($type, "tcp")==0)
				$protoNum = 6;
			else
				$protoNum = 17;
			$port_range = substr($arr_temp[1], 1, strlen($arr_temp[1]) -2);
			$arr_temp2 = array();
			$arr_temp2 = explode("-", $port_range);
			
			$port_from = $arr_temp2[0];
			$port_to = $arr_temp2[1];
			
			$field_name="fromPort, toPort, protoNum, type, ruleName";
			$field_value = "'".$port_from."', '".$port_to."', ".$protoNum.", 1, '".$_POST["rule_name_".$val]."'";
		}
		else{
			$protoNum = substr($arr_temp[1], 1, strlen($arr_temp[1]) -2);
			$field_name="protoNum, type, ruleName";
			$field_value = "".$protoNum.", 1, '".$_POST["rule_name_".$val]."'";
		}
		
		$q="INSERT INTO $rule_port_tablename ($field_name) VALUES ($field_value); ";
		// echo $q."<br/>";
		$result=$myDB->query($q);
	}
	else 
		break;
		
	$count++;
}

// dest port
$count = 0;
while(1){
	$dest_port_name = "hinput_".$val."_destp_".$count;

	if (isset($_POST[$dest_port_name])){
		$arr_temp = array();
		$arr_temp = explode(" ", $_POST[$dest_port_name]);
		
		$type = $arr_temp[0];
		
		$protoNum = 0;
		
		$field_name="";
		$field_value="";
		
		if (strcasecmp($type, "tcp")==0 || strcasecmp($type, "udp")==0){
			if (strcasecmp($type, "tcp")==0)
				$protoNum = 6;
			else
				$protoNum = 17;
			$port_range = substr($arr_temp[1], 1, strlen($arr_temp[1]) -2);
			$arr_temp2 = array();
			$arr_temp2 = explode("-", $port_range);
			
			$port_from = $arr_temp2[0];
			$port_to = $arr_temp2[1];
			
			$field_name="fromPort, toPort, protoNum, type, ruleName";
			$field_value = "'".$port_from."', '".$port_to."', ".$protoNum.", 0, '".$_POST["rule_name_".$val]."'";
		}
		else{
			$protoNum = substr($arr_temp[1], 1, strlen($arr_temp[1]) -2);
			$field_name="protoNum, type, ruleName";
			$field_value = "".$protoNum.", 0, '".$_POST["rule_name_".$val]."'";
		}
		$q="INSERT INTO $rule_port_tablename ($field_name) VALUES ($field_value); ";
		// echo $q."<br/>";
		$result=$myDB->query($q);
	}
	else 
		break;
		
	$count++;
}

// user/group
$count = 0;
while(1){
	$user_and_group_input_name = "hinput_".$val."_user_and_group_".$count;

	if (isset($_POST[$user_and_group_input_name])){
		$arr_temp = array();
		$arr_temp = explode(" ", $_POST[$user_and_group_input_name]);
		
		// need prevent name contain space character
		$name = "";
		
		for ($i=0; $i < count($arr_temp)-1; $i++){
			if ($name !="")
				$name .= " ";
			$name .= $arr_temp[$i];
		}
		
		$type = substr($arr_temp[count($arr_temp)-1], 1, strlen($arr_temp[count($arr_temp)-1]) -2);
	
		$field_name="";
		$field_value="";
		
		if (strcasecmp($type, "user") == 0){
			$field_name="userName, ruleName";
		
			$field_value = "'".$name."', '".$_POST["rule_name_".$val]."'";

			$q="INSERT INTO $rule_user_tablename ($field_name) VALUES ($field_value); ";
			// echo $q."<br/>";
			$result=$myDB->query($q);
		}
		else if (strcasecmp($type, "group") == 0){
			$field_name="groupName, ruleName";
		
			$field_value = "'".$name."', '".$_POST["rule_name_".$val]."'";

			$q="INSERT INTO $rule_group_tablename ($field_name) VALUES ($field_value); ";
			// echo $q."<br/>";
			$result=$myDB->query($q);
		}
	}
	else 
		break;
		
	$count++;
}


}

if ($myDB)
	$myDB->close();
	
$settingobj->ReloadRule();
	
$settingobj=null;

$cat="arule";

$message='Access Rule information is successfully saved.';
	
$saved='true';
$errorlog='';

// exit();

?>

<html>
<head></head>
<!-- redirect back to setcfg.php -->
<body onLoad="window.location.href='setcfg.php?category=<?= $cat ?>'">
</body>
</html>