<?php
require_once 'secureLogin.php'; //prevent hacker run this script by setting GET variables
?>
<html>
<head>
<title>QOS table</title>
<style type="text/css">
<!--
    table { font-family: Tahoma, sans-serif; font-size: 10pt; }
    .odd { background: #F0F0F0; }
    .even { background: #FFF; }
    .checked { background: #BAEAD6; }
    #display { border-collapse: collapse; color: #000; }
    #add { border-top: 1px solid #99D1A2; border-collapse: collapse ; color: #096; }
    form { margin: 0;}
-->
</style>
<script type="text/javascript">
<!--
function combo_submit(element)
{
    document.combo.item_no_dhcp.value = element;
    document.combo.submit();
}
// -->
</script>
</head>
<body>
<?php

require_once 'display_list.php';

// register sessions, if needed
if (!isset($ser_display_dhcp)) {
    $settingobj = new COM('EGCONFIG.Cfgmgr') or die('table_dhcp.php EGCONFIG.Cfgmgr Object cannot be created!');
    $static_dhcp_path = $settingobj->getkey('static_dhcp_path', 'gateway');
    //$settingobj->Release();
    $settingobj=null;

    $display_dhcp = new Saved_Array($static_dhcp_path);
    $i=0;
    while ($i < $display_dhcp->num_sites) {
        if ($display_dhcp->site_list[$i]->name != ';') {
            $keyarray = split(' ', $display_dhcp->site_list[$i]->name);
            $display_dhcp->site_list[$i]->name = trim($keyarray[0]);
            $display_dhcp->site_list[$i]->span = trim($keyarray[1]);
        }
        $i++;
    }
    $ser_display_dhcp=serialize($display_dhcp);
    session_register('ser_display_dhcp');
}

if (!isset($ser_add_dhcp)) {
  $add_dhcp = new Site_Array;
  $ser_add_dhcp = serialize($add_dhcp);
  session_register('ser_add_dhcp');
}

// unserialize data
if (isset($ser_display_dhcp)) {
    $display_dhcp = unserialize($ser_display_dhcp);
}
if (isset($ser_add_dhcp)) {
    $add_dhcp = unserialize($ser_add_dhcp);
}


if ($display_dhcp->num_sites > 0) {
    echo '
<table id="display" width="100%">
<colgroup span="3">
<col width="120">
<col width="140">
<col width="50">
</colgroup>';

    $i = 0;
    $class = '';

    while ($i < $display_dhcp->num_sites) {
        if ($display_dhcp->site_list[$i]->name != ';') {
            $class = ($class == 'odd')? 'even': 'odd';
            if ($display_dhcp->site_list[$i]->checked == 'true') {
                $checked = 'checked';
                $class = 'checked';
            } else {
                $checked = '';
            }

            echo "\n<tr class=\"$class\">\n";

            echo "    <td>{$display_dhcp->site_list[$i]->name}</td>\n";
            echo "    <td>{$display_dhcp->site_list[$i]->span}</td>\n";

            echo '    <td><input type="checkbox" onclick="combo_submit(\'dis'.$i.'\');" '.$checked.'></td>';
            echo "\n</tr>\n";
        }
        $i++;
    }
    echo "</table>\n";
}

if ($add_dhcp->num_sites > 0) {
    echo '
<table id="add" width="100%">
<colgroup span="3">
<col width="120">
<col width="140">
<col width="50">
</colgroup>';

    $i = 0;
    $class = '';

    while ($i < $add_dhcp->num_sites) {
        if ($add_dhcp->site_list[$i]->name != ';') {
            $class = ($class == 'odd')? 'even': 'odd';
            if ($add_dhcp->site_list[$i]->checked == 'true') {
                $checked = 'checked';
                $class = 'checked';
            } else {
                $checked = '';
            }

            echo "\n<tr class=\"$class\">\n";

            echo "    <td>{$add_dhcp->site_list[$i]->name}</td>\n";
            echo "    <td>{$add_dhcp->site_list[$i]->span}</td>\n";

            echo '    <td><input type="checkbox" onclick="combo_submit(\'add'.$i.'\');" '.$checked.'></td>';
            echo "\n</tr>\n";
        }
        $i++;
    }
    echo "</table>\n";
}

?>

<form name="combo" action="intermediate.php" method="post">
    <input type="hidden" name="item_no_dhcp" value="">
</form>

</body>
</html>

