<?php
include "..\\cfgmgr\\db_access.php";
include_once "..\\cfgmgr\\egAPI.php";

class transaction {

  var $transaction_table;
  var $usr_table;
  var $plan_table;
  var $myDB;
  
  function transaction() {
	$this->myDB = new db();
    $this->transaction_table = $this->myDB->get_transaction_table();
    $this->usr_table = $this->myDB->get_usr_table();
    $this->plan_table = $this->myDB->get_plan_table();
  }

	// 20090519 - Move javascript section to body
	//submit form to payment gateway
	function submit_form($url, $arr_postfields)
	{
		echo '<form name="payment" action="'.$url.'" method="post">'."\n";
		foreach ($arr_postfields as $key => $val) {
			echo '<input type="hidden" name="'.$key.'" value="'.$val.'">'."\n";
		}
		echo 'Your page will be redirected after 5 seconds<br>If not, Click the button below<br><br>'."\n";
		echo '<input type="submit" value="submit">'."\n";
		echo '</form>'."\n";
	}


  function postfields_urlencode($arr_postfields)
  {
    $postfields_string = null;
    foreach ($arr_postfields as $key => $val)
    {
      if ($postfields_string != null)
        $postfields_string .= "&";
      $postfields_string .= "$key=".urlencode(stripslashes($val));
    }

    return $postfields_string;
  }


  //postback to payment gateway
  function postback($url, $header, $postfields, $timeout)
  {
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_HEADER, 0);
    curl_setopt ($ch, CURLOPT_HTTPHEADER, $header);
    curl_setopt ($ch, CURLOPT_POST, 1); 
    curl_setopt ($ch, CURLOPT_POSTFIELDS, $postfields); 
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt ($ch, CURLOPT_TIMEOUT, $timeout);
	//curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, false);
    $res = curl_exec ($ch);
    curl_close ($ch);

    return $res;
  }
  
  // workaround for using curl to postback (with SLL)
  function postback_ssl($url, $header, $postfields, $timeout)
  {
	// direct init 
    $ch = curl_init($url.$postfields);
    curl_setopt ($ch, CURLOPT_HEADER, 0);
    curl_setopt ($ch, CURLOPT_HTTPHEADER, $header);
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable 
    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1); // allow redirects 
    curl_setopt ($ch, CURLOPT_TIMEOUT, $timeout);
	// Below two option will enable the HTTPS option.
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  FALSE);
	// execute post
    $res = curl_exec ($ch);
	// close connection
    curl_close ($ch);
	
    return $res;
  }

  
  function update_usr_table($username, $plan_name, $quantity = 1)
  {
    if ($username == null || $username == "" || $plan_name == null || $plan_name == "")
        return false;
	
	// 20071211 - Obtain add_replace_bw_quota setting
    // 20071207 - Set object to config here
    $settingObj = new COM('EGCONFIG.Cfgmgr') or die('transaction.php EGCONFIG.Cfgmgr Object cannot be created!');
    $flagOverwriteSuspend = $settingObj->getKey('overwrite_user_suspend', 'cart') == NULL? "" : $settingObj->getKey('overwrite_user_suspend', 'cart');
    if ($flagOverwriteSuspend == "") {
	$flagOverwriteSuspend = "1";
    }
    $flagARBwQuota = $settingObj->getKey('add_replace_bw_quota', 'cart') == NULL? "" : $settingObj->getKey('add_replace_bw_quota', 'cart');
    if ($flagARBwQuota == "") {
	$flagARBwQuota = "0";
    }
	
	$flagResetBwCount = ($settingObj->getKey('reset_bw_count_upon_purchase', 'cart') == NULL? "" : $settingObj->getKey('reset_bw_count_upon_purchase', 'cart'));
    if ($flagResetBwCount == "") {
	$flagResetBwCount = "1";
    }
	
	$settingObj = NULL;

    //retrieve fields from plan
    $q="SELECT * FROM $this->plan_table WHERE pname='$plan_name'";

    $result=$this->myDB->query($q);
    
	// 20090708 - Add field type array
    $fields=array();
	$bFieldNumeric = array();

    if (odbc_fetch_row($result)) {
		// 20071204 - Round all numeric fields
		for ($i = 1; $i <= odbc_num_fields($result); $i++) {
			if (strtolower(odbc_field_type($result, $i)) == "numeric" || strtolower(odbc_field_type($result, $i)) == "integer") {
				if (odbc_result($result, $i) != NULL || strlen(odbc_result($result, $i)) > 0) {
					$fields[strtolower(odbc_field_name($result, $i))] = round(odbc_result($result, $i));
				} else {
					$fields[strtolower(odbc_field_name($result, $i))] = odbc_result($result, $i);
				}
				$bFieldNumeric[strtolower(odbc_field_name($result, $i))] = 1;
			} else {
				$fields[strtolower(odbc_field_name($result, $i))] = odbc_result($result, $i);
				$bFieldNumeric[strtolower(odbc_field_name($result, $i))] = 0;
			}
		}
	}
    else {
	    echo 'Warning! No plan selected of that item. ';
	     return false;
    }
	
	$q="SELECT * FROM $this->usr_table WHERE name = '$username'";
    $result=$this->myDB->query($q);
	
	// ----interpret the update field with (shopping cart behavior)-----
	
	$nSetEdate = false;
	if (!isset($fields['edate']) || $fields['edate'] == NULL || strlen($fields['edate']) <= 0){
		$nSetEdate = true;
	}
	
	// 20090406 - Add missing situations
	// 20071207 - Add flag checking
    // 20071009 - Clear plan edate if user edate is NULL
    // 20070712 - Clear edate content if eminutes is not NULL
	if ((odbc_result($result, 'edate') != NULL || strlen(odbc_result($result, 'edate')) > 0) && ($fields['edate'] != NULL || strlen($fields['edate']) > 0)) {
		$eDateUser = strtotime(odbc_result($result, 'edate'));
		$eDatePlan = strtotime($fields['edate']);
		if ($eDateUser != FALSE && $eDatePlan != FALSE) {
			if ($eDateUser > $eDatePlan) {
				$fields['edate'] = odbc_result($result, 'edate');
			}
		} else {
			$fields['edate'] = odbc_result($result, 'edate');
		}
	} elseif ($flagOverwriteSuspend == '0') {
		if (odbc_result($result, 'edate') == NULL || strlen(odbc_result($result, 'edate')) == 0) {
			$fields['edate'] = NULL;
		} else {
			$fields['edate'] = odbc_result($result, 'edate');
		}
	} elseif (odbc_result($result, 'edate') != NULL || strlen(odbc_result($result, 'edate')) > 0) {
		$fields['edate'] = odbc_result($result, 'edate');
    }

	// 20090406 - Add missing situations
    // 20071207 - New section separated from pagenum to add flag checking of overwriting suspend conditions
    $correct_fields = array("timeleft", "logins");
    foreach ($correct_fields as $value) {
		if ((strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != null) && (strlen($fields[$value]) > 0 || $fields[$value] != null)) {
			$fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
		} else if ($flagOverwriteSuspend == "0") {
			if ((odbc_result($result, $value) == null || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != null)) {
				$fields[$value] = NULL;
			} elseif ((odbc_result($result, $value) != NULL || strlen(odbc_result($result, $value)) > 0) && ($fields[$value] == NULL || (strlen($fields[$value]) == 0))) {
				$fields[$value] = round(odbc_result($result, $value));
			}
		} elseif (odbc_result($result, $value) != NULL || strlen(odbc_result($result, $value)) > 0) {
			$fields[$value] = round(odbc_result($result, $value));
		}
    }

    // 20071207 - Remove timeleft, logins
    // 20071203 - Round up values to prevent special SQL error
    // 20070918 - Separate case for bwquota and bwquotaul
    // 20070712 - Remove eminutes
    $correct_fields = array("pagenum");
    foreach ($correct_fields as $value)
    {
      if ( (strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != null) && (strlen($fields[$value]) > 0 || $fields[$value] != null) )
        $fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
      else if ( (odbc_result($result, $value) == null || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != null) )
        $fields[$value] = NULL;
    }

    // 20071211 - Check config flag and decide to add or replace data transfer quota values
    // 20071203 - Round up values to prevent special SQL error
    // 20071127 - Add bwquotasha
    $correct_fields = array("bwquota", "bwquotaul", "bwquotasha");
    foreach ($correct_fields as $value) {
		if (strlen($fields[$value]) > 0 || $fields[$value] != NULL) {
			if ($flagARBwQuota == "0") {
				$fields[$value] = round($fields[$value] * $quantity);
			} else {
				$fields[$value] = round($fields[$value] * $quantity + odbc_result($result, $value));
			}
		} else {
			$fields[$value] = NULL;
		}
    }
	
	// if set expiry month, it will ignore eminutes, edate
	if (isset($fields["emonth"]) && $fields["emonth"] > 0 && isset($fields["eyear"]) && $fields["eyear"] > 0){
		// ignore to update
		$fields["edate"] = NULL;
		$fields["eminutes"] = NULL;
	}
	else if (!(odbc_result($result, 'emonth') == NULL || strlen(odbc_result($result, 'emonth')) == 0 || odbc_result($result, 'emonth') <= 0) && !(odbc_result($result, 'eyear') == NULL || strlen(odbc_result($result, 'eyear')) == 0 || odbc_result($result, 'eyear') <=0)){
		// ignore to update edate and eminute, since user has already set expiry month
		$fields["edate"] = NULL;
		$fields["eminutes"] = NULL;
	}
	
	// do not modify expiry month when plan do not set expiry month
	if (!(isset($fields["emonth"]) && $fields["emonth"] > 0 && isset($fields["eyear"]) && $fields["eyear"] > 0)){
		$fields["emonth"] = "unused";
		$fields["eyear"] = "unused";
	}

    // 20071203 - Round up values to prevent special SQL error
    // 20070712 - Update edate and eminutes according to the active option set in the plan
    $eMinutes = round($fields["eminutes"]);
    $startMod = round($fields["startmod"]);
    $eDate = odbc_result($result, "edate");
    $mac = odbc_result($result, "reserved1");
    if ($eDate == NULL) {
	$eDate = '';
    }
    if ($mac == NULL) {
	$mac = '';
    }
    //echo "<script>alert('mac: ".$mac."')</script>";
    //echo "<script>alert('old: ".$eDate."')</script>";

    // 20071210 - Add checking of overwriting suspend condition
    // 20071203 - Round up values to prevent special SQL error
    // 20071009 - Adjust plan edate if user edate is not NULL, else clear plan eminutes
    if ((strlen($eDate) > 0 && $eDate != "" && $eDate != NULL) || $flagOverwriteSuspend == "1") {
	if ((strlen($startMod) > 0 || $startMod != NULL) && $startMod == 0 && (strlen($eMinutes) > 0 || $eMinutes != NULL) && $eMinutes > 0) {
	    if (strlen($eDate) == 0 || $eDate == "") {
		$eDate = date('D M d H:i:s Y', time());
	    }
	    $newEdate = '';
	    $myObj = new COM('FSAUTH.Authserv') or die('transaction.php FSAUTH.Authserv Object cannot be created!');
	    $objResult = $myObj->UpdateEdate($mac, $eDate, $eMinutes, $newEdate);

	    // Update edate and remove eminutes in user table
	    $fields["edate"] = $newEdate;
	    $fields["eminutes"] = NULL;
	    $myObj = NULL;
	} else if ((strlen($startMod) > 0 || $startMod != NULL) && $startMod > 0 && (strlen($eMinutes) > 0 || $eMinutes != NULL) && $eMinutes > 0) {
	    $fields["edate"] = $eDate;
	    $correct_fields = array("eminutes");
	    foreach ($correct_fields as $value) {
			// 20090406 - Add missing situations
			if ((strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != NULL) && (strlen($fields[$value]) > 0 || $fields[$value] != NULL)) {
				$fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
			} elseif ($flagOverwriteSuspend == '1' && (odbc_result($result, $value) == NULL || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != NULL)) {
				$fields[$value] = round($fields[$value] * $quantity);
			} elseif (odbc_result($result, $value) != NULL || strlen(odbc_result($result, $value)) > 0) {
				$fields[$value] = round(odbc_result($result, $value));
			} else {
				$fields[$value] = NULL;
			}
	    }
	}
    } else {
	$fields["eminutes"] = NULL;
    }
	
	// Special case to handle eminutes (set edate to null when eminutes != null + user's edate != null + plan's edate = null)
	if ($nSetEdate == true && isset($fields['eminutes']) && $fields["eminutes"] != NULL && (strlen(odbc_result($result, 'edate')) > 0 && odbc_result($result, 'edate') != "" && odbc_result($result, 'edate') != NULL))
	{
		$fields['edate'] = NULL;
	}
	
    $fname_exclude = array("pname", "ipmap", "resetopt");
    
    $field_update = array();
    
    // 20071203 - Round up values to prevent special SQL error
    // 20071127 - Add bandwidth quota sharing related field checking
    // 20071003 - Check not to update bwquota values for offline update
    $planBwCountDl = $fields["bwcount"];
    $planBwCountUl = $fields["bwcountul"];
    $planBwCountShare = $fields["bwcountsha"];
    $userBwCountDl = round(odbc_result($result, "bwcount"));
    $userBwCountUl = round(odbc_result($result, "bwcountul"));
    $userBwCountShare = round(odbc_result($result, "bwcountsha"));
    $userBwQuotaDl = round(odbc_result($result, "bwquota"));
    $userBwQuotaUl = round(odbc_result($result, "bwquotaul"));
    $userBwQuotaShare = round(odbc_result($result, "bwquotasha"));
    $userMac = odbc_result($result, "reserved1");
    if ($userMac == "") {
		// check updated counter == orginal counter == 2 ([Yes and disable...] option)
		if ($planBwCountDl != 2 || ($planBwCountDl == 2 && $userBwCountDl != 2)) {
			$fields["bwcount"] = "unused";
			$fields["bwquota"] = "unused";
		}
		if ($planBwCountUl != 2 || ($planBwCountUl == 2 && $userBwCountUl != 2)) {
			$fields["bwcountul"] = "unused";
			$fields["bwquotaul"] = "unused";
		}
		if ($planBwCountShare != 2 || ($planBwCountShare == 2 && $userBwCountShare != 2)) {
			$fields["bwcountsha"] = "unused";
			$fields["bwquotasha"] = "unused";
		}
    }
    
    foreach ($fname_exclude as $fname) {
	  $fields[$fname] = "unused";
    }

    foreach ($fields as $key => $value) {
		// 20071204 - Log for debug use only
		if (strcmp("$value", "unused") != 0) {
			$field_update[$key] = $value;
			//$this->writeLog("..\\log\\txn.log", $key."->".$value."\r\n");
		}
    }
	
	// ----End-----
	
	$myfsapi = new fsAPI();
	
	// sort array by the array key
	// ksort ($field_update);
	
		// 20100423 - 6th parameter 1 means from legacy plan
		$myfsapi->update_usr_attributes($username, $field_update, $bFieldNumeric, $flagResetBwCount, 0, 1);
    $this->myDB->close();

    return true;
  }


	// 20090708 - Pass field type array
	function update_transaction($invoice, $arr_fields, $bFieldNumeric)
	{ 
		$this->myDB->update($this->transaction_table, $arr_fields, "WHERE invoice = $invoice", $bFieldNumeric);
    $this->myDB->close();

    return true;
  }


  function insert_transaction($username, $arr_fields)
  {
    if ($username == null || $username == "")
      return -1;
    
    $zerocount = false;
 
    //prevent invoice == null 
    $q="SELECT count(*) FROM $this->transaction_table";
    $result = $this->myDB->query($q);
    // 20080206 - Terminate and return error
    if ($result == FALSE) {
	return -1;
    }
    if(round(odbc_result($result, 1)) <= 0)
    {
      $zerocount = true;
      $this->myDB->close();
      $q="INSERT INTO $this->transaction_table (invoice) VALUES (0)";
	// 20080206 - Obtain return value, return error if so
	$result = $this->myDB->query($q);
	if ($result == FALSE) {
	    return -1;
	}
    }
    $this->myDB->close();

    //$now=date("YmdHisZ");
    $now=time();
    
    $fields_name = "INVOICE, USERNAME, ORDER_DATE";
    //$fields_value = "$invoice_no, '$now'";
    $fields_value = "SELECT max(invoice)+1, '$username', '$now'";

    foreach ($arr_fields as $key => $value) {
      if (strtoupper($key) != "INVOICE" || strtoupper($key) != "USERNAME" || strtoupper($key) != "ORDER_DATE")
      {
        $fields_name .= ", ".$key;
        if (strlen($value) > 0 || $value != NULL)
            $fields_value .= ", '$value'";
        else
            $fields_value .= ", NULL";
      }
    }
	
	if (isset($arr_fields['item_name']) && $arr_fields['useMethod'] == 1){ // using item attribute
		
		// interpret cart item, since some NULL value field in user table have other meaning
		// eminutes, bwquota, bwquotaul, bwquotasha, topup: 0 or "" = not enable,  >0 = enable
		// timeleft: "" = not enable, >0 = enable
		// edate: "" = not enable
		// btul, btdl: ""=not enable, 0=no throtling, -1=global setting, >0 = enable
		
		// 20100421 - Add obtaining config setting object and item index check
		if (!isset($_POST['item_index'])) {
			return -1;
		}
		$index = $_POST['item_index'];
		$settingobj = new COM('EGCONFIG.Cfgmgr') or die('transaction.php EGCONFIG.Cfgmgr Object cannot be created!');
		$fields['timeleft'] = $settingobj->getKey( "item_attr_timeleft".$index, "cart");
		$fields['btul'] = $settingobj->getKey( "item_attr_btul".$index, "cart");
		$fields['btdl'] = $settingobj->getKey( "item_attr_btdl".$index, "cart");
		$fields['bwquota'] = $settingobj->getKey( "item_attr_bwquota".$index, "cart");
		$fields['bwquotaul'] = $settingobj->getKey( "item_attr_bwquotaUL".$index, "cart");
		$fields['bwquotasha'] = $settingobj->getKey( "item_attr_bwquotaSha".$index, "cart");
		$fields['edate'] = $settingobj->getKey( "item_attr_edate".$index, "cart");
		$fields['eminutes'] = $settingobj->getKey( "item_attr_eminutes".$index, "cart");
		$fields['topup'] = $settingobj->getKey( "item_attr_topup".$index, "cart");
		$settingobj = NULL;
		
		if ($fields["bwquota"] >0 && $fields["bwquota"] != ""){
			// hard code
			$fields["bwcount"] = 2;
		}
		else{
			$fields["bwquota"] = "";
		}
		
		if ($fields["bwquotaul"] >0 && $fields["bwquotaul"] != ""){
			// hard code
			$fields["bwcountul"] = 2;
		}
		else{
			$fields["bwquotaul"] = "";
		}
		
		if ($fields["bwquotasha"] >0 && $fields["bwquotasha"] != ""){
			// hard code
			$fields["bwcountsha"] = 2;
			// ignore upload and download
			$fields["bwcount"] = "";
			$fields["bwcountul"] = "";
			$fields["bwquota"] = "";
			$fields["bwquotaul"] = "";
		}
		else{
			$fields["bwquotasha"] = "";
		}
		
		if ($fields["topup"] <= 0)
			$fields["topup"] = "";
		
		foreach ($fields as $key => $value) {
		  $fields_name .= ", ".$key;
		  if (strlen($value) > 0 || $value != NULL)
			$fields_value .= ", '$value'";
		  else
			$fields_value .= ", NULL";
		}
	}
    else if (isset($arr_fields['planname']) && $arr_fields['planname'] != "" && $arr_fields['planname'] != null) {
      $q="SELECT * FROM $this->plan_table WHERE pname='".$arr_fields['planname']."'";
      $result=$this->myDB->query($q);
	// 20080206 - Terminate and return error
	if ($result == FALSE) {
	    return -1;
	}
      if (odbc_fetch_row($result)) {
	    // 20071213 - Round other numeric fields also
	    // 20071130 - Add rounding for integer fields
	    // 20071127 - Add bwquotasha, bwcountsha
	    $fields["timeleft"] = round(odbc_result($result, "timeleft"));
	    $fields["btul"] = round(odbc_result($result, "btul"));
	    $fields["btdl"] = round(odbc_result($result, "btdl"));
	    $fields["bwquota"] = round(odbc_result($result, "bwquota"));
	    $fields["bwcount"] = round(odbc_result($result, "bwcount"));
	    $fields["bwquotaul"] = round(odbc_result($result, "bwquotaul"));
	    $fields["bwcountul"] = round(odbc_result($result, "bwcountul"));
	    $fields["sdate"] = odbc_result($result, "sdate");
	    $fields["edate"] = odbc_result($result, "edate");
	    $fields["logins"] = round(odbc_result($result, "logins"));
	    $fields["eminutes"] = round(odbc_result($result, "eminutes"));
	    $fields["startmod"] = round(odbc_result($result, "startmod"));
	    $fields["auto_del"] = round(odbc_result($result, "auto_del"));
	    $fields["bwrmethod"] = odbc_result($result, "bwrmethod");
	    $fields["bwrperiod"] = round(odbc_result($result, "bwrperiod"));
	    $fields["bwrdate"] = round(odbc_result($result, "bwrdate"));
	    $fields["pagenum"] = round(odbc_result($result, "pagenum"));
	    $fields["bwquotasha"] = round(odbc_result($result, "bwquotasha"));
	    $fields["bwcountsha"] = round(odbc_result($result, "bwcountsha"));
		$fields["emonth"] = round(odbc_result($result, "emonth"));
		$fields["eyear"] = round(odbc_result($result, "eyear"));
        
        foreach ($fields as $key => $value) {
          $fields_name .= ", ".$key;
          if (strlen($value) > 0 || $value != NULL)
            $fields_value .= ", '$value'";
          else
            $fields_value .= ", NULL";
        }
      }

      $this->myDB->close();
    }

    $fields_value .= " FROM $this->transaction_table";

    $q = "INSERT INTO $this->transaction_table ($fields_name) $fields_value";
    // 20080206 - Obtain return value
    $result = $this->myDB->query($q);
    $this->myDB->close();
    // 20080206 - Terminate and return error
    if ($result == FALSE) {
	return -1;
    }

    if ($zerocount == true) {
      $q = "DELETE FROM $this->transaction_table WHERE invoice=0";
	// 20080206 - Obtain return value
	$result = $this->myDB->query($q);
      $this->myDB->close();
	// 20080206 - Terminate and return error
	if ($result == FALSE) {
	    return -1;
	}
    }

    $q="SELECT max(INVOICE) FROM $this->transaction_table WHERE username = '$username'";
    $result = $this->myDB->query($q);
    // 20080206 - Terminate and return error
    if ($result == FALSE) {
	return -1;
    }
    if (odbc_fetch_row($result))
      $invoice_no = round(odbc_result($result, 1));
    else
      return -1;
    //echo $invoice_no;
    $this->myDB->close();
   
    return $invoice_no;
  }

  function isexist_transaction($field_name, $field_value)
  {
    $exist = false;
    
    if ( strtolower($field_name) == "invoice" )
      $q="SELECT * FROM $this->transaction_table WHERE ".$field_name." = $field_value";
    else
      $q="SELECT * FROM $this->transaction_table WHERE ".$field_name." = '".$field_value."'";
    
    $result = $this->myDB->query($q);
    
    if (odbc_fetch_row($result))
      $exist = true;
    
    $this->myDB->close();
    return $exist;
  }

  function writeLog($file, $log)
  {
    $fh = fopen($file, "a");
    
    if ($fh) {
      flock($fh, LOCK_EX);
      fwrite($fh, $log);
      flock($fh, LOCK_UN);
      fclose($fh);
    }
  }

    // 20071119 - Using number_format to handle decimal price value comparison
    // 20070807 - Check if the price matches the plan description in config file
    function ValidateCart($description, $price) {
	$cnt = 0;
	$result = -1;
	$settingObj = new COM('EGCONFIG.Cfgmgr') or die('transaction.php EGCONFIG.Cfgmgr Object cannot be created!');

	$num = $settingObj->getKey('max_slot_open', 'cart');
	for ($cnt = 0; $cnt < $num; $cnt++) {
	    $tmp = $settingObj->getKey('description'.$cnt, 'cart');
	    if (strcmp($tmp, $description) == 0) {
		$result = -2;
		$tmp = $settingObj->getKey('price'.$cnt, 'cart');
		if (number_format($tmp) == number_format($price)) {
		    $result = 0;
		}
		break;
	    }
	}

	$settingObj = NULL;
	return $result;
    }
	
	//20080716 added function get_cart_item_arr
	//this function return the attributes of the cart items from config file
	//return null if the item index does not exist
	function get_cart_item_arr($index){
		$settingobj=new COM("EGCONFIG.Cfgmgr") or die("fs_cart.php EGCONFIG.Cfgmgr Object cannot be created!");
		
		$cart_item_arr=null;
		$max_slot_open=$settingobj->getKey( "max_slot_open", "cart");
		if ( ($index>=0) && ($index < $max_slot_open) ){
			//get all the attributes needed
			$cart_item_arr["item_name"]=$settingobj->getKey( "description".$index, "cart");
			$cart_item_arr["amount"]=$settingobj->getKey( "price".$index, "cart");
			$cart_item_arr["quantity"]=1;
			$cart_item_arr["plan"]=$settingobj->getKey( "plan".$index, "cart");
			$cart_item_arr["recurring_enable"]=$settingobj->getKey( "recurring_enable".$index, "cart");
			$cart_item_arr["interval"]=$settingobj->getKey( "interval".$index, "cart");
			$cart_item_arr["interval_unit"]=$settingobj->getKey( "interval_unit".$index, "cart");
			$cart_item_arr["recurring_method"]=$settingobj->getKey( "recurring_method".$index, "cart");
			$cart_item_arr["fixed_number"]=$settingobj->getKey( "fixed_number".$index, "cart");
			$cart_item_arr["useMethod"]=$settingobj->getKey( "useMethod".$index, "cart");
			
			$cart_item_arr['item_attr'] = null;
			$cart_item_arr['item_bFieldNumeric'] = null;
			
			$fields=array();
			$bFieldNumeric = array();
			
			if ($cart_item_arr["useMethod"] == 1){ // using item attribute
			
				$fields['timeleft'] = $settingobj->getKey( "item_attr_timeleft".$index, "cart");
				$bFieldNumeric['timeleft'] = 1;
				$fields['btul'] = $settingobj->getKey( "item_attr_btul".$index, "cart");
				$bFieldNumeric['btul'] = 1;
				$fields['btdl'] = $settingobj->getKey( "item_attr_btdl".$index, "cart");
				$bFieldNumeric['btdl'] = 1;
				$fields['bwquota'] = $settingobj->getKey( "item_attr_bwquota".$index, "cart");
				$bFieldNumeric['bwquota'] = 1;
				$fields['bwquotaul'] = $settingobj->getKey( "item_attr_bwquotaUL".$index, "cart");
				$bFieldNumeric['bwquotaul'] = 1;
				$fields['bwquotasha'] = $settingobj->getKey( "item_attr_bwquotaSha".$index, "cart");
				$bFieldNumeric['bwquotasha'] = 1;
				$fields['edate'] = $settingobj->getKey( "item_attr_edate".$index, "cart");
				$bFieldNumeric['edate'] = 0;
				$fields['eminutes'] = $settingobj->getKey( "item_attr_eminutes".$index, "cart");
				$bFieldNumeric['eminutes'] = 1;
				$fields['topup'] = $settingobj->getKey( "item_attr_topup".$index, "cart");
				$bFieldNumeric['topup'] = 1;
				
				$cart_item_arr['item_attr'] = $fields;
				$cart_item_arr['item_bFieldNumeric'] = $bFieldNumeric;
				
			}
		}

		// 20100421 - Fix typo
		$settingobj = NULL;

		return $cart_item_arr;
	}
	
	//this function return the attributes of the cart items by description
	//return null if the item index does not exist
	function get_cart_item_arr_by_desc($description){
		$cnt = 0;
		$settingObj = new COM('EGCONFIG.Cfgmgr') or die('transaction.php EGCONFIG.Cfgmgr Object cannot be created!');
		
		$cart_item_by_desc_arr=null;

		$num = $settingObj->getKey('max_slot_open', 'cart');
		for ($cnt = 0; $cnt < $num; $cnt++) {
			$tmp = $settingObj->getKey('description'.$cnt, 'cart');
			if (strcmp($tmp, $description) == 0) {
				// match
				$cart_item_by_desc_arr = $this->get_cart_item_arr($cnt);
				break;
			}
		}

		$settingObj = NULL;
		return $cart_item_by_desc_arr;
    }
	
	// update user (shopping cart item attributes)
	function update_usr_table_by_item_attr($username, $description, $u_time, $quantity = 1)
	{
		if ($username == null || $username == "" || $description == null || $description == "")
			return false;
		
		$cart_item_arr = null;
		$cart_item_arr = $this->get_cart_item_arr_by_desc($description);
		if($cart_item_arr!=null && isset($cart_item_arr["item_attr"]) && $cart_item_arr["item_attr"] != null){
			$this->interpret_update_usr_by_cart_behavior($username, $cart_item_arr["item_attr"], $cart_item_arr["item_bFieldNumeric"], $u_time);
				}
		else{
			echo 'Warning! Item\'s attributes not found. ';
			return false;
		}
	}
	
	// u_time for topup use
	function interpret_update_usr_by_cart_behavior($username, $item_fields, $bFieldNumeric, $u_time, $quantity = 1)
	{
		$settingObj = new COM('EGCONFIG.Cfgmgr') or die('transaction.php EGCONFIG.Cfgmgr Object cannot be created!');
		$flagOverwriteSuspend = $settingObj->getKey('overwrite_user_suspend', 'cart') == NULL? "" : $settingObj->getKey('overwrite_user_suspend', 'cart');
		if ($flagOverwriteSuspend == "") {
			$flagOverwriteSuspend = "1";
		}
		$flagARBwQuota = $settingObj->getKey('add_replace_bw_quota', 'cart') == NULL? "" : $settingObj->getKey('add_replace_bw_quota', 'cart');
		if ($flagARBwQuota == "") {
			$flagARBwQuota = "0";
		}

		$flagResetBwCount = ($settingObj->getKey('reset_bw_count_upon_purchase', 'cart') == NULL? "" : $settingObj->getKey('reset_bw_count_upon_purchase', 'cart'));
		if ($flagResetBwCount == "") {
			$flagResetBwCount = "1";
		}

		$settingObj = NULL;
	
		$q="SELECT * FROM $this->usr_table WHERE name = '$username'";
		$result=$this->myDB->query($q);
		
		$fields = array();
		
		// interpret item attributes (by ini)
		foreach ($item_fields as $key => $value) {
			if (strcmp("$value", "") != 0) {
				$fields[$key] = $value;
			}
		}
		
		// btul, btdl: ""=not enable, 0=no throtling, -1=global setting, >0 = enable
		if (isset($fields['btul']) && $fields['btul'] == "-1"){
			$fields['btul'] = NULL;
		}
		if (isset($fields['btdl']) && $fields['btdl'] == "-1"){
			$fields['btdl'] = NULL;
		}

		// ----interpret the update field with (shopping cart behavior)-----
		
		$nSetEdate = false;
		if (!isset($fields['edate']) || $fields['edate'] == NULL || strlen($fields['edate']) <= 0){
			$nSetEdate = true;
		}
		
		if (isset($fields['edate'])){
			// 20090406 - Add missing situations
			// 20071207 - Add flag checking
			// 20071009 - Clear plan edate if user edate is NULL
			// 20070712 - Clear edate content if eminutes is not NULL
			if ((odbc_result($result, 'edate') != NULL || strlen(odbc_result($result, 'edate')) > 0) && ($fields['edate'] != NULL || strlen($fields['edate']) > 0)) {
				$eDateUser = strtotime(odbc_result($result, 'edate'));
				$eDatePlan = strtotime($fields['edate']);
				if ($eDateUser != FALSE && $eDatePlan != FALSE) {
					if ($eDateUser > $eDatePlan) {
						$fields['edate'] = odbc_result($result, 'edate');
					}
				} else {
					$fields['edate'] = odbc_result($result, 'edate');
				}
			} elseif ($flagOverwriteSuspend == '0') {
				if (odbc_result($result, 'edate') == NULL || strlen(odbc_result($result, 'edate')) == 0) {
					$fields['edate'] = NULL;
				} else {
					$fields['edate'] = odbc_result($result, 'edate');
				}
			} elseif (odbc_result($result, 'edate') != NULL || strlen(odbc_result($result, 'edate')) > 0) {
				$fields['edate'] = odbc_result($result, 'edate');
			}
		}

		// 20090406 - Add missing situations
		// 20071207 - New section separated from pagenum to add flag checking of overwriting suspend conditions
		$correct_fields = array("timeleft", "logins");
		foreach ($correct_fields as $value) {
			if (isset($fields[$value])){
				if ((strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != null) && (strlen($fields[$value]) > 0 || $fields[$value] != null)) {
					$fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
				} else if ($flagOverwriteSuspend == "0") {
					if ((odbc_result($result, $value) == null || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != null)) {
						$fields[$value] = NULL;
					} elseif ((odbc_result($result, $value) != NULL || strlen(odbc_result($result, $value)) > 0) && ($fields[$value] == NULL || (strlen($fields[$value]) == 0))) {
						$fields[$value] = round(odbc_result($result, $value));
					}
				} elseif (odbc_result($result, $value) != NULL || strlen(odbc_result($result, $value)) > 0) {
					$fields[$value] = round(odbc_result($result, $value));
				}
			}
		}

		// 20071207 - Remove timeleft, logins
		// 20071203 - Round up values to prevent special SQL error
		// 20070918 - Separate case for bwquota and bwquotaul
		// 20070712 - Remove eminutes
		$correct_fields = array("pagenum");
		foreach ($correct_fields as $value)
		{
			if (isset($fields[$value])){
			  if ( (strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != null) && (strlen($fields[$value]) > 0 || $fields[$value] != null) )
				$fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
			  else if ( (odbc_result($result, $value) == null || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != null) )
				$fields[$value] = NULL;
			}
		}

		// 20071211 - Check config flag and decide to add or replace data transfer quota values
		// 20071203 - Round up values to prevent special SQL error
		// 20071127 - Add bwquotasha
		$correct_fields = array("bwquota", "bwquotaul", "bwquotasha");
		foreach ($correct_fields as $value) {
			if (isset($fields[$value])){
				if (strlen($fields[$value]) > 0 || $fields[$value] != NULL) {
					if ($flagARBwQuota == "0") {
						$fields[$value] = round($fields[$value] * $quantity);
					} else {
						$fields[$value] = round($fields[$value] * $quantity + odbc_result($result, $value));
					}
				} else {
					$fields[$value] = NULL;
				}
			}
		}
		
		// if set topup, it will ignore update eminutes, edate
		if (isset($fields["topup"]) && $fields["topup"] > 0){
			$emonth=odbc_result($result,"emonth");
			$eyear=odbc_result($result,"eyear");
			
			$base_time = 0;
			$u_expire_month = -1;
			
			if (isset ($emonth) && isset($eyear) && $emonth != "" && $eyear != "" && $emonth >0 && $eyear >0){
				// mktime() will autom adjust
				$u_expire_month = mktime(0, 0, 0, $emonth+1, 1, $eyear); 
			}
			
			if ( $u_expire_month == false || $u_expire_month == -1 || $u_time > $u_expire_month) // emonth eyear field is null or expired
				$base_time = $u_time;
			else
				$base_time = $u_expire_month;
				
			
			$localtime  = localtime($base_time, true);
			$tm_mday = $localtime['tm_mday']; // day of the month
			$update_eyear = $localtime['tm_year'] + 1900;
			$update_emonth = $localtime['tm_mon'] +1;
			
			$update_emonth = $update_emonth + $fields["topup"] -1;
			
			if ($update_emonth > 12){
				$update_eyear = $update_eyear + (($update_emonth - ($update_emonth%12)) / 12);
				$update_emonth = $update_emonth%12;
			}
			$fields["eyear"] = $update_eyear;
			$fields["emonth"] = $update_emonth;
			$bFieldNumeric["eyear"] = 1;
			$bFieldNumeric["emonth"] = 1;
			
			// attribute not in user table (fsusr)
			$fields["topup"] = NULL;
			
			// ignore to update
			$fields["edate"] = NULL;
			$fields["eminutes"] = NULL;
			$fields["startmod"] = NULL;
		}
		else if (!(odbc_result($result, 'emonth') == NULL || strlen(odbc_result($result, 'emonth')) == 0 || odbc_result($result, 'emonth') <= 0) && !(odbc_result($result, 'eyear') == NULL || strlen(odbc_result($result, 'eyear')) == 0 || odbc_result($result, 'eyear') <=0)){
			$fields["topup"] = NULL;
			
			// ignore to update edate and eminute, since user has already set expiry month
			$fields["edate"] = NULL;
			$fields["eminutes"] = NULL;
		}
		else{
			// ignore
			$fields["topup"] = NULL;
			
			// 20071203 - Round up values to prevent special SQL error
			// 20070712 - Update edate and eminutes according to the active option set in the plan
			if (isset($fields["eminutes"]))
				$eMinutes = round($fields["eminutes"]);
			else
				$eMinutes = '';
			if (isset($fields["startmod"]))
				$startMod = round($fields["startmod"]);
			else{
				// default "When it is created" / Now
				$startMod = 0 ;
			}
				
			$eDate = odbc_result($result, "edate");
			$mac = odbc_result($result, "reserved1");
			if ($eDate == NULL) {
			$eDate = '';
			}
			if ($mac == NULL) {
			$mac = '';
			}
			//echo "<script>alert('mac: ".$mac."')</script>";
			//echo "<script>alert('old: ".$eDate."')</script>";

			// 20071210 - Add checking of overwriting suspend condition
			// 20071203 - Round up values to prevent special SQL error
			// 20071009 - Adjust plan edate if user edate is not NULL, else clear plan eminutes
			if ((strlen($eDate) > 0 && $eDate != "" && $eDate != NULL) || $flagOverwriteSuspend == "1") {
			if ((strlen($startMod) > 0 || $startMod != NULL) && $startMod == 0 && (strlen($eMinutes) > 0 || $eMinutes != NULL) && $eMinutes > 0) {
				if (strlen($eDate) == 0 || $eDate == "") {
				$eDate = date('D M d H:i:s Y', time());
				}
				$newEdate = '';
				$myObj = new COM('FSAUTH.Authserv') or die('transaction.php FSAUTH.Authserv Object cannot be created!');
				$objResult = $myObj->UpdateEdate($mac, $eDate, $eMinutes, $newEdate);

				// Update edate and remove eminutes in user table
				$fields["edate"] = $newEdate;
				$fields["eminutes"] = NULL;
				$myObj = NULL;
			} else if ((strlen($startMod) > 0 || $startMod != NULL) && $startMod > 0 && (strlen($eMinutes) > 0 || $eMinutes != NULL) && $eMinutes > 0) {
				$fields["edate"] = $eDate;
				$correct_fields = array("eminutes");
				foreach ($correct_fields as $value) {
					// 20090406 - Add missing situations
					if ((strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != NULL) && (strlen($fields[$value]) > 0 || $fields[$value] != NULL)) {
						$fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
					} elseif ($flagOverwriteSuspend == '1' && (odbc_result($result, $value) == NULL || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != NULL)) {
						$fields[$value] = round($fields[$value] * $quantity);
					} elseif (odbc_result($result, $value) != NULL || strlen(odbc_result($result, $value)) > 0) {
						$fields[$value] = round(odbc_result($result, $value));
					} else {
						$fields[$value] = NULL;
					}
				}
			}
			} else {
			$fields["eminutes"] = NULL;
			}
		}

		// Special case to handle eminutes (set edate to null when eminutes != null + user's edate != null + plan's edate = null)
		if ($nSetEdate == true && isset($fields['eminutes']) && $fields["eminutes"] != NULL && (strlen(odbc_result($result, 'edate')) > 0 && odbc_result($result, 'edate') != "" && odbc_result($result, 'edate') != NULL))
		{
			$fields['edate'] = NULL;
		}
		
		$fname_exclude = array("pname", "ipmap", "resetopt", "topup");

		$field_update = array();

		// 20071203 - Round up values to prevent special SQL error
		// 20071127 - Add bandwidth quota sharing related field checking
		// 20071003 - Check not to update bwquota values for offline update
		// handle not set count, but have quota value (by item attribute)
		if (isset($fields["bwcount"]))
			$planBwCountDl = $fields["bwcount"];
		else if (isset($fields["bwquota"]) && $fields["bwquota"] > 0){
			$planBwCountDl = 2;
			$fields["bwcount"] = 2;
			$bFieldNumeric["bwcount"] = 1;
		}
		else
			$planBwCountDl = -1;
			
		if (isset($fields["bwcountul"]))
			$planBwCountUl = $fields["bwcountul"];
		else if (isset($fields["bwquotaul"]) && $fields["bwquotaul"] > 0){
			$planBwCountUl = 2;
			$fields["bwcountul"] = 2;
			$bFieldNumeric["bwcountul"] = 1;
		}
		else
			$planBwCountUl = -1;
			
		if (isset($fields["bwcountsha"]))
			$planBwCountShare = $fields["bwcountsha"];
		else if (isset($fields["bwquotasha"]) && $fields["bwquotasha"] > 0){
			$planBwCountShare = 2;
			$fields["bwcountsha"] = 2;
			$bFieldNumeric["bwcountsha"] = 1;
		}
		else
			$planBwCountShare = -1;
			
		$userBwCountDl = round(odbc_result($result, "bwcount"));
		$userBwCountUl = round(odbc_result($result, "bwcountul"));
		$userBwCountShare = round(odbc_result($result, "bwcountsha"));
		$userBwQuotaDl = round(odbc_result($result, "bwquota"));
		$userBwQuotaUl = round(odbc_result($result, "bwquotaul"));
		$userBwQuotaShare = round(odbc_result($result, "bwquotasha"));
		$userMac = odbc_result($result, "reserved1");
		if ($userMac == "") {
			// check updated counter == orginal counter == 2 ([Yes and disable...] option)
			if ($planBwCountDl != 2 || ($planBwCountDl == 2 && $userBwCountDl != 2)) {
				$fields["bwcount"] = "unused";
				$fields["bwquota"] = "unused";
			}
			if ($planBwCountUl != 2 || ($planBwCountUl == 2 && $userBwCountUl != 2)) {
				$fields["bwcountul"] = "unused";
				$fields["bwquotaul"] = "unused";
			}
			if ($planBwCountShare != 2 || ($planBwCountShare == 2 && $userBwCountShare != 2)) {
				$fields["bwcountsha"] = "unused";
				$fields["bwquotasha"] = "unused";
			}
		}

		foreach ($fname_exclude as $fname) {
		  $fields[$fname] = "unused";
		}

		foreach ($fields as $key => $value) {
			// 20071204 - Log for debug use only
			if (strcmp("$value", "unused") != 0) {
				$field_update[$key] = $value;
				//$this->writeLog("..\\log\\txn.log", $key."->".$value."\r\n");
			}
		}

		// ----End-----

		$myfsapi = new fsAPI();

		// sort array by the array key
		// ksort ($field_update);

		// 20100423 - 6th parameter 0 means not from legacy plan
		$myfsapi->update_usr_attributes($username, $field_update, $bFieldNumeric, $flagResetBwCount, 0, 0);
		$this->myDB->close();

		return true;
	
	}
}
?>
